(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports) :
    typeof define === 'function' && define.amd ? define(['exports'], factory) :
    (factory((global.Temple = global.Temple || {})));
}(this, function (exports) { 'use strict';

    var babelHelpers = {};
    babelHelpers.typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) {
      return typeof obj;
    } : function (obj) {
      return obj && typeof Symbol === "function" && obj.constructor === Symbol ? "symbol" : typeof obj;
    };

    babelHelpers.classCallCheck = function (instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    };

    babelHelpers.createClass = function () {
      function defineProperties(target, props) {
        for (var i = 0; i < props.length; i++) {
          var descriptor = props[i];
          descriptor.enumerable = descriptor.enumerable || false;
          descriptor.configurable = true;
          if ("value" in descriptor) descriptor.writable = true;
          Object.defineProperty(target, descriptor.key, descriptor);
        }
      }

      return function (Constructor, protoProps, staticProps) {
        if (protoProps) defineProperties(Constructor.prototype, protoProps);
        if (staticProps) defineProperties(Constructor, staticProps);
        return Constructor;
      };
    }();

    babelHelpers.inherits = function (subClass, superClass) {
      if (typeof superClass !== "function" && superClass !== null) {
        throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
      }

      subClass.prototype = Object.create(superClass && superClass.prototype, {
        constructor: {
          value: subClass,
          enumerable: false,
          writable: true,
          configurable: true
        }
      });
      if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
    };

    babelHelpers.possibleConstructorReturn = function (self, call) {
      if (!self) {
        throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
      }

      return call && (typeof call === "object" || typeof call === "function") ? call : self;
    };

    babelHelpers.slicedToArray = function () {
      function sliceIterator(arr, i) {
        var _arr = [];
        var _n = true;
        var _d = false;
        var _e = undefined;

        try {
          for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
            _arr.push(_s.value);

            if (i && _arr.length === i) break;
          }
        } catch (err) {
          _d = true;
          _e = err;
        } finally {
          try {
            if (!_n && _i["return"]) _i["return"]();
          } finally {
            if (_d) throw _e;
          }
        }

        return _arr;
      }

      return function (arr, i) {
        if (Array.isArray(arr)) {
          return arr;
        } else if (Symbol.iterator in Object(arr)) {
          return sliceIterator(arr, i);
        } else {
          throw new TypeError("Invalid attempt to destructure non-iterable instance");
        }
      };
    }();

    babelHelpers;


    var __commonjs_global = typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : this;
    function __commonjs(fn, module) { return module = { exports: {} }, fn(module, module.exports, __commonjs_global), module.exports; }

    var isObject = __commonjs(function (module) {
    /**
     * Checks if `value` is the [language type](https://es5.github.io/#x8) of `Object`.
     * (e.g. arrays, functions, objects, regexes, `new Number(0)`, and `new String('')`)
     *
     * @static
     * @memberOf _
     * @category Lang
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is an object, else `false`.
     * @example
     *
     * _.isObject({});
     * // => true
     *
     * _.isObject([1, 2, 3]);
     * // => true
     *
     * _.isObject(_.noop);
     * // => true
     *
     * _.isObject(null);
     * // => false
     */
    function isObject(value) {
      var type = typeof value;
      return !!value && (type == 'object' || type == 'function');
    }

    module.exports = isObject;
    });

    var require$$0$2 = (isObject && typeof isObject === 'object' && 'default' in isObject ? isObject['default'] : isObject);

    var isFunction = __commonjs(function (module) {
    var isObject = require$$0$2;

    /** `Object#toString` result references. */
    var funcTag = '[object Function]',
        genTag = '[object GeneratorFunction]';

    /** Used for built-in method references. */
    var objectProto = Object.prototype;

    /**
     * Used to resolve the [`toStringTag`](http://ecma-international.org/ecma-262/6.0/#sec-object.prototype.tostring)
     * of values.
     */
    var objectToString = objectProto.toString;

    /**
     * Checks if `value` is classified as a `Function` object.
     *
     * @static
     * @memberOf _
     * @category Lang
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is correctly classified, else `false`.
     * @example
     *
     * _.isFunction(_);
     * // => true
     *
     * _.isFunction(/abc/);
     * // => false
     */
    function isFunction(value) {
      // The use of `Object#toString` avoids issues with the `typeof` operator
      // in Safari 8 which returns 'object' for typed array constructors, and
      // PhantomJS 1.9 which returns 'function' for `NodeList` instances.
      var tag = isObject(value) ? objectToString.call(value) : '';
      return tag == funcTag || tag == genTag;
    }

    module.exports = isFunction;
    });

    var _default2 = (isFunction && typeof isFunction === 'object' && 'default' in isFunction ? isFunction['default'] : isFunction);

    var toNumber = __commonjs(function (module) {
    var isFunction = _default2,
        isObject = require$$0$2;

    /** Used as references for various `Number` constants. */
    var NAN = 0 / 0;

    /** Used to match leading and trailing whitespace. */
    var reTrim = /^\s+|\s+$/g;

    /** Used to detect bad signed hexadecimal string values. */
    var reIsBadHex = /^[-+]0x[0-9a-f]+$/i;

    /** Used to detect binary string values. */
    var reIsBinary = /^0b[01]+$/i;

    /** Used to detect octal string values. */
    var reIsOctal = /^0o[0-7]+$/i;

    /** Built-in method references without a dependency on `root`. */
    var freeParseInt = parseInt;

    /**
     * Converts `value` to a number.
     *
     * @static
     * @memberOf _
     * @category Lang
     * @param {*} value The value to process.
     * @returns {number} Returns the number.
     * @example
     *
     * _.toNumber(3);
     * // => 3
     *
     * _.toNumber(Number.MIN_VALUE);
     * // => 5e-324
     *
     * _.toNumber(Infinity);
     * // => Infinity
     *
     * _.toNumber('3');
     * // => 3
     */
    function toNumber(value) {
      if (isObject(value)) {
        var other = isFunction(value.valueOf) ? value.valueOf() : value;
        value = isObject(other) ? (other + '') : other;
      }
      if (typeof value != 'string') {
        return value === 0 ? value : +value;
      }
      value = value.replace(reTrim, '');
      var isBinary = reIsBinary.test(value);
      return (isBinary || reIsOctal.test(value))
        ? freeParseInt(value.slice(2), isBinary ? 2 : 8)
        : (reIsBadHex.test(value) ? NAN : +value);
    }

    module.exports = toNumber;
    });

    var require$$0$1 = (toNumber && typeof toNumber === 'object' && 'default' in toNumber ? toNumber['default'] : toNumber);

    var toInteger = __commonjs(function (module) {
    var toNumber = require$$0$1;

    /** Used as references for various `Number` constants. */
    var INFINITY = 1 / 0,
        MAX_INTEGER = 1.7976931348623157e+308;

    /**
     * Converts `value` to an integer.
     *
     * **Note:** This function is loosely based on [`ToInteger`](http://www.ecma-international.org/ecma-262/6.0/#sec-tointeger).
     *
     * @static
     * @memberOf _
     * @category Lang
     * @param {*} value The value to convert.
     * @returns {number} Returns the converted integer.
     * @example
     *
     * _.toInteger(3);
     * // => 3
     *
     * _.toInteger(Number.MIN_VALUE);
     * // => 0
     *
     * _.toInteger(Infinity);
     * // => 1.7976931348623157e+308
     *
     * _.toInteger('3');
     * // => 3
     */
    function toInteger(value) {
      if (!value) {
        return value === 0 ? value : 0;
      }
      value = toNumber(value);
      if (value === INFINITY || value === -INFINITY) {
        var sign = (value < 0 ? -1 : 1);
        return sign * MAX_INTEGER;
      }
      var remainder = value % 1;
      return value === value ? (remainder ? value - remainder : value) : 0;
    }

    module.exports = toInteger;
    });

    var require$$1 = (toInteger && typeof toInteger === 'object' && 'default' in toInteger ? toInteger['default'] : toInteger);

    var _apply = __commonjs(function (module) {
    /**
     * A faster alternative to `Function#apply`, this function invokes `func`
     * with the `this` binding of `thisArg` and the arguments of `args`.
     *
     * @private
     * @param {Function} func The function to invoke.
     * @param {*} thisArg The `this` binding of `func`.
     * @param {...*} args The arguments to invoke `func` with.
     * @returns {*} Returns the result of `func`.
     */
    function apply(func, thisArg, args) {
      var length = args.length;
      switch (length) {
        case 0: return func.call(thisArg);
        case 1: return func.call(thisArg, args[0]);
        case 2: return func.call(thisArg, args[0], args[1]);
        case 3: return func.call(thisArg, args[0], args[1], args[2]);
      }
      return func.apply(thisArg, args);
    }

    module.exports = apply;
    });

    var require$$4 = (_apply && typeof _apply === 'object' && 'default' in _apply ? _apply['default'] : _apply);

    var rest = __commonjs(function (module) {
    var apply = require$$4,
        toInteger = require$$1;

    /** Used as the `TypeError` message for "Functions" methods. */
    var FUNC_ERROR_TEXT = 'Expected a function';

    /* Built-in method references for those with the same name as other `lodash` methods. */
    var nativeMax = Math.max;

    /**
     * Creates a function that invokes `func` with the `this` binding of the
     * created function and arguments from `start` and beyond provided as an array.
     *
     * **Note:** This method is based on the [rest parameter](https://mdn.io/rest_parameters).
     *
     * @static
     * @memberOf _
     * @category Function
     * @param {Function} func The function to apply a rest parameter to.
     * @param {number} [start=func.length-1] The start position of the rest parameter.
     * @returns {Function} Returns the new function.
     * @example
     *
     * var say = _.rest(function(what, names) {
     *   return what + ' ' + _.initial(names).join(', ') +
     *     (_.size(names) > 1 ? ', & ' : '') + _.last(names);
     * });
     *
     * say('hello', 'fred', 'barney', 'pebbles');
     * // => 'hello fred, barney, & pebbles'
     */
    function rest(func, start) {
      if (typeof func != 'function') {
        throw new TypeError(FUNC_ERROR_TEXT);
      }
      start = nativeMax(start === undefined ? (func.length - 1) : toInteger(start), 0);
      return function() {
        var args = arguments,
            index = -1,
            length = nativeMax(args.length - start, 0),
            array = Array(length);

        while (++index < length) {
          array[index] = args[start + index];
        }
        switch (start) {
          case 0: return func.call(this, array);
          case 1: return func.call(this, args[0], array);
          case 2: return func.call(this, args[0], args[1], array);
        }
        var otherArgs = Array(start + 1);
        index = -1;
        while (++index < start) {
          otherArgs[index] = args[index];
        }
        otherArgs[start] = array;
        return apply(func, this, otherArgs);
      };
    }

    module.exports = rest;
    });

    var require$$0 = (rest && typeof rest === 'object' && 'default' in rest ? rest['default'] : rest);

    var isObjectLike = __commonjs(function (module) {
    /**
     * Checks if `value` is object-like. A value is object-like if it's not `null`
     * and has a `typeof` result of "object".
     *
     * @static
     * @memberOf _
     * @category Lang
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is object-like, else `false`.
     * @example
     *
     * _.isObjectLike({});
     * // => true
     *
     * _.isObjectLike([1, 2, 3]);
     * // => true
     *
     * _.isObjectLike(_.noop);
     * // => false
     *
     * _.isObjectLike(null);
     * // => false
     */
    function isObjectLike(value) {
      return !!value && typeof value == 'object';
    }

    module.exports = isObjectLike;
    });

    var require$$0$4 = (isObjectLike && typeof isObjectLike === 'object' && 'default' in isObjectLike ? isObjectLike['default'] : isObjectLike);

    var isLength = __commonjs(function (module) {
    /** Used as references for various `Number` constants. */
    var MAX_SAFE_INTEGER = 9007199254740991;

    /**
     * Checks if `value` is a valid array-like length.
     *
     * **Note:** This function is loosely based on [`ToLength`](http://ecma-international.org/ecma-262/6.0/#sec-tolength).
     *
     * @static
     * @memberOf _
     * @category Lang
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is a valid length, else `false`.
     * @example
     *
     * _.isLength(3);
     * // => true
     *
     * _.isLength(Number.MIN_VALUE);
     * // => false
     *
     * _.isLength(Infinity);
     * // => false
     *
     * _.isLength('3');
     * // => false
     */
    function isLength(value) {
      return typeof value == 'number' &&
        value > -1 && value % 1 == 0 && value <= MAX_SAFE_INTEGER;
    }

    module.exports = isLength;
    });

    var require$$1$1 = (isLength && typeof isLength === 'object' && 'default' in isLength ? isLength['default'] : isLength);

    var _baseProperty = __commonjs(function (module) {
    /**
     * The base implementation of `_.property` without support for deep paths.
     *
     * @private
     * @param {string} key The key of the property to get.
     * @returns {Function} Returns the new function.
     */
    function baseProperty(key) {
      return function(object) {
        return object == null ? undefined : object[key];
      };
    }

    module.exports = baseProperty;
    });

    var require$$2$1 = (_baseProperty && typeof _baseProperty === 'object' && 'default' in _baseProperty ? _baseProperty['default'] : _baseProperty);

    var _getLength = __commonjs(function (module) {
    var baseProperty = require$$2$1;

    /**
     * Gets the "length" property value of `object`.
     *
     * **Note:** This function is used to avoid a [JIT bug](https://bugs.webkit.org/show_bug.cgi?id=142792)
     * that affects Safari on at least iOS 8.1-8.3 ARM64.
     *
     * @private
     * @param {Object} object The object to query.
     * @returns {*} Returns the "length" value.
     */
    var getLength = baseProperty('length');

    module.exports = getLength;
    });

    var require$$2 = (_getLength && typeof _getLength === 'object' && 'default' in _getLength ? _getLength['default'] : _getLength);

    var isArrayLike = __commonjs(function (module) {
    var getLength = require$$2,
        isFunction = _default2,
        isLength = require$$1$1;

    /**
     * Checks if `value` is array-like. A value is considered array-like if it's
     * not a function and has a `value.length` that's an integer greater than or
     * equal to `0` and less than or equal to `Number.MAX_SAFE_INTEGER`.
     *
     * @static
     * @memberOf _
     * @category Lang
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is array-like, else `false`.
     * @example
     *
     * _.isArrayLike([1, 2, 3]);
     * // => true
     *
     * _.isArrayLike(document.body.children);
     * // => true
     *
     * _.isArrayLike('abc');
     * // => true
     *
     * _.isArrayLike(_.noop);
     * // => false
     */
    function isArrayLike(value) {
      return value != null &&
        !(typeof value == 'function' && isFunction(value)) && isLength(getLength(value));
    }

    module.exports = isArrayLike;
    });

    var require$$0$5 = (isArrayLike && typeof isArrayLike === 'object' && 'default' in isArrayLike ? isArrayLike['default'] : isArrayLike);

    var isArrayLikeObject = __commonjs(function (module) {
    var isArrayLike = require$$0$5,
        isObjectLike = require$$0$4;

    /**
     * This method is like `_.isArrayLike` except that it also checks if `value`
     * is an object.
     *
     * @static
     * @memberOf _
     * @category Lang
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is an array-like object, else `false`.
     * @example
     *
     * _.isArrayLikeObject([1, 2, 3]);
     * // => true
     *
     * _.isArrayLikeObject(document.body.children);
     * // => true
     *
     * _.isArrayLikeObject('abc');
     * // => false
     *
     * _.isArrayLikeObject(_.noop);
     * // => false
     */
    function isArrayLikeObject(value) {
      return isObjectLike(value) && isArrayLike(value);
    }

    module.exports = isArrayLikeObject;
    });

    var require$$0$3 = (isArrayLikeObject && typeof isArrayLikeObject === 'object' && 'default' in isArrayLikeObject ? isArrayLikeObject['default'] : isArrayLikeObject);

    var _isKeyable = __commonjs(function (module) {
    /**
     * Checks if `value` is suitable for use as unique object key.
     *
     * @private
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is suitable, else `false`.
     */
    function isKeyable(value) {
      var type = typeof value;
      return type == 'number' || type == 'boolean' ||
        (type == 'string' && value != '__proto__') || value == null;
    }

    module.exports = isKeyable;
    });

    var require$$0$7 = (_isKeyable && typeof _isKeyable === 'object' && 'default' in _isKeyable ? _isKeyable['default'] : _isKeyable);

    var _cacheHas = __commonjs(function (module) {
    var isKeyable = require$$0$7;

    /** Used to stand-in for `undefined` hash values. */
    var HASH_UNDEFINED = '__lodash_hash_undefined__';

    /**
     * Checks if `value` is in `cache`.
     *
     * @private
     * @param {Object} cache The set cache to search.
     * @param {*} value The value to search for.
     * @returns {number} Returns `true` if `value` is found, else `false`.
     */
    function cacheHas(cache, value) {
      var map = cache.__data__;
      if (isKeyable(value)) {
        var data = map.__data__,
            hash = typeof value == 'string' ? data.string : data.hash;

        return hash[value] === HASH_UNDEFINED;
      }
      return map.has(value);
    }

    module.exports = cacheHas;
    });

    var require$$0$6 = (_cacheHas && typeof _cacheHas === 'object' && 'default' in _cacheHas ? _cacheHas['default'] : _cacheHas);

    var _baseUnary = __commonjs(function (module) {
    /**
     * The base implementation of `_.unary` without support for storing wrapper metadata.
     *
     * @private
     * @param {Function} func The function to cap arguments for.
     * @returns {Function} Returns the new function.
     */
    function baseUnary(func) {
      return function(value) {
        return func(value);
      };
    }

    module.exports = baseUnary;
    });

    var require$$1$2 = (_baseUnary && typeof _baseUnary === 'object' && 'default' in _baseUnary ? _baseUnary['default'] : _baseUnary);

    var _arrayMap = __commonjs(function (module) {
    /**
     * A specialized version of `_.map` for arrays without support for iteratee
     * shorthands.
     *
     * @private
     * @param {Array} array The array to iterate over.
     * @param {Function} iteratee The function invoked per iteration.
     * @returns {Array} Returns the new mapped array.
     */
    function arrayMap(array, iteratee) {
      var index = -1,
          length = array.length,
          result = Array(length);

      while (++index < length) {
        result[index] = iteratee(array[index], index, array);
      }
      return result;
    }

    module.exports = arrayMap;
    });

    var require$$0$8 = (_arrayMap && typeof _arrayMap === 'object' && 'default' in _arrayMap ? _arrayMap['default'] : _arrayMap);

    var _arrayIncludesWith = __commonjs(function (module) {
    /**
     * A specialized version of `_.includesWith` for arrays without support for
     * specifying an index to search from.
     *
     * @private
     * @param {Array} array The array to search.
     * @param {*} target The value to search for.
     * @param {Function} comparator The comparator invoked per element.
     * @returns {boolean} Returns `true` if `target` is found, else `false`.
     */
    function arrayIncludesWith(array, value, comparator) {
      var index = -1,
          length = array.length;

      while (++index < length) {
        if (comparator(value, array[index])) {
          return true;
        }
      }
      return false;
    }

    module.exports = arrayIncludesWith;
    });

    var require$$3 = (_arrayIncludesWith && typeof _arrayIncludesWith === 'object' && 'default' in _arrayIncludesWith ? _arrayIncludesWith['default'] : _arrayIncludesWith);

    var _indexOfNaN = __commonjs(function (module) {
    /**
     * Gets the index at which the first occurrence of `NaN` is found in `array`.
     *
     * @private
     * @param {Array} array The array to search.
     * @param {number} fromIndex The index to search from.
     * @param {boolean} [fromRight] Specify iterating from right to left.
     * @returns {number} Returns the index of the matched `NaN`, else `-1`.
     */
    function indexOfNaN(array, fromIndex, fromRight) {
      var length = array.length,
          index = fromIndex + (fromRight ? 0 : -1);

      while ((fromRight ? index-- : ++index < length)) {
        var other = array[index];
        if (other !== other) {
          return index;
        }
      }
      return -1;
    }

    module.exports = indexOfNaN;
    });

    var require$$0$9 = (_indexOfNaN && typeof _indexOfNaN === 'object' && 'default' in _indexOfNaN ? _indexOfNaN['default'] : _indexOfNaN);

    var _baseIndexOf = __commonjs(function (module) {
    var indexOfNaN = require$$0$9;

    /**
     * The base implementation of `_.indexOf` without `fromIndex` bounds checks.
     *
     * @private
     * @param {Array} array The array to search.
     * @param {*} value The value to search for.
     * @param {number} fromIndex The index to search from.
     * @returns {number} Returns the index of the matched value, else `-1`.
     */
    function baseIndexOf(array, value, fromIndex) {
      if (value !== value) {
        return indexOfNaN(array, fromIndex);
      }
      var index = fromIndex - 1,
          length = array.length;

      while (++index < length) {
        if (array[index] === value) {
          return index;
        }
      }
      return -1;
    }

    module.exports = baseIndexOf;
    });

    var require$$4$2 = (_baseIndexOf && typeof _baseIndexOf === 'object' && 'default' in _baseIndexOf ? _baseIndexOf['default'] : _baseIndexOf);

    var _arrayIncludes = __commonjs(function (module) {
    var baseIndexOf = require$$4$2;

    /**
     * A specialized version of `_.includes` for arrays without support for
     * specifying an index to search from.
     *
     * @private
     * @param {Array} array The array to search.
     * @param {*} target The value to search for.
     * @returns {boolean} Returns `true` if `target` is found, else `false`.
     */
    function arrayIncludes(array, value) {
      return !!array.length && baseIndexOf(array, value, 0) > -1;
    }

    module.exports = arrayIncludes;
    });

    var require$$4$1 = (_arrayIncludes && typeof _arrayIncludes === 'object' && 'default' in _arrayIncludes ? _arrayIncludes['default'] : _arrayIncludes);

    var _cachePush = __commonjs(function (module) {
    var isKeyable = require$$0$7;

    /** Used to stand-in for `undefined` hash values. */
    var HASH_UNDEFINED = '__lodash_hash_undefined__';

    /**
     * Adds `value` to the set cache.
     *
     * @private
     * @name push
     * @memberOf SetCache
     * @param {*} value The value to cache.
     */
    function cachePush(value) {
      var map = this.__data__;
      if (isKeyable(value)) {
        var data = map.__data__,
            hash = typeof value == 'string' ? data.string : data.hash;

        hash[value] = HASH_UNDEFINED;
      }
      else {
        map.set(value, HASH_UNDEFINED);
      }
    }

    module.exports = cachePush;
    });

    var require$$0$10 = (_cachePush && typeof _cachePush === 'object' && 'default' in _cachePush ? _cachePush['default'] : _cachePush);

    var _isHostObject = __commonjs(function (module) {
    /**
     * Checks if `value` is a host object in IE < 9.
     *
     * @private
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is a host object, else `false`.
     */
    function isHostObject(value) {
      // Many host objects are `Object` objects that can coerce to strings
      // despite having improperly defined `toString` methods.
      var result = false;
      if (value != null && typeof value.toString != 'function') {
        try {
          result = !!(value + '');
        } catch (e) {}
      }
      return result;
    }

    module.exports = isHostObject;
    });

    var require$$1$6 = (_isHostObject && typeof _isHostObject === 'object' && 'default' in _isHostObject ? _isHostObject['default'] : _isHostObject);

    var isNative = __commonjs(function (module) {
    var isFunction = _default2,
        isHostObject = require$$1$6,
        isObjectLike = require$$0$4;

    /** Used to match `RegExp` [syntax characters](http://ecma-international.org/ecma-262/6.0/#sec-patterns). */
    var reRegExpChar = /[\\^$.*+?()[\]{}|]/g;

    /** Used to detect host constructors (Safari > 5). */
    var reIsHostCtor = /^\[object .+?Constructor\]$/;

    /** Used for built-in method references. */
    var objectProto = Object.prototype;

    /** Used to resolve the decompiled source of functions. */
    var funcToString = Function.prototype.toString;

    /** Used to check objects for own properties. */
    var hasOwnProperty = objectProto.hasOwnProperty;

    /** Used to detect if a method is native. */
    var reIsNative = RegExp('^' +
      funcToString.call(hasOwnProperty).replace(reRegExpChar, '\\$&')
      .replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, '$1.*?') + '$'
    );

    /**
     * Checks if `value` is a native function.
     *
     * @static
     * @memberOf _
     * @category Lang
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is a native function, else `false`.
     * @example
     *
     * _.isNative(Array.prototype.push);
     * // => true
     *
     * _.isNative(_);
     * // => false
     */
    function isNative(value) {
      if (value == null) {
        return false;
      }
      if (isFunction(value)) {
        return reIsNative.test(funcToString.call(value));
      }
      return isObjectLike(value) &&
        (isHostObject(value) ? reIsNative : reIsHostCtor).test(value);
    }

    module.exports = isNative;
    });

    var require$$0$13 = (isNative && typeof isNative === 'object' && 'default' in isNative ? isNative['default'] : isNative);

    var _getNative = __commonjs(function (module) {
    var isNative = require$$0$13;

    /**
     * Gets the native function at `key` of `object`.
     *
     * @private
     * @param {Object} object The object to query.
     * @param {string} key The key of the method to get.
     * @returns {*} Returns the function if it's native, else `undefined`.
     */
    function getNative(object, key) {
      var value = object == null ? undefined : object[key];
      return isNative(value) ? value : undefined;
    }

    module.exports = getNative;
    });

    var require$$1$5 = (_getNative && typeof _getNative === 'object' && 'default' in _getNative ? _getNative['default'] : _getNative);

    var _nativeCreate = __commonjs(function (module) {
    var getNative = require$$1$5;

    /* Built-in method references that are verified to be native. */
    var nativeCreate = getNative(Object, 'create');

    module.exports = nativeCreate;
    });

    var require$$0$12 = (_nativeCreate && typeof _nativeCreate === 'object' && 'default' in _nativeCreate ? _nativeCreate['default'] : _nativeCreate);

    var _hashSet = __commonjs(function (module) {
    var nativeCreate = require$$0$12;

    /** Used to stand-in for `undefined` hash values. */
    var HASH_UNDEFINED = '__lodash_hash_undefined__';

    /**
     * Sets the hash `key` to `value`.
     *
     * @private
     * @param {Object} hash The hash to modify.
     * @param {string} key The key of the value to set.
     * @param {*} value The value to set.
     */
    function hashSet(hash, key, value) {
      hash[key] = (nativeCreate && value === undefined) ? HASH_UNDEFINED : value;
    }

    module.exports = hashSet;
    });

    var require$$1$4 = (_hashSet && typeof _hashSet === 'object' && 'default' in _hashSet ? _hashSet['default'] : _hashSet);

    var eq = __commonjs(function (module) {
    /**
     * Performs a [`SameValueZero`](http://ecma-international.org/ecma-262/6.0/#sec-samevaluezero)
     * comparison between two values to determine if they are equivalent.
     *
     * @static
     * @memberOf _
     * @category Lang
     * @param {*} value The value to compare.
     * @param {*} other The other value to compare.
     * @returns {boolean} Returns `true` if the values are equivalent, else `false`.
     * @example
     *
     * var object = { 'user': 'fred' };
     * var other = { 'user': 'fred' };
     *
     * _.eq(object, object);
     * // => true
     *
     * _.eq(object, other);
     * // => false
     *
     * _.eq('a', 'a');
     * // => true
     *
     * _.eq('a', Object('a'));
     * // => false
     *
     * _.eq(NaN, NaN);
     * // => true
     */
    function eq(value, other) {
      return value === other || (value !== value && other !== other);
    }

    module.exports = eq;
    });

    var require$$0$16 = (eq && typeof eq === 'object' && 'default' in eq ? eq['default'] : eq);

    var _assocIndexOf = __commonjs(function (module) {
    var eq = require$$0$16;

    /**
     * Gets the index at which the first occurrence of `key` is found in `array`
     * of key-value pairs.
     *
     * @private
     * @param {Array} array The array to search.
     * @param {*} key The key to search for.
     * @returns {number} Returns the index of the matched value, else `-1`.
     */
    function assocIndexOf(array, key) {
      var length = array.length;
      while (length--) {
        if (eq(array[length][0], key)) {
          return length;
        }
      }
      return -1;
    }

    module.exports = assocIndexOf;
    });

    var require$$0$15 = (_assocIndexOf && typeof _assocIndexOf === 'object' && 'default' in _assocIndexOf ? _assocIndexOf['default'] : _assocIndexOf);

    var _assocSet = __commonjs(function (module) {
    var assocIndexOf = require$$0$15;

    /**
     * Sets the associative array `key` to `value`.
     *
     * @private
     * @param {Array} array The array to modify.
     * @param {string} key The key of the value to set.
     * @param {*} value The value to set.
     */
    function assocSet(array, key, value) {
      var index = assocIndexOf(array, key);
      if (index < 0) {
        array.push([key, value]);
      } else {
        array[index][1] = value;
      }
    }

    module.exports = assocSet;
    });

    var require$$0$14 = (_assocSet && typeof _assocSet === 'object' && 'default' in _assocSet ? _assocSet['default'] : _assocSet);

    var _checkGlobal = __commonjs(function (module) {
    /**
     * Checks if `value` is a global object.
     *
     * @private
     * @param {*} value The value to check.
     * @returns {null|Object} Returns `value` if it's a global object, else `null`.
     */
    function checkGlobal(value) {
      return (value && value.Object === Object) ? value : null;
    }

    module.exports = checkGlobal;
    });

    var require$$0$18 = (_checkGlobal && typeof _checkGlobal === 'object' && 'default' in _checkGlobal ? _checkGlobal['default'] : _checkGlobal);

    var _root = __commonjs(function (module, exports, global) {
    var checkGlobal = require$$0$18;

    /** Used to determine if values are of the language type `Object`. */
    var objectTypes = {
      'function': true,
      'object': true
    };

    /** Detect free variable `exports`. */
    var freeExports = (objectTypes[typeof exports] && exports && !exports.nodeType)
      ? exports
      : undefined;

    /** Detect free variable `module`. */
    var freeModule = (objectTypes[typeof module] && module && !module.nodeType)
      ? module
      : undefined;

    /** Detect free variable `global` from Node.js. */
    var freeGlobal = checkGlobal(freeExports && freeModule && typeof global == 'object' && global);

    /** Detect free variable `self`. */
    var freeSelf = checkGlobal(objectTypes[typeof self] && self);

    /** Detect free variable `window`. */
    var freeWindow = checkGlobal(objectTypes[typeof window] && window);

    /** Detect `this` as the global object. */
    var thisGlobal = checkGlobal(objectTypes[typeof __commonjs_global] && __commonjs_global);

    /**
     * Used as a reference to the global object.
     *
     * The `this` value is used if it's the global object to avoid Greasemonkey's
     * restricted `window` object, otherwise the `window` object is used.
     */
    var root = freeGlobal ||
      ((freeWindow !== (thisGlobal && thisGlobal.window)) && freeWindow) ||
        freeSelf || thisGlobal || Function('return this')();

    module.exports = root;
    });

    var require$$0$17 = (_root && typeof _root === 'object' && 'default' in _root ? _root['default'] : _root);

    var _Map = __commonjs(function (module) {
    var getNative = require$$1$5,
        root = require$$0$17;

    /* Built-in method references that are verified to be native. */
    var Map = getNative(root, 'Map');

    module.exports = Map;
    });

    var require$$2$3 = (_Map && typeof _Map === 'object' && 'default' in _Map ? _Map['default'] : _Map);

    var _mapSet = __commonjs(function (module) {
    var Map = require$$2$3,
        assocSet = require$$0$14,
        hashSet = require$$1$4,
        isKeyable = require$$0$7;

    /**
     * Sets the map `key` to `value`.
     *
     * @private
     * @name set
     * @memberOf MapCache
     * @param {string} key The key of the value to set.
     * @param {*} value The value to set.
     * @returns {Object} Returns the map cache object.
     */
    function mapSet(key, value) {
      var data = this.__data__;
      if (isKeyable(key)) {
        hashSet(typeof key == 'string' ? data.string : data.hash, key, value);
      } else if (Map) {
        data.map.set(key, value);
      } else {
        assocSet(data.map, key, value);
      }
      return this;
    }

    module.exports = mapSet;
    });

    var require$$0$11 = (_mapSet && typeof _mapSet === 'object' && 'default' in _mapSet ? _mapSet['default'] : _mapSet);

    var _hashHas = __commonjs(function (module) {
    var nativeCreate = require$$0$12;

    /** Used for built-in method references. */
    var objectProto = Object.prototype;

    /** Used to check objects for own properties. */
    var hasOwnProperty = objectProto.hasOwnProperty;

    /**
     * Checks if a hash value for `key` exists.
     *
     * @private
     * @param {Object} hash The hash to query.
     * @param {string} key The key of the entry to check.
     * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
     */
    function hashHas(hash, key) {
      return nativeCreate ? hash[key] !== undefined : hasOwnProperty.call(hash, key);
    }

    module.exports = hashHas;
    });

    var require$$0$19 = (_hashHas && typeof _hashHas === 'object' && 'default' in _hashHas ? _hashHas['default'] : _hashHas);

    var _assocHas = __commonjs(function (module) {
    var assocIndexOf = require$$0$15;

    /**
     * Checks if an associative array value for `key` exists.
     *
     * @private
     * @param {Array} array The array to query.
     * @param {string} key The key of the entry to check.
     * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
     */
    function assocHas(array, key) {
      return assocIndexOf(array, key) > -1;
    }

    module.exports = assocHas;
    });

    var require$$0$20 = (_assocHas && typeof _assocHas === 'object' && 'default' in _assocHas ? _assocHas['default'] : _assocHas);

    var _mapHas = __commonjs(function (module) {
    var Map = require$$2$3,
        assocHas = require$$0$20,
        hashHas = require$$0$19,
        isKeyable = require$$0$7;

    /**
     * Checks if a map value for `key` exists.
     *
     * @private
     * @name has
     * @memberOf MapCache
     * @param {string} key The key of the entry to check.
     * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
     */
    function mapHas(key) {
      var data = this.__data__;
      if (isKeyable(key)) {
        return hashHas(typeof key == 'string' ? data.string : data.hash, key);
      }
      return Map ? data.map.has(key) : assocHas(data.map, key);
    }

    module.exports = mapHas;
    });

    var require$$1$7 = (_mapHas && typeof _mapHas === 'object' && 'default' in _mapHas ? _mapHas['default'] : _mapHas);

    var _hashGet = __commonjs(function (module) {
    var nativeCreate = require$$0$12;

    /** Used to stand-in for `undefined` hash values. */
    var HASH_UNDEFINED = '__lodash_hash_undefined__';

    /** Used for built-in method references. */
    var objectProto = Object.prototype;

    /** Used to check objects for own properties. */
    var hasOwnProperty = objectProto.hasOwnProperty;

    /**
     * Gets the hash value for `key`.
     *
     * @private
     * @param {Object} hash The hash to query.
     * @param {string} key The key of the value to get.
     * @returns {*} Returns the entry value.
     */
    function hashGet(hash, key) {
      if (nativeCreate) {
        var result = hash[key];
        return result === HASH_UNDEFINED ? undefined : result;
      }
      return hasOwnProperty.call(hash, key) ? hash[key] : undefined;
    }

    module.exports = hashGet;
    });

    var require$$1$8 = (_hashGet && typeof _hashGet === 'object' && 'default' in _hashGet ? _hashGet['default'] : _hashGet);

    var _assocGet = __commonjs(function (module) {
    var assocIndexOf = require$$0$15;

    /**
     * Gets the associative array value for `key`.
     *
     * @private
     * @param {Array} array The array to query.
     * @param {string} key The key of the value to get.
     * @returns {*} Returns the entry value.
     */
    function assocGet(array, key) {
      var index = assocIndexOf(array, key);
      return index < 0 ? undefined : array[index][1];
    }

    module.exports = assocGet;
    });

    var require$$0$21 = (_assocGet && typeof _assocGet === 'object' && 'default' in _assocGet ? _assocGet['default'] : _assocGet);

    var _mapGet = __commonjs(function (module) {
    var Map = require$$2$3,
        assocGet = require$$0$21,
        hashGet = require$$1$8,
        isKeyable = require$$0$7;

    /**
     * Gets the map value for `key`.
     *
     * @private
     * @name get
     * @memberOf MapCache
     * @param {string} key The key of the value to get.
     * @returns {*} Returns the entry value.
     */
    function mapGet(key) {
      var data = this.__data__;
      if (isKeyable(key)) {
        return hashGet(typeof key == 'string' ? data.string : data.hash, key);
      }
      return Map ? data.map.get(key) : assocGet(data.map, key);
    }

    module.exports = mapGet;
    });

    var require$$2$4 = (_mapGet && typeof _mapGet === 'object' && 'default' in _mapGet ? _mapGet['default'] : _mapGet);

    var _hashDelete = __commonjs(function (module) {
    var hashHas = require$$0$19;

    /**
     * Removes `key` and its value from the hash.
     *
     * @private
     * @param {Object} hash The hash to modify.
     * @param {string} key The key of the value to remove.
     * @returns {boolean} Returns `true` if the entry was removed, else `false`.
     */
    function hashDelete(hash, key) {
      return hashHas(hash, key) && delete hash[key];
    }

    module.exports = hashDelete;
    });

    var require$$1$9 = (_hashDelete && typeof _hashDelete === 'object' && 'default' in _hashDelete ? _hashDelete['default'] : _hashDelete);

    var _assocDelete = __commonjs(function (module) {
    var assocIndexOf = require$$0$15;

    /** Used for built-in method references. */
    var arrayProto = Array.prototype;

    /** Built-in value references. */
    var splice = arrayProto.splice;

    /**
     * Removes `key` and its value from the associative array.
     *
     * @private
     * @param {Array} array The array to query.
     * @param {string} key The key of the value to remove.
     * @returns {boolean} Returns `true` if the entry was removed, else `false`.
     */
    function assocDelete(array, key) {
      var index = assocIndexOf(array, key);
      if (index < 0) {
        return false;
      }
      var lastIndex = array.length - 1;
      if (index == lastIndex) {
        array.pop();
      } else {
        splice.call(array, index, 1);
      }
      return true;
    }

    module.exports = assocDelete;
    });

    var require$$0$22 = (_assocDelete && typeof _assocDelete === 'object' && 'default' in _assocDelete ? _assocDelete['default'] : _assocDelete);

    var _mapDelete = __commonjs(function (module) {
    var Map = require$$2$3,
        assocDelete = require$$0$22,
        hashDelete = require$$1$9,
        isKeyable = require$$0$7;

    /**
     * Removes `key` and its value from the map.
     *
     * @private
     * @name delete
     * @memberOf MapCache
     * @param {string} key The key of the value to remove.
     * @returns {boolean} Returns `true` if the entry was removed, else `false`.
     */
    function mapDelete(key) {
      var data = this.__data__;
      if (isKeyable(key)) {
        return hashDelete(typeof key == 'string' ? data.string : data.hash, key);
      }
      return Map ? data.map['delete'](key) : assocDelete(data.map, key);
    }

    module.exports = mapDelete;
    });

    var require$$3$1 = (_mapDelete && typeof _mapDelete === 'object' && 'default' in _mapDelete ? _mapDelete['default'] : _mapDelete);

    var _Hash = __commonjs(function (module) {
    var nativeCreate = require$$0$12;

    /** Used for built-in method references. */
    var objectProto = Object.prototype;

    /**
     * Creates an hash object.
     *
     * @private
     * @constructor
     * @returns {Object} Returns the new hash object.
     */
    function Hash() {}

    // Avoid inheriting from `Object.prototype` when possible.
    Hash.prototype = nativeCreate ? nativeCreate(null) : objectProto;

    module.exports = Hash;
    });

    var require$$1$10 = (_Hash && typeof _Hash === 'object' && 'default' in _Hash ? _Hash['default'] : _Hash);

    var _mapClear = __commonjs(function (module) {
    var Hash = require$$1$10,
        Map = require$$2$3;

    /**
     * Removes all key-value entries from the map.
     *
     * @private
     * @name clear
     * @memberOf MapCache
     */
    function mapClear() {
      this.__data__ = {
        'hash': new Hash,
        'map': Map ? new Map : [],
        'string': new Hash
      };
    }

    module.exports = mapClear;
    });

    var require$$4$3 = (_mapClear && typeof _mapClear === 'object' && 'default' in _mapClear ? _mapClear['default'] : _mapClear);

    var _MapCache = __commonjs(function (module) {
    var mapClear = require$$4$3,
        mapDelete = require$$3$1,
        mapGet = require$$2$4,
        mapHas = require$$1$7,
        mapSet = require$$0$11;

    /**
     * Creates a map cache object to store key-value pairs.
     *
     * @private
     * @constructor
     * @param {Array} [values] The values to cache.
     */
    function MapCache(values) {
      var index = -1,
          length = values ? values.length : 0;

      this.clear();
      while (++index < length) {
        var entry = values[index];
        this.set(entry[0], entry[1]);
      }
    }

    // Add functions to the `MapCache`.
    MapCache.prototype.clear = mapClear;
    MapCache.prototype['delete'] = mapDelete;
    MapCache.prototype.get = mapGet;
    MapCache.prototype.has = mapHas;
    MapCache.prototype.set = mapSet;

    module.exports = MapCache;
    });

    var require$$1$3 = (_MapCache && typeof _MapCache === 'object' && 'default' in _MapCache ? _MapCache['default'] : _MapCache);

    var _SetCache = __commonjs(function (module) {
    var MapCache = require$$1$3,
        cachePush = require$$0$10;

    /**
     *
     * Creates a set cache object to store unique values.
     *
     * @private
     * @constructor
     * @param {Array} [values] The values to cache.
     */
    function SetCache(values) {
      var index = -1,
          length = values ? values.length : 0;

      this.__data__ = new MapCache;
      while (++index < length) {
        this.push(values[index]);
      }
    }

    // Add functions to the `SetCache`.
    SetCache.prototype.push = cachePush;

    module.exports = SetCache;
    });

    var require$$5 = (_SetCache && typeof _SetCache === 'object' && 'default' in _SetCache ? _SetCache['default'] : _SetCache);

    var _baseDifference = __commonjs(function (module) {
    var SetCache = require$$5,
        arrayIncludes = require$$4$1,
        arrayIncludesWith = require$$3,
        arrayMap = require$$0$8,
        baseUnary = require$$1$2,
        cacheHas = require$$0$6;

    /** Used as the size to enable large array optimizations. */
    var LARGE_ARRAY_SIZE = 200;

    /**
     * The base implementation of methods like `_.difference` without support for
     * excluding multiple arrays or iteratee shorthands.
     *
     * @private
     * @param {Array} array The array to inspect.
     * @param {Array} values The values to exclude.
     * @param {Function} [iteratee] The iteratee invoked per element.
     * @param {Function} [comparator] The comparator invoked per element.
     * @returns {Array} Returns the new array of filtered values.
     */
    function baseDifference(array, values, iteratee, comparator) {
      var index = -1,
          includes = arrayIncludes,
          isCommon = true,
          length = array.length,
          result = [],
          valuesLength = values.length;

      if (!length) {
        return result;
      }
      if (iteratee) {
        values = arrayMap(values, baseUnary(iteratee));
      }
      if (comparator) {
        includes = arrayIncludesWith;
        isCommon = false;
      }
      else if (values.length >= LARGE_ARRAY_SIZE) {
        includes = cacheHas;
        isCommon = false;
        values = new SetCache(values);
      }
      outer:
      while (++index < length) {
        var value = array[index],
            computed = iteratee ? iteratee(value) : value;

        if (isCommon && computed === computed) {
          var valuesIndex = valuesLength;
          while (valuesIndex--) {
            if (values[valuesIndex] === computed) {
              continue outer;
            }
          }
          result.push(value);
        }
        else if (!includes(values, computed, comparator)) {
          result.push(value);
        }
      }
      return result;
    }

    module.exports = baseDifference;
    });

    var require$$2$2 = (_baseDifference && typeof _baseDifference === 'object' && 'default' in _baseDifference ? _baseDifference['default'] : _baseDifference);

    var without = __commonjs(function (module) {
    var baseDifference = require$$2$2,
        isArrayLikeObject = require$$0$3,
        rest = require$$0;

    /**
     * Creates an array excluding all given values using
     * [`SameValueZero`](http://ecma-international.org/ecma-262/6.0/#sec-samevaluezero)
     * for equality comparisons.
     *
     * @static
     * @memberOf _
     * @category Array
     * @param {Array} array The array to filter.
     * @param {...*} [values] The values to exclude.
     * @returns {Array} Returns the new array of filtered values.
     * @example
     *
     * _.without([1, 2, 1, 3], 1, 2);
     * // => [3]
     */
    var without = rest(function(array, values) {
      return isArrayLikeObject(array)
        ? baseDifference(array, values)
        : [];
    });

    module.exports = without;
    });

    var _default5 = (without && typeof without === 'object' && 'default' in without ? without['default'] : without);

    var isArray = __commonjs(function (module) {
    /**
     * Checks if `value` is classified as an `Array` object.
     *
     * @static
     * @memberOf _
     * @type {Function}
     * @category Lang
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is correctly classified, else `false`.
     * @example
     *
     * _.isArray([1, 2, 3]);
     * // => true
     *
     * _.isArray(document.body.children);
     * // => false
     *
     * _.isArray('abc');
     * // => false
     *
     * _.isArray(_.noop);
     * // => false
     */
    var isArray = Array.isArray;

    module.exports = isArray;
    });

    var require$$2$5 = (isArray && typeof isArray === 'object' && 'default' in isArray ? isArray['default'] : isArray);

    var _createBaseEach = __commonjs(function (module) {
    var isArrayLike = require$$0$5;

    /**
     * Creates a `baseEach` or `baseEachRight` function.
     *
     * @private
     * @param {Function} eachFunc The function to iterate over a collection.
     * @param {boolean} [fromRight] Specify iterating from right to left.
     * @returns {Function} Returns the new base function.
     */
    function createBaseEach(eachFunc, fromRight) {
      return function(collection, iteratee) {
        if (collection == null) {
          return collection;
        }
        if (!isArrayLike(collection)) {
          return eachFunc(collection, iteratee);
        }
        var length = collection.length,
            index = fromRight ? length : -1,
            iterable = Object(collection);

        while ((fromRight ? index-- : ++index < length)) {
          if (iteratee(iterable[index], index, iterable) === false) {
            break;
          }
        }
        return collection;
      };
    }

    module.exports = createBaseEach;
    });

    var require$$0$23 = (_createBaseEach && typeof _createBaseEach === 'object' && 'default' in _createBaseEach ? _createBaseEach['default'] : _createBaseEach);

    var _isPrototype = __commonjs(function (module) {
    var isFunction = _default2;

    /** Used for built-in method references. */
    var objectProto = Object.prototype;

    /**
     * Checks if `value` is likely a prototype object.
     *
     * @private
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is a prototype, else `false`.
     */
    function isPrototype(value) {
      var Ctor = value && value.constructor,
          proto = (isFunction(Ctor) && Ctor.prototype) || objectProto;

      return value === proto;
    }

    module.exports = isPrototype;
    });

    var require$$0$25 = (_isPrototype && typeof _isPrototype === 'object' && 'default' in _isPrototype ? _isPrototype['default'] : _isPrototype);

    var _isIndex = __commonjs(function (module) {
    /** Used as references for various `Number` constants. */
    var MAX_SAFE_INTEGER = 9007199254740991;

    /** Used to detect unsigned integer values. */
    var reIsUint = /^(?:0|[1-9]\d*)$/;

    /**
     * Checks if `value` is a valid array-like index.
     *
     * @private
     * @param {*} value The value to check.
     * @param {number} [length=MAX_SAFE_INTEGER] The upper bounds of a valid index.
     * @returns {boolean} Returns `true` if `value` is a valid index, else `false`.
     */
    function isIndex(value, length) {
      value = (typeof value == 'number' || reIsUint.test(value)) ? +value : -1;
      length = length == null ? MAX_SAFE_INTEGER : length;
      return value > -1 && value % 1 == 0 && value < length;
    }

    module.exports = isIndex;
    });

    var require$$1$13 = (_isIndex && typeof _isIndex === 'object' && 'default' in _isIndex ? _isIndex['default'] : _isIndex);

    var isString = __commonjs(function (module) {
    var isArray = require$$2$5,
        isObjectLike = require$$0$4;

    /** `Object#toString` result references. */
    var stringTag = '[object String]';

    /** Used for built-in method references. */
    var objectProto = Object.prototype;

    /**
     * Used to resolve the [`toStringTag`](http://ecma-international.org/ecma-262/6.0/#sec-object.prototype.tostring)
     * of values.
     */
    var objectToString = objectProto.toString;

    /**
     * Checks if `value` is classified as a `String` primitive or object.
     *
     * @static
     * @memberOf _
     * @category Lang
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is correctly classified, else `false`.
     * @example
     *
     * _.isString('abc');
     * // => true
     *
     * _.isString(1);
     * // => false
     */
    function isString(value) {
      return typeof value == 'string' ||
        (!isArray(value) && isObjectLike(value) && objectToString.call(value) == stringTag);
    }

    module.exports = isString;
    });

    var _default3 = (isString && typeof isString === 'object' && 'default' in isString ? isString['default'] : isString);

    var isArguments = __commonjs(function (module) {
    var isArrayLikeObject = require$$0$3;

    /** `Object#toString` result references. */
    var argsTag = '[object Arguments]';

    /** Used for built-in method references. */
    var objectProto = Object.prototype;

    /** Used to check objects for own properties. */
    var hasOwnProperty = objectProto.hasOwnProperty;

    /**
     * Used to resolve the [`toStringTag`](http://ecma-international.org/ecma-262/6.0/#sec-object.prototype.tostring)
     * of values.
     */
    var objectToString = objectProto.toString;

    /** Built-in value references. */
    var propertyIsEnumerable = objectProto.propertyIsEnumerable;

    /**
     * Checks if `value` is likely an `arguments` object.
     *
     * @static
     * @memberOf _
     * @category Lang
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is correctly classified, else `false`.
     * @example
     *
     * _.isArguments(function() { return arguments; }());
     * // => true
     *
     * _.isArguments([1, 2, 3]);
     * // => false
     */
    function isArguments(value) {
      // Safari 8.1 incorrectly makes `arguments.callee` enumerable in strict mode.
      return isArrayLikeObject(value) && hasOwnProperty.call(value, 'callee') &&
        (!propertyIsEnumerable.call(value, 'callee') || objectToString.call(value) == argsTag);
    }

    module.exports = isArguments;
    });

    var require$$2$6 = (isArguments && typeof isArguments === 'object' && 'default' in isArguments ? isArguments['default'] : isArguments);

    var _baseTimes = __commonjs(function (module) {
    /**
     * The base implementation of `_.times` without support for iteratee shorthands
     * or max array length checks.
     *
     * @private
     * @param {number} n The number of times to invoke `iteratee`.
     * @param {Function} iteratee The function invoked per iteration.
     * @returns {Array} Returns the array of results.
     */
    function baseTimes(n, iteratee) {
      var index = -1,
          result = Array(n);

      while (++index < n) {
        result[index] = iteratee(index);
      }
      return result;
    }

    module.exports = baseTimes;
    });

    var require$$4$4 = (_baseTimes && typeof _baseTimes === 'object' && 'default' in _baseTimes ? _baseTimes['default'] : _baseTimes);

    var _indexKeys = __commonjs(function (module) {
    var baseTimes = require$$4$4,
        isArguments = require$$2$6,
        isArray = require$$2$5,
        isLength = require$$1$1,
        isString = _default3;

    /**
     * Creates an array of index keys for `object` values of arrays,
     * `arguments` objects, and strings, otherwise `null` is returned.
     *
     * @private
     * @param {Object} object The object to query.
     * @returns {Array|null} Returns index keys, else `null`.
     */
    function indexKeys(object) {
      var length = object ? object.length : undefined;
      if (isLength(length) &&
          (isArray(object) || isString(object) || isArguments(object))) {
        return baseTimes(length, String);
      }
      return null;
    }

    module.exports = indexKeys;
    });

    var require$$3$2 = (_indexKeys && typeof _indexKeys === 'object' && 'default' in _indexKeys ? _indexKeys['default'] : _indexKeys);

    var _baseKeys = __commonjs(function (module) {
    /* Built-in method references for those with the same name as other `lodash` methods. */
    var nativeKeys = Object.keys;

    /**
     * The base implementation of `_.keys` which doesn't skip the constructor
     * property of prototypes or treat sparse arrays as dense.
     *
     * @private
     * @param {Object} object The object to query.
     * @returns {Array} Returns the array of property names.
     */
    function baseKeys(object) {
      return nativeKeys(Object(object));
    }

    module.exports = baseKeys;
    });

    var require$$4$5 = (_baseKeys && typeof _baseKeys === 'object' && 'default' in _baseKeys ? _baseKeys['default'] : _baseKeys);

    var _baseHas = __commonjs(function (module) {
    /** Used for built-in method references. */
    var objectProto = Object.prototype;

    /** Used to check objects for own properties. */
    var hasOwnProperty = objectProto.hasOwnProperty;

    /** Built-in value references. */
    var getPrototypeOf = Object.getPrototypeOf;

    /**
     * The base implementation of `_.has` without support for deep paths.
     *
     * @private
     * @param {Object} object The object to query.
     * @param {Array|string} key The key to check.
     * @returns {boolean} Returns `true` if `key` exists, else `false`.
     */
    function baseHas(object, key) {
      // Avoid a bug in IE 10-11 where objects with a [[Prototype]] of `null`,
      // that are composed entirely of index properties, return `false` for
      // `hasOwnProperty` checks of them.
      return hasOwnProperty.call(object, key) ||
        (typeof object == 'object' && key in object && getPrototypeOf(object) === null);
    }

    module.exports = baseHas;
    });

    var require$$1$14 = (_baseHas && typeof _baseHas === 'object' && 'default' in _baseHas ? _baseHas['default'] : _baseHas);

    var keys = __commonjs(function (module) {
    var baseHas = require$$1$14,
        baseKeys = require$$4$5,
        indexKeys = require$$3$2,
        isArrayLike = require$$0$5,
        isIndex = require$$1$13,
        isPrototype = require$$0$25;

    /**
     * Creates an array of the own enumerable property names of `object`.
     *
     * **Note:** Non-object values are coerced to objects. See the
     * [ES spec](http://ecma-international.org/ecma-262/6.0/#sec-object.keys)
     * for more details.
     *
     * @static
     * @memberOf _
     * @category Object
     * @param {Object} object The object to query.
     * @returns {Array} Returns the array of property names.
     * @example
     *
     * function Foo() {
     *   this.a = 1;
     *   this.b = 2;
     * }
     *
     * Foo.prototype.c = 3;
     *
     * _.keys(new Foo);
     * // => ['a', 'b'] (iteration order is not guaranteed)
     *
     * _.keys('hi');
     * // => ['0', '1']
     */
    function keys(object) {
      var isProto = isPrototype(object);
      if (!(isProto || isArrayLike(object))) {
        return baseKeys(object);
      }
      var indexes = indexKeys(object),
          skipIndexes = !!indexes,
          result = indexes || [],
          length = result.length;

      for (var key in object) {
        if (baseHas(object, key) &&
            !(skipIndexes && (key == 'length' || isIndex(key, length))) &&
            !(isProto && key == 'constructor')) {
          result.push(key);
        }
      }
      return result;
    }

    module.exports = keys;
    });

    var require$$0$24 = (keys && typeof keys === 'object' && 'default' in keys ? keys['default'] : keys);

    var _createBaseFor = __commonjs(function (module) {
    /**
     * Creates a base function for methods like `_.forIn`.
     *
     * @private
     * @param {boolean} [fromRight] Specify iterating from right to left.
     * @returns {Function} Returns the new base function.
     */
    function createBaseFor(fromRight) {
      return function(object, iteratee, keysFunc) {
        var index = -1,
            iterable = Object(object),
            props = keysFunc(object),
            length = props.length;

        while (length--) {
          var key = props[fromRight ? length : ++index];
          if (iteratee(iterable[key], key, iterable) === false) {
            break;
          }
        }
        return object;
      };
    }

    module.exports = createBaseFor;
    });

    var require$$0$26 = (_createBaseFor && typeof _createBaseFor === 'object' && 'default' in _createBaseFor ? _createBaseFor['default'] : _createBaseFor);

    var _baseFor = __commonjs(function (module) {
    var createBaseFor = require$$0$26;

    /**
     * The base implementation of `baseForIn` and `baseForOwn` which iterates
     * over `object` properties returned by `keysFunc` invoking `iteratee` for
     * each property. Iteratee functions may exit iteration early by explicitly
     * returning `false`.
     *
     * @private
     * @param {Object} object The object to iterate over.
     * @param {Function} iteratee The function invoked per iteration.
     * @param {Function} keysFunc The function to get the keys of `object`.
     * @returns {Object} Returns `object`.
     */
    var baseFor = createBaseFor();

    module.exports = baseFor;
    });

    var require$$1$15 = (_baseFor && typeof _baseFor === 'object' && 'default' in _baseFor ? _baseFor['default'] : _baseFor);

    var _baseForOwn = __commonjs(function (module) {
    var baseFor = require$$1$15,
        keys = require$$0$24;

    /**
     * The base implementation of `_.forOwn` without support for iteratee shorthands.
     *
     * @private
     * @param {Object} object The object to iterate over.
     * @param {Function} iteratee The function invoked per iteration.
     * @returns {Object} Returns `object`.
     */
    function baseForOwn(object, iteratee) {
      return object && baseFor(object, iteratee, keys);
    }

    module.exports = baseForOwn;
    });

    var require$$1$12 = (_baseForOwn && typeof _baseForOwn === 'object' && 'default' in _baseForOwn ? _baseForOwn['default'] : _baseForOwn);

    var _baseEach = __commonjs(function (module) {
    var baseForOwn = require$$1$12,
        createBaseEach = require$$0$23;

    /**
     * The base implementation of `_.forEach` without support for iteratee shorthands.
     *
     * @private
     * @param {Array|Object} collection The collection to iterate over.
     * @param {Function} iteratee The function invoked per iteration.
     * @returns {Array|Object} Returns `collection`.
     */
    var baseEach = createBaseEach(baseForOwn);

    module.exports = baseEach;
    });

    var require$$1$11 = (_baseEach && typeof _baseEach === 'object' && 'default' in _baseEach ? _baseEach['default'] : _baseEach);

    var identity = __commonjs(function (module) {
    /**
     * This method returns the first argument given to it.
     *
     * @static
     * @memberOf _
     * @category Util
     * @param {*} value Any value.
     * @returns {*} Returns `value`.
     * @example
     *
     * var object = { 'user': 'fred' };
     *
     * _.identity(object) === object;
     * // => true
     */
    function identity(value) {
      return value;
    }

    module.exports = identity;
    });

    var require$$2$8 = (identity && typeof identity === 'object' && 'default' in identity ? identity['default'] : identity);

    var _baseCastFunction = __commonjs(function (module) {
    var identity = require$$2$8;

    /**
     * Casts `value` to `identity` if it's not a function.
     *
     * @private
     * @param {*} value The value to inspect.
     * @returns {Array} Returns the array-like object.
     */
    function baseCastFunction(value) {
      return typeof value == 'function' ? value : identity;
    }

    module.exports = baseCastFunction;
    });

    var require$$2$7 = (_baseCastFunction && typeof _baseCastFunction === 'object' && 'default' in _baseCastFunction ? _baseCastFunction['default'] : _baseCastFunction);

    var _arrayEach = __commonjs(function (module) {
    /**
     * A specialized version of `_.forEach` for arrays without support for
     * iteratee shorthands.
     *
     * @private
     * @param {Array} array The array to iterate over.
     * @param {Function} iteratee The function invoked per iteration.
     * @returns {Array} Returns `array`.
     */
    function arrayEach(array, iteratee) {
      var index = -1,
          length = array.length;

      while (++index < length) {
        if (iteratee(array[index], index, array) === false) {
          break;
        }
      }
      return array;
    }

    module.exports = arrayEach;
    });

    var require$$3$3 = (_arrayEach && typeof _arrayEach === 'object' && 'default' in _arrayEach ? _arrayEach['default'] : _arrayEach);

    var forEach = __commonjs(function (module) {
    var arrayEach = require$$3$3,
        baseCastFunction = require$$2$7,
        baseEach = require$$1$11,
        isArray = require$$2$5;

    /**
     * Iterates over elements of `collection` invoking `iteratee` for each element.
     * The iteratee is invoked with three arguments: (value, index|key, collection).
     * Iteratee functions may exit iteration early by explicitly returning `false`.
     *
     * **Note:** As with other "Collections" methods, objects with a "length" property
     * are iterated like arrays. To avoid this behavior use `_.forIn` or `_.forOwn`
     * for object iteration.
     *
     * @static
     * @memberOf _
     * @alias each
     * @category Collection
     * @param {Array|Object} collection The collection to iterate over.
     * @param {Function} [iteratee=_.identity] The function invoked per iteration.
     * @returns {Array|Object} Returns `collection`.
     * @example
     *
     * _([1, 2]).forEach(function(value) {
     *   console.log(value);
     * });
     * // => logs `1` then `2`
     *
     * _.forEach({ 'a': 1, 'b': 2 }, function(value, key) {
     *   console.log(key);
     * });
     * // => logs 'a' then 'b' (iteration order is not guaranteed)
     */
    function forEach(collection, iteratee) {
      return (typeof iteratee == 'function' && isArray(collection))
        ? arrayEach(collection, iteratee)
        : baseEach(collection, baseCastFunction(iteratee));
    }

    module.exports = forEach;
    });

    var _default = (forEach && typeof forEach === 'object' && 'default' in forEach ? forEach['default'] : forEach);

    /**
     * Copyright 2015 The Incremental DOM Authors. All Rights Reserved.
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     *      http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS-IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */


    /**
     * A cached reference to the hasOwnProperty function.
     */
    var hasOwnProperty = Object.prototype.hasOwnProperty;


    /**
     * A cached reference to the create function.
     */
    var create = Object.create;


    /**
     * Used to prevent property collisions between our "map" and its prototype.
     * @param {!Object<string, *>} map The map to check.
     * @param {string} property The property to check.
     * @return {boolean} Whether map has property.
     */
    var has = function(map, property) {
      return hasOwnProperty.call(map, property);
    };


    /**
     * Creates an map object without a prototype.
     * @return {!Object}
     */
    var createMap = function() {
      return create(null);
    };

    /**
     * Keeps track of information needed to perform diffs for a given DOM node.
     * @param {!string} nodeName
     * @param {?string=} key
     * @constructor
     */
    function NodeData(nodeName, key) {
      /**
       * The attributes and their values.
       * @const {!Object<string, *>}
       */
      this.attrs = createMap();

      /**
       * An array of attribute name/value pairs, used for quickly diffing the
       * incomming attributes to see if the DOM node's attributes need to be
       * updated.
       * @const {Array<*>}
       */
      this.attrsArr = [];

      /**
       * The incoming attributes for this Node, before they are updated.
       * @const {!Object<string, *>}
       */
      this.newAttrs = createMap();

      /**
       * The key used to identify this node, used to preserve DOM nodes when they
       * move within their parent.
       * @const
       */
      this.key = key;

      /**
       * Keeps track of children within this node by their key.
       * {?Object<string, !Element>}
       */
      this.keyMap = null;

      /**
       * Whether or not the keyMap is currently valid.
       * {boolean}
       */
      this.keyMapValid = true;

      /**
       * The node name for this node.
       * @const {string}
       */
      this.nodeName = nodeName;

      /**
       * @type {?string}
       */
      this.text = null;
    }


    /**
     * Initializes a NodeData object for a Node.
     *
     * @param {Node} node The node to initialize data for.
     * @param {string} nodeName The node name of node.
     * @param {?string=} key The key that identifies the node.
     * @return {!NodeData} The newly initialized data object
     */
    var initData = function(node, nodeName, key) {
      var data = new NodeData(nodeName, key);
      node['__incrementalDOMData'] = data;
      return data;
    };


    /**
     * Retrieves the NodeData object for a Node, creating it if necessary.
     *
     * @param {Node} node The node to retrieve the data for.
     * @return {!NodeData} The NodeData for this Node.
     */
    var getData = function(node) {
      var data = node['__incrementalDOMData'];

      if (!data) {
        var nodeName = node.nodeName.toLowerCase();
        var key = null;

        if (node instanceof Element) {
          key = node.getAttribute('key');
        }

        data = initData(node, nodeName, key);
      }

      return data;
    };

    /**
     * Copyright 2015 The Incremental DOM Authors. All Rights Reserved.
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     *      http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS-IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */

    var symbols = {
      default: '__default',

      placeholder: '__placeholder'
    };

    /**
     * Applies an attribute or property to a given Element. If the value is null
     * or undefined, it is removed from the Element. Otherwise, the value is set
     * as an attribute.
     * @param {!Element} el
     * @param {string} name The attribute's name.
     * @param {?(boolean|number|string)=} value The attribute's value.
     */
    var applyAttr = function(el, name, value) {
      if (value == null) {
        el.removeAttribute(name);
      } else {
        el.setAttribute(name, value);
      }
    };

    /**
     * Applies a property to a given Element.
     * @param {!Element} el
     * @param {string} name The property's name.
     * @param {*} value The property's value.
     */
    var applyProp = function(el, name, value) {
      el[name] = value;
    };


    /**
     * Applies a style to an Element. No vendor prefix expansion is done for
     * property names/values.
     * @param {!Element} el
     * @param {string} name The attribute's name.
     * @param {*} style The style to set. Either a string of css or an object
     *     containing property-value pairs.
     */
    var applyStyle = function(el, name, style) {
      if (typeof style === 'string') {
        el.style.cssText = style;
      } else {
        el.style.cssText = '';
        var elStyle = el.style;
        var obj = /** @type {!Object<string,string>} */(style);

        for (var prop in obj) {
          if (has(obj, prop)) {
            elStyle[prop] = obj[prop];
          }
        }
      }
    };


    /**
     * Updates a single attribute on an Element.
     * @param {!Element} el
     * @param {string} name The attribute's name.
     * @param {*} value The attribute's value. If the value is an object or
     *     function it is set on the Element, otherwise, it is set as an HTML
     *     attribute.
     */
    var applyAttributeTyped = function(el, name, value) {
      var type = typeof value;

      if (type === 'object' || type === 'function') {
        applyProp(el, name, value);
      } else {
        applyAttr(el, name, /** @type {?(boolean|number|string)} */(value));
      }
    };


    /**
     * Calls the appropriate attribute mutator for this attribute.
     * @param {!Element} el
     * @param {string} name The attribute's name.
     * @param {*} value The attribute's value.
     */
    var updateAttribute = function(el, name, value) {
      var data = getData(el);
      var attrs = data.attrs;

      if (attrs[name] === value) {
        return;
      }

      var mutator = attributes[name] || attributes[symbols.default];
      mutator(el, name, value);

      attrs[name] = value;
    };


    /**
     * A publicly mutable object to provide custom mutators for attributes.
     * @const {!Object<string, function(!Element, string, *)>}
     */
    var attributes = createMap();

    // Special generic mutator that's called for any attribute that does not
    // have a specific mutator.
    attributes[symbols.default] = applyAttributeTyped;

    attributes[symbols.placeholder] = function() {};

    attributes['style'] = applyStyle;

    /**
     * Gets the namespace to create an element (of a given tag) in.
     * @param {string} tag The tag to get the namespace for.
     * @param {?Node} parent
     * @return {?string} The namespace to create the tag in.
     */
    var getNamespaceForTag = function(tag, parent) {
      if (tag === 'svg') {
        return 'http://www.w3.org/2000/svg';
      }

      if (getData(parent).nodeName === 'foreignObject') {
        return null;
      }

      return parent.namespaceURI;
    };


    /**
     * Creates an Element.
     * @param {Document} doc The document with which to create the Element.
     * @param {?Node} parent
     * @param {string} tag The tag for the Element.
     * @param {?string=} key A key to identify the Element.
     * @param {?Array<*>=} statics An array of attribute name/value pairs of the
     *     static attributes for the Element.
     * @return {!Element}
     */
    var createElement = function(doc, parent, tag, key, statics) {
      var namespace = getNamespaceForTag(tag, parent);
      var el;

      if (namespace) {
        el = doc.createElementNS(namespace, tag);
      } else {
        el = doc.createElement(tag);
      }

      initData(el, tag, key);

      if (statics) {
        for (var i = 0; i < statics.length; i += 2) {
          updateAttribute(el, /** @type {!string}*/(statics[i]), statics[i + 1]);
        }
      }

      return el;
    };


    /**
     * Creates a Text Node.
     * @param {Document} doc The document with which to create the Element.
     * @return {!Text}
     */
    var createText = function(doc) {
      var node = doc.createTextNode('');
      initData(node, '#text', null);
      return node;
    };


    /**
     * Creates a mapping that can be used to look up children using a key.
     * @param {?Node} el
     * @return {!Object<string, !Element>} A mapping of keys to the children of the
     *     Element.
     */
    var createKeyMap = function(el) {
      var map = createMap();
      var children = el.children;
      var count = children.length;

      for (var i = 0; i < count; i += 1) {
        var child = children[i];
        var key = getData(child).key;

        if (key) {
          map[key] = child;
        }
      }

      return map;
    };


    /**
     * Retrieves the mapping of key to child node for a given Element, creating it
     * if necessary.
     * @param {?Node} el
     * @return {!Object<string, !Node>} A mapping of keys to child Elements
     */
    var getKeyMap = function(el) {
      var data = getData(el);

      if (!data.keyMap) {
        data.keyMap = createKeyMap(el);
      }

      return data.keyMap;
    };


    /**
     * Retrieves a child from the parent with the given key.
     * @param {?Node} parent
     * @param {?string=} key
     * @return {?Node} The child corresponding to the key.
     */
    var getChild = function(parent, key) {
      return key ? getKeyMap(parent)[key] : null;
    };


    /**
     * Registers an element as being a child. The parent will keep track of the
     * child using the key. The child can be retrieved using the same key using
     * getKeyMap. The provided key should be unique within the parent Element.
     * @param {?Node} parent The parent of child.
     * @param {string} key A key to identify the child with.
     * @param {!Node} child The child to register.
     */
    var registerChild = function(parent, key, child) {
      getKeyMap(parent)[key] = child;
    };

    /**
     * Copyright 2015 The Incremental DOM Authors. All Rights Reserved.
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     *      http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS-IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */

    /** */
    var notifications = {
      /**
       * Called after patch has compleated with any Nodes that have been created
       * and added to the DOM.
       * @type {?function(Array<!Node>)}
       */
      nodesCreated: null,

      /**
       * Called after patch has compleated with any Nodes that have been removed
       * from the DOM.
       * Note it's an applications responsibility to handle any childNodes.
       * @type {?function(Array<!Node>)}
       */
      nodesDeleted: null
    };

    /**
     * Keeps track of the state of a patch.
     * @constructor
     */
    function Context() {
      /**
       * @type {(Array<!Node>|undefined)}
       */
      this.created = notifications.nodesCreated && [];

      /**
       * @type {(Array<!Node>|undefined)}
       */
      this.deleted = notifications.nodesDeleted && [];
    }


    /**
     * @param {!Node} node
     */
    Context.prototype.markCreated = function(node) {
      if (this.created) {
        this.created.push(node);
      }
    };


    /**
     * @param {!Node} node
     */
    Context.prototype.markDeleted = function(node) {
      if (this.deleted) {
        this.deleted.push(node);
      }
    };


    /**
     * Notifies about nodes that were created during the patch opearation.
     */
    Context.prototype.notifyChanges = function() {
      if (this.created && this.created.length > 0) {
        notifications.nodesCreated(this.created);
      }

      if (this.deleted && this.deleted.length > 0) {
        notifications.nodesDeleted(this.deleted);
      }
    };

    /**
    * Makes sure that keyed Element matches the tag name provided.
    * @param {!string} nodeName The nodeName of the node that is being matched.
    * @param {string=} tag The tag name of the Element.
    * @param {?string=} key The key of the Element.
    */
    var assertKeyedTagMatches = function(nodeName, tag, key) {
      if (nodeName !== tag) {
        throw new Error('Was expecting node with key "' + key + '" to be a ' +
            tag + ', not a ' + nodeName + '.');
      }
    };

    /** @type {?Context} */
    var context = null;

    /** @type {?Node} */
    var currentNode;

    /** @type {?Node} */
    var currentParent;

    /** @type {?Node} */
    var previousNode;

    /** @type {?Element|?DocumentFragment} */
    var root;

    /** @type {?Document} */
    var doc;


    /**
     * Patches the document starting at el with the provided function. This function
     * may be called during an existing patch operation.
     * @param {!Element|!DocumentFragment} node The Element or Document
     *     to patch.
     * @param {!function(T)} fn A function containing elementOpen/elementClose/etc.
     *     calls that describe the DOM.
     * @param {T=} data An argument passed to fn to represent DOM state.
     * @template T
     */
    var patch = function(node, fn, data) {
      var prevContext = context;
      var prevRoot = root;
      var prevDoc = doc;
      var prevCurrentNode = currentNode;
      var prevCurrentParent = currentParent;
      var prevPreviousNode = previousNode;
      var previousInAttributes = false;
      var previousInSkip = false;

      context = new Context();
      root = node;
      doc = node.ownerDocument;
      currentNode = node;
      currentParent = null;
      previousNode = null;

      if ("production" !== 'production') {}

      enterNode();
      fn(data);
      exitNode();

      if ("production" !== 'production') {}

      context.notifyChanges();

      context = prevContext;
      root = prevRoot;
      doc = prevDoc;
      currentNode = prevCurrentNode;
      currentParent = prevCurrentParent;
      previousNode = prevPreviousNode;
    };


    /**
     * Checks whether or not the current node matches the specified nodeName and
     * key.
     *
     * @param {?string} nodeName The nodeName for this node.
     * @param {?string=} key An optional key that identifies a node.
     * @return {boolean} True if the node matches, false otherwise.
     */
    var matches = function(nodeName, key) {
      var data = getData(currentNode);

      // Key check is done using double equals as we want to treat a null key the
      // same as undefined. This should be okay as the only values allowed are
      // strings, null and undefined so the == semantics are not too weird.
      return nodeName === data.nodeName && key == data.key;
    };


    /**
     * Aligns the virtual Element definition with the actual DOM, moving the
     * corresponding DOM node to the correct location or creating it if necessary.
     * @param {string} nodeName For an Element, this should be a valid tag string.
     *     For a Text, this should be #text.
     * @param {?string=} key The key used to identify this element.
     * @param {?Array<*>=} statics For an Element, this should be an array of
     *     name-value pairs.
     */
    var alignWithDOM = function(nodeName, key, statics) {
      if (currentNode && matches(nodeName, key)) {
        return;
      }

      var node;

      // Check to see if the node has moved within the parent.
      if (key) {
        node = getChild(currentParent, key);
        if (node && "production" !== 'production') {
          assertKeyedTagMatches(getData(node).nodeName, nodeName, key);
        }
      }

      // Create the node if it doesn't exist.
      if (!node) {
        if (nodeName === '#text') {
          node = createText(doc);
        } else {
          node = createElement(doc, currentParent, nodeName, key, statics);
        }

        if (key) {
          registerChild(currentParent, key, node);
        }

        context.markCreated(node);
      }

      // If the node has a key, remove it from the DOM to prevent a large number
      // of re-orders in the case that it moved far or was completely removed.
      // Since we hold on to a reference through the keyMap, we can always add it
      // back.
      if (currentNode && getData(currentNode).key) {
        currentParent.replaceChild(node, currentNode);
        getData(currentParent).keyMapValid = false;
      } else {
        currentParent.insertBefore(node, currentNode);
      }

      currentNode = node;
    };


    /**
     * Clears out any unvisited Nodes, as the corresponding virtual element
     * functions were never called for them.
     */
    var clearUnvisitedDOM = function() {
      var node = currentParent;
      var data = getData(node);
      var keyMap = data.keyMap;
      var keyMapValid = data.keyMapValid;
      var child = node.lastChild;
      var key;

      if (child === previousNode && keyMapValid) {
        return;
      }

      if (data.attrs[symbols.placeholder] && node !== root) {
        return;
      }

      while (child !== previousNode) {
        node.removeChild(child);
        context.markDeleted(/** @type {!Node}*/(child));

        key = getData(child).key;
        if (key) {
          delete keyMap[key];
        }
        child = node.lastChild;
      }

      // Clean the keyMap, removing any unusued keys.
      if (!keyMapValid) {
        for (key in keyMap) {
          child = keyMap[key];
          if (child.parentNode !== node) {
            context.markDeleted(child);
            delete keyMap[key];
          }
        }

        data.keyMapValid = true;
      }
    };


    /**
     * Changes to the first child of the current node.
     */
    var enterNode = function() {
      currentParent = currentNode;
      currentNode = currentNode.firstChild;
      previousNode = null;
    };


    /**
     * Changes to the next sibling of the current node.
     */
    var nextNode = function() {
      previousNode = currentNode;
      currentNode = currentNode.nextSibling;
    };


    /**
     * Changes to the parent of the current node, removing any unvisited children.
     */
    var exitNode = function() {
      clearUnvisitedDOM();

      previousNode = currentParent;
      currentNode = currentParent.nextSibling;
      currentParent = currentParent.parentNode;
    };


    /**
     * Makes sure that the current node is an Element with a matching tagName and
     * key.
     *
     * @param {string} tag The element's tag.
     * @param {?string=} key The key used to identify this element. This can be an
     *     empty string, but performance may be better if a unique value is used
     *     when iterating over an array of items.
     * @param {?Array<*>=} statics An array of attribute name/value pairs of the
     *     static attributes for the Element. These will only be set once when the
     *     Element is created.
     * @return {!Element} The corresponding Element.
     */
    var coreElementOpen = function(tag, key, statics) {
      alignWithDOM(tag, key, statics);
      enterNode();
      return /** @type {!Element} */(currentParent);
    };


    /**
     * Closes the currently open Element, removing any unvisited children if
     * necessary.
     *
     * @return {!Element} The corresponding Element.
     */
    var coreElementClose = function() {
      if ("production" !== 'production') {}

      exitNode();
      return /** @type {!Element} */(previousNode);
    };


    /**
     * Makes sure the current node is a Text node and creates a Text node if it is
     * not.
     *
     * @return {!Text} The corresponding Text Node.
     */
    var coreText = function() {
      alignWithDOM('#text', null, null);
      nextNode();
      return /** @type {!Text} */(previousNode);
    };


    /**
     * Gets the current Element being patched.
     * @return {!Element}
     */
    var currentElement = function() {
      if ("production" !== 'production') {}
      return /** @type {!Element} */(currentParent);
    };


    /**
     * Skips the children in a subtree, allowing an Element to be closed without
     * clearing out the children.
     */
    var skip = function() {
      if ("production" !== 'production') {}
      previousNode = currentParent.lastChild;
    };

    /**
     * The offset in the virtual element declaration where the attributes are
     * specified.
     * @const
     */
    var ATTRIBUTES_OFFSET = 3;


    /**
     * Builds an array of arguments for use with elementOpenStart, attr and
     * elementOpenEnd.
     * @const {Array<*>}
     */
    var argsBuilder = [];


    /**
     * @param {string} tag The element's tag.
     * @param {?string=} key The key used to identify this element. This can be an
     *     empty string, but performance may be better if a unique value is used
     *     when iterating over an array of items.
     * @param {?Array<*>=} statics An array of attribute name/value pairs of the
     *     static attributes for the Element. These will only be set once when the
     *     Element is created.
     * @param {...*} var_args Attribute name/value pairs of the dynamic attributes
     *     for the Element.
     * @return {!Element} The corresponding Element.
     */
    var elementOpen = function(tag, key, statics, var_args) {
      if ("production" !== 'production') {}

      var node = coreElementOpen(tag, key, statics);
      var data = getData(node);

      /*
       * Checks to see if one or more attributes have changed for a given Element.
       * When no attributes have changed, this is much faster than checking each
       * individual argument. When attributes have changed, the overhead of this is
       * minimal.
       */
      var attrsArr = data.attrsArr;
      var newAttrs = data.newAttrs;
      var attrsChanged = false;
      var i = ATTRIBUTES_OFFSET;
      var j = 0;

      for (; i < arguments.length; i += 1, j += 1) {
        if (attrsArr[j] !== arguments[i]) {
          attrsChanged = true;
          break;
        }
      }

      for (; i < arguments.length; i += 1, j += 1) {
        attrsArr[j] = arguments[i];
      }

      if (j < attrsArr.length) {
        attrsChanged = true;
        attrsArr.length = j;
      }

      /*
       * Actually perform the attribute update.
       */
      if (attrsChanged) {
        for (i = ATTRIBUTES_OFFSET; i < arguments.length; i += 2) {
          newAttrs[arguments[i]] = arguments[i + 1];
        }

        for (var attr in newAttrs) {
          updateAttribute(node, attr, newAttrs[attr]);
          newAttrs[attr] = undefined;
        }
      }

      return node;
    };


    /**
     * Declares a virtual Element at the current location in the document. This
     * corresponds to an opening tag and a elementClose tag is required. This is
     * like elementOpen, but the attributes are defined using the attr function
     * rather than being passed as arguments. Must be folllowed by 0 or more calls
     * to attr, then a call to elementOpenEnd.
     * @param {string} tag The element's tag.
     * @param {?string=} key The key used to identify this element. This can be an
     *     empty string, but performance may be better if a unique value is used
     *     when iterating over an array of items.
     * @param {?Array<*>=} statics An array of attribute name/value pairs of the
     *     static attributes for the Element. These will only be set once when the
     *     Element is created.
     */
    var elementOpenStart = function(tag, key, statics) {
      if ("production" !== 'production') {}

      argsBuilder[0] = tag;
      argsBuilder[1] = key;
      argsBuilder[2] = statics;
    };


    /***
     * Defines a virtual attribute at this point of the DOM. This is only valid
     * when called between elementOpenStart and elementOpenEnd.
     *
     * @param {string} name
     * @param {*} value
     */
    var attr = function(name, value) {
      if ("production" !== 'production') {}

      argsBuilder.push(name, value);
    };


    /**
     * Closes an open tag started with elementOpenStart.
     * @return {!Element} The corresponding Element.
     */
    var elementOpenEnd = function() {
      if ("production" !== 'production') {}

      var node = elementOpen.apply(null, argsBuilder);
      argsBuilder.length = 0;
      return node;
    };


    /**
     * Closes an open virtual Element.
     *
     * @param {string} tag The element's tag.
     * @return {!Element} The corresponding Element.
     */
    var elementClose = function(tag) {
      if ("production" !== 'production') {}

      var node = coreElementClose();

      if ("production" !== 'production') {}

      return node;
    };


    /**
     * Declares a virtual Element at the current location in the document that has
     * no children.
     * @param {string} tag The element's tag.
     * @param {?string=} key The key used to identify this element. This can be an
     *     empty string, but performance may be better if a unique value is used
     *     when iterating over an array of items.
     * @param {?Array<*>=} statics An array of attribute name/value pairs of the
     *     static attributes for the Element. These will only be set once when the
     *     Element is created.
     * @param {...*} var_args Attribute name/value pairs of the dynamic attributes
     *     for the Element.
     * @return {!Element} The corresponding Element.
     */
    var elementVoid = function(tag, key, statics, var_args) {
      var node = elementOpen.apply(null, arguments);
      elementClose.apply(null, arguments);
      return node;
    };


    /**
     * Declares a virtual Element at the current location in the document that is a
     * placeholder element. Children of this Element can be manually managed and
     * will not be cleared by the library.
     *
     * A key must be specified to make sure that this node is correctly preserved
     * across all conditionals.
     *
     * @param {string} tag The element's tag.
     * @param {string} key The key used to identify this element.
     * @param {?Array<*>=} statics An array of attribute name/value pairs of the
     *     static attributes for the Element. These will only be set once when the
     *     Element is created.
     * @param {...*} var_args Attribute name/value pairs of the dynamic attributes
     *     for the Element.
     * @return {!Element} The corresponding Element.
     */
    var elementPlaceholder = function(tag, key, statics, var_args) {
      if ("production" !== 'production') {}

      elementOpen.apply(null, arguments);
      skip();
      return elementClose.apply(null, arguments);
    };


    /**
     * Declares a virtual Text at this point in the document.
     *
     * @param {string|number|boolean} value The value of the Text.
     * @param {...(function((string|number|boolean)):string)} var_args
     *     Functions to format the value which are called only when the value has
     *     changed.
     * @return {!Text} The corresponding text node.
     */
    var text = function(value, var_args) {
      if ("production" !== 'production') {}

      var node = coreText();
      var data = getData(node);

      if (data.text !== value) {
        data.text = /** @type {string} */(value);

        var formatted = value;
        for (var i = 1; i < arguments.length; i += 1) {
          formatted = arguments[i](formatted);
        }

        node.data = formatted;
      }

      return node;
    };

    var _baseValues = __commonjs(function (module) {
    var arrayMap = require$$0$8;

    /**
     * The base implementation of `_.values` and `_.valuesIn` which creates an
     * array of `object` property values corresponding to the property names
     * of `props`.
     *
     * @private
     * @param {Object} object The object to query.
     * @param {Array} props The property names to get values for.
     * @returns {Object} Returns the array of property values.
     */
    function baseValues(object, props) {
      return arrayMap(props, function(key) {
        return object[key];
      });
    }

    module.exports = baseValues;
    });

    var require$$1$16 = (_baseValues && typeof _baseValues === 'object' && 'default' in _baseValues ? _baseValues['default'] : _baseValues);

    var values = __commonjs(function (module) {
    var baseValues = require$$1$16,
        keys = require$$0$24;

    /**
     * Creates an array of the own enumerable property values of `object`.
     *
     * **Note:** Non-object values are coerced to objects.
     *
     * @static
     * @memberOf _
     * @category Object
     * @param {Object} object The object to query.
     * @returns {Array} Returns the array of property values.
     * @example
     *
     * function Foo() {
     *   this.a = 1;
     *   this.b = 2;
     * }
     *
     * Foo.prototype.c = 3;
     *
     * _.values(new Foo);
     * // => [1, 2] (iteration order is not guaranteed)
     *
     * _.values('hi');
     * // => ['h', 'i']
     */
    function values(object) {
      return object ? baseValues(object, keys(object)) : [];
    }

    module.exports = values;
    });

    var require$$0$27 = (values && typeof values === 'object' && 'default' in values ? values['default'] : values);

    var _stringToArray = __commonjs(function (module) {
    /** Used to compose unicode character classes. */
    var rsAstralRange = '\\ud800-\\udfff',
        rsComboMarksRange = '\\u0300-\\u036f\\ufe20-\\ufe23',
        rsComboSymbolsRange = '\\u20d0-\\u20f0',
        rsVarRange = '\\ufe0e\\ufe0f';

    /** Used to compose unicode capture groups. */
    var rsAstral = '[' + rsAstralRange + ']',
        rsCombo = '[' + rsComboMarksRange + rsComboSymbolsRange + ']',
        rsFitz = '\\ud83c[\\udffb-\\udfff]',
        rsModifier = '(?:' + rsCombo + '|' + rsFitz + ')',
        rsNonAstral = '[^' + rsAstralRange + ']',
        rsRegional = '(?:\\ud83c[\\udde6-\\uddff]){2}',
        rsSurrPair = '[\\ud800-\\udbff][\\udc00-\\udfff]',
        rsZWJ = '\\u200d';

    /** Used to compose unicode regexes. */
    var reOptMod = rsModifier + '?',
        rsOptVar = '[' + rsVarRange + ']?',
        rsOptJoin = '(?:' + rsZWJ + '(?:' + [rsNonAstral, rsRegional, rsSurrPair].join('|') + ')' + rsOptVar + reOptMod + ')*',
        rsSeq = rsOptVar + reOptMod + rsOptJoin,
        rsSymbol = '(?:' + [rsNonAstral + rsCombo + '?', rsCombo, rsRegional, rsSurrPair, rsAstral].join('|') + ')';

    /** Used to match [string symbols](https://mathiasbynens.be/notes/javascript-unicode). */
    var reComplexSymbol = RegExp(rsFitz + '(?=' + rsFitz + ')|' + rsSymbol + rsSeq, 'g');

    /**
     * Converts `string` to an array.
     *
     * @private
     * @param {string} string The string to convert.
     * @returns {Array} Returns the converted array.
     */
    function stringToArray(string) {
      return string.match(reComplexSymbol);
    }

    module.exports = stringToArray;
    });

    var require$$1$17 = (_stringToArray && typeof _stringToArray === 'object' && 'default' in _stringToArray ? _stringToArray['default'] : _stringToArray);

    var _setToArray = __commonjs(function (module) {
    /**
     * Converts `set` to an array.
     *
     * @private
     * @param {Object} set The set to convert.
     * @returns {Array} Returns the converted array.
     */
    function setToArray(set) {
      var index = -1,
          result = Array(set.size);

      set.forEach(function(value) {
        result[++index] = value;
      });
      return result;
    }

    module.exports = setToArray;
    });

    var require$$0$28 = (_setToArray && typeof _setToArray === 'object' && 'default' in _setToArray ? _setToArray['default'] : _setToArray);

    var _mapToArray = __commonjs(function (module) {
    /**
     * Converts `map` to an array.
     *
     * @private
     * @param {Object} map The map to convert.
     * @returns {Array} Returns the converted array.
     */
    function mapToArray(map) {
      var index = -1,
          result = Array(map.size);

      map.forEach(function(value, key) {
        result[++index] = [key, value];
      });
      return result;
    }

    module.exports = mapToArray;
    });

    var require$$1$18 = (_mapToArray && typeof _mapToArray === 'object' && 'default' in _mapToArray ? _mapToArray['default'] : _mapToArray);

    var _iteratorToArray = __commonjs(function (module) {
    /**
     * Converts `iterator` to an array.
     *
     * @private
     * @param {Object} iterator The iterator to convert.
     * @returns {Array} Returns the converted array.
     */
    function iteratorToArray(iterator) {
      var data,
          result = [];

      while (!(data = iterator.next()).done) {
        result.push(data.value);
      }
      return result;
    }

    module.exports = iteratorToArray;
    });

    var require$$4$6 = (_iteratorToArray && typeof _iteratorToArray === 'object' && 'default' in _iteratorToArray ? _iteratorToArray['default'] : _iteratorToArray);

    var _WeakMap = __commonjs(function (module) {
    var getNative = require$$1$5,
        root = require$$0$17;

    /* Built-in method references that are verified to be native. */
    var WeakMap = getNative(root, 'WeakMap');

    module.exports = WeakMap;
    });

    var require$$0$29 = (_WeakMap && typeof _WeakMap === 'object' && 'default' in _WeakMap ? _WeakMap['default'] : _WeakMap);

    var _Set = __commonjs(function (module) {
    var getNative = require$$1$5,
        root = require$$0$17;

    /* Built-in method references that are verified to be native. */
    var Set = getNative(root, 'Set');

    module.exports = Set;
    });

    var require$$1$19 = (_Set && typeof _Set === 'object' && 'default' in _Set ? _Set['default'] : _Set);

    var _getTag = __commonjs(function (module) {
    var Map = require$$2$3,
        Set = require$$1$19,
        WeakMap = require$$0$29;

    /** `Object#toString` result references. */
    var mapTag = '[object Map]',
        objectTag = '[object Object]',
        setTag = '[object Set]',
        weakMapTag = '[object WeakMap]';

    /** Used for built-in method references. */
    var objectProto = Object.prototype;

    /** Used to resolve the decompiled source of functions. */
    var funcToString = Function.prototype.toString;

    /**
     * Used to resolve the [`toStringTag`](http://ecma-international.org/ecma-262/6.0/#sec-object.prototype.tostring)
     * of values.
     */
    var objectToString = objectProto.toString;

    /** Used to detect maps, sets, and weakmaps. */
    var mapCtorString = Map ? funcToString.call(Map) : '',
        setCtorString = Set ? funcToString.call(Set) : '',
        weakMapCtorString = WeakMap ? funcToString.call(WeakMap) : '';

    /**
     * Gets the `toStringTag` of `value`.
     *
     * @private
     * @param {*} value The value to query.
     * @returns {string} Returns the `toStringTag`.
     */
    function getTag(value) {
      return objectToString.call(value);
    }

    // Fallback for IE 11 providing `toStringTag` values for maps, sets, and weakmaps.
    if ((Map && getTag(new Map) != mapTag) ||
        (Set && getTag(new Set) != setTag) ||
        (WeakMap && getTag(new WeakMap) != weakMapTag)) {
      getTag = function(value) {
        var result = objectToString.call(value),
            Ctor = result == objectTag ? value.constructor : null,
            ctorString = typeof Ctor == 'function' ? funcToString.call(Ctor) : '';

        if (ctorString) {
          switch (ctorString) {
            case mapCtorString: return mapTag;
            case setCtorString: return setTag;
            case weakMapCtorString: return weakMapTag;
          }
        }
        return result;
      };
    }

    module.exports = getTag;
    });

    var require$$3$4 = (_getTag && typeof _getTag === 'object' && 'default' in _getTag ? _getTag['default'] : _getTag);

    var _copyArray = __commonjs(function (module) {
    /**
     * Copies the values of `source` to `array`.
     *
     * @private
     * @param {Array} source The array to copy values from.
     * @param {Array} [array=[]] The array to copy values to.
     * @returns {Array} Returns `array`.
     */
    function copyArray(source, array) {
      var index = -1,
          length = source.length;

      array || (array = Array(length));
      while (++index < length) {
        array[index] = source[index];
      }
      return array;
    }

    module.exports = copyArray;
    });

    var require$$8 = (_copyArray && typeof _copyArray === 'object' && 'default' in _copyArray ? _copyArray['default'] : _copyArray);

    var _Symbol = __commonjs(function (module) {
    var root = require$$0$17;

    /** Built-in value references. */
    var Symbol = root.Symbol;

    module.exports = Symbol;
    });

    var require$$3$5 = (_Symbol && typeof _Symbol === 'object' && 'default' in _Symbol ? _Symbol['default'] : _Symbol);

    var toArray = __commonjs(function (module) {
    var Symbol = require$$3$5,
        copyArray = require$$8,
        getTag = require$$3$4,
        isArrayLike = require$$0$5,
        isString = _default3,
        iteratorToArray = require$$4$6,
        mapToArray = require$$1$18,
        setToArray = require$$0$28,
        stringToArray = require$$1$17,
        values = require$$0$27;

    /** `Object#toString` result references. */
    var mapTag = '[object Map]',
        setTag = '[object Set]';

    /** Built-in value references. */
    var iteratorSymbol = typeof (iteratorSymbol = Symbol && Symbol.iterator) == 'symbol' ? iteratorSymbol : undefined;

    /**
     * Converts `value` to an array.
     *
     * @static
     * @memberOf _
     * @category Lang
     * @param {*} value The value to convert.
     * @returns {Array} Returns the converted array.
     * @example
     *
     * _.toArray({ 'a': 1, 'b': 2 });
     * // => [1, 2]
     *
     * _.toArray('abc');
     * // => ['a', 'b', 'c']
     *
     * _.toArray(1);
     * // => []
     *
     * _.toArray(null);
     * // => []
     */
    function toArray(value) {
      if (!value) {
        return [];
      }
      if (isArrayLike(value)) {
        return isString(value) ? stringToArray(value) : copyArray(value);
      }
      if (iteratorSymbol && value[iteratorSymbol]) {
        return iteratorToArray(value[iteratorSymbol]());
      }
      var tag = getTag(value),
          func = tag == mapTag ? mapToArray : (tag == setTag ? setToArray : values);

      return func(value);
    }

    module.exports = toArray;
    });

    var _default4 = (toArray && typeof toArray === 'object' && 'default' in toArray ? toArray['default'] : toArray);

    var index = __commonjs(function (module) {
    'use strict';

    /**
     * Determine if a DOM element matches a CSS selector
     *
     * @param {Element} elem
     * @param {String} selector
     * @return {Boolean}
     * @api public
     */

    function matches(elem, selector) {
      // Vendor-specific implementations of `Element.prototype.matches()`.
      var proto = window.Element.prototype;
      var nativeMatches = proto.matches ||
          proto.mozMatchesSelector ||
          proto.msMatchesSelector ||
          proto.oMatchesSelector ||
          proto.webkitMatchesSelector;

      if (!elem || elem.nodeType !== 1) {
        return false;
      }

      var parentElem = elem.parentNode;

      // use native 'matches'
      if (nativeMatches) {
        return nativeMatches.call(elem, selector);
      }

      // native support for `matches` is missing and a fallback is required
      var nodes = parentElem.querySelectorAll(selector);
      var len = nodes.length;

      for (var i = 0; i < len; i++) {
        if (nodes[i] === elem) {
          return true;
        }
      }

      return false;
    }

    /**
     * Expose `matches`
     */

    module.exports = matches;
    });

    var matchesSelector = (index && typeof index === 'object' && 'default' in index ? index['default'] : index);

    function forEach$1(val, fn, ctx) {
    	if (val && typeof val.forEach === "function") val.forEach(fn, ctx);else _default(val, fn, ctx);
    }

    function map(val, fn, ctx) {
    	var res = [];
    	forEach$1(val, function (v, i, l) {
    		res.push(fn.call(ctx, v, i, l));
    	});
    	return res;
    }

    // like jQuery's empty(), removes all children
    function emptyNode(node) {
    	while (node.lastChild) {
    		node.removeChild(node.lastChild);
    	}return node;
    }

    var entity = /&(?:#x[a-f0-9]+|#[0-9]+|[a-z0-9]+);?/ig;

    function containsEntities(str) {
    	return entity.test(str);
    }

    // converts html entities to unicode
    var decodeEntities = function () {
    	if (typeof document === "undefined") return;

    	// this prevents any overhead from creating the object each time
    	var element = document.createElement('div');

    	return function decodeHTMLEntities(str) {
    		str = str.replace(entity, function (m) {
    			element.innerHTML = m;
    			return element.textContent;
    		});

    		emptyNode(element);

    		return str;
    	};
    }();

    // convert html into DOM nodes
    function toString(value) {
    	if (typeof value !== "string") {
    		value = value != null ? value.toString() : "";
    	}

    	return value;
    }

    function joinValues() {
    	return _default4(arguments).map(toString).join("");
    }

    function matches$1(node, selector) {
    	if (require$$2$5(selector)) return selector.some(function (s) {
    		return matches$1(node, s);
    	});

    	if (selector instanceof window.Node) {
    		return node === selector;
    	}

    	if (typeof selector === "function") {
    		return !!selector(node);
    	}

    	if (node.nodeType === window.Node.ELEMENT_NODE) {
    		return matchesSelector(node, selector);
    	}

    	return false;
    }

    // export function getPropertyFromClass(obj, prop) {
    // 	var val;
    // 	let proto = Object.getPrototypeOf(obj);
    //
    // 	if (typeof prop === "string" && prop) {
    // 		let p = prop;
    // 		prop = c => c[p];
    // 	}
    //
    // 	if (typeof prop !== "function") {
    // 		throw new Error("Expecting function or string for property.");
    // 	}
    //
    // 	while (proto) {
    // 		val = merge.defaults(val, prop(proto.constructor));
    // 		proto = Object.getPrototypeOf(proto);
    // 	}
    //
    // 	return val;
    // }

var utils = Object.freeze({
    	forEach: forEach$1,
    	map: map,
    	emptyNode: emptyNode,
    	containsEntities: containsEntities,
    	decodeEntities: decodeEntities,
    	toString: toString,
    	joinValues: joinValues,
    	matches: matches$1
    });

    var performanceNow = __commonjs(function (module, exports, global) {
    // Generated by CoffeeScript 1.7.1
    (function() {
      var getNanoSeconds, hrtime, loadTime;

      if ((typeof performance !== "undefined" && performance !== null) && performance.now) {
        module.exports = function() {
          return performance.now();
        };
      } else if ((typeof process !== "undefined" && process !== null) && process.hrtime) {
        module.exports = function() {
          return (getNanoSeconds() - loadTime) / 1e6;
        };
        hrtime = process.hrtime;
        getNanoSeconds = function() {
          var hr;
          hr = hrtime();
          return hr[0] * 1e9 + hr[1];
        };
        loadTime = getNanoSeconds();
      } else if (Date.now) {
        module.exports = function() {
          return Date.now() - loadTime;
        };
        loadTime = Date.now();
      } else {
        module.exports = function() {
          return new Date().getTime() - loadTime;
        };
        loadTime = new Date().getTime();
      }

    }).call(__commonjs_global);
    });

    var require$$0$30 = (performanceNow && typeof performanceNow === 'object' && 'default' in performanceNow ? performanceNow['default'] : performanceNow);

    var index$1 = __commonjs(function (module, exports, global) {
    var now = require$$0$30
      , global = typeof window === 'undefined' ? {} : window
      , vendors = ['moz', 'webkit']
      , suffix = 'AnimationFrame'
      , raf = global['request' + suffix]
      , caf = global['cancel' + suffix] || global['cancelRequest' + suffix]

    for(var i = 0; i < vendors.length && !raf; i++) {
      raf = global[vendors[i] + 'Request' + suffix]
      caf = global[vendors[i] + 'Cancel' + suffix]
          || global[vendors[i] + 'CancelRequest' + suffix]
    }

    // Some versions of FF have rAF but not cAF
    if(!raf || !caf) {
      var last = 0
        , id = 0
        , queue = []
        , frameDuration = 1000 / 60

      raf = function(callback) {
        if(queue.length === 0) {
          var _now = now()
            , next = Math.max(0, frameDuration - (_now - last))
          last = next + _now
          setTimeout(function() {
            var cp = queue.slice(0)
            // Clear queue here to prevent
            // callbacks from appending listeners
            // to the current frame's queue
            queue.length = 0
            for(var i = 0; i < cp.length; i++) {
              if(!cp[i].cancelled) {
                try{
                  cp[i].callback(last)
                } catch(e) {
                  setTimeout(function() { throw e }, 0)
                }
              }
            }
          }, Math.round(next))
        }
        queue.push({
          handle: ++id,
          callback: callback,
          cancelled: false
        })
        return id
      }

      caf = function(handle) {
        for(var i = 0; i < queue.length; i++) {
          if(queue[i].handle === handle) {
            queue[i].cancelled = true
          }
        }
      }
    }

    module.exports = function(fn) {
      // Wrap in a new function to prevent
      // `cancel` potentially being assigned
      // to the native rAF function
      return raf.call(global, fn)
    }
    module.exports.cancel = function() {
      caf.apply(global, arguments)
    }
    });

    var raf = (index$1 && typeof index$1 === 'object' && 'default' in index$1 ? index$1['default'] : index$1);

    var trackr = __commonjs(function (module, exports, global) {
    /////////////////////////////////////////////////////
    // Package docs at http://docs.meteor.com/#tracker //
    // Last merge: https://github.com/meteor/meteor/blob/696876b1848e4d6a920143422c2c50c4501c85a3/packages/tracker/tracker.js //
    /////////////////////////////////////////////////////

    //
    module.exports = (function() {

    // check for global and use that one instead of loading a new one
    if (typeof global.Trackr !== "undefined") {
    	return global.Trackr;
    }

    /**
     * @namespace Trackr
     * @summary The namespace for Trackr-related methods.
     */
    var Trackr = global.Trackr = {};

    // http://docs.meteor.com/#tracker_active

    /**
     * @summary True if there is a current computation, meaning that dependencies on reactive data sources will be tracked and potentially cause the current computation to be rerun.
     * @locus Client
     * @type {Boolean}
     */
    Trackr.active = false;

    // http://docs.meteor.com/#tracker_currentcomputation

    /**
     * @summary The current computation, or `null` if there isn't one.	The current computation is the [`Trackr.Computation`](#tracker_computation) object created by the innermost active call to `Trackr.autorun`, and it's the computation that gains dependencies when reactive data sources are accessed.
     * @locus Client
     * @type {Trackr.Computation}
     */
    Trackr.currentComputation = null;

    // References to all computations created within the Trackr by id.
    // Keeping these references on an underscore property gives more control to
    // tooling and packages extending Trackr without increasing the API surface.
    // These can used to monkey-patch computations, their functions, use
    // computation ids for tracking, etc.
    Trackr._computations = {};

    var setCurrentComputation = function (c) {
    	Trackr.currentComputation = c;
    	Trackr.active = !! c;
    };

    var _debugFunc = function () {
    	return (typeof console !== "undefined") && console.error ?
    			 function () { console.error.apply(console, arguments); } :
    			 function () {};
    };

    var _throwOrLog = function (from, e) {
    	if (throwFirstError) {
    		throw e;
    	} else {
    		var printArgs = ["Exception from Trackr " + from + " function:"];
    		if (e.stack && e.message && e.name) {
    			var idx = e.stack.indexOf(e.message);
    			if (idx < 0 || idx > e.name.length + 2) { // check for "Error: "
    				// message is not part of the stack
    				var message = e.name + ": " + e.message;
    				printArgs.push(message);
    			}
    		}
    		printArgs.push(e.stack);

    		for (var i = 0; i < printArgs.length; i++) {
    			_debugFunc()(printArgs[i]);
    		}
    	}
    };

    // Takes a function `f`, and wraps it in a `Meteor._noYieldsAllowed`
    // block if we are running on the server. On the client, returns the
    // original function (since `Meteor._noYieldsAllowed` is a
    // no-op). This has the benefit of not adding an unnecessary stack
    // frame on the client.
    var withNoYieldsAllowed = function (f) {
    	return f;
    };

    var nextId = 1;
    // computations whose callbacks we should call at flush time
    var pendingComputations = [];
    // `true` if a Trackr.flush is scheduled, or if we are in Trackr.flush now
    var willFlush = false;
    // `true` if we are in Trackr.flush now
    var inFlush = false;
    // `true` if we are computing a computation now, either first time
    // or recompute.	This matches Trackr.active unless we are inside
    // Trackr.nonreactive, which nullfies currentComputation even though
    // an enclosing computation may still be running.
    var inCompute = false;
    // `true` if the `_throwFirstError` option was passed in to the call
    // to Trackr.flush that we are in. When set, throw rather than log the
    // first error encountered while flushing. Before throwing the error,
    // finish flushing (from a finally block), logging any subsequent
    // errors.
    var throwFirstError = false;

    var afterFlushCallbacks = [];

    var requestAnimationFrame = raf;

    var requireFlush = function () {
    	if (! willFlush) {
    		requestAnimationFrame(Trackr._runFlush);
    		willFlush = true;
    	}
    };

    // Trackr.Computation constructor is visible but private
    // (throws an error if you try to call it)
    var constructingComputation = false;

    //
    // http://docs.meteor.com/#tracker_computation

    /**
     * @summary A Computation object represents code that is repeatedly rerun
     * in response to
     * reactive data changes. Computations don't have return values; they just
     * perform actions, such as rerendering a template on the screen. Computations
     * are created using Trackr.autorun. Use stop to prevent further rerunning of a
     * computation.
     * @instancename computation
     */
    Trackr.Computation = function (f, parent, options) {
    	if (! constructingComputation)
    		throw new Error(
    			"Trackr.Computation constructor is private; use Trackr.autorun");
    	constructingComputation = false;

    	var self = this;
    	options = options || {};

    	// http://docs.meteor.com/#computation_stopped

    	/**
    	 * @summary True if this computation has been stopped.
    	 * @locus Client
    	 * @memberOf Trackr.Computation
    	 * @instance
    	 * @name	stopped
    	 */
    	self.stopped = false;

    	// http://docs.meteor.com/#computation_invalidated

    	/**
    	 * @summary True if this computation has been invalidated (and not yet rerun), or if it has been stopped.
    	 * @locus Client
    	 * @memberOf Trackr.Computation
    	 * @instance
    	 * @name	invalidated
    	 * @type {Boolean}
    	 */
    	self.invalidated = false;

    	// http://docs.meteor.com/#computation_firstrun

    	/**
    	 * @summary True during the initial run of the computation at the time `Trackr.autorun` is called, and false on subsequent reruns and at other times.
    	 * @locus Client
    	 * @memberOf Trackr.Computation
    	 * @instance
    	 * @name	firstRun
    	 * @type {Boolean}
    	 */
    	self.firstRun = true;

    	self._id = nextId++;
    	self._onInvalidateCallbacks = [];
    	self._onStopCallbacks = [];
    	// the plan is at some point to use the parent relation
    	// to constrain the order that computations are processed
    	self._parent = parent;
    	self._func = f;
    	self._onError = options.onError;
    	self._recomputing = false;
    	self._context = options.context || null;

    	// Register the computation within the global Trackr.
    	Trackr._computations[self._id] = self;

    	var errored = true;
    	try {
    		self._compute();
    		errored = false;
    	} finally {
    		self.firstRun = false;
    		if (errored)
    			self.stop();
    	}
    };

    // http://docs.meteor.com/#computation_oninvalidate

    /**
     * @summary Registers `callback` to run when this computation is next invalidated, or runs it immediately if the computation is already invalidated.	The callback is run exactly once and not upon future invalidations unless `onInvalidate` is called again after the computation becomes valid again.
     * @locus Client
     * @param {Function} callback Function to be called on invalidation. Receives one argument, the computation that was invalidated.
     */
    Trackr.Computation.prototype.onInvalidate = function (f, ctx) {
    	var self = this;

    	if (typeof f !== 'function')
    		throw new Error("onInvalidate requires a function");

    	if (self.invalidated) {
    		Trackr.nonreactive(function () {
    			withNoYieldsAllowed(f).call(ctx || self._context, self);
    		});
    	} else {
    		self._onInvalidateCallbacks.push({ fn: f, ctx: ctx });
    	}
    };

    /**
     * @summary Registers `callback` to run when this computation is stopped, or runs it immediately if the computation is already stopped.	The callback is run after any `onInvalidate` callbacks.
     * @locus Client
     * @param {Function} callback Function to be called on stop. Receives one argument, the computation that was stopped.
     */
    Trackr.Computation.prototype.onStop = function (f, ctx) {
    	var self = this;

    	if (typeof f !== 'function')
    		throw new Error("onStop requires a function");

    	if (self.stopped) {
    		Trackr.nonreactive(function () {
    			withNoYieldsAllowed(f).call(ctx || self._context, self);
    		});
    	} else {
    		self._onStopCallbacks.push({ fn: f, ctx: ctx });
    	}
    };

    // http://docs.meteor.com/#computation_invalidate

    /**
     * @summary Invalidates this computation so that it will be rerun.
     * @locus Client
     */
    Trackr.Computation.prototype.invalidate = function () {
    	var self = this;
    	if (! self.invalidated) {
    		// if we're currently in _recompute(), don't enqueue
    		// ourselves, since we'll rerun immediately anyway.
    		if (! self._recomputing && ! self.stopped) {
    			requireFlush();
    			pendingComputations.push(this);
    		}

    		self.invalidated = true;

    		// callbacks can't add callbacks, because
    		// self.invalidated === true.
    		for(var i = 0, f; f = self._onInvalidateCallbacks[i]; i++) {
    			Trackr.nonreactive(function () {
    				withNoYieldsAllowed(f.fn).call(f.ctx || self._context, self);
    			});
    		}
    		self._onInvalidateCallbacks = [];
    	}
    };

    // http://docs.meteor.com/#computation_stop

    /**
     * @summary Prevents this computation from rerunning.
     * @locus Client
     */
    Trackr.Computation.prototype.stop = function () {
    	var self = this;

    	if (! self.stopped) {
    		self.stopped = true;
    		self.invalidate();
    		// Unregister from global Trackr.
    		delete Trackr._computations[self._id];
    		for(var i = 0, f; f = self._onStopCallbacks[i]; i++) {
    			Trackr.nonreactive(function () {
    				withNoYieldsAllowed(f.fn).call(f.ctx || self._context, self);
    			});
    		}
    		self._onStopCallbacks = [];
    	}
    };

    Trackr.Computation.prototype._compute = function () {
    	var self = this;
    	self.invalidated = false;

    	var previous = Trackr.currentComputation;
    	setCurrentComputation(self);
    	var previousInCompute = inCompute;
    	inCompute = true;
    	try {
    		withNoYieldsAllowed(self._func).call(self._context, self);
    	} finally {
    		setCurrentComputation(previous);
    		inCompute = previousInCompute;
    	}
    };

    Trackr.Computation.prototype._needsRecompute = function () {
    	var self = this;
    	return self.invalidated && ! self.stopped;
    };

    Trackr.Computation.prototype._recompute = function () {
    	var self = this;

    	self._recomputing = true;
    	try {
    		if (self._needsRecompute()) {
    			try {
    				self._compute();
    			} catch (e) {
    				if (self._onError) {
    					self._onError(e);
    				} else {
    					_throwOrLog("recompute", e);
    				}
    			}
    		}
    	} finally {
    		self._recomputing = false;
    	}
    };

    //
    // http://docs.meteor.com/#tracker_dependency

    /**
     * @summary A Dependency represents an atomic unit of reactive data that a
     * computation might depend on. Reactive data sources such as Session or
     * Minimongo internally create different Dependency objects for different
     * pieces of data, each of which may be depended on by multiple computations.
     * When the data changes, the computations are invalidated.
     * @class
     * @instanceName dependency
     */
    Trackr.Dependency = function () {
    	this._dependentsById = {};
    };

    // http://docs.meteor.com/#dependency_depend
    //
    // Adds `computation` to this set if it is not already
    // present.	Returns true if `computation` is a new member of the set.
    // If no argument, defaults to currentComputation, or does nothing
    // if there is no currentComputation.

    /**
     * @summary Declares that the current computation (or `fromComputation` if given) depends on `dependency`.	The computation will be invalidated the next time `dependency` changes.

    If there is no current computation and `depend()` is called with no arguments, it does nothing and returns false.

    Returns true if the computation is a new dependent of `dependency` rather than an existing one.
     * @locus Client
     * @param {Trackr.Computation} [fromComputation] An optional computation declared to depend on `dependency` instead of the current computation.
     * @returns {Boolean}
     */
    Trackr.Dependency.prototype.depend = function (computation) {
    	if (! computation) {
    		if (! Trackr.active)
    			return false;

    		computation = Trackr.currentComputation;
    	}
    	var self = this;
    	var id = computation._id;
    	if (! (id in self._dependentsById)) {
    		self._dependentsById[id] = computation;
    		computation.onInvalidate(function () {
    			delete self._dependentsById[id];
    		});
    		return true;
    	}
    	return false;
    };

    // http://docs.meteor.com/#dependency_changed

    /**
     * @summary Invalidate all dependent computations immediately and remove them as dependents.
     * @locus Client
     */
    Trackr.Dependency.prototype.changed = function () {
    	var self = this;
    	for (var id in self._dependentsById)
    		self._dependentsById[id].invalidate();
    };

    // http://docs.meteor.com/#dependency_hasdependents

    /**
     * @summary True if this Dependency has one or more dependent Computations, which would be invalidated if this Dependency were to change.
     * @locus Client
     * @returns {Boolean}
     */
    Trackr.Dependency.prototype.hasDependents = function () {
    	var self = this;
    	for(var id in self._dependentsById)
    		return true;
    	return false;
    };

    // http://docs.meteor.com/#tracker_flush

    /**
     * @summary Process all reactive updates immediately and ensure that all invalidated computations are rerun.
     * @locus Client
     */
    Trackr.flush = function (options) {
    	Trackr._runFlush({ finishSynchronously: true,
    											throwFirstError: options && options._throwFirstError });
    };

    // Run all pending computations and afterFlush callbacks.	If we were not called
    // directly via Trackr.flush, this may return before they're all done to allow
    // the event loop to run a little before continuing.
    Trackr._runFlush = function (options) {
    	// XXX What part of the comment below is still true? (We no longer
    	// have Spark)
    	//
    	// Nested flush could plausibly happen if, say, a flush causes
    	// DOM mutation, which causes a "blur" event, which runs an
    	// app event handler that calls Trackr.flush.	At the moment
    	// Spark blocks event handlers during DOM mutation anyway,
    	// because the LiveRange tree isn't valid.	And we don't have
    	// any useful notion of a nested flush.
    	//
    	// https://app.asana.com/0/159908330244/385138233856
    	if (inFlush)
    		throw new Error("Can't call Trackr.flush while flushing");

    	if (inCompute)
    		throw new Error("Can't flush inside Trackr.autorun");

    	options = options || {};

    	inFlush = true;
    	willFlush = true;
    	throwFirstError = !! options.throwFirstError;

    	var recomputedCount = 0;
    	var finishedTry = false;
    	try {
    		while (pendingComputations.length ||
    					 afterFlushCallbacks.length) {

    			// recompute all pending computations
    			while (pendingComputations.length) {
    				var comp = pendingComputations.shift();
    				comp._recompute();
    				if (comp._needsRecompute()) {
    					pendingComputations.unshift(comp);
    				}

    				if (! options.finishSynchronously && ++recomputedCount > 1000) {
    					finishedTry = true;
    					return;
    				}
    			}

    			if (afterFlushCallbacks.length) {
    				// call one afterFlush callback, which may
    				// invalidate more computations
    				var cb = afterFlushCallbacks.shift();
    				try {
    					cb.fn.call(cb.ctx);
    				} catch (e) {
    					_throwOrLog("afterFlush", e);
    				}
    			}
    		}
    		finishedTry = true;
    	} finally {
    		if (! finishedTry) {
    			// we're erroring due to throwFirstError being true.
    			inFlush = false; // needed before calling `Trackr.flush()` again
    			// finish flushing
    			Trackr._runFlush({
    				finishSynchronously: options.finishSynchronously,
    				throwFirstError: false
    			});
    		}
    		willFlush = false;
    		inFlush = false;
    		if (pendingComputations.length || afterFlushCallbacks.length) {
    			// We're yielding because we ran a bunch of computations and we aren't
    			// required to finish synchronously, so we'd like to give the event loop a
    			// chance. We should flush again soon.
    			if (options.finishSynchronously) {
    				throw new Error("still have more to do?");	// shouldn't happen
    			}
    			setTimeout(requireFlush, 10);
    		}
    	}
    };

    // http://docs.meteor.com/#tracker_autorun
    //
    // Run f(). Record its dependencies. Rerun it whenever the
    // dependencies change.
    //
    // Returns a new Computation, which is also passed to f.
    //
    // Links the computation to the current computation
    // so that it is stopped if the current computation is invalidated.

    /**
     * @callback Trackr.ComputationFunction
     * @param {Trackr.Computation}
     */
    /**
     * @summary Run a function now and rerun it later whenever its dependencies
     * change. Returns a Computation object that can be used to stop or observe the
     * rerunning.
     * @locus Client
     * @param {Trackr.ComputationFunction} runFunc The function to run. It receives
     * one argument: the Computation object that will be returned.
     * @param {Object} [options]
     * @param {Function} options.onError Optional. The function to run when an error
     * happens in the Computation. The only argument it recieves is the Error
     * thrown. Defaults to the error being logged to the console.
     * @returns {Trackr.Computation}
     */
    Trackr.autorun = function (f, options, ctx) {
    	if (typeof f !== 'function')
    		throw new Error('Trackr.autorun requires a function argument');

    	options = options || {};
    	if (ctx) options.context = ctx;

    	constructingComputation = true;
    	var c = new Trackr.Computation(
    		f, Trackr.currentComputation, options);

    	if (Trackr.active)
    		Trackr.onInvalidate(function () {
    			c.stop();
    		});

    	return c;
    };

    // http://docs.meteor.com/#tracker_nonreactive
    //
    // Run `f` with no current computation, returning the return value
    // of `f`.	Used to turn off reactivity for the duration of `f`,
    // so that reactive data sources accessed by `f` will not result in any
    // computations being invalidated.

    /**
     * @summary Run a function without tracking dependencies.
     * @locus Client
     * @param {Function} func A function to call immediately.
     */
    Trackr.nonReactive =
    Trackr.nonreactive = function (f, ctx) {
    	var previous = Trackr.currentComputation;
    	setCurrentComputation(null);
    	try {
    		return f.call(ctx);
    	} finally {
    		setCurrentComputation(previous);
    	}
    };

    // like nonreactive but makes a function instead
    Trackr.nonReactable =
    Trackr.nonreactable = function (f, ctx) {
    	return function() {
    		var args = arguments;
    		var self = this;
    		return Trackr.nonreactive(function() {
    			return f.apply(ctx || self, args);
    		});
    	};
    };

    // http://docs.meteor.com/#tracker_oninvalidate

    /**
     * @summary Registers a new [`onInvalidate`](#computation_oninvalidate) callback on the current computation (which must exist), to be called immediately when the current computation is invalidated or stopped.
     * @locus Client
     * @param {Function} callback A callback function that will be invoked as `func(c)`, where `c` is the computation on which the callback is registered.
     */
    Trackr.onInvalidate = function (f, ctx) {
    	if (! Trackr.active)
    		throw new Error("Trackr.onInvalidate requires a currentComputation");

    	Trackr.currentComputation.onInvalidate(f, ctx);
    };

    // http://docs.meteor.com/#tracker_afterflush

    /**
     * @summary Schedules a function to be called during the next flush, or later in the current flush if one is in progress, after all invalidated computations have been rerun.	The function will be run once and not on subsequent flushes unless `afterFlush` is called again.
     * @locus Client
     * @param {Function} callback A function to call at flush time.
     */
    Trackr.afterFlush = function (f, ctx) {
    	afterFlushCallbacks.push({ fn: f, ctx: ctx });
    	requireFlush();
    };

    // export it
    return Trackr;

    })();
    });

    var Trackr = (trackr && typeof trackr === 'object' && 'default' in trackr ? trackr['default'] : trackr);

    function autotext(fn, that) {
    	var node = coreText();

    	function renderText(c) {
    		c.node = node;
    		var data = getData(node);
    		var value = fn.call(that, node);

    		if (data.text !== value) {
    			data.text = value;
    			node.data = toString(value);
    		}
    	}

    	return Trackr.autorun(renderText);
    }

    function autoelement(node, fn) {
    	return Trackr.autorun(function (c) {
    		c.element = node;

    		// catch errors that idom likes to throw
    		var cur = undefined;
    		try {
    			cur = currentElement();
    		} catch (e) {}

    		// call straight or patch
    		if (cur === node) fn(node, c);else patch(node, function () {
    			return fn(node, c);
    		});
    	});
    }

    var execDeletedCallbacks = function execDeletedCallbacks(node) {
    	var data = getData(node);
    	var cbs = data.deletedCallbacks;
    	if (!cbs) return;
    	cbs.splice(0, cbs.length).forEach(function (fn) {
    		fn.call(null, node);
    	});
    };

    notifications.nodesDeleted = function (nodes) {
    	_default(nodes, function (node) {
    		if (node.childNodes) notifications.nodesDeleted(node.childNodes);
    		execDeletedCallbacks(node);
    	});
    };

    function onDestroy(node, fn) {
    	if (typeof fn !== "function") {
    		throw new Error("Expecting function.");
    	}

    	var data = getData(node);
    	if (!data.deletedCallbacks) data.deletedCallbacks = [];
    	data.deletedCallbacks.push(fn);
    }

    function removeDestroyListener(node, fn) {
    	var data = getData(node);
    	if (data.deletedCallbacks) {
    		data.deletedCallbacks = _default5(data.deletedCallbacks, fn);
    	}
    }

    // function renderHTML(node) {
    // 	if (node.type == "text") {
    // 		return idom.text(node.content);
    // 	}
    //
    // 	if (node.type == "tag") {
    // 		var argsArray = [node.name, null, null];
    //
    // 		// convert attrs into a flat array
    // 		for (var attr in node.attrs) {
    // 			argsArray.push(attr);
    // 			argsArray.push(node.attrs[attr]);
    // 		}
    //
    // 		if (node.voidElement) {
    // 			return idom.elementVoid.apply(idom, argsArray);
    // 		} else {
    // 			idom.elementOpen.apply(idom, argsArray);
    //
    // 			for (var i = 0; i < node.children.length; i++) {
    // 				renderHTML(node.children[i]);
    // 			}
    //
    // 			return idom.elementClose(node.name);
    // 		}
    // 	}
    // }

    // export function html(src) {
    // 	var tree = parseHTML("<div>" + src + "</div>");
    // 	if (_.isArray(tree)) tree = tree[0];
    // 	return tree.children.map(renderHTML);
    // }

    function updateProperty(el, name, value) {
    	var data = getData(el);
    	var attrs = data.attrs;

    	if (attrs[name] === value) {
    		return;
    	}

    	el[name] = value;
    	attrs[name] = value;
    }

var idom = Object.freeze({
    	updateAttribute: updateAttribute,
    	getData: getData,
    	autotext: autotext,
    	autoelement: autoelement,
    	onDestroy: onDestroy,
    	removeDestroyListener: removeDestroyListener,
    	updateProperty: updateProperty,
    	patch: patch,
    	currentElement: currentElement,
    	skip: skip,
    	elementVoid: elementVoid,
    	elementOpenStart: elementOpenStart,
    	elementOpenEnd: elementOpenEnd,
    	elementOpen: elementOpen,
    	elementClose: elementClose,
    	elementPlaceholder: elementPlaceholder,
    	text: text,
    	attr: attr,
    	symbols: symbols,
    	attributes: attributes,
    	applyAttr: applyAttr,
    	applyProp: applyProp,
    	notifications: notifications
    });

    var _isKey = __commonjs(function (module) {
    var isArray = require$$2$5;

    /** Used to match property names within property paths. */
    var reIsDeepProp = /\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/,
        reIsPlainProp = /^\w*$/;

    /**
     * Checks if `value` is a property name and not a property path.
     *
     * @private
     * @param {*} value The value to check.
     * @param {Object} [object] The object to query keys on.
     * @returns {boolean} Returns `true` if `value` is a property name, else `false`.
     */
    function isKey(value, object) {
      if (typeof value == 'number') {
        return true;
      }
      return !isArray(value) &&
        (reIsPlainProp.test(value) || !reIsDeepProp.test(value) ||
          (object != null && value in Object(object)));
    }

    module.exports = isKey;
    });

    var require$$0$34 = (_isKey && typeof _isKey === 'object' && 'default' in _isKey ? _isKey['default'] : _isKey);

    var isSymbol = __commonjs(function (module) {
    var isObjectLike = require$$0$4;

    /** `Object#toString` result references. */
    var symbolTag = '[object Symbol]';

    /** Used for built-in method references. */
    var objectProto = Object.prototype;

    /**
     * Used to resolve the [`toStringTag`](http://ecma-international.org/ecma-262/6.0/#sec-object.prototype.tostring)
     * of values.
     */
    var objectToString = objectProto.toString;

    /**
     * Checks if `value` is classified as a `Symbol` primitive or object.
     *
     * @static
     * @memberOf _
     * @category Lang
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is correctly classified, else `false`.
     * @example
     *
     * _.isSymbol(Symbol.iterator);
     * // => true
     *
     * _.isSymbol('abc');
     * // => false
     */
    function isSymbol(value) {
      return typeof value == 'symbol' ||
        (isObjectLike(value) && objectToString.call(value) == symbolTag);
    }

    module.exports = isSymbol;
    });

    var require$$0$37 = (isSymbol && typeof isSymbol === 'object' && 'default' in isSymbol ? isSymbol['default'] : isSymbol);

    var toString$1 = __commonjs(function (module) {
    var Symbol = require$$3$5,
        isSymbol = require$$0$37;

    /** Used as references for various `Number` constants. */
    var INFINITY = 1 / 0;

    /** Used to convert symbols to primitives and strings. */
    var symbolProto = Symbol ? Symbol.prototype : undefined,
        symbolToString = Symbol ? symbolProto.toString : undefined;

    /**
     * Converts `value` to a string if it's not one. An empty string is returned
     * for `null` and `undefined` values. The sign of `-0` is preserved.
     *
     * @static
     * @memberOf _
     * @category Lang
     * @param {*} value The value to process.
     * @returns {string} Returns the string.
     * @example
     *
     * _.toString(null);
     * // => ''
     *
     * _.toString(-0);
     * // => '-0'
     *
     * _.toString([1, 2, 3]);
     * // => '1,2,3'
     */
    function toString(value) {
      // Exit early for strings to avoid a performance hit in some environments.
      if (typeof value == 'string') {
        return value;
      }
      if (value == null) {
        return '';
      }
      if (isSymbol(value)) {
        return Symbol ? symbolToString.call(value) : '';
      }
      var result = (value + '');
      return (result == '0' && (1 / value) == -INFINITY) ? '-0' : result;
    }

    module.exports = toString;
    });

    var require$$0$36 = (toString$1 && typeof toString$1 === 'object' && 'default' in toString$1 ? toString$1['default'] : toString$1);

    var _stringToPath = __commonjs(function (module) {
    var toString = require$$0$36;

    /** Used to match property names within property paths. */
    var rePropName = /[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]/g;

    /** Used to match backslashes in property paths. */
    var reEscapeChar = /\\(\\)?/g;

    /**
     * Converts `string` to a property path array.
     *
     * @private
     * @param {string} string The string to convert.
     * @returns {Array} Returns the property path array.
     */
    function stringToPath(string) {
      var result = [];
      toString(string).replace(rePropName, function(match, number, quote, string) {
        result.push(quote ? string.replace(reEscapeChar, '$1') : (number || match));
      });
      return result;
    }

    module.exports = stringToPath;
    });

    var require$$0$35 = (_stringToPath && typeof _stringToPath === 'object' && 'default' in _stringToPath ? _stringToPath['default'] : _stringToPath);

    var _baseCastPath = __commonjs(function (module) {
    var isArray = require$$2$5,
        stringToPath = require$$0$35;

    /**
     * Casts `value` to a path array if it's not one.
     *
     * @private
     * @param {*} value The value to inspect.
     * @returns {Array} Returns the cast property path array.
     */
    function baseCastPath(value) {
      return isArray(value) ? value : stringToPath(value);
    }

    module.exports = baseCastPath;
    });

    var require$$3$6 = (_baseCastPath && typeof _baseCastPath === 'object' && 'default' in _baseCastPath ? _baseCastPath['default'] : _baseCastPath);

    var _baseGet = __commonjs(function (module) {
    var baseCastPath = require$$3$6,
        isKey = require$$0$34;

    /**
     * The base implementation of `_.get` without support for default values.
     *
     * @private
     * @param {Object} object The object to query.
     * @param {Array|string} path The path of the property to get.
     * @returns {*} Returns the resolved value.
     */
    function baseGet(object, path) {
      path = isKey(path, object) ? [path + ''] : baseCastPath(path);

      var index = 0,
          length = path.length;

      while (object != null && index < length) {
        object = object[path[index++]];
      }
      return (index && index == length) ? object : undefined;
    }

    module.exports = baseGet;
    });

    var require$$0$33 = (_baseGet && typeof _baseGet === 'object' && 'default' in _baseGet ? _baseGet['default'] : _baseGet);

    var get = __commonjs(function (module) {
    var baseGet = require$$0$33;

    /**
     * Gets the value at `path` of `object`. If the resolved value is
     * `undefined` the `defaultValue` is used in its place.
     *
     * @static
     * @memberOf _
     * @category Object
     * @param {Object} object The object to query.
     * @param {Array|string} path The path of the property to get.
     * @param {*} [defaultValue] The value returned if the resolved value is `undefined`.
     * @returns {*} Returns the resolved value.
     * @example
     *
     * var object = { 'a': [{ 'b': { 'c': 3 } }] };
     *
     * _.get(object, 'a[0].b.c');
     * // => 3
     *
     * _.get(object, ['a', '0', 'b', 'c']);
     * // => 3
     *
     * _.get(object, 'a.b.c', 'default');
     * // => 'default'
     */
    function get(object, path, defaultValue) {
      var result = object == null ? undefined : baseGet(object, path);
      return result === undefined ? defaultValue : result;
    }

    module.exports = get;
    });

    var require$$1$20 = (get && typeof get === 'object' && 'default' in get ? get['default'] : get);

    var _baseSlice = __commonjs(function (module) {
    /**
     * The base implementation of `_.slice` without an iteratee call guard.
     *
     * @private
     * @param {Array} array The array to slice.
     * @param {number} [start=0] The start position.
     * @param {number} [end=array.length] The end position.
     * @returns {Array} Returns the slice of `array`.
     */
    function baseSlice(array, start, end) {
      var index = -1,
          length = array.length;

      if (start < 0) {
        start = -start > length ? 0 : (length + start);
      }
      end = end > length ? length : end;
      if (end < 0) {
        end += length;
      }
      length = start > end ? 0 : ((end - start) >>> 0);
      start >>>= 0;

      var result = Array(length);
      while (++index < length) {
        result[index] = array[index + start];
      }
      return result;
    }

    module.exports = baseSlice;
    });

    var require$$1$21 = (_baseSlice && typeof _baseSlice === 'object' && 'default' in _baseSlice ? _baseSlice['default'] : _baseSlice);

    var _parent = __commonjs(function (module) {
    var baseSlice = require$$1$21,
        get = require$$1$20;

    /**
     * Gets the parent value at `path` of `object`.
     *
     * @private
     * @param {Object} object The object to query.
     * @param {Array} path The path to get the parent value of.
     * @returns {*} Returns the parent value.
     */
    function parent(object, path) {
      return path.length == 1 ? object : get(object, baseSlice(path, 0, -1));
    }

    module.exports = parent;
    });

    var require$$0$32 = (_parent && typeof _parent === 'object' && 'default' in _parent ? _parent['default'] : _parent);

    var last = __commonjs(function (module) {
    /**
     * Gets the last element of `array`.
     *
     * @static
     * @memberOf _
     * @category Array
     * @param {Array} array The array to query.
     * @returns {*} Returns the last element of `array`.
     * @example
     *
     * _.last([1, 2, 3]);
     * // => 3
     */
    function last(array) {
      var length = array ? array.length : 0;
      return length ? array[length - 1] : undefined;
    }

    module.exports = last;
    });

    var _default4$1 = (last && typeof last === 'object' && 'default' in last ? last['default'] : last);

    var _hasPath = __commonjs(function (module) {
    var baseCastPath = require$$3$6,
        isArguments = require$$2$6,
        isArray = require$$2$5,
        isIndex = require$$1$13,
        isKey = require$$0$34,
        isLength = require$$1$1,
        isString = _default3,
        last = _default4$1,
        parent = require$$0$32;

    /**
     * Checks if `path` exists on `object`.
     *
     * @private
     * @param {Object} object The object to query.
     * @param {Array|string} path The path to check.
     * @param {Function} hasFunc The function to check properties.
     * @returns {boolean} Returns `true` if `path` exists, else `false`.
     */
    function hasPath(object, path, hasFunc) {
      if (object == null) {
        return false;
      }
      var result = hasFunc(object, path);
      if (!result && !isKey(path)) {
        path = baseCastPath(path);
        object = parent(object, path);
        if (object != null) {
          path = last(path);
          result = hasFunc(object, path);
        }
      }
      var length = object ? object.length : undefined;
      return result || (
        !!length && isLength(length) && isIndex(path, length) &&
        (isArray(object) || isString(object) || isArguments(object))
      );
    }

    module.exports = hasPath;
    });

    var require$$0$31 = (_hasPath && typeof _hasPath === 'object' && 'default' in _hasPath ? _hasPath['default'] : _hasPath);

    var has$1 = __commonjs(function (module) {
    var baseHas = require$$1$14,
        hasPath = require$$0$31;

    /**
     * Checks if `path` is a direct property of `object`.
     *
     * @static
     * @memberOf _
     * @category Object
     * @param {Object} object The object to query.
     * @param {Array|string} path The path to check.
     * @returns {boolean} Returns `true` if `path` exists, else `false`.
     * @example
     *
     * var object = { 'a': { 'b': { 'c': 3 } } };
     * var other = _.create({ 'a': _.create({ 'b': _.create({ 'c': 3 }) }) });
     *
     * _.has(object, 'a');
     * // => true
     *
     * _.has(object, 'a.b.c');
     * // => true
     *
     * _.has(object, ['a', 'b', 'c']);
     * // => true
     *
     * _.has(other, 'a');
     * // => false
     */
    function has(object, path) {
      return hasPath(object, path, baseHas);
    }

    module.exports = has;
    });

    var _default2$1 = (has$1 && typeof has$1 === 'object' && 'default' in has$1 ? has$1['default'] : has$1);

    var events = __commonjs(function (module) {
    // Copyright Joyent, Inc. and other Node contributors.
    //
    // Permission is hereby granted, free of charge, to any person obtaining a
    // copy of this software and associated documentation files (the
    // "Software"), to deal in the Software without restriction, including
    // without limitation the rights to use, copy, modify, merge, publish,
    // distribute, sublicense, and/or sell copies of the Software, and to permit
    // persons to whom the Software is furnished to do so, subject to the
    // following conditions:
    //
    // The above copyright notice and this permission notice shall be included
    // in all copies or substantial portions of the Software.
    //
    // THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
    // OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
    // MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN
    // NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
    // DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
    // OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE
    // USE OR OTHER DEALINGS IN THE SOFTWARE.

    function EventEmitter() {
      this._events = this._events || {};
      this._maxListeners = this._maxListeners || undefined;
    }
    module.exports = EventEmitter;

    // Backwards-compat with node 0.10.x
    EventEmitter.EventEmitter = EventEmitter;

    EventEmitter.prototype._events = undefined;
    EventEmitter.prototype._maxListeners = undefined;

    // By default EventEmitters will print a warning if more than 10 listeners are
    // added to it. This is a useful default which helps finding memory leaks.
    EventEmitter.defaultMaxListeners = 10;

    // Obviously not all Emitters should be limited to 10. This function allows
    // that to be increased. Set to zero for unlimited.
    EventEmitter.prototype.setMaxListeners = function(n) {
      if (!isNumber(n) || n < 0 || isNaN(n))
        throw TypeError('n must be a positive number');
      this._maxListeners = n;
      return this;
    };

    EventEmitter.prototype.emit = function(type) {
      var er, handler, len, args, i, listeners;

      if (!this._events)
        this._events = {};

      // If there is no 'error' event listener then throw.
      if (type === 'error') {
        if (!this._events.error ||
            (isObject(this._events.error) && !this._events.error.length)) {
          er = arguments[1];
          if (er instanceof Error) {
            throw er; // Unhandled 'error' event
          }
          throw TypeError('Uncaught, unspecified "error" event.');
        }
      }

      handler = this._events[type];

      if (isUndefined(handler))
        return false;

      if (isFunction(handler)) {
        switch (arguments.length) {
          // fast cases
          case 1:
            handler.call(this);
            break;
          case 2:
            handler.call(this, arguments[1]);
            break;
          case 3:
            handler.call(this, arguments[1], arguments[2]);
            break;
          // slower
          default:
            args = Array.prototype.slice.call(arguments, 1);
            handler.apply(this, args);
        }
      } else if (isObject(handler)) {
        args = Array.prototype.slice.call(arguments, 1);
        listeners = handler.slice();
        len = listeners.length;
        for (i = 0; i < len; i++)
          listeners[i].apply(this, args);
      }

      return true;
    };

    EventEmitter.prototype.addListener = function(type, listener) {
      var m;

      if (!isFunction(listener))
        throw TypeError('listener must be a function');

      if (!this._events)
        this._events = {};

      // To avoid recursion in the case that type === "newListener"! Before
      // adding it to the listeners, first emit "newListener".
      if (this._events.newListener)
        this.emit('newListener', type,
                  isFunction(listener.listener) ?
                  listener.listener : listener);

      if (!this._events[type])
        // Optimize the case of one listener. Don't need the extra array object.
        this._events[type] = listener;
      else if (isObject(this._events[type]))
        // If we've already got an array, just append.
        this._events[type].push(listener);
      else
        // Adding the second element, need to change to array.
        this._events[type] = [this._events[type], listener];

      // Check for listener leak
      if (isObject(this._events[type]) && !this._events[type].warned) {
        if (!isUndefined(this._maxListeners)) {
          m = this._maxListeners;
        } else {
          m = EventEmitter.defaultMaxListeners;
        }

        if (m && m > 0 && this._events[type].length > m) {
          this._events[type].warned = true;
          console.error('(node) warning: possible EventEmitter memory ' +
                        'leak detected. %d listeners added. ' +
                        'Use emitter.setMaxListeners() to increase limit.',
                        this._events[type].length);
          if (typeof console.trace === 'function') {
            // not supported in IE 10
            console.trace();
          }
        }
      }

      return this;
    };

    EventEmitter.prototype.on = EventEmitter.prototype.addListener;

    EventEmitter.prototype.once = function(type, listener) {
      if (!isFunction(listener))
        throw TypeError('listener must be a function');

      var fired = false;

      function g() {
        this.removeListener(type, g);

        if (!fired) {
          fired = true;
          listener.apply(this, arguments);
        }
      }

      g.listener = listener;
      this.on(type, g);

      return this;
    };

    // emits a 'removeListener' event iff the listener was removed
    EventEmitter.prototype.removeListener = function(type, listener) {
      var list, position, length, i;

      if (!isFunction(listener))
        throw TypeError('listener must be a function');

      if (!this._events || !this._events[type])
        return this;

      list = this._events[type];
      length = list.length;
      position = -1;

      if (list === listener ||
          (isFunction(list.listener) && list.listener === listener)) {
        delete this._events[type];
        if (this._events.removeListener)
          this.emit('removeListener', type, listener);

      } else if (isObject(list)) {
        for (i = length; i-- > 0;) {
          if (list[i] === listener ||
              (list[i].listener && list[i].listener === listener)) {
            position = i;
            break;
          }
        }

        if (position < 0)
          return this;

        if (list.length === 1) {
          list.length = 0;
          delete this._events[type];
        } else {
          list.splice(position, 1);
        }

        if (this._events.removeListener)
          this.emit('removeListener', type, listener);
      }

      return this;
    };

    EventEmitter.prototype.removeAllListeners = function(type) {
      var key, listeners;

      if (!this._events)
        return this;

      // not listening for removeListener, no need to emit
      if (!this._events.removeListener) {
        if (arguments.length === 0)
          this._events = {};
        else if (this._events[type])
          delete this._events[type];
        return this;
      }

      // emit removeListener for all listeners on all events
      if (arguments.length === 0) {
        for (key in this._events) {
          if (key === 'removeListener') continue;
          this.removeAllListeners(key);
        }
        this.removeAllListeners('removeListener');
        this._events = {};
        return this;
      }

      listeners = this._events[type];

      if (isFunction(listeners)) {
        this.removeListener(type, listeners);
      } else if (listeners) {
        // LIFO order
        while (listeners.length)
          this.removeListener(type, listeners[listeners.length - 1]);
      }
      delete this._events[type];

      return this;
    };

    EventEmitter.prototype.listeners = function(type) {
      var ret;
      if (!this._events || !this._events[type])
        ret = [];
      else if (isFunction(this._events[type]))
        ret = [this._events[type]];
      else
        ret = this._events[type].slice();
      return ret;
    };

    EventEmitter.prototype.listenerCount = function(type) {
      if (this._events) {
        var evlistener = this._events[type];

        if (isFunction(evlistener))
          return 1;
        else if (evlistener)
          return evlistener.length;
      }
      return 0;
    };

    EventEmitter.listenerCount = function(emitter, type) {
      return emitter.listenerCount(type);
    };

    function isFunction(arg) {
      return typeof arg === 'function';
    }

    function isNumber(arg) {
      return typeof arg === 'number';
    }

    function isObject(arg) {
      return typeof arg === 'object' && arg !== null;
    }

    function isUndefined(arg) {
      return arg === void 0;
    }
    });

    var EventEmitter = events.EventEmitter;

    var index$2 = __commonjs(function (module, exports) {
    'use strict';

    function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

    var Trackr$$ = _interopDefault(Trackr);

    var babelHelpers = {};
    babelHelpers.typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) {
      return typeof obj;
    } : function (obj) {
      return obj && typeof Symbol === "function" && obj.constructor === Symbol ? "symbol" : typeof obj;
    };

    babelHelpers.classCallCheck = function (instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    };

    babelHelpers.createClass = function () {
      function defineProperties(target, props) {
        for (var i = 0; i < props.length; i++) {
          var descriptor = props[i];
          descriptor.enumerable = descriptor.enumerable || false;
          descriptor.configurable = true;
          if ("value" in descriptor) descriptor.writable = true;
          Object.defineProperty(target, descriptor.key, descriptor);
        }
      }

      return function (Constructor, protoProps, staticProps) {
        if (protoProps) defineProperties(Constructor.prototype, protoProps);
        if (staticProps) defineProperties(Constructor, staticProps);
        return Constructor;
      };
    }();

    babelHelpers;

    function trackProperty(obj, prop, value, options) {
    	if ((typeof obj === "undefined" ? "undefined" : babelHelpers.typeof(obj)) !== "object" || obj == null) {
    		throw new Error("Expecting object to define the reactive property on.");
    	}

    	if (typeof prop !== "string") throw new Error("Expecting string for property name.");

    	var dep = new Trackr$$.Dependency();

    	Object.defineProperty(obj, prop, {
    		configurable: options != null && Boolean(options.configurable),
    		enumerable: options == null || options.enumerable !== false,
    		set: function set(val) {
    			if (val !== value) {
    				value = val;
    				dep.changed();
    			}

    			return value;
    		},
    		get: function get() {
    			dep.depend();
    			return value;
    		}
    	});

    	return obj;
    }

    function hasOwn(o, k) {
    	return Object.prototype.hasOwnProperty.call(o, k);
    }

    var Map = function () {
    	function Map(obj) {
    		babelHelpers.classCallCheck(this, Map);

    		this._keysDep = new Trackr$$.Dependency();
    		this._valuesDep = new Trackr$$.Dependency();
    		this._deps = {};
    		this._values = {};

    		if ((typeof obj === "undefined" ? "undefined" : babelHelpers.typeof(obj)) === "object" && obj != null) {
    			for (var key in obj) {
    				this.set(key, obj[key]);
    			}
    		}
    	}

    	babelHelpers.createClass(Map, [{
    		key: "set",
    		value: function set(key, value) {
    			if ((typeof key === "undefined" ? "undefined" : babelHelpers.typeof(key)) === "object") {
    				for (var k in key) {
    					if (hasOwn(key, k)) this.set(k, key[k]);
    				}
    				return this;
    			}

    			var has = hasOwn(this._values, key);

    			if (!has || this._values[key] !== value) {
    				this._values[key] = value;
    				this._getDep(key).changed();
    				if (!has) this._keysDep.changed();
    				this._valuesDep.changed();
    			}

    			return this;
    		}
    	}, {
    		key: "clear",
    		value: function clear() {
    			var keys = Object.keys(this._values);

    			if (keys.length) {
    				var _iteratorNormalCompletion = true;
    				var _didIteratorError = false;
    				var _iteratorError = undefined;

    				try {
    					for (var _iterator = keys[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
    						var k = _step.value;

    						delete this._values[k];
    						this._getDep(k).changed();
    					}
    				} catch (err) {
    					_didIteratorError = true;
    					_iteratorError = err;
    				} finally {
    					try {
    						if (!_iteratorNormalCompletion && _iterator.return) {
    							_iterator.return();
    						}
    					} finally {
    						if (_didIteratorError) {
    							throw _iteratorError;
    						}
    					}
    				}

    				this._keysDep.changed();
    				this._valuesDep.changed();
    			}

    			return this;
    		}
    	}, {
    		key: "delete",
    		value: function _delete(key) {
    			if (hasOwn(this._values, key)) {
    				delete this._values[key];
    				this._getDep(key).changed();
    				this._keysDep.changed();
    				this._valuesDep.changed();
    			}

    			return this;
    		}
    	}, {
    		key: "forEach",
    		value: function forEach(fn, ctx) {
    			var _iteratorNormalCompletion2 = true;
    			var _didIteratorError2 = false;
    			var _iteratorError2 = undefined;

    			try {
    				for (var _iterator2 = this.keys()[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
    					var k = _step2.value;

    					fn.call(ctx, this.get(k), k, this);
    				}
    			} catch (err) {
    				_didIteratorError2 = true;
    				_iteratorError2 = err;
    			} finally {
    				try {
    					if (!_iteratorNormalCompletion2 && _iterator2.return) {
    						_iterator2.return();
    					}
    				} finally {
    					if (_didIteratorError2) {
    						throw _iteratorError2;
    					}
    				}
    			}

    			return this;
    		}
    	}, {
    		key: "_getDep",
    		value: function _getDep(k) {
    			if (this._deps[k] == null) this._deps[k] = new Trackr$$.Dependency();
    			return this._deps[k];
    		}
    	}, {
    		key: "get",
    		value: function get(key) {
    			this._getDep(key).depend();
    			return this._values[key];
    		}
    	}, {
    		key: "has",
    		value: function has(key) {
    			this._getDep(key).depend();
    			return hasOwn(this._values, key);
    		}
    	}, {
    		key: "keys",
    		value: function keys() {
    			this._keysDep.depend();
    			return Object.keys(this._values);
    		}

    		// TODO enable when ES6 settles
    		// * entries() {
    		// 	for (let k of this.keys()) {
    		// 		yield [ k, this.get(k) ];
    		// 	}
    		// }
    		//
    		// * values() {
    		// 	for (let k of this.keys()) {
    		// 		yield this.get(k);
    		// 	}
    		// }

    	}, {
    		key: "toJSON",
    		value: function toJSON() {
    			var out = {};
    			var _iteratorNormalCompletion3 = true;
    			var _didIteratorError3 = false;
    			var _iteratorError3 = undefined;

    			try {
    				for (var _iterator3 = this.keys()[Symbol.iterator](), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
    					var k = _step3.value;
    					out[k] = this.get(k);
    				}
    			} catch (err) {
    				_didIteratorError3 = true;
    				_iteratorError3 = err;
    			} finally {
    				try {
    					if (!_iteratorNormalCompletion3 && _iterator3.return) {
    						_iterator3.return();
    					}
    				} finally {
    					if (_didIteratorError3) {
    						throw _iteratorError3;
    					}
    				}
    			}

    			return out;
    		}
    	}, {
    		key: "__trackr",
    		get: function get() {
    			return true;
    		}
    	}, {
    		key: "__trackr_type",
    		get: function get() {
    			return "map";
    		}
    	}, {
    		key: "size",
    		get: function get() {
    			return this.keys().length;
    		}
    	}]);
    	return Map;
    }();

    // Map.prototype[Symbol.iterator] = Map.prototype.values;

    Map.isMap = function (o) {
    	return o && o.__trackr && o.__trackr_type === "map";
    };

    var slice = Array.prototype.slice.call.bind(Array.prototype.slice);
    var arrayLike = function arrayLike(o) {
    	return typeof o.length === "number" && o.length >= 0;
    };

    function summariseSpliceOperation(array, args) {
    	var index, addedItems, removedItems;

    	if (!args) return null;

    	// figure out where the changes started...
    	index = +(args[0] < 0 ? array.length + args[0] : args[0]);

    	// ...and how many items were added to or removed from the array
    	addedItems = Math.max(0, args.length - 2);
    	removedItems = args[1] !== undefined ? args[1] : array.length - index;

    	// It's possible to do e.g. [ 1, 2, 3 ].splice( 2, 2 ) - i.e. the second argument
    	// means removing more items from the end of the array than there are. In these
    	// cases we need to curb JavaScript's enthusiasm or we'll get out of sync
    	removedItems = Math.min(removedItems, array.length - index);

    	return {
    		index: index,
    		added: addedItems,
    		removed: removedItems
    	};
    }

    var List = function () {
    	function List() {
    		babelHelpers.classCallCheck(this, List);

    		this._itemDep = new Trackr$$.Dependency();
    		this._lengthDep = new Trackr$$.Dependency();
    		this._deps = {};
    		this._items = [];
    		var _iteratorNormalCompletion = true;
    		var _didIteratorError = false;
    		var _iteratorError = undefined;

    		try {
    			for (var _iterator = slice(arguments)[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
    				var a = _step.value;
    				pushDynamic(this, a);
    			}
    		} catch (err) {
    			_didIteratorError = true;
    			_iteratorError = err;
    		} finally {
    			try {
    				if (!_iteratorNormalCompletion && _iterator.return) {
    					_iterator.return();
    				}
    			} finally {
    				if (_didIteratorError) {
    					throw _iteratorError;
    				}
    			}
    		}
    	}

    	babelHelpers.createClass(List, [{
    		key: "get",
    		value: function get(index) {
    			this._getDep(index).depend();
    			return this._items[index];
    		}
    	}, {
    		key: "_getDep",
    		value: function _getDep(k) {
    			if (this._deps[k] == null) this._deps[k] = new Trackr$$.Dependency();
    			return this._deps[k];
    		}
    	}, {
    		key: "splice",
    		value: function splice() {
    			var args = slice(arguments);
    			var op = summariseSpliceOperation(this._items, args);
    			var r = this._items.splice.apply(this._items, args);

    			this._itemDep.changed();
    			if (op.added !== op.removed) this._lengthDep.changed();
    			for (var i = 0; i < Math.max(op.added, op.removed); i++) {
    				this._getDep(op.index + i).changed();
    			}

    			return r;
    		}
    	}, {
    		key: "push",
    		value: function push() {
    			var args = [this._items.length, 0].concat(slice(arguments));
    			this.splice.apply(this, args);
    			return this._items.length;
    		}
    	}, {
    		key: "pop",
    		value: function pop() {
    			return this.splice(this._items.length - 1, 1)[0];
    		}
    	}, {
    		key: "unshift",
    		value: function unshift() {
    			var args = [0, 0].concat(slice(arguments));
    			this.splice.apply(this, args);
    			return this._items.length;
    		}
    	}, {
    		key: "shift",
    		value: function shift() {
    			return this.splice(0, 1)[0];
    		}
    	}, {
    		key: "reverse",
    		value: function reverse() {
    			this._items.reverse();

    			this._itemDep.changed();
    			for (var i = 0; i < this._items.length; i++) {
    				this._getDep(i).changed();
    			}

    			return this;
    		}
    	}, {
    		key: "sort",
    		value: function sort(f) {
    			this._items.sort(f);

    			this._itemDep.changed();
    			for (var i = 0; i < this._items.length; i++) {
    				this._getDep(i).changed();
    			}

    			return this;
    		}
    	}, {
    		key: "set",
    		value: function set(index, value) {
    			this.splice(index, 1, value);
    			return this;
    		}
    	}, {
    		key: "concat",
    		value: function concat() {
    			var l = new List(this);
    			var _iteratorNormalCompletion2 = true;
    			var _didIteratorError2 = false;
    			var _iteratorError2 = undefined;

    			try {
    				for (var _iterator2 = slice(arguments)[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
    					var a = _step2.value;
    					pushDynamic(l, a);
    				}
    			} catch (err) {
    				_didIteratorError2 = true;
    				_iteratorError2 = err;
    			} finally {
    				try {
    					if (!_iteratorNormalCompletion2 && _iterator2.return) {
    						_iterator2.return();
    					}
    				} finally {
    					if (_didIteratorError2) {
    						throw _iteratorError2;
    					}
    				}
    			}

    			return l;
    		}
    	}, {
    		key: "join",
    		value: function join(char) {
    			var str = "";
    			var len = this.length;

    			for (var v, i = 0; i < len; i++) {
    				v = this.get(i);
    				if (v == null) v = "";
    				if (typeof v !== "string") v = v.toString();
    				str += v + (i !== len - 1 ? char : "");
    			}

    			return str;
    		}
    	}, {
    		key: "slice",
    		value: function slice(start, end) {
    			var i = undefined,
    			    cloned = [],
    			    upTo = undefined,
    			    size = undefined,
    			    len = this._items.length;

    			// Handle negative value for "start"
    			if (typeof start === "number" && !isNaN(start)) {
    				if (start < 0) {
    					this._lengthDep.depend();
    					start = Math.max(0, len + start);
    				}
    			} else {
    				start = 0;
    			}

    			// Handle negative value for "end"
    			if (typeof end === "number" && !isNaN(end)) {
    				upTo = Math.min(end, len);
    				if (end < 0) {
    					this._lengthDep.depend();
    					upTo = len + end;
    				}
    			} else {
    				this._lengthDep.depend();
    				upTo = len;
    			}

    			// Actual expected size of the slice
    			size = upTo - start;

    			if (size > 0) {
    				cloned = new Array(size);
    				for (i = 0; i < size; i++) {
    					cloned[i] = this.get(start + i);
    				}
    			}

    			return cloned;
    		}
    	}, {
    		key: "indexOf",
    		value: function indexOf(member, start) {
    			var len = this._items.length;

    			if (typeof start === "number" && !isNaN(start)) {
    				start = Math.min(Math.max(start, 0), len);
    			} else {
    				start = 0;
    			}

    			for (var i = start; i < len; i++) {
    				if (this.get(i) === member) return i;
    			}

    			// only depend on length change if member wasn't found
    			this._lengthDep.depend();
    			return -1;
    		}
    	}, {
    		key: "forEach",
    		value: function forEach(fn, ctx) {
    			this._itemDep.depend();

    			for (var i = 0; i < this._items.length; i++) {
    				fn.call(ctx, this._items[i], i, this);
    			}

    			return this;
    		}
    	}, {
    		key: "reduce",
    		value: function reduce(fn, value) {
    			this.forEach(function (current, index, list) {
    				value = fn.call(null, value, current, index, list);
    			});

    			return value;
    		}
    	}, {
    		key: "map",
    		value: function map(fn, ctx) {
    			return this.reduce(function (els) {
    				els.push(fn.apply(ctx, slice(arguments, 1)));
    				return els;
    			}, []);
    		}
    	}, {
    		key: "filter",
    		value: function filter(fn, ctx) {
    			return this.reduce(function (els, item) {
    				if (fn.apply(ctx, slice(arguments, 1))) els.push(item);
    				return els;
    			}, []);
    		}
    	}, {
    		key: "some",
    		value: function some(fn, ctx) {
    			var len = this._items.length;

    			for (var i = 0; i < len; i++) {
    				if (fn.call(ctx, this.get(i), i, this)) return true;
    			}

    			// only depend on length if none of the elements pass
    			this._lengthDep.depend();
    			return false;
    		}
    	}, {
    		key: "every",
    		value: function every(fn, ctx) {
    			var len = this._items.length;

    			for (var i = 0; i < len; i++) {
    				if (!fn.call(ctx, this.get(i), i, this)) return false;
    			}

    			// only depend on length if all of the elements pass
    			this._lengthDep.depend();
    			return true;
    		}

    		// TODO enable when ES6 settles
    		// * values() {
    		// 	let len = this._items.length;
    		//
    		// 	for (let i = 0; i < len; i++) {
    		// 		yield this.get(i);
    		// 	}
    		//
    		// 	// depend on length if it gets to the end
    		// 	this._lengthDep.depend();
    		// }

    	}, {
    		key: "toJSON",
    		value: function toJSON() {
    			return this.slice(0);
    		}
    	}, {
    		key: "toArray",
    		value: function toArray() {
    			return this.slice(0);
    		}
    	}, {
    		key: "__trackr",
    		get: function get() {
    			return true;
    		}
    	}, {
    		key: "__trackr_type",
    		get: function get() {
    			return "list";
    		}
    	}, {
    		key: "length",
    		get: function get() {
    			this._lengthDep.depend();
    			return this._items.length;
    		}
    	}]);
    	return List;
    }();

    // List.prototype[Symbol.iterator] = List.prototype.values;

    List.isList = function (o) {
    	return o && o.__trackr && o.__trackr_type === "list";
    };

    function pushDynamic(l, v) {
    	if (arrayLike(v)) l.push.apply(l, slice(v));else if (List.isList(v)) v.forEach(function (i) {
    		return l.push(i);
    	});else l.push(v);
    }

    var Variable = function () {
    	function Variable(value) {
    		babelHelpers.classCallCheck(this, Variable);

    		this._value = void 0;
    		this._dep = new Trackr$$.Dependency();
    		this.set(value);
    	}

    	babelHelpers.createClass(Variable, [{
    		key: "set",
    		value: function set(value) {
    			if (value !== this._value) {
    				this._value = value;
    				this._dep.changed();
    			}
    		}
    	}, {
    		key: "get",
    		value: function get() {
    			this._dep.depend();
    			return this._value;
    		}
    	}, {
    		key: "toString",
    		value: function toString() {
    			return "" + this.get();
    		}
    	}, {
    		key: "toJSON",
    		value: function toJSON() {
    			return this.get();
    		}
    	}, {
    		key: "__trackr",
    		get: function get() {
    			return true;
    		}
    	}, {
    		key: "__trackr_type",
    		get: function get() {
    			return "variable";
    		}
    	}]);
    	return Variable;
    }();

    Variable.isVariable = function (o) {
    	return o && o.__trackr && o.__trackr_type === "variable";
    };

    exports.List = List;
    exports.Map = Map;
    exports.Variable = Variable;
    exports.trackProperty = trackProperty;
    });

    var trackProperty = index$2.trackProperty;
    var Variable = index$2.Variable;
    var Map = index$2.Map;
    var List = index$2.List;

    var index$4 = __commonjs(function (module) {
    var hasOwn = Object.prototype.hasOwnProperty;

    var defaults = {
    	configurable: false,
    	enumerable: true
    };

    // defines protected, immutable properties
    function assignProps(obj, key, val, opts) {
    	var k;

    	// accept object syntax
    	if (typeof key === "object") {
    		for (k in key) {
    			if (hasOwn.call(key, k)) assignProps(obj, k, key[k], val);
    		}
    		return;
    	}

    	var desc = {};
    	opts = opts || {};

    	// build base descriptor
    	for (k in defaults) {
    		desc[k] = typeof opts[k] === "boolean" ? opts[k] : defaults[k];
    	}

    	// set descriptor props based on value
    	if (!opts.forceStatic && typeof val === "function") {
    		desc.get = val;
    	} else {
    		desc.value = val;
    		desc.writable = false;
    	}

    	// define the property
    	Object.defineProperty(obj, key, desc);
    }

    module.exports = assignProps;
    });

    var assignProps = (index$4 && typeof index$4 === 'object' && 'default' in index$4 ? index$4['default'] : index$4);

    var _isIterateeCall = __commonjs(function (module) {
    var eq = require$$0$16,
        isArrayLike = require$$0$5,
        isIndex = require$$1$13,
        isObject = require$$0$2;

    /**
     * Checks if the given arguments are from an iteratee call.
     *
     * @private
     * @param {*} value The potential iteratee value argument.
     * @param {*} index The potential iteratee index or key argument.
     * @param {*} object The potential iteratee object argument.
     * @returns {boolean} Returns `true` if the arguments are from an iteratee call, else `false`.
     */
    function isIterateeCall(value, index, object) {
      if (!isObject(object)) {
        return false;
      }
      var type = typeof index;
      if (type == 'number'
          ? (isArrayLike(object) && isIndex(index, object.length))
          : (type == 'string' && index in object)) {
        return eq(object[index], value);
      }
      return false;
    }

    module.exports = isIterateeCall;
    });

    var require$$1$23 = (_isIterateeCall && typeof _isIterateeCall === 'object' && 'default' in _isIterateeCall ? _isIterateeCall['default'] : _isIterateeCall);

    var _createAssigner = __commonjs(function (module) {
    var isIterateeCall = require$$1$23,
        rest = require$$0;

    /**
     * Creates a function like `_.assign`.
     *
     * @private
     * @param {Function} assigner The function to assign values.
     * @returns {Function} Returns the new assigner function.
     */
    function createAssigner(assigner) {
      return rest(function(object, sources) {
        var index = -1,
            length = sources.length,
            customizer = length > 1 ? sources[length - 1] : undefined,
            guard = length > 2 ? sources[2] : undefined;

        customizer = typeof customizer == 'function'
          ? (length--, customizer)
          : undefined;

        if (guard && isIterateeCall(sources[0], sources[1], guard)) {
          customizer = length < 3 ? undefined : customizer;
          length = 1;
        }
        object = Object(object);
        while (++index < length) {
          var source = sources[index];
          if (source) {
            assigner(object, source, index, customizer);
          }
        }
        return object;
      });
    }

    module.exports = createAssigner;
    });

    var require$$1$22 = (_createAssigner && typeof _createAssigner === 'object' && 'default' in _createAssigner ? _createAssigner['default'] : _createAssigner);

    var _assignValue = __commonjs(function (module) {
    var eq = require$$0$16;

    /** Used for built-in method references. */
    var objectProto = Object.prototype;

    /** Used to check objects for own properties. */
    var hasOwnProperty = objectProto.hasOwnProperty;

    /**
     * Assigns `value` to `key` of `object` if the existing value is not equivalent
     * using [`SameValueZero`](http://ecma-international.org/ecma-262/6.0/#sec-samevaluezero)
     * for equality comparisons.
     *
     * @private
     * @param {Object} object The object to modify.
     * @param {string} key The key of the property to assign.
     * @param {*} value The value to assign.
     */
    function assignValue(object, key, value) {
      var objValue = object[key];
      if (!(hasOwnProperty.call(object, key) && eq(objValue, value)) ||
          (value === undefined && !(key in object))) {
        object[key] = value;
      }
    }

    module.exports = assignValue;
    });

    var require$$0$39 = (_assignValue && typeof _assignValue === 'object' && 'default' in _assignValue ? _assignValue['default'] : _assignValue);

    var _copyObjectWith = __commonjs(function (module) {
    var assignValue = require$$0$39;

    /**
     * This function is like `copyObject` except that it accepts a function to
     * customize copied values.
     *
     * @private
     * @param {Object} source The object to copy properties from.
     * @param {Array} props The property names to copy.
     * @param {Object} [object={}] The object to copy properties to.
     * @param {Function} [customizer] The function to customize copied values.
     * @returns {Object} Returns `object`.
     */
    function copyObjectWith(source, props, object, customizer) {
      object || (object = {});

      var index = -1,
          length = props.length;

      while (++index < length) {
        var key = props[index];

        var newValue = customizer
          ? customizer(object[key], source[key], key, object, source)
          : source[key];

        assignValue(object, key, newValue);
      }
      return object;
    }

    module.exports = copyObjectWith;
    });

    var require$$0$38 = (_copyObjectWith && typeof _copyObjectWith === 'object' && 'default' in _copyObjectWith ? _copyObjectWith['default'] : _copyObjectWith);

    var _copyObject = __commonjs(function (module) {
    var copyObjectWith = require$$0$38;

    /**
     * Copies properties of `source` to `object`.
     *
     * @private
     * @param {Object} source The object to copy properties from.
     * @param {Array} props The property names to copy.
     * @param {Object} [object={}] The object to copy properties to.
     * @returns {Object} Returns `object`.
     */
    function copyObject(source, props, object) {
      return copyObjectWith(source, props, object);
    }

    module.exports = copyObject;
    });

    var require$$2$9 = (_copyObject && typeof _copyObject === 'object' && 'default' in _copyObject ? _copyObject['default'] : _copyObject);

    var assign = __commonjs(function (module) {
    var copyObject = require$$2$9,
        createAssigner = require$$1$22,
        keys = require$$0$24;

    /**
     * Assigns own enumerable properties of source objects to the destination
     * object. Source objects are applied from left to right. Subsequent sources
     * overwrite property assignments of previous sources.
     *
     * **Note:** This method mutates `object` and is loosely based on
     * [`Object.assign`](https://mdn.io/Object/assign).
     *
     * @static
     * @memberOf _
     * @category Object
     * @param {Object} object The destination object.
     * @param {...Object} [sources] The source objects.
     * @returns {Object} Returns `object`.
     * @example
     *
     * function Foo() {
     *   this.c = 3;
     * }
     *
     * function Bar() {
     *   this.e = 5;
     * }
     *
     * Foo.prototype.d = 4;
     * Bar.prototype.f = 6;
     *
     * _.assign({ 'a': 1 }, new Foo, new Bar);
     * // => { 'a': 1, 'c': 3, 'e': 5 }
     */
    var assign = createAssigner(function(object, source) {
      copyObject(source, keys(source), object);
    });

    module.exports = assign;
    });

    var _default3$1 = (assign && typeof assign === 'object' && 'default' in assign ? assign['default'] : assign);

    var includes = __commonjs(function (module) {
    var baseIndexOf = require$$4$2,
        isArrayLike = require$$0$5,
        isString = _default3,
        toInteger = require$$1,
        values = require$$0$27;

    /* Built-in method references for those with the same name as other `lodash` methods. */
    var nativeMax = Math.max;

    /**
     * Checks if `value` is in `collection`. If `collection` is a string it's checked
     * for a substring of `value`, otherwise [`SameValueZero`](http://ecma-international.org/ecma-262/6.0/#sec-samevaluezero)
     * is used for equality comparisons. If `fromIndex` is negative, it's used as
     * the offset from the end of `collection`.
     *
     * @static
     * @memberOf _
     * @category Collection
     * @param {Array|Object|string} collection The collection to search.
     * @param {*} value The value to search for.
     * @param {number} [fromIndex=0] The index to search from.
     * @param- {Object} [guard] Enables use as an iteratee for functions like `_.reduce`.
     * @returns {boolean} Returns `true` if `value` is found, else `false`.
     * @example
     *
     * _.includes([1, 2, 3], 1);
     * // => true
     *
     * _.includes([1, 2, 3], 1, 2);
     * // => false
     *
     * _.includes({ 'user': 'fred', 'age': 40 }, 'fred');
     * // => true
     *
     * _.includes('pebbles', 'eb');
     * // => true
     */
    function includes(collection, value, fromIndex, guard) {
      collection = isArrayLike(collection) ? collection : values(collection);
      fromIndex = (fromIndex && !guard) ? toInteger(fromIndex) : 0;

      var length = collection.length;
      if (fromIndex < 0) {
        fromIndex = nativeMax(length + fromIndex, 0);
      }
      return isString(collection)
        ? (fromIndex <= length && collection.indexOf(value, fromIndex) > -1)
        : (!!length && baseIndexOf(collection, value, fromIndex) > -1);
    }

    module.exports = includes;
    });

    var _default2$2 = (includes && typeof includes === 'object' && 'default' in includes ? includes['default'] : includes);

    var decorators = {};

    function plugin() {
    	this._decorators = {};
    	this.decorate = add;
    	this.stopDecorating = remove;
    	this.findDecorator = find;
    }

    // creates a decorator
    function add(name, fn, options) {
    	var _this = this;

    	if ((typeof name === "undefined" ? "undefined" : babelHelpers.typeof(name)) === "object") {
    		options = fn;
    		_default(name, function (fn, n) {
    			if (require$$2$5(fn)) add.call(_this, n, fn[0], fn[1]);else add.call(_this, n, fn, options);
    		});
    		return this;
    	}

    	if (typeof name !== "string" || name === "") throw new Error("Expecting non-empty string for decorator name.");
    	if (typeof fn !== "function") throw new Error("Expecting function for decorator.");

    	var decs = this._decorators ? this._decorators : decorators;
    	decs[name] = {
    		template: this,
    		callback: fn,
    		options: options || {}
    	};

    	return this;
    }

    // removes a decorator
    function remove(name) {
    	if (this._decorators) {
    		if (name == null) this._decorators = {};else delete this._decorators[name];
    	} else if (name) {
    		delete decorators[name];
    	}

    	return this;
    }

    function find(name) {
    	var decs = this._decorators;
    	if (decs != null && decs[name]) {
    		return decs[name];
    	}
    }

    // finds the best decorator
    function lookup$1(ctx, name) {
    	// look on the closest template
    	var owner = ctx.getTemplateContext();
    	if (owner) {
    		var dec = owner.template.findDecorator(name);
    		if (dec) return _default3$1({ owner: owner }, dec);
    	}

    	// look globally
    	if (decorators[name]) {
    		return _default3$1({ owner: global }, decorators[name]);
    	}
    }

    function setAttribute(node, name, values) {
    	var v = !values || !values.length || values[0] == null ? "" : values[0];
    	updateAttribute(node, name, v);
    }

    function render$1(_ctx, name, value) {
    	var node = currentElement();
    	if (!node) throw new Error("Not currently patching.");

    	// each decorator is given its own context
    	var ctx = new Context$1(null, _ctx);

    	var isStaticValue = typeof value !== "function";
    	var getValue = function getValue() {
    		var val = isStaticValue ? value : value(ctx);
    		if (!require$$2$5(val)) val = [val];
    		return val;
    	};

    	// look up decorator by name
    	var d = lookup$1(ctx, name);

    	// quick escape if static value and no decorator
    	if (isStaticValue && !d) {
    		setAttribute(node, name, getValue());
    		return;
    	}

    	var anim = undefined,
    	    comp = undefined;
    	var cancel = false;
    	var decctx = _default3$1({
    		target: node,
    		context: ctx
    	}, d);

    	var run = function run(c) {
    		decctx.comp = c;
    		var val = getValue();

    		if (!d) {
    			setAttribute(node, name, val);
    			return;
    		}

    		// execute the callback
    		d.callback.apply(d.template, [decctx].concat(val));
    	};

    	// defer computation if desired
    	if (d && d.options && d.options.defer) {
    		// clean up when current computation reruns
    		var pcomp = Trackr.currentComputation;
    		if (!pcomp) throw new Error("Can only render decorator in a computation.");
    		pcomp.onInvalidate(function () {
    			cancel = true;
    			if (anim) raf.cancel(anim);
    			if (comp) comp.stop();
    		});

    		// run decorator on the next frame
    		anim = raf(function () {
    			if (cancel) return;
    			anim = null;
    			comp = Trackr.autorun(run);
    		});
    	} else {
    		Trackr.autorun(run);
    	}
    }

var decorators$1 = Object.freeze({
    	plugin: plugin,
    	default: plugin,
    	add: add,
    	remove: remove,
    	find: find,
    	lookup: lookup$1,
    	render: render$1
    });

    var decorators$2 = {};
    var actions = {};

    // Action Class
    var Action = function () {
    	function Action(name, context) {
    		babelHelpers.classCallCheck(this, Action);

    		this.name = name;
    		this.context = context;
    		this.bubbles = true;
    	}

    	babelHelpers.createClass(Action, [{
    		key: "stopPropagation",
    		value: function stopPropagation() {
    			this.bubbles = false;
    			return this;
    		}
    	}], [{
    		key: "create",
    		value: function create(name, context) {
    			var action = undefined;

    			if (typeof name === "string") {
    				action = new Action(name, context);
    			} else if (require$$0$2(name) && !(name instanceof Action)) {
    				action = _default3$1(new Action(), action);
    			} else {
    				action = name;
    			}

    			if (!(action instanceof Action)) {
    				throw new Error("Expecting action name, object or instance of Action.");
    			}

    			return action;
    		}
    	}]);
    	return Action;
    }();

    // the plugin
    function plugin$1() {
    	this.use("decorators");
    	this._actions = {};
    	this.actions = this.addAction = add$1;
    	this.removeAction = remove$1;
    	this.decorate(decorators$2);
    }

    // standard dom events
    defineEvent(['load', 'scroll', 'click', 'dblclick', 'mousedown', 'mouseup', 'mouseenter', 'mouseleave', 'keydown', 'keypress', 'keyup', 'blur', 'focus', 'change', 'input', 'submit', 'reset', 'drag', 'dragdrop', 'dragend', 'dragenter', 'dragexit', 'dragleave', 'dragover', 'dragstart', 'drop']);

    function defineEvent(event) {
    	if (require$$2$5(event)) return event.forEach(defineEvent);

    	decorators$2["on-" + event] = function (decor, key) {
    		var node = undefined,
    		    args = undefined;
    		var listener = function listener(e) {
    			// create a new action object
    			var action = new Action(key, decor.context);
    			action.original = e;
    			action.target = action.node = node;
    			action.owner = decor.owner;
    			action.template = decor.template;

    			// fire the action
    			return fire(action, null, args);
    		};

    		node = decor.target;
    		args = Array.prototype.slice.call(arguments, 2);

    		node.addEventListener(event, listener);
    		decor.comp.onInvalidate(function () {
    			node.removeEventListener(event, listener);
    		});
    	};
    }

    // Msutache Instance Methods
    function add$1(name, fn) {
    	var _this = this;

    	if ((typeof name === "undefined" ? "undefined" : babelHelpers.typeof(name)) === "object" && fn == null) {
    		_default(name, function (fn, n) {
    			return add$1.call(_this, n, fn);
    		});
    		return this;
    	}

    	if (typeof name !== "string" || name === "") throw new Error("Expecting non-empty string for action name.");
    	if (typeof fn !== "function") throw new Error("Expecting function for action.");

    	var obj = this._actions;
    	if (!obj) obj = actions;
    	if (obj[name] == null) obj[name] = [];
    	if (! ~obj[name].indexOf(fn)) obj[name].push(fn);

    	return this;
    }

    function remove$1(name, fn) {
    	if (typeof name === "function" && fn == null) {
    		fn = name;
    		name = null;
    	}

    	var obj = this._actions;
    	if (!obj) obj = actions;

    	if (name == null && fn == null) {
    		// clear actions, but never on the global
    		if (this._actions != null) this._actions = {};
    	} else if (fn == null) {
    		delete obj[name];
    	} else if (name == null) {
    		_default(obj, function (d, n) {
    			obj[n] = d.filter(function (f) {
    				return f !== fn;
    			});
    		});
    	} else if (obj[name] != null) {
    		obj[name] = _default5(obj[name], fn);
    	}

    	return this;
    }

    function fire(a, b, args) {
    	var action = Action.create(a, b);
    	if (!action.context) {
    		throw new Error("Action is missing a context.");
    	}

    	var ctx = action.context;
    	var name = action.name;
    	args = [].concat(action, args);

    	// runs function, unless propagation is stopped
    	function run(fn) {
    		if (fn.apply(ctx, args) === false) {
    			action.bubbles = false;
    		}

    		return !action.bubbles;
    	}

    	// bubble the action up through all the contexts
    	while (action.bubbles && ctx) {
    		if (ctx.template) {
    			var acts = ctx.template._actions;
    			if (acts != null && Array.isArray(acts[name])) {
    				acts[name].some(run);
    			}
    		}

    		ctx = ctx.parent;
    	}

    	// bubble action to the global actions
    	if (action.bubbles && Array.isArray(actions[name])) {
    		actions[name].some(run);
    	}

    	return Boolean(action.bubbles);
    }

var actions$1 = Object.freeze({
    	Action: Action,
    	plugin: plugin$1,
    	default: plugin$1,
    	defineEvent: defineEvent,
    	add: add$1,
    	remove: remove$1,
    	fire: fire
    });

    var _baseDelay = __commonjs(function (module) {
    /** Used as the `TypeError` message for "Functions" methods. */
    var FUNC_ERROR_TEXT = 'Expected a function';

    /**
     * The base implementation of `_.delay` and `_.defer` which accepts an array
     * of `func` arguments.
     *
     * @private
     * @param {Function} func The function to delay.
     * @param {number} wait The number of milliseconds to delay invocation.
     * @param {Object} args The arguments to provide to `func`.
     * @returns {number} Returns the timer id.
     */
    function baseDelay(func, wait, args) {
      if (typeof func != 'function') {
        throw new TypeError(FUNC_ERROR_TEXT);
      }
      return setTimeout(function() { func.apply(undefined, args); }, wait);
    }

    module.exports = baseDelay;
    });

    var require$$1$24 = (_baseDelay && typeof _baseDelay === 'object' && 'default' in _baseDelay ? _baseDelay['default'] : _baseDelay);

    var defer = __commonjs(function (module) {
    var baseDelay = require$$1$24,
        rest = require$$0;

    /**
     * Defers invoking the `func` until the current call stack has cleared. Any
     * additional arguments are provided to `func` when it's invoked.
     *
     * @static
     * @memberOf _
     * @category Function
     * @param {Function} func The function to defer.
     * @param {...*} [args] The arguments to invoke `func` with.
     * @returns {number} Returns the timer id.
     * @example
     *
     * _.defer(function(text) {
     *   console.log(text);
     * }, 'deferred');
     * // => logs 'deferred' after one or more milliseconds
     */
    var defer = rest(function(func, args) {
      return baseDelay(func, 1, args);
    });

    module.exports = defer;
    });

    var _default8 = (defer && typeof defer === 'object' && 'default' in defer ? defer['default'] : defer);

    var _arrayReduce = __commonjs(function (module) {
    /**
     * A specialized version of `_.reduce` for arrays without support for
     * iteratee shorthands.
     *
     * @private
     * @param {Array} array The array to iterate over.
     * @param {Function} iteratee The function invoked per iteration.
     * @param {*} [accumulator] The initial value.
     * @param {boolean} [initAccum] Specify using the first element of `array` as the initial value.
     * @returns {*} Returns the accumulated value.
     */
    function arrayReduce(array, iteratee, accumulator, initAccum) {
      var index = -1,
          length = array.length;

      if (initAccum && length) {
        accumulator = array[++index];
      }
      while (++index < length) {
        accumulator = iteratee(accumulator, array[index], index, array);
      }
      return accumulator;
    }

    module.exports = arrayReduce;
    });

    var require$$0$40 = (_arrayReduce && typeof _arrayReduce === 'object' && 'default' in _arrayReduce ? _arrayReduce['default'] : _arrayReduce);

    var _basePick = __commonjs(function (module) {
    var arrayReduce = require$$0$40;

    /**
     * The base implementation of `_.pick` without support for individual
     * property names.
     *
     * @private
     * @param {Object} object The source object.
     * @param {string[]} props The property names to pick.
     * @returns {Object} Returns the new object.
     */
    function basePick(object, props) {
      object = Object(object);
      return arrayReduce(props, function(result, key) {
        if (key in object) {
          result[key] = object[key];
        }
        return result;
      }, {});
    }

    module.exports = basePick;
    });

    var require$$1$25 = (_basePick && typeof _basePick === 'object' && 'default' in _basePick ? _basePick['default'] : _basePick);

    var _arrayPush = __commonjs(function (module) {
    /**
     * Appends the elements of `values` to `array`.
     *
     * @private
     * @param {Array} array The array to modify.
     * @param {Array} values The values to append.
     * @returns {Array} Returns `array`.
     */
    function arrayPush(array, values) {
      var index = -1,
          length = values.length,
          offset = array.length;

      while (++index < length) {
        array[offset + index] = values[index];
      }
      return array;
    }

    module.exports = arrayPush;
    });

    var require$$3$7 = (_arrayPush && typeof _arrayPush === 'object' && 'default' in _arrayPush ? _arrayPush['default'] : _arrayPush);

    var _baseFlatten = __commonjs(function (module) {
    var arrayPush = require$$3$7,
        isArguments = require$$2$6,
        isArray = require$$2$5,
        isArrayLikeObject = require$$0$3;

    /**
     * The base implementation of `_.flatten` with support for restricting flattening.
     *
     * @private
     * @param {Array} array The array to flatten.
     * @param {number} depth The maximum recursion depth.
     * @param {boolean} [isStrict] Restrict flattening to arrays-like objects.
     * @param {Array} [result=[]] The initial result value.
     * @returns {Array} Returns the new flattened array.
     */
    function baseFlatten(array, depth, isStrict, result) {
      result || (result = []);

      var index = -1,
          length = array.length;

      while (++index < length) {
        var value = array[index];
        if (depth > 0 && isArrayLikeObject(value) &&
            (isStrict || isArray(value) || isArguments(value))) {
          if (depth > 1) {
            // Recursively flatten arrays (susceptible to call stack limits).
            baseFlatten(value, depth - 1, isStrict, result);
          } else {
            arrayPush(result, value);
          }
        } else if (!isStrict) {
          result[result.length] = value;
        }
      }
      return result;
    }

    module.exports = baseFlatten;
    });

    var require$$2$10 = (_baseFlatten && typeof _baseFlatten === 'object' && 'default' in _baseFlatten ? _baseFlatten['default'] : _baseFlatten);

    var pick = __commonjs(function (module) {
    var baseFlatten = require$$2$10,
        basePick = require$$1$25,
        rest = require$$0;

    /**
     * Creates an object composed of the picked `object` properties.
     *
     * @static
     * @memberOf _
     * @category Object
     * @param {Object} object The source object.
     * @param {...(string|string[])} [props] The property names to pick, specified
     *  individually or in arrays.
     * @returns {Object} Returns the new object.
     * @example
     *
     * var object = { 'a': 1, 'b': '2', 'c': 3 };
     *
     * _.pick(object, ['a', 'c']);
     * // => { 'a': 1, 'c': 3 }
     */
    var pick = rest(function(object, props) {
      return object == null ? {} : basePick(object, baseFlatten(props, 1));
    });

    module.exports = pick;
    });

    var _default2$3 = (pick && typeof pick === 'object' && 'default' in pick ? pick['default'] : pick);

    var isDate = __commonjs(function (module) {
    var isObjectLike = require$$0$4;

    /** `Object#toString` result references. */
    var dateTag = '[object Date]';

    /** Used for built-in method references. */
    var objectProto = Object.prototype;

    /**
     * Used to resolve the [`toStringTag`](http://ecma-international.org/ecma-262/6.0/#sec-object.prototype.tostring)
     * of values.
     */
    var objectToString = objectProto.toString;

    /**
     * Checks if `value` is classified as a `Date` object.
     *
     * @static
     * @memberOf _
     * @category Lang
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is correctly classified, else `false`.
     * @example
     *
     * _.isDate(new Date);
     * // => true
     *
     * _.isDate('Mon April 23 2012');
     * // => false
     */
    function isDate(value) {
      return isObjectLike(value) && objectToString.call(value) == dateTag;
    }

    module.exports = isDate;
    });

    var _default5$1 = (isDate && typeof isDate === 'object' && 'default' in isDate ? isDate['default'] : isDate);

    var value_types = ["radio", "option"];
    var selection_types = ["text", "search", "tel", "url", "password"];

    var formBindings = {};

    function plugin$2(options) {
    	this.use("decorators");

    	options = options || {};

    	// add methods
    	this._formBindings = {};
    	this.twoway = this.addFormBinding = add$2;
    	this.getFormBinding = get$2;
    	this.removeFormBinding = remove$2;

    	// add main binding decorator
    	this.decorate("bind-to", bindTo.bind(this, options, false));
    	this.decorate("lazybind-to", bindTo.bind(this, options, true));

    	// add value decorator for radios and options
    	this.decorate("value", valueOf, { parse: "string" });
    }

    function add$2(id, getter, onChange) {
    	var _this = this;

    	if (require$$0$2(id)) {
    		_default(id, function (v, k) {
    			return add$2.call(_this, k, v);
    		});
    		return this;
    	}

    	if (typeof id !== "string") throw new Error("Expecting a string for the form binding ID.");

    	var bindings = this._formBindings || formBindings;
    	if (bindings[id] != null) throw new Error("A form binding with id '" + id + "' already exists.");

    	if (require$$0$2(getter) && onChange == null) {
    		onChange = getter.change;
    		getter = getter.get;
    	}

    	if (typeof getter !== "function") throw new Error("Expecting a function or object for the form binding getter.");
    	if (typeof onChange !== "function") onChange = null;

    	bindings[id] = {
    		get: getter,
    		change: onChange
    	};

    	return this;
    }

    function get$2(id) {
    	if (typeof id !== "string") return;

    	if (this._formBindings && this._formBindings[id]) {
    		return this._formBindings[id];
    	}

    	return formBindings[id];
    }

    function remove$2(id) {
    	if (this._formBindings) {
    		if (id == null) this._formBindings = {};else delete this._formBindings[id];
    	} else if (id) {
    		delete formBindings[id];
    	}

    	return this;
    }

    var type_map = {
    	"text": ["text", "color", "email", "password", "search", "tel", "url", "hidden"],
    	"number": ["number", "range"],
    	"date": ["date", "datetime", "datetime-local", "month", "time", "week"],
    	"file": ["file"],
    	"checkbox": ["checkbox"],
    	"radio": ["radio"]
    };

    function getType(el) {
    	switch (el.tagName.toLowerCase()) {
    		case "input":
    			for (var type in type_map) {
    				if (_default2$2(type_map[type], el.type)) return type;
    			}
    			break;

    		case "select":
    			return "select";

    		case "option":
    			return "option";

    		case "textarea":
    			return "text";
    	}
    }

    function getNodeValue(node, type) {
    	if (type == null) type = getType(node);
    	var val;

    	switch (type) {
    		case "number":
    			val = node.valueAsNumber;
    			break;
    		case "text":
    			val = node.value;
    			break;

    		case "checkbox":
    			val = node.checked;
    			break;

    		case "date":
    			val = node.valueAsDate;
    			break;

    		case "select":
    			var opt = node.querySelector("option:checked");
    			if (opt != null) val = opt.$bound_value;
    			break;

    		case "file":
    			val = !node.multiple ? node.files[0] : _default4(node.files);
    			break;

    		case "radio":
    			val = node.$bound_value;
    			break;
    	}

    	return val;
    }

    function setLiveValue(live, el, fn) {
    	var active = document.activeElement === el;
    	if (!live && active) return;
    	var sel = selection_types.indexOf(el.type) > -1;
    	var pos = sel ? [el.selectionStart, el.selectionEnd] : null;
    	fn();
    	if (sel && active) el.setSelectionRange.apply(el, pos);
    }

    function setNodeValue(el, val, type, live) {
    	if (type == null) type = getType(el);

    	switch (type) {
    		case "number":
    			setLiveValue(live, el, function () {
    				updateProperty(el, typeof val === "number" ? "valueAsNumber" : "value", val);
    			});
    			break;

    		case "text":
    			setLiveValue(live, el, function () {
    				updateProperty(el, "value", toString(val));
    			});
    			break;

    		case "checkbox":
    			updateProperty(el, "checked", Boolean(val));
    			break;

    		case "date":
    			setLiveValue(live, el, function () {
    				updateProperty(el, _default5$1(val) ? "valueAsDate" : "value", val);
    			});
    			break;

    		case "select":
    			_default4(el.querySelectorAll("option")).forEach(function (opt) {
    				updateProperty(opt, "selected", opt.$bound_value === val);
    			});
    			break;

    		case "radio":
    			updateProperty(el, "checked", el.$bound_value === val);
    			break;
    	}
    }

    function bindTo(options, lazy, d, id) {
    	var fbind = this.getFormBinding(id);
    	if (fbind == null) return;

    	var el = d.target;
    	var args = _default4(arguments).slice(4);
    	var type = getType(el);
    	var onChange = undefined;
    	var twctx = _default2$3(d, "context", "template", "target");

    	// detect changes to the input's value
    	if (typeof fbind.change === "function") {
    		onChange = function onChange(e) {
    			fbind.change.apply(_default3$1(twctx, {
    				original: e
    			}), [getNodeValue(el, type)].concat(args));
    		};

    		el.addEventListener("change", onChange);
    		el.addEventListener("paste", onChange);
    		if (!(options.lazy || lazy)) el.addEventListener("keyup", onChange);

    		d.comp.onInvalidate(function () {
    			el.removeEventListener("change", onChange);
    			el.removeEventListener("paste", onChange);
    			el.removeEventListener("keyup", onChange);
    		});
    	}

    	var nodeValueComp = undefined,
    	    stopped = false;

    	d.comp.onInvalidate(function () {
    		stopped = true;
    		if (nodeValueComp) nodeValueComp.stop();
    	});

    	// reactively set the value on the input
    	// deferred so value decorators run
    	_default8(function () {
    		if (stopped) return;
    		nodeValueComp = Trackr.autorun(function () {
    			setNodeValue(el, fbind.get.apply(twctx, args), type, options.live);
    		});
    	});
    }

    function valueOf(d, val) {
    	var el = d.target,
    	    type = getType(el);

    	if (!_default2$2(value_types, type)) {
    		updateAttribute(el, "value", val);
    		return;
    	}

    	el.$bound_value = val;
    	updateProperty(el, "value", val);
    }

    function plugin$3() {
    	this.use("decorators");
    	this.decorate("ref", decorator);
    }

    var warned = [];

    function warnOnce(msg) {
    	if (_default2$2(warned, msg)) return;
    	console.warn(msg);
    	warned.push(msg);
    }

    function decorator(d, key) {
    	var ctx = d.owner;
    	if (!ctx.refs) ctx.refs = {};

    	// warn about overwrites overwrite
    	if (_default2$1(ctx.refs, key)) {
    		warnOnce("Multiple elements with reference '" + key + "'.");
    		return;
    	}

    	// set the reference
    	ctx.refs[key] = d.target;

    	// remove the reference when the element disappears
    	d.comp.onInvalidate(function () {
    		delete ctx.refs[key];
    	});
    }

    // export function find(key) {
    // 	var tpls = [ this ],
    // 		tpl;
    //
    // 	while (tpls.length) {
    // 		tpl = tpls.shift();
    // 		if (tpl.refs && tpl.refs[key]) return tpl.refs[key];
    // 		// tpls = tpls.concat(tpl.getComponents());
    // 	}
    //
    // 	return null;
    // }

    // declare, but don't set the plugin variable
    // exports and imports are hoisted, so this cannot do anything to the value
    var plugins;

    function load(tpl, plugin, args) {
    	var name = undefined;
    	if (plugins == null) plugins = {};

    	if (_default3(plugin)) {
    		name = plugin;
    		if (plugins[name] == null) throw new Error("No plugin exists with id '" + name + "'.");

    		plugin = plugins[name];
    	}

    	if (!_default2(plugin)) throw new Error("Expecting string or function for plugin");

    	// check if plugin is already loaded on this template
    	if (tpl._loaded_plugins == null) tpl._loaded_plugins = [];
    	if (tpl._loaded_plugins.some(function (p) {
    		return p.plugin === plugin;
    	})) return tpl;

    	if (args == null) args = [];
    	if (!require$$2$5(args)) args = [args];
    	tpl._loaded_plugins.push({
    		name: name,
    		plugin: plugin,
    		args: args
    	});

    	plugin.apply(tpl, args);
    	return tpl;
    }

    function register(name, fn) {
    	if (plugins == null) plugins = {};

    	if (typeof name !== "string") {
    		throw new Error("Expecting string name for plugin.");
    	}

    	if (typeof fn !== "function") {
    		throw new Error("Expecting function for plugin.");
    	}

    	if (fn === plugins[name]) return;
    	if (plugins[name] != null) {
    		throw new Error("Refusing to overwrite existing plugin \"name\".");
    	}

    	plugins[name] = fn;
    }

    function get$1(name) {
    	return plugins && plugins[name];
    }

    register("decorators", plugin);
    register("actions", plugin$1);
    register("twoway", plugin$2);
    register("refs", plugin$3);

var plugins$1 = Object.freeze({
    	load: load,
    	register: register,
    	get: get$1
    });

    var backboneExtendStandalone = __commonjs(function (module, exports) {
    (function (definition) {
      if (typeof exports === "object") {
        module.exports = definition();
      }
      else if (typeof define === 'function' && define.amd) {
        define(definition);
      }
      else {
        window.BackboneExtend = definition();
      }
    })(function () {
      "use strict";
      
      // mini-underscore
      var _ = {
        has: function (obj, key) {
          return Object.prototype.hasOwnProperty.call(obj, key);
        },
      
        extend: function(obj) {
          for (var i=1; i<arguments.length; ++i) {
            var source = arguments[i];
            if (source) {
              for (var prop in source) {
                obj[prop] = source[prop];
              }
            }
          }
          return obj;
        }
      };

      /// Following code is pasted from Backbone.js ///

      // Helper function to correctly set up the prototype chain, for subclasses.
      // Similar to `goog.inherits`, but uses a hash of prototype properties and
      // class properties to be extended.
      var extend = function(protoProps, staticProps) {
        var parent = this;
        var child;

        // The constructor function for the new subclass is either defined by you
        // (the "constructor" property in your `extend` definition), or defaulted
        // by us to simply call the parent's constructor.
        if (protoProps && _.has(protoProps, 'constructor')) {
          child = protoProps.constructor;
        } else {
          child = function(){ return parent.apply(this, arguments); };
        }

        // Add static properties to the constructor function, if supplied.
        _.extend(child, parent, staticProps);

        // Set the prototype chain to inherit from `parent`, without calling
        // `parent`'s constructor function.
        var Surrogate = function(){ this.constructor = child; };
        Surrogate.prototype = parent.prototype;
        child.prototype = new Surrogate();

        // Add prototype properties (instance properties) to the subclass,
        // if supplied.
        if (protoProps) _.extend(child.prototype, protoProps);

        // Set a convenience property in case the parent's prototype is needed
        // later.
        child.__super__ = parent.prototype;

        return child;
      };

      // Expose the extend function
      return extend;
    });
    });

    var subclass = (backboneExtendStandalone && typeof backboneExtendStandalone === 'object' && 'default' in backboneExtendStandalone ? backboneExtendStandalone['default'] : backboneExtendStandalone);

    var templates = {};
    var types = {};

    function Template(name, render) {
    	if (typeof name !== "string" || name === "") {
    		throw new Error("Expecting a non-empty string for template name.");
    	}

    	if (typeof render !== "function") {
    		throw new Error("Expecting a function for render.");
    	}

    	EventEmitter.call(this);
    	this.setMaxListeners(0);

    	// internal state
    	this.s = {
    		// template name
    		name: name,
    		// render method
    		render: render,
    		// dependency for easy invalidate
    		renderdep: new Trackr.Dependency(),
    		// holds the helpers
    		helpers: new Map()
    	};

    	// default plugins
    	this.use("decorators");
    	this.initialize();
    }

    Template.extend = subclass;
    Template.prototype = Object.create(EventEmitter.prototype);
    Template.prototype.constructor = Template;
    Template.prototype.type = "template";
    Template.prototype.initialize = function () {};

    // plugin proxy for contexts
    Template.prototype.use = function use(p) {
    	return load(this, p, _default4(arguments).slice(1));
    };

    Template.prototype.createContext = function (data, parent) {
    	if (data instanceof Context$1) {
    		;
    		var _ref = [data, null];
    		parent = _ref[0];
    		data = _ref[1];
    	}var ctx = new Context$1(data, parent, this);
    	this.emit("context", ctx);
    	return ctx;
    };

    Template.prototype.invalidate = function () {
    	this.s.renderdep.changed();
    	return this;
    };

    Template.prototype.render = function (data, key) {
    	this.s.renderdep.depend();
    	var ctx = this.createContext(data);
    	this.s.render(ctx, key);
    	this.emit("render", ctx);
    	return ctx;
    };

    var injectable_nodes = [1, // Node.ELEMENT_NODE,
    9, // Node.DOCUMENT_NODE,
    11];

    // Node.DOCUMENT_FRAGMENT_NODE
    Template.prototype.paint = function (node, data) {
    	var _this = this;

    	if (typeof node === "string") node = document.querySelector(node);
    	if (!node || !_default2$2(injectable_nodes, node.nodeType)) {
    		throw new Error("Expecting a valid DOM element to paint.");
    	}

    	var ctx = data instanceof Context$1 ? data : new Context$1(data);
    	var c = Trackr.autorun(function () {
    		patch(node, function () {
    			return _this.render(ctx);
    		});
    	});

    	c.context = ctx;
    	c.template = this;

    	c.onStop(function () {
    		patch(node, function () {});
    	});

    	return c;
    };

    var globalHelpers = new Map();

    var helpers = Template.prototype.helpers = function (key, value) {
    	var _this2 = this;

    	if ((typeof key === "undefined" ? "undefined" : babelHelpers.typeof(key)) === "object") {
    		Object.keys(key).forEach(function (k) {
    			return helpers.call(_this2, k, key[k]);
    		});
    		return this;
    	}

    	var h = globalHelpers;
    	if (this instanceof Template) h = this.s.helpers;

    	if (typeof value === "undefined") h.delete(key);else h.set(key, value);

    	return this;
    };

    var getHelper = Template.prototype.getHelper = function (key) {
    	if (this instanceof Template) {
    		return this.s.helpers.get(key);
    	}

    	return globalHelpers.get(key);
    };

    function render(name, ctx, key) {
    	var tpl = getByName(name);
    	if (tpl) return tpl.render(ctx, key);
    }

    function getByName(name) {
    	return templates[name];
    }

    function paint(tpl, node, data) {
    	if (typeof tpl === "string") {
    		tpl = getByName(tpl);
    		if (!tpl) throw new Error("No template exists with name '" + tpl + "'");
    	}
    	if (!(tpl instanceof Template)) {
    		throw new Error("Expecting template name or instance of Template.");
    	}
    	return tpl.paint(node, data);
    }

    function registerType(type, props) {
    	if (typeof type !== "string" || !type) {
    		throw new Error("Expecting non-empty string for type.");
    	}
    	if (_default2$1(types, type)) {
    		throw new Error("Template type '" + type + "' already exists.");
    	}

    	if (typeof props === "function") {
    		props = { initialize: props };
    	}

    	props = _default3$1({}, props, { type: type });

    	var T = Template;
    	if (props.extends && _default2$1(types, props.extends)) {
    		T = types[props.extends];
    		delete props.extends;
    	}

    	function wrap(k, f) {
    		return function () {
    			var osuper = this.super;
    			this.super = T.prototype[k];
    			var ret = f.apply(this, arguments);
    			this.super = osuper;
    			return ret;
    		};
    	}

    	for (var k in props) {
    		var fn = props[k];
    		if (typeof fn !== "function") continue;
    		if (/this\.super|this\["super"\]|this\['super'\]/.test(fn.toString())) {
    			props[k] = wrap(k, fn);
    		}
    	}

    	return types[type] = T.extend(props);
    }

    function create$1(name, type, render) {
    	if (typeof name !== "string" || !name) {
    		throw new Error("Expecting non-empty string for name.");
    	}
    	if (getByName(name)) {
    		throw new Error("Template '" + name + "' already exists.");
    	}

    	if (typeof type === "function") {
    		;
    		var _ref2 = [type, null];
    		render = _ref2[0];
    		type = _ref2[1];
    	}if (type && !_default2$1(types, type)) {
    		throw new Error("Template type " + type + " does not exist.");
    	}

    	var T = type ? types[type] : Template;
    	return templates[name] = new T(name, render);
    }

    function Context$1(data, parent, template) {
    	if (!(this instanceof Context$1)) {
    		return new Context$1(parent);
    	}

    	EventEmitter.call(this);
    	this.setMaxListeners(0);

    	if (data instanceof Context$1) {
    		var _ref = [parent, data, null];
    		template = _ref[0];
    		parent = _ref[1];
    		data = _ref[2];
    	}

    	if (parent && !(parent instanceof Context$1)) {
    		throw new Error("Expecting an instance of Context for parent.");
    	}

    	// internal view state
    	this.s = {
    		// parent view for scope
    		parent: parent || null,
    		// associated template object
    		template: template || null,
    		// holds lexical data
    		scope: {},
    		// holds "this" data
    		data: new Variable()
    	};

    	// set initial data
    	if (data != null) this.set(data);
    	if (!this.parent) this.dataVar.set(data);
    }

    Context$1.prototype = Object.create(EventEmitter.prototype);
    Context$1.prototype.constructor = Context$1;

    assignProps(Context$1.prototype, {
    	scope: function scope() {
    		return this.s.scope;
    	},
    	dataVar: function dataVar() {
    		return this.s.data;
    	},
    	data: function data() {
    		return this.s.data.get();
    	},
    	template: function template() {
    		return this.s.template;
    	},
    	parent: function parent() {
    		return this.s.parent;
    	}
    });

    Context$1.prototype.set = function (key, value) {
    	var _this = this;

    	if ((typeof key === "undefined" ? "undefined" : babelHelpers.typeof(key)) === "object") {
    		_default(key, function (v, k) {
    			return _this.set(k, v);
    		});
    		return this;
    	}

    	if (key === "this") {
    		this.s.data.set(value);
    	} else {
    		if (typeof value === "undefined") delete this.s.scope[key];else this.s.scope[key] = value;
    	}

    	return this;
    };

    Context$1.prototype.get = function (key) {
    	return _default2$1(this.s.scope, key) ? this.s.scope[key] : void 0;
    };

    Context$1.prototype.parentData = function (dist) {
    	if (typeof dist !== "number" || isNaN(dist)) dist = 1;

    	if (dist >= 0) {
    		var _v = this;
    		while (dist && _v) {
    			dist--;
    			_v = _v.parent;
    		}
    		return !dist && _v ? _v.data : void 0;
    	}

    	var views = [];
    	var v = this;

    	while (v) {
    		views.push(v);
    		v = v.parent;
    	}

    	var view = views[Math.abs(dist) - 1];
    	return view ? view.data : void 0;
    };

    Context$1.prototype.getTemplateContext = function () {
    	var view = this;

    	while (view) {
    		if (view.template != null) {
    			return view;
    		}

    		view = view.parent;
    	}
    };

    Context$1.prototype.getTemplate = function () {
    	var ctx = this.getTemplateContext();
    	return ctx ? ctx.template : void 0;
    };

    var lookup = function lookup(tpl, ctx, key) {
    	var view = undefined;

    	// 0-0. check for this
    	if (!key || key === "this") {
    		view = ctx;
    		while (view) {
    			var _val = view.data;
    			if (_val !== void 0) return _val;
    			view = view.parent;
    		}
    	}

    	// 0-1. special method $this
    	if (key === "$this") {
    		return function (d) {
    			return ctx.parentData(d);
    		};
    	}

    	// 1. check closest template helpers
    	if (tpl) {
    		var _val2 = tpl.getHelper(key);
    		if (_val2 !== void 0) return _val2;
    	}

    	// 2. check lexical scope
    	view = ctx;
    	while (view) {
    		var _val3 = view.get(key);
    		if (_val3 !== void 0) return _val3;
    		view = view.parent;
    	}

    	// 3. check global helpers
    	var val = getHelper(key);
    	if (val !== void 0) return val;
    };

    Context$1.prototype.lookup = function (key) {
    	return lookup(this.getTemplate(), this, key);
    };

    var util = __commonjs(function (module, exports) {
    /* -*- Mode: js; js-indent-level: 2; -*- */
    /*
     * Copyright 2011 Mozilla Foundation and contributors
     * Licensed under the New BSD license. See LICENSE or:
     * http://opensource.org/licenses/BSD-3-Clause
     */
    {
      /**
       * This is a helper function for getting values from parameter/options
       * objects.
       *
       * @param args The object we are extracting values from
       * @param name The name of the property we are getting.
       * @param defaultValue An optional value to return if the property is missing
       * from the object. If this is not specified and the property is missing, an
       * error will be thrown.
       */
      function getArg(aArgs, aName, aDefaultValue) {
        if (aName in aArgs) {
          return aArgs[aName];
        } else if (arguments.length === 3) {
          return aDefaultValue;
        } else {
          throw new Error('"' + aName + '" is a required argument.');
        }
      }
      exports.getArg = getArg;

      var urlRegexp = /^(?:([\w+\-.]+):)?\/\/(?:(\w+:\w+)@)?([\w.]*)(?::(\d+))?(\S*)$/;
      var dataUrlRegexp = /^data:.+\,.+$/;

      function urlParse(aUrl) {
        var match = aUrl.match(urlRegexp);
        if (!match) {
          return null;
        }
        return {
          scheme: match[1],
          auth: match[2],
          host: match[3],
          port: match[4],
          path: match[5]
        };
      }
      exports.urlParse = urlParse;

      function urlGenerate(aParsedUrl) {
        var url = '';
        if (aParsedUrl.scheme) {
          url += aParsedUrl.scheme + ':';
        }
        url += '//';
        if (aParsedUrl.auth) {
          url += aParsedUrl.auth + '@';
        }
        if (aParsedUrl.host) {
          url += aParsedUrl.host;
        }
        if (aParsedUrl.port) {
          url += ":" + aParsedUrl.port
        }
        if (aParsedUrl.path) {
          url += aParsedUrl.path;
        }
        return url;
      }
      exports.urlGenerate = urlGenerate;

      /**
       * Normalizes a path, or the path portion of a URL:
       *
       * - Replaces consequtive slashes with one slash.
       * - Removes unnecessary '.' parts.
       * - Removes unnecessary '<dir>/..' parts.
       *
       * Based on code in the Node.js 'path' core module.
       *
       * @param aPath The path or url to normalize.
       */
      function normalize(aPath) {
        var path = aPath;
        var url = urlParse(aPath);
        if (url) {
          if (!url.path) {
            return aPath;
          }
          path = url.path;
        }
        var isAbsolute = exports.isAbsolute(path);

        var parts = path.split(/\/+/);
        for (var part, up = 0, i = parts.length - 1; i >= 0; i--) {
          part = parts[i];
          if (part === '.') {
            parts.splice(i, 1);
          } else if (part === '..') {
            up++;
          } else if (up > 0) {
            if (part === '') {
              // The first part is blank if the path is absolute. Trying to go
              // above the root is a no-op. Therefore we can remove all '..' parts
              // directly after the root.
              parts.splice(i + 1, up);
              up = 0;
            } else {
              parts.splice(i, 2);
              up--;
            }
          }
        }
        path = parts.join('/');

        if (path === '') {
          path = isAbsolute ? '/' : '.';
        }

        if (url) {
          url.path = path;
          return urlGenerate(url);
        }
        return path;
      }
      exports.normalize = normalize;

      /**
       * Joins two paths/URLs.
       *
       * @param aRoot The root path or URL.
       * @param aPath The path or URL to be joined with the root.
       *
       * - If aPath is a URL or a data URI, aPath is returned, unless aPath is a
       *   scheme-relative URL: Then the scheme of aRoot, if any, is prepended
       *   first.
       * - Otherwise aPath is a path. If aRoot is a URL, then its path portion
       *   is updated with the result and aRoot is returned. Otherwise the result
       *   is returned.
       *   - If aPath is absolute, the result is aPath.
       *   - Otherwise the two paths are joined with a slash.
       * - Joining for example 'http://' and 'www.example.com' is also supported.
       */
      function join(aRoot, aPath) {
        if (aRoot === "") {
          aRoot = ".";
        }
        if (aPath === "") {
          aPath = ".";
        }
        var aPathUrl = urlParse(aPath);
        var aRootUrl = urlParse(aRoot);
        if (aRootUrl) {
          aRoot = aRootUrl.path || '/';
        }

        // `join(foo, '//www.example.org')`
        if (aPathUrl && !aPathUrl.scheme) {
          if (aRootUrl) {
            aPathUrl.scheme = aRootUrl.scheme;
          }
          return urlGenerate(aPathUrl);
        }

        if (aPathUrl || aPath.match(dataUrlRegexp)) {
          return aPath;
        }

        // `join('http://', 'www.example.com')`
        if (aRootUrl && !aRootUrl.host && !aRootUrl.path) {
          aRootUrl.host = aPath;
          return urlGenerate(aRootUrl);
        }

        var joined = aPath.charAt(0) === '/'
          ? aPath
          : normalize(aRoot.replace(/\/+$/, '') + '/' + aPath);

        if (aRootUrl) {
          aRootUrl.path = joined;
          return urlGenerate(aRootUrl);
        }
        return joined;
      }
      exports.join = join;

      exports.isAbsolute = function (aPath) {
        return aPath.charAt(0) === '/' || !!aPath.match(urlRegexp);
      };

      /**
       * Make a path relative to a URL or another path.
       *
       * @param aRoot The root path or URL.
       * @param aPath The path or URL to be made relative to aRoot.
       */
      function relative(aRoot, aPath) {
        if (aRoot === "") {
          aRoot = ".";
        }

        aRoot = aRoot.replace(/\/$/, '');

        // It is possible for the path to be above the root. In this case, simply
        // checking whether the root is a prefix of the path won't work. Instead, we
        // need to remove components from the root one by one, until either we find
        // a prefix that fits, or we run out of components to remove.
        var level = 0;
        while (aPath.indexOf(aRoot + '/') !== 0) {
          var index = aRoot.lastIndexOf("/");
          if (index < 0) {
            return aPath;
          }

          // If the only part of the root that is left is the scheme (i.e. http://,
          // file:///, etc.), one or more slashes (/), or simply nothing at all, we
          // have exhausted all components, so the path is not relative to the root.
          aRoot = aRoot.slice(0, index);
          if (aRoot.match(/^([^\/]+:\/)?\/*$/)) {
            return aPath;
          }

          ++level;
        }

        // Make sure we add a "../" for each component we removed from the root.
        return Array(level + 1).join("../") + aPath.substr(aRoot.length + 1);
      }
      exports.relative = relative;

      /**
       * Because behavior goes wacky when you set `__proto__` on objects, we
       * have to prefix all the strings in our set with an arbitrary character.
       *
       * See https://github.com/mozilla/source-map/pull/31 and
       * https://github.com/mozilla/source-map/issues/30
       *
       * @param String aStr
       */
      function toSetString(aStr) {
        return '$' + aStr;
      }
      exports.toSetString = toSetString;

      function fromSetString(aStr) {
        return aStr.substr(1);
      }
      exports.fromSetString = fromSetString;

      /**
       * Comparator between two mappings where the original positions are compared.
       *
       * Optionally pass in `true` as `onlyCompareGenerated` to consider two
       * mappings with the same original source/line/column, but different generated
       * line and column the same. Useful when searching for a mapping with a
       * stubbed out mapping.
       */
      function compareByOriginalPositions(mappingA, mappingB, onlyCompareOriginal) {
        var cmp = mappingA.source - mappingB.source;
        if (cmp !== 0) {
          return cmp;
        }

        cmp = mappingA.originalLine - mappingB.originalLine;
        if (cmp !== 0) {
          return cmp;
        }

        cmp = mappingA.originalColumn - mappingB.originalColumn;
        if (cmp !== 0 || onlyCompareOriginal) {
          return cmp;
        }

        cmp = mappingA.generatedColumn - mappingB.generatedColumn;
        if (cmp !== 0) {
          return cmp;
        }

        cmp = mappingA.generatedLine - mappingB.generatedLine;
        if (cmp !== 0) {
          return cmp;
        }

        return mappingA.name - mappingB.name;
      }
      exports.compareByOriginalPositions = compareByOriginalPositions;

      /**
       * Comparator between two mappings with deflated source and name indices where
       * the generated positions are compared.
       *
       * Optionally pass in `true` as `onlyCompareGenerated` to consider two
       * mappings with the same generated line and column, but different
       * source/name/original line and column the same. Useful when searching for a
       * mapping with a stubbed out mapping.
       */
      function compareByGeneratedPositionsDeflated(mappingA, mappingB, onlyCompareGenerated) {
        var cmp = mappingA.generatedLine - mappingB.generatedLine;
        if (cmp !== 0) {
          return cmp;
        }

        cmp = mappingA.generatedColumn - mappingB.generatedColumn;
        if (cmp !== 0 || onlyCompareGenerated) {
          return cmp;
        }

        cmp = mappingA.source - mappingB.source;
        if (cmp !== 0) {
          return cmp;
        }

        cmp = mappingA.originalLine - mappingB.originalLine;
        if (cmp !== 0) {
          return cmp;
        }

        cmp = mappingA.originalColumn - mappingB.originalColumn;
        if (cmp !== 0) {
          return cmp;
        }

        return mappingA.name - mappingB.name;
      }
      exports.compareByGeneratedPositionsDeflated = compareByGeneratedPositionsDeflated;

      function strcmp(aStr1, aStr2) {
        if (aStr1 === aStr2) {
          return 0;
        }

        if (aStr1 > aStr2) {
          return 1;
        }

        return -1;
      }

      /**
       * Comparator between two mappings with inflated source and name strings where
       * the generated positions are compared.
       */
      function compareByGeneratedPositionsInflated(mappingA, mappingB) {
        var cmp = mappingA.generatedLine - mappingB.generatedLine;
        if (cmp !== 0) {
          return cmp;
        }

        cmp = mappingA.generatedColumn - mappingB.generatedColumn;
        if (cmp !== 0) {
          return cmp;
        }

        cmp = strcmp(mappingA.source, mappingB.source);
        if (cmp !== 0) {
          return cmp;
        }

        cmp = mappingA.originalLine - mappingB.originalLine;
        if (cmp !== 0) {
          return cmp;
        }

        cmp = mappingA.originalColumn - mappingB.originalColumn;
        if (cmp !== 0) {
          return cmp;
        }

        return strcmp(mappingA.name, mappingB.name);
      }
      exports.compareByGeneratedPositionsInflated = compareByGeneratedPositionsInflated;
    }
    });

    var require$$4$7 = (util && typeof util === 'object' && 'default' in util ? util['default'] : util);

    var mappingList = __commonjs(function (module, exports) {
    /* -*- Mode: js; js-indent-level: 2; -*- */
    /*
     * Copyright 2014 Mozilla Foundation and contributors
     * Licensed under the New BSD license. See LICENSE or:
     * http://opensource.org/licenses/BSD-3-Clause
     */
    {
      var util = require$$4$7;

      /**
       * Determine whether mappingB is after mappingA with respect to generated
       * position.
       */
      function generatedPositionAfter(mappingA, mappingB) {
        // Optimized for most common case
        var lineA = mappingA.generatedLine;
        var lineB = mappingB.generatedLine;
        var columnA = mappingA.generatedColumn;
        var columnB = mappingB.generatedColumn;
        return lineB > lineA || lineB == lineA && columnB >= columnA ||
               util.compareByGeneratedPositionsInflated(mappingA, mappingB) <= 0;
      }

      /**
       * A data structure to provide a sorted view of accumulated mappings in a
       * performance conscious manner. It trades a neglibable overhead in general
       * case for a large speedup in case of mappings being added in order.
       */
      function MappingList() {
        this._array = [];
        this._sorted = true;
        // Serves as infimum
        this._last = {generatedLine: -1, generatedColumn: 0};
      }

      /**
       * Iterate through internal items. This method takes the same arguments that
       * `Array.prototype.forEach` takes.
       *
       * NOTE: The order of the mappings is NOT guaranteed.
       */
      MappingList.prototype.unsortedForEach =
        function MappingList_forEach(aCallback, aThisArg) {
          this._array.forEach(aCallback, aThisArg);
        };

      /**
       * Add the given source mapping.
       *
       * @param Object aMapping
       */
      MappingList.prototype.add = function MappingList_add(aMapping) {
        if (generatedPositionAfter(this._last, aMapping)) {
          this._last = aMapping;
          this._array.push(aMapping);
        } else {
          this._sorted = false;
          this._array.push(aMapping);
        }
      };

      /**
       * Returns the flat, sorted array of mappings. The mappings are sorted by
       * generated position.
       *
       * WARNING: This method returns internal data without copying, for
       * performance. The return value must NOT be mutated, and should be treated as
       * an immutable borrow. If you want to take ownership, you must make your own
       * copy.
       */
      MappingList.prototype.toArray = function MappingList_toArray() {
        if (!this._sorted) {
          this._array.sort(util.compareByGeneratedPositionsInflated);
          this._sorted = true;
        }
        return this._array;
      };

      exports.MappingList = MappingList;
    }
    });

    var require$$0$42 = (mappingList && typeof mappingList === 'object' && 'default' in mappingList ? mappingList['default'] : mappingList);

    var arraySet = __commonjs(function (module, exports) {
    /* -*- Mode: js; js-indent-level: 2; -*- */
    /*
     * Copyright 2011 Mozilla Foundation and contributors
     * Licensed under the New BSD license. See LICENSE or:
     * http://opensource.org/licenses/BSD-3-Clause
     */
    {
      var util = require$$4$7;

      /**
       * A data structure which is a combination of an array and a set. Adding a new
       * member is O(1), testing for membership is O(1), and finding the index of an
       * element is O(1). Removing elements from the set is not supported. Only
       * strings are supported for membership.
       */
      function ArraySet() {
        this._array = [];
        this._set = {};
      }

      /**
       * Static method for creating ArraySet instances from an existing array.
       */
      ArraySet.fromArray = function ArraySet_fromArray(aArray, aAllowDuplicates) {
        var set = new ArraySet();
        for (var i = 0, len = aArray.length; i < len; i++) {
          set.add(aArray[i], aAllowDuplicates);
        }
        return set;
      };

      /**
       * Return how many unique items are in this ArraySet. If duplicates have been
       * added, than those do not count towards the size.
       *
       * @returns Number
       */
      ArraySet.prototype.size = function ArraySet_size() {
        return Object.getOwnPropertyNames(this._set).length;
      };

      /**
       * Add the given string to this set.
       *
       * @param String aStr
       */
      ArraySet.prototype.add = function ArraySet_add(aStr, aAllowDuplicates) {
        var sStr = util.toSetString(aStr);
        var isDuplicate = this._set.hasOwnProperty(sStr);
        var idx = this._array.length;
        if (!isDuplicate || aAllowDuplicates) {
          this._array.push(aStr);
        }
        if (!isDuplicate) {
          this._set[sStr] = idx;
        }
      };

      /**
       * Is the given string a member of this set?
       *
       * @param String aStr
       */
      ArraySet.prototype.has = function ArraySet_has(aStr) {
        var sStr = util.toSetString(aStr);
        return this._set.hasOwnProperty(sStr);
      };

      /**
       * What is the index of the given string in the array?
       *
       * @param String aStr
       */
      ArraySet.prototype.indexOf = function ArraySet_indexOf(aStr) {
        var sStr = util.toSetString(aStr);
        if (this._set.hasOwnProperty(sStr)) {
          return this._set[sStr];
        }
        throw new Error('"' + aStr + '" is not in the set.');
      };

      /**
       * What is the element at the given index?
       *
       * @param Number aIdx
       */
      ArraySet.prototype.at = function ArraySet_at(aIdx) {
        if (aIdx >= 0 && aIdx < this._array.length) {
          return this._array[aIdx];
        }
        throw new Error('No element indexed by ' + aIdx);
      };

      /**
       * Returns the array representation of this set (which has the proper indices
       * indicated by indexOf). Note that this is a copy of the internal array used
       * for storing the members so that no one can mess with internal state.
       */
      ArraySet.prototype.toArray = function ArraySet_toArray() {
        return this._array.slice();
      };

      exports.ArraySet = ArraySet;
    }
    });

    var require$$2$11 = (arraySet && typeof arraySet === 'object' && 'default' in arraySet ? arraySet['default'] : arraySet);

    var base64 = __commonjs(function (module, exports) {
    /* -*- Mode: js; js-indent-level: 2; -*- */
    /*
     * Copyright 2011 Mozilla Foundation and contributors
     * Licensed under the New BSD license. See LICENSE or:
     * http://opensource.org/licenses/BSD-3-Clause
     */
    {
      var intToCharMap = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/'.split('');

      /**
       * Encode an integer in the range of 0 to 63 to a single base 64 digit.
       */
      exports.encode = function (number) {
        if (0 <= number && number < intToCharMap.length) {
          return intToCharMap[number];
        }
        throw new TypeError("Must be between 0 and 63: " + number);
      };

      /**
       * Decode a single base 64 character code digit to an integer. Returns -1 on
       * failure.
       */
      exports.decode = function (charCode) {
        var bigA = 65;     // 'A'
        var bigZ = 90;     // 'Z'

        var littleA = 97;  // 'a'
        var littleZ = 122; // 'z'

        var zero = 48;     // '0'
        var nine = 57;     // '9'

        var plus = 43;     // '+'
        var slash = 47;    // '/'

        var littleOffset = 26;
        var numberOffset = 52;

        // 0 - 25: ABCDEFGHIJKLMNOPQRSTUVWXYZ
        if (bigA <= charCode && charCode <= bigZ) {
          return (charCode - bigA);
        }

        // 26 - 51: abcdefghijklmnopqrstuvwxyz
        if (littleA <= charCode && charCode <= littleZ) {
          return (charCode - littleA + littleOffset);
        }

        // 52 - 61: 0123456789
        if (zero <= charCode && charCode <= nine) {
          return (charCode - zero + numberOffset);
        }

        // 62: +
        if (charCode == plus) {
          return 62;
        }

        // 63: /
        if (charCode == slash) {
          return 63;
        }

        // Invalid base64 digit.
        return -1;
      };
    }
    });

    var require$$0$43 = (base64 && typeof base64 === 'object' && 'default' in base64 ? base64['default'] : base64);

    var base64Vlq = __commonjs(function (module, exports) {
    /* -*- Mode: js; js-indent-level: 2; -*- */
    /*
     * Copyright 2011 Mozilla Foundation and contributors
     * Licensed under the New BSD license. See LICENSE or:
     * http://opensource.org/licenses/BSD-3-Clause
     *
     * Based on the Base 64 VLQ implementation in Closure Compiler:
     * https://code.google.com/p/closure-compiler/source/browse/trunk/src/com/google/debugging/sourcemap/Base64VLQ.java
     *
     * Copyright 2011 The Closure Compiler Authors. All rights reserved.
     * Redistribution and use in source and binary forms, with or without
     * modification, are permitted provided that the following conditions are
     * met:
     *
     *  * Redistributions of source code must retain the above copyright
     *    notice, this list of conditions and the following disclaimer.
     *  * Redistributions in binary form must reproduce the above
     *    copyright notice, this list of conditions and the following
     *    disclaimer in the documentation and/or other materials provided
     *    with the distribution.
     *  * Neither the name of Google Inc. nor the names of its
     *    contributors may be used to endorse or promote products derived
     *    from this software without specific prior written permission.
     *
     * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
     * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
     * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
     * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
     * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
     * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
     * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
     * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
     * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
     * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
     * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
     */
    {
      var base64 = require$$0$43;

      // A single base 64 digit can contain 6 bits of data. For the base 64 variable
      // length quantities we use in the source map spec, the first bit is the sign,
      // the next four bits are the actual value, and the 6th bit is the
      // continuation bit. The continuation bit tells us whether there are more
      // digits in this value following this digit.
      //
      //   Continuation
      //   |    Sign
      //   |    |
      //   V    V
      //   101011

      var VLQ_BASE_SHIFT = 5;

      // binary: 100000
      var VLQ_BASE = 1 << VLQ_BASE_SHIFT;

      // binary: 011111
      var VLQ_BASE_MASK = VLQ_BASE - 1;

      // binary: 100000
      var VLQ_CONTINUATION_BIT = VLQ_BASE;

      /**
       * Converts from a two-complement value to a value where the sign bit is
       * placed in the least significant bit.  For example, as decimals:
       *   1 becomes 2 (10 binary), -1 becomes 3 (11 binary)
       *   2 becomes 4 (100 binary), -2 becomes 5 (101 binary)
       */
      function toVLQSigned(aValue) {
        return aValue < 0
          ? ((-aValue) << 1) + 1
          : (aValue << 1) + 0;
      }

      /**
       * Converts to a two-complement value from a value where the sign bit is
       * placed in the least significant bit.  For example, as decimals:
       *   2 (10 binary) becomes 1, 3 (11 binary) becomes -1
       *   4 (100 binary) becomes 2, 5 (101 binary) becomes -2
       */
      function fromVLQSigned(aValue) {
        var isNegative = (aValue & 1) === 1;
        var shifted = aValue >> 1;
        return isNegative
          ? -shifted
          : shifted;
      }

      /**
       * Returns the base 64 VLQ encoded value.
       */
      exports.encode = function base64VLQ_encode(aValue) {
        var encoded = "";
        var digit;

        var vlq = toVLQSigned(aValue);

        do {
          digit = vlq & VLQ_BASE_MASK;
          vlq >>>= VLQ_BASE_SHIFT;
          if (vlq > 0) {
            // There are still more digits in this value, so we must make sure the
            // continuation bit is marked.
            digit |= VLQ_CONTINUATION_BIT;
          }
          encoded += base64.encode(digit);
        } while (vlq > 0);

        return encoded;
      };

      /**
       * Decodes the next base 64 VLQ value from the given string and returns the
       * value and the rest of the string via the out parameter.
       */
      exports.decode = function base64VLQ_decode(aStr, aIndex, aOutParam) {
        var strLen = aStr.length;
        var result = 0;
        var shift = 0;
        var continuation, digit;

        do {
          if (aIndex >= strLen) {
            throw new Error("Expected more digits in base 64 VLQ value.");
          }

          digit = base64.decode(aStr.charCodeAt(aIndex++));
          if (digit === -1) {
            throw new Error("Invalid base64 digit: " + aStr.charAt(aIndex - 1));
          }

          continuation = !!(digit & VLQ_CONTINUATION_BIT);
          digit &= VLQ_BASE_MASK;
          result = result + (digit << shift);
          shift += VLQ_BASE_SHIFT;
        } while (continuation);

        aOutParam.value = fromVLQSigned(result);
        aOutParam.rest = aIndex;
      };
    }
    });

    var require$$1$27 = (base64Vlq && typeof base64Vlq === 'object' && 'default' in base64Vlq ? base64Vlq['default'] : base64Vlq);

    var sourceMapGenerator = __commonjs(function (module, exports) {
    /* -*- Mode: js; js-indent-level: 2; -*- */
    /*
     * Copyright 2011 Mozilla Foundation and contributors
     * Licensed under the New BSD license. See LICENSE or:
     * http://opensource.org/licenses/BSD-3-Clause
     */
    {
      var base64VLQ = require$$1$27;
      var util = require$$4$7;
      var ArraySet = require$$2$11.ArraySet;
      var MappingList = require$$0$42.MappingList;

      /**
       * An instance of the SourceMapGenerator represents a source map which is
       * being built incrementally. You may pass an object with the following
       * properties:
       *
       *   - file: The filename of the generated source.
       *   - sourceRoot: A root for all relative URLs in this source map.
       */
      function SourceMapGenerator(aArgs) {
        if (!aArgs) {
          aArgs = {};
        }
        this._file = util.getArg(aArgs, 'file', null);
        this._sourceRoot = util.getArg(aArgs, 'sourceRoot', null);
        this._skipValidation = util.getArg(aArgs, 'skipValidation', false);
        this._sources = new ArraySet();
        this._names = new ArraySet();
        this._mappings = new MappingList();
        this._sourcesContents = null;
      }

      SourceMapGenerator.prototype._version = 3;

      /**
       * Creates a new SourceMapGenerator based on a SourceMapConsumer
       *
       * @param aSourceMapConsumer The SourceMap.
       */
      SourceMapGenerator.fromSourceMap =
        function SourceMapGenerator_fromSourceMap(aSourceMapConsumer) {
          var sourceRoot = aSourceMapConsumer.sourceRoot;
          var generator = new SourceMapGenerator({
            file: aSourceMapConsumer.file,
            sourceRoot: sourceRoot
          });
          aSourceMapConsumer.eachMapping(function (mapping) {
            var newMapping = {
              generated: {
                line: mapping.generatedLine,
                column: mapping.generatedColumn
              }
            };

            if (mapping.source != null) {
              newMapping.source = mapping.source;
              if (sourceRoot != null) {
                newMapping.source = util.relative(sourceRoot, newMapping.source);
              }

              newMapping.original = {
                line: mapping.originalLine,
                column: mapping.originalColumn
              };

              if (mapping.name != null) {
                newMapping.name = mapping.name;
              }
            }

            generator.addMapping(newMapping);
          });
          aSourceMapConsumer.sources.forEach(function (sourceFile) {
            var content = aSourceMapConsumer.sourceContentFor(sourceFile);
            if (content != null) {
              generator.setSourceContent(sourceFile, content);
            }
          });
          return generator;
        };

      /**
       * Add a single mapping from original source line and column to the generated
       * source's line and column for this source map being created. The mapping
       * object should have the following properties:
       *
       *   - generated: An object with the generated line and column positions.
       *   - original: An object with the original line and column positions.
       *   - source: The original source file (relative to the sourceRoot).
       *   - name: An optional original token name for this mapping.
       */
      SourceMapGenerator.prototype.addMapping =
        function SourceMapGenerator_addMapping(aArgs) {
          var generated = util.getArg(aArgs, 'generated');
          var original = util.getArg(aArgs, 'original', null);
          var source = util.getArg(aArgs, 'source', null);
          var name = util.getArg(aArgs, 'name', null);

          if (!this._skipValidation) {
            this._validateMapping(generated, original, source, name);
          }

          if (source != null && !this._sources.has(source)) {
            this._sources.add(source);
          }

          if (name != null && !this._names.has(name)) {
            this._names.add(name);
          }

          this._mappings.add({
            generatedLine: generated.line,
            generatedColumn: generated.column,
            originalLine: original != null && original.line,
            originalColumn: original != null && original.column,
            source: source,
            name: name
          });
        };

      /**
       * Set the source content for a source file.
       */
      SourceMapGenerator.prototype.setSourceContent =
        function SourceMapGenerator_setSourceContent(aSourceFile, aSourceContent) {
          var source = aSourceFile;
          if (this._sourceRoot != null) {
            source = util.relative(this._sourceRoot, source);
          }

          if (aSourceContent != null) {
            // Add the source content to the _sourcesContents map.
            // Create a new _sourcesContents map if the property is null.
            if (!this._sourcesContents) {
              this._sourcesContents = {};
            }
            this._sourcesContents[util.toSetString(source)] = aSourceContent;
          } else if (this._sourcesContents) {
            // Remove the source file from the _sourcesContents map.
            // If the _sourcesContents map is empty, set the property to null.
            delete this._sourcesContents[util.toSetString(source)];
            if (Object.keys(this._sourcesContents).length === 0) {
              this._sourcesContents = null;
            }
          }
        };

      /**
       * Applies the mappings of a sub-source-map for a specific source file to the
       * source map being generated. Each mapping to the supplied source file is
       * rewritten using the supplied source map. Note: The resolution for the
       * resulting mappings is the minimium of this map and the supplied map.
       *
       * @param aSourceMapConsumer The source map to be applied.
       * @param aSourceFile Optional. The filename of the source file.
       *        If omitted, SourceMapConsumer's file property will be used.
       * @param aSourceMapPath Optional. The dirname of the path to the source map
       *        to be applied. If relative, it is relative to the SourceMapConsumer.
       *        This parameter is needed when the two source maps aren't in the same
       *        directory, and the source map to be applied contains relative source
       *        paths. If so, those relative source paths need to be rewritten
       *        relative to the SourceMapGenerator.
       */
      SourceMapGenerator.prototype.applySourceMap =
        function SourceMapGenerator_applySourceMap(aSourceMapConsumer, aSourceFile, aSourceMapPath) {
          var sourceFile = aSourceFile;
          // If aSourceFile is omitted, we will use the file property of the SourceMap
          if (aSourceFile == null) {
            if (aSourceMapConsumer.file == null) {
              throw new Error(
                'SourceMapGenerator.prototype.applySourceMap requires either an explicit source file, ' +
                'or the source map\'s "file" property. Both were omitted.'
              );
            }
            sourceFile = aSourceMapConsumer.file;
          }
          var sourceRoot = this._sourceRoot;
          // Make "sourceFile" relative if an absolute Url is passed.
          if (sourceRoot != null) {
            sourceFile = util.relative(sourceRoot, sourceFile);
          }
          // Applying the SourceMap can add and remove items from the sources and
          // the names array.
          var newSources = new ArraySet();
          var newNames = new ArraySet();

          // Find mappings for the "sourceFile"
          this._mappings.unsortedForEach(function (mapping) {
            if (mapping.source === sourceFile && mapping.originalLine != null) {
              // Check if it can be mapped by the source map, then update the mapping.
              var original = aSourceMapConsumer.originalPositionFor({
                line: mapping.originalLine,
                column: mapping.originalColumn
              });
              if (original.source != null) {
                // Copy mapping
                mapping.source = original.source;
                if (aSourceMapPath != null) {
                  mapping.source = util.join(aSourceMapPath, mapping.source)
                }
                if (sourceRoot != null) {
                  mapping.source = util.relative(sourceRoot, mapping.source);
                }
                mapping.originalLine = original.line;
                mapping.originalColumn = original.column;
                if (original.name != null) {
                  mapping.name = original.name;
                }
              }
            }

            var source = mapping.source;
            if (source != null && !newSources.has(source)) {
              newSources.add(source);
            }

            var name = mapping.name;
            if (name != null && !newNames.has(name)) {
              newNames.add(name);
            }

          }, this);
          this._sources = newSources;
          this._names = newNames;

          // Copy sourcesContents of applied map.
          aSourceMapConsumer.sources.forEach(function (sourceFile) {
            var content = aSourceMapConsumer.sourceContentFor(sourceFile);
            if (content != null) {
              if (aSourceMapPath != null) {
                sourceFile = util.join(aSourceMapPath, sourceFile);
              }
              if (sourceRoot != null) {
                sourceFile = util.relative(sourceRoot, sourceFile);
              }
              this.setSourceContent(sourceFile, content);
            }
          }, this);
        };

      /**
       * A mapping can have one of the three levels of data:
       *
       *   1. Just the generated position.
       *   2. The Generated position, original position, and original source.
       *   3. Generated and original position, original source, as well as a name
       *      token.
       *
       * To maintain consistency, we validate that any new mapping being added falls
       * in to one of these categories.
       */
      SourceMapGenerator.prototype._validateMapping =
        function SourceMapGenerator_validateMapping(aGenerated, aOriginal, aSource,
                                                    aName) {
          if (aGenerated && 'line' in aGenerated && 'column' in aGenerated
              && aGenerated.line > 0 && aGenerated.column >= 0
              && !aOriginal && !aSource && !aName) {
            // Case 1.
            return;
          }
          else if (aGenerated && 'line' in aGenerated && 'column' in aGenerated
                   && aOriginal && 'line' in aOriginal && 'column' in aOriginal
                   && aGenerated.line > 0 && aGenerated.column >= 0
                   && aOriginal.line > 0 && aOriginal.column >= 0
                   && aSource) {
            // Cases 2 and 3.
            return;
          }
          else {
            throw new Error('Invalid mapping: ' + JSON.stringify({
              generated: aGenerated,
              source: aSource,
              original: aOriginal,
              name: aName
            }));
          }
        };

      /**
       * Serialize the accumulated mappings in to the stream of base 64 VLQs
       * specified by the source map format.
       */
      SourceMapGenerator.prototype._serializeMappings =
        function SourceMapGenerator_serializeMappings() {
          var previousGeneratedColumn = 0;
          var previousGeneratedLine = 1;
          var previousOriginalColumn = 0;
          var previousOriginalLine = 0;
          var previousName = 0;
          var previousSource = 0;
          var result = '';
          var mapping;
          var nameIdx;
          var sourceIdx;

          var mappings = this._mappings.toArray();
          for (var i = 0, len = mappings.length; i < len; i++) {
            mapping = mappings[i];

            if (mapping.generatedLine !== previousGeneratedLine) {
              previousGeneratedColumn = 0;
              while (mapping.generatedLine !== previousGeneratedLine) {
                result += ';';
                previousGeneratedLine++;
              }
            }
            else {
              if (i > 0) {
                if (!util.compareByGeneratedPositionsInflated(mapping, mappings[i - 1])) {
                  continue;
                }
                result += ',';
              }
            }

            result += base64VLQ.encode(mapping.generatedColumn
                                       - previousGeneratedColumn);
            previousGeneratedColumn = mapping.generatedColumn;

            if (mapping.source != null) {
              sourceIdx = this._sources.indexOf(mapping.source);
              result += base64VLQ.encode(sourceIdx - previousSource);
              previousSource = sourceIdx;

              // lines are stored 0-based in SourceMap spec version 3
              result += base64VLQ.encode(mapping.originalLine - 1
                                         - previousOriginalLine);
              previousOriginalLine = mapping.originalLine - 1;

              result += base64VLQ.encode(mapping.originalColumn
                                         - previousOriginalColumn);
              previousOriginalColumn = mapping.originalColumn;

              if (mapping.name != null) {
                nameIdx = this._names.indexOf(mapping.name);
                result += base64VLQ.encode(nameIdx - previousName);
                previousName = nameIdx;
              }
            }
          }

          return result;
        };

      SourceMapGenerator.prototype._generateSourcesContent =
        function SourceMapGenerator_generateSourcesContent(aSources, aSourceRoot) {
          return aSources.map(function (source) {
            if (!this._sourcesContents) {
              return null;
            }
            if (aSourceRoot != null) {
              source = util.relative(aSourceRoot, source);
            }
            var key = util.toSetString(source);
            return Object.prototype.hasOwnProperty.call(this._sourcesContents,
                                                        key)
              ? this._sourcesContents[key]
              : null;
          }, this);
        };

      /**
       * Externalize the source map.
       */
      SourceMapGenerator.prototype.toJSON =
        function SourceMapGenerator_toJSON() {
          var map = {
            version: this._version,
            sources: this._sources.toArray(),
            names: this._names.toArray(),
            mappings: this._serializeMappings()
          };
          if (this._file != null) {
            map.file = this._file;
          }
          if (this._sourceRoot != null) {
            map.sourceRoot = this._sourceRoot;
          }
          if (this._sourcesContents) {
            map.sourcesContent = this._generateSourcesContent(map.sources, map.sourceRoot);
          }

          return map;
        };

      /**
       * Render the source map being generated to a string.
       */
      SourceMapGenerator.prototype.toString =
        function SourceMapGenerator_toString() {
          return JSON.stringify(this.toJSON());
        };

      exports.SourceMapGenerator = SourceMapGenerator;
    }
    });

    var require$$1$26 = (sourceMapGenerator && typeof sourceMapGenerator === 'object' && 'default' in sourceMapGenerator ? sourceMapGenerator['default'] : sourceMapGenerator);

    var sourceNode = __commonjs(function (module, exports) {
    /* -*- Mode: js; js-indent-level: 2; -*- */
    /*
     * Copyright 2011 Mozilla Foundation and contributors
     * Licensed under the New BSD license. See LICENSE or:
     * http://opensource.org/licenses/BSD-3-Clause
     */
    {
      var SourceMapGenerator = require$$1$26.SourceMapGenerator;
      var util = require$$4$7;

      // Matches a Windows-style `\r\n` newline or a `\n` newline used by all other
      // operating systems these days (capturing the result).
      var REGEX_NEWLINE = /(\r?\n)/;

      // Newline character code for charCodeAt() comparisons
      var NEWLINE_CODE = 10;

      // Private symbol for identifying `SourceNode`s when multiple versions of
      // the source-map library are loaded. This MUST NOT CHANGE across
      // versions!
      var isSourceNode = "$$$isSourceNode$$$";

      /**
       * SourceNodes provide a way to abstract over interpolating/concatenating
       * snippets of generated JavaScript source code while maintaining the line and
       * column information associated with the original source code.
       *
       * @param aLine The original line number.
       * @param aColumn The original column number.
       * @param aSource The original source's filename.
       * @param aChunks Optional. An array of strings which are snippets of
       *        generated JS, or other SourceNodes.
       * @param aName The original identifier.
       */
      function SourceNode(aLine, aColumn, aSource, aChunks, aName) {
        this.children = [];
        this.sourceContents = {};
        this.line = aLine == null ? null : aLine;
        this.column = aColumn == null ? null : aColumn;
        this.source = aSource == null ? null : aSource;
        this.name = aName == null ? null : aName;
        this[isSourceNode] = true;
        if (aChunks != null) this.add(aChunks);
      }

      /**
       * Creates a SourceNode from generated code and a SourceMapConsumer.
       *
       * @param aGeneratedCode The generated code
       * @param aSourceMapConsumer The SourceMap for the generated code
       * @param aRelativePath Optional. The path that relative sources in the
       *        SourceMapConsumer should be relative to.
       */
      SourceNode.fromStringWithSourceMap =
        function SourceNode_fromStringWithSourceMap(aGeneratedCode, aSourceMapConsumer, aRelativePath) {
          // The SourceNode we want to fill with the generated code
          // and the SourceMap
          var node = new SourceNode();

          // All even indices of this array are one line of the generated code,
          // while all odd indices are the newlines between two adjacent lines
          // (since `REGEX_NEWLINE` captures its match).
          // Processed fragments are removed from this array, by calling `shiftNextLine`.
          var remainingLines = aGeneratedCode.split(REGEX_NEWLINE);
          var shiftNextLine = function() {
            var lineContents = remainingLines.shift();
            // The last line of a file might not have a newline.
            var newLine = remainingLines.shift() || "";
            return lineContents + newLine;
          };

          // We need to remember the position of "remainingLines"
          var lastGeneratedLine = 1, lastGeneratedColumn = 0;

          // The generate SourceNodes we need a code range.
          // To extract it current and last mapping is used.
          // Here we store the last mapping.
          var lastMapping = null;

          aSourceMapConsumer.eachMapping(function (mapping) {
            if (lastMapping !== null) {
              // We add the code from "lastMapping" to "mapping":
              // First check if there is a new line in between.
              if (lastGeneratedLine < mapping.generatedLine) {
                // Associate first line with "lastMapping"
                addMappingWithCode(lastMapping, shiftNextLine());
                lastGeneratedLine++;
                lastGeneratedColumn = 0;
                // The remaining code is added without mapping
              } else {
                // There is no new line in between.
                // Associate the code between "lastGeneratedColumn" and
                // "mapping.generatedColumn" with "lastMapping"
                var nextLine = remainingLines[0];
                var code = nextLine.substr(0, mapping.generatedColumn -
                                              lastGeneratedColumn);
                remainingLines[0] = nextLine.substr(mapping.generatedColumn -
                                                    lastGeneratedColumn);
                lastGeneratedColumn = mapping.generatedColumn;
                addMappingWithCode(lastMapping, code);
                // No more remaining code, continue
                lastMapping = mapping;
                return;
              }
            }
            // We add the generated code until the first mapping
            // to the SourceNode without any mapping.
            // Each line is added as separate string.
            while (lastGeneratedLine < mapping.generatedLine) {
              node.add(shiftNextLine());
              lastGeneratedLine++;
            }
            if (lastGeneratedColumn < mapping.generatedColumn) {
              var nextLine = remainingLines[0];
              node.add(nextLine.substr(0, mapping.generatedColumn));
              remainingLines[0] = nextLine.substr(mapping.generatedColumn);
              lastGeneratedColumn = mapping.generatedColumn;
            }
            lastMapping = mapping;
          }, this);
          // We have processed all mappings.
          if (remainingLines.length > 0) {
            if (lastMapping) {
              // Associate the remaining code in the current line with "lastMapping"
              addMappingWithCode(lastMapping, shiftNextLine());
            }
            // and add the remaining lines without any mapping
            node.add(remainingLines.join(""));
          }

          // Copy sourcesContent into SourceNode
          aSourceMapConsumer.sources.forEach(function (sourceFile) {
            var content = aSourceMapConsumer.sourceContentFor(sourceFile);
            if (content != null) {
              if (aRelativePath != null) {
                sourceFile = util.join(aRelativePath, sourceFile);
              }
              node.setSourceContent(sourceFile, content);
            }
          });

          return node;

          function addMappingWithCode(mapping, code) {
            if (mapping === null || mapping.source === undefined) {
              node.add(code);
            } else {
              var source = aRelativePath
                ? util.join(aRelativePath, mapping.source)
                : mapping.source;
              node.add(new SourceNode(mapping.originalLine,
                                      mapping.originalColumn,
                                      source,
                                      code,
                                      mapping.name));
            }
          }
        };

      /**
       * Add a chunk of generated JS to this source node.
       *
       * @param aChunk A string snippet of generated JS code, another instance of
       *        SourceNode, or an array where each member is one of those things.
       */
      SourceNode.prototype.add = function SourceNode_add(aChunk) {
        if (Array.isArray(aChunk)) {
          aChunk.forEach(function (chunk) {
            this.add(chunk);
          }, this);
        }
        else if (aChunk[isSourceNode] || typeof aChunk === "string") {
          if (aChunk) {
            this.children.push(aChunk);
          }
        }
        else {
          throw new TypeError(
            "Expected a SourceNode, string, or an array of SourceNodes and strings. Got " + aChunk
          );
        }
        return this;
      };

      /**
       * Add a chunk of generated JS to the beginning of this source node.
       *
       * @param aChunk A string snippet of generated JS code, another instance of
       *        SourceNode, or an array where each member is one of those things.
       */
      SourceNode.prototype.prepend = function SourceNode_prepend(aChunk) {
        if (Array.isArray(aChunk)) {
          for (var i = aChunk.length-1; i >= 0; i--) {
            this.prepend(aChunk[i]);
          }
        }
        else if (aChunk[isSourceNode] || typeof aChunk === "string") {
          this.children.unshift(aChunk);
        }
        else {
          throw new TypeError(
            "Expected a SourceNode, string, or an array of SourceNodes and strings. Got " + aChunk
          );
        }
        return this;
      };

      /**
       * Walk over the tree of JS snippets in this node and its children. The
       * walking function is called once for each snippet of JS and is passed that
       * snippet and the its original associated source's line/column location.
       *
       * @param aFn The traversal function.
       */
      SourceNode.prototype.walk = function SourceNode_walk(aFn) {
        var chunk;
        for (var i = 0, len = this.children.length; i < len; i++) {
          chunk = this.children[i];
          if (chunk[isSourceNode]) {
            chunk.walk(aFn);
          }
          else {
            if (chunk !== '') {
              aFn(chunk, { source: this.source,
                           line: this.line,
                           column: this.column,
                           name: this.name });
            }
          }
        }
      };

      /**
       * Like `String.prototype.join` except for SourceNodes. Inserts `aStr` between
       * each of `this.children`.
       *
       * @param aSep The separator.
       */
      SourceNode.prototype.join = function SourceNode_join(aSep) {
        var newChildren;
        var i;
        var len = this.children.length;
        if (len > 0) {
          newChildren = [];
          for (i = 0; i < len-1; i++) {
            newChildren.push(this.children[i]);
            newChildren.push(aSep);
          }
          newChildren.push(this.children[i]);
          this.children = newChildren;
        }
        return this;
      };

      /**
       * Call String.prototype.replace on the very right-most source snippet. Useful
       * for trimming whitespace from the end of a source node, etc.
       *
       * @param aPattern The pattern to replace.
       * @param aReplacement The thing to replace the pattern with.
       */
      SourceNode.prototype.replaceRight = function SourceNode_replaceRight(aPattern, aReplacement) {
        var lastChild = this.children[this.children.length - 1];
        if (lastChild[isSourceNode]) {
          lastChild.replaceRight(aPattern, aReplacement);
        }
        else if (typeof lastChild === 'string') {
          this.children[this.children.length - 1] = lastChild.replace(aPattern, aReplacement);
        }
        else {
          this.children.push(''.replace(aPattern, aReplacement));
        }
        return this;
      };

      /**
       * Set the source content for a source file. This will be added to the SourceMapGenerator
       * in the sourcesContent field.
       *
       * @param aSourceFile The filename of the source file
       * @param aSourceContent The content of the source file
       */
      SourceNode.prototype.setSourceContent =
        function SourceNode_setSourceContent(aSourceFile, aSourceContent) {
          this.sourceContents[util.toSetString(aSourceFile)] = aSourceContent;
        };

      /**
       * Walk over the tree of SourceNodes. The walking function is called for each
       * source file content and is passed the filename and source content.
       *
       * @param aFn The traversal function.
       */
      SourceNode.prototype.walkSourceContents =
        function SourceNode_walkSourceContents(aFn) {
          for (var i = 0, len = this.children.length; i < len; i++) {
            if (this.children[i][isSourceNode]) {
              this.children[i].walkSourceContents(aFn);
            }
          }

          var sources = Object.keys(this.sourceContents);
          for (var i = 0, len = sources.length; i < len; i++) {
            aFn(util.fromSetString(sources[i]), this.sourceContents[sources[i]]);
          }
        };

      /**
       * Return the string representation of this source node. Walks over the tree
       * and concatenates all the various snippets together to one string.
       */
      SourceNode.prototype.toString = function SourceNode_toString() {
        var str = "";
        this.walk(function (chunk) {
          str += chunk;
        });
        return str;
      };

      /**
       * Returns the string representation of this source node along with a source
       * map.
       */
      SourceNode.prototype.toStringWithSourceMap = function SourceNode_toStringWithSourceMap(aArgs) {
        var generated = {
          code: "",
          line: 1,
          column: 0
        };
        var map = new SourceMapGenerator(aArgs);
        var sourceMappingActive = false;
        var lastOriginalSource = null;
        var lastOriginalLine = null;
        var lastOriginalColumn = null;
        var lastOriginalName = null;
        this.walk(function (chunk, original) {
          generated.code += chunk;
          if (original.source !== null
              && original.line !== null
              && original.column !== null) {
            if(lastOriginalSource !== original.source
               || lastOriginalLine !== original.line
               || lastOriginalColumn !== original.column
               || lastOriginalName !== original.name) {
              map.addMapping({
                source: original.source,
                original: {
                  line: original.line,
                  column: original.column
                },
                generated: {
                  line: generated.line,
                  column: generated.column
                },
                name: original.name
              });
            }
            lastOriginalSource = original.source;
            lastOriginalLine = original.line;
            lastOriginalColumn = original.column;
            lastOriginalName = original.name;
            sourceMappingActive = true;
          } else if (sourceMappingActive) {
            map.addMapping({
              generated: {
                line: generated.line,
                column: generated.column
              }
            });
            lastOriginalSource = null;
            sourceMappingActive = false;
          }
          for (var idx = 0, length = chunk.length; idx < length; idx++) {
            if (chunk.charCodeAt(idx) === NEWLINE_CODE) {
              generated.line++;
              generated.column = 0;
              // Mappings end at eol
              if (idx + 1 === length) {
                lastOriginalSource = null;
                sourceMappingActive = false;
              } else if (sourceMappingActive) {
                map.addMapping({
                  source: original.source,
                  original: {
                    line: original.line,
                    column: original.column
                  },
                  generated: {
                    line: generated.line,
                    column: generated.column
                  },
                  name: original.name
                });
              }
            } else {
              generated.column++;
            }
          }
        });
        this.walkSourceContents(function (sourceFile, sourceContent) {
          map.setSourceContent(sourceFile, sourceContent);
        });

        return { code: generated.code, map: map };
      };

      exports.SourceNode = SourceNode;
    }
    });

    var require$$0$41 = (sourceNode && typeof sourceNode === 'object' && 'default' in sourceNode ? sourceNode['default'] : sourceNode);

    var quickSort = __commonjs(function (module, exports) {
    /* -*- Mode: js; js-indent-level: 2; -*- */
    /*
     * Copyright 2011 Mozilla Foundation and contributors
     * Licensed under the New BSD license. See LICENSE or:
     * http://opensource.org/licenses/BSD-3-Clause
     */
    {
      // It turns out that some (most?) JavaScript engines don't self-host
      // `Array.prototype.sort`. This makes sense because C++ will likely remain
      // faster than JS when doing raw CPU-intensive sorting. However, when using a
      // custom comparator function, calling back and forth between the VM's C++ and
      // JIT'd JS is rather slow *and* loses JIT type information, resulting in
      // worse generated code for the comparator function than would be optimal. In
      // fact, when sorting with a comparator, these costs outweigh the benefits of
      // sorting in C++. By using our own JS-implemented Quick Sort (below), we get
      // a ~3500ms mean speed-up in `bench/bench.html`.

      /**
       * Swap the elements indexed by `x` and `y` in the array `ary`.
       *
       * @param {Array} ary
       *        The array.
       * @param {Number} x
       *        The index of the first item.
       * @param {Number} y
       *        The index of the second item.
       */
      function swap(ary, x, y) {
        var temp = ary[x];
        ary[x] = ary[y];
        ary[y] = temp;
      }

      /**
       * Returns a random integer within the range `low .. high` inclusive.
       *
       * @param {Number} low
       *        The lower bound on the range.
       * @param {Number} high
       *        The upper bound on the range.
       */
      function randomIntInRange(low, high) {
        return Math.round(low + (Math.random() * (high - low)));
      }

      /**
       * The Quick Sort algorithm.
       *
       * @param {Array} ary
       *        An array to sort.
       * @param {function} comparator
       *        Function to use to compare two items.
       * @param {Number} p
       *        Start index of the array
       * @param {Number} r
       *        End index of the array
       */
      function doQuickSort(ary, comparator, p, r) {
        // If our lower bound is less than our upper bound, we (1) partition the
        // array into two pieces and (2) recurse on each half. If it is not, this is
        // the empty array and our base case.

        if (p < r) {
          // (1) Partitioning.
          //
          // The partitioning chooses a pivot between `p` and `r` and moves all
          // elements that are less than or equal to the pivot to the before it, and
          // all the elements that are greater than it after it. The effect is that
          // once partition is done, the pivot is in the exact place it will be when
          // the array is put in sorted order, and it will not need to be moved
          // again. This runs in O(n) time.

          // Always choose a random pivot so that an input array which is reverse
          // sorted does not cause O(n^2) running time.
          var pivotIndex = randomIntInRange(p, r);
          var i = p - 1;

          swap(ary, pivotIndex, r);
          var pivot = ary[r];

          // Immediately after `j` is incremented in this loop, the following hold
          // true:
          //
          //   * Every element in `ary[p .. i]` is less than or equal to the pivot.
          //
          //   * Every element in `ary[i+1 .. j-1]` is greater than the pivot.
          for (var j = p; j < r; j++) {
            if (comparator(ary[j], pivot) <= 0) {
              i += 1;
              swap(ary, i, j);
            }
          }

          swap(ary, i + 1, j);
          var q = i + 1;

          // (2) Recurse on each half.

          doQuickSort(ary, comparator, p, q - 1);
          doQuickSort(ary, comparator, q + 1, r);
        }
      }

      /**
       * Sort the given array in-place with the given comparator function.
       *
       * @param {Array} ary
       *        An array to sort.
       * @param {function} comparator
       *        Function to use to compare two items.
       */
      exports.quickSort = function (ary, comparator) {
        doQuickSort(ary, comparator, 0, ary.length - 1);
      };
    }
    });

    var require$$0$44 = (quickSort && typeof quickSort === 'object' && 'default' in quickSort ? quickSort['default'] : quickSort);
    var quickSort = quickSort.quickSort;

    var binarySearch = __commonjs(function (module, exports) {
    /* -*- Mode: js; js-indent-level: 2; -*- */
    /*
     * Copyright 2011 Mozilla Foundation and contributors
     * Licensed under the New BSD license. See LICENSE or:
     * http://opensource.org/licenses/BSD-3-Clause
     */
    {
      exports.GREATEST_LOWER_BOUND = 1;
      exports.LEAST_UPPER_BOUND = 2;

      /**
       * Recursive implementation of binary search.
       *
       * @param aLow Indices here and lower do not contain the needle.
       * @param aHigh Indices here and higher do not contain the needle.
       * @param aNeedle The element being searched for.
       * @param aHaystack The non-empty array being searched.
       * @param aCompare Function which takes two elements and returns -1, 0, or 1.
       * @param aBias Either 'binarySearch.GREATEST_LOWER_BOUND' or
       *     'binarySearch.LEAST_UPPER_BOUND'. Specifies whether to return the
       *     closest element that is smaller than or greater than the one we are
       *     searching for, respectively, if the exact element cannot be found.
       */
      function recursiveSearch(aLow, aHigh, aNeedle, aHaystack, aCompare, aBias) {
        // This function terminates when one of the following is true:
        //
        //   1. We find the exact element we are looking for.
        //
        //   2. We did not find the exact element, but we can return the index of
        //      the next-closest element.
        //
        //   3. We did not find the exact element, and there is no next-closest
        //      element than the one we are searching for, so we return -1.
        var mid = Math.floor((aHigh - aLow) / 2) + aLow;
        var cmp = aCompare(aNeedle, aHaystack[mid], true);
        if (cmp === 0) {
          // Found the element we are looking for.
          return mid;
        }
        else if (cmp > 0) {
          // Our needle is greater than aHaystack[mid].
          if (aHigh - mid > 1) {
            // The element is in the upper half.
            return recursiveSearch(mid, aHigh, aNeedle, aHaystack, aCompare, aBias);
          }

          // The exact needle element was not found in this haystack. Determine if
          // we are in termination case (3) or (2) and return the appropriate thing.
          if (aBias == exports.LEAST_UPPER_BOUND) {
            return aHigh < aHaystack.length ? aHigh : -1;
          } else {
            return mid;
          }
        }
        else {
          // Our needle is less than aHaystack[mid].
          if (mid - aLow > 1) {
            // The element is in the lower half.
            return recursiveSearch(aLow, mid, aNeedle, aHaystack, aCompare, aBias);
          }

          // we are in termination case (3) or (2) and return the appropriate thing.
          if (aBias == exports.LEAST_UPPER_BOUND) {
            return mid;
          } else {
            return aLow < 0 ? -1 : aLow;
          }
        }
      }

      /**
       * This is an implementation of binary search which will always try and return
       * the index of the closest element if there is no exact hit. This is because
       * mappings between original and generated line/col pairs are single points,
       * and there is an implicit region between each of them, so a miss just means
       * that you aren't on the very start of a region.
       *
       * @param aNeedle The element you are looking for.
       * @param aHaystack The array that is being searched.
       * @param aCompare A function which takes the needle and an element in the
       *     array and returns -1, 0, or 1 depending on whether the needle is less
       *     than, equal to, or greater than the element, respectively.
       * @param aBias Either 'binarySearch.GREATEST_LOWER_BOUND' or
       *     'binarySearch.LEAST_UPPER_BOUND'. Specifies whether to return the
       *     closest element that is smaller than or greater than the one we are
       *     searching for, respectively, if the exact element cannot be found.
       *     Defaults to 'binarySearch.GREATEST_LOWER_BOUND'.
       */
      exports.search = function search(aNeedle, aHaystack, aCompare, aBias) {
        if (aHaystack.length === 0) {
          return -1;
        }

        var index = recursiveSearch(-1, aHaystack.length, aNeedle, aHaystack,
                                    aCompare, aBias || exports.GREATEST_LOWER_BOUND);
        if (index < 0) {
          return -1;
        }

        // We have found either the exact element, or the next-closest element than
        // the one we are searching for. However, there may be more than one such
        // element. Make sure we always return the smallest of these.
        while (index - 1 >= 0) {
          if (aCompare(aHaystack[index], aHaystack[index - 1], true) !== 0) {
            break;
          }
          --index;
        }

        return index;
      };
    }
    });

    var require$$3$8 = (binarySearch && typeof binarySearch === 'object' && 'default' in binarySearch ? binarySearch['default'] : binarySearch);

    var sourceMapConsumer = __commonjs(function (module, exports) {
    /* -*- Mode: js; js-indent-level: 2; -*- */
    /*
     * Copyright 2011 Mozilla Foundation and contributors
     * Licensed under the New BSD license. See LICENSE or:
     * http://opensource.org/licenses/BSD-3-Clause
     */
    {
      var util = require$$4$7;
      var binarySearch = require$$3$8;
      var ArraySet = require$$2$11.ArraySet;
      var base64VLQ = require$$1$27;
      var quickSort = require$$0$44.quickSort;

      function SourceMapConsumer(aSourceMap) {
        var sourceMap = aSourceMap;
        if (typeof aSourceMap === 'string') {
          sourceMap = JSON.parse(aSourceMap.replace(/^\)\]\}'/, ''));
        }

        return sourceMap.sections != null
          ? new IndexedSourceMapConsumer(sourceMap)
          : new BasicSourceMapConsumer(sourceMap);
      }

      SourceMapConsumer.fromSourceMap = function(aSourceMap) {
        return BasicSourceMapConsumer.fromSourceMap(aSourceMap);
      }

      /**
       * The version of the source mapping spec that we are consuming.
       */
      SourceMapConsumer.prototype._version = 3;

      // `__generatedMappings` and `__originalMappings` are arrays that hold the
      // parsed mapping coordinates from the source map's "mappings" attribute. They
      // are lazily instantiated, accessed via the `_generatedMappings` and
      // `_originalMappings` getters respectively, and we only parse the mappings
      // and create these arrays once queried for a source location. We jump through
      // these hoops because there can be many thousands of mappings, and parsing
      // them is expensive, so we only want to do it if we must.
      //
      // Each object in the arrays is of the form:
      //
      //     {
      //       generatedLine: The line number in the generated code,
      //       generatedColumn: The column number in the generated code,
      //       source: The path to the original source file that generated this
      //               chunk of code,
      //       originalLine: The line number in the original source that
      //                     corresponds to this chunk of generated code,
      //       originalColumn: The column number in the original source that
      //                       corresponds to this chunk of generated code,
      //       name: The name of the original symbol which generated this chunk of
      //             code.
      //     }
      //
      // All properties except for `generatedLine` and `generatedColumn` can be
      // `null`.
      //
      // `_generatedMappings` is ordered by the generated positions.
      //
      // `_originalMappings` is ordered by the original positions.

      SourceMapConsumer.prototype.__generatedMappings = null;
      Object.defineProperty(SourceMapConsumer.prototype, '_generatedMappings', {
        get: function () {
          if (!this.__generatedMappings) {
            this._parseMappings(this._mappings, this.sourceRoot);
          }

          return this.__generatedMappings;
        }
      });

      SourceMapConsumer.prototype.__originalMappings = null;
      Object.defineProperty(SourceMapConsumer.prototype, '_originalMappings', {
        get: function () {
          if (!this.__originalMappings) {
            this._parseMappings(this._mappings, this.sourceRoot);
          }

          return this.__originalMappings;
        }
      });

      SourceMapConsumer.prototype._charIsMappingSeparator =
        function SourceMapConsumer_charIsMappingSeparator(aStr, index) {
          var c = aStr.charAt(index);
          return c === ";" || c === ",";
        };

      /**
       * Parse the mappings in a string in to a data structure which we can easily
       * query (the ordered arrays in the `this.__generatedMappings` and
       * `this.__originalMappings` properties).
       */
      SourceMapConsumer.prototype._parseMappings =
        function SourceMapConsumer_parseMappings(aStr, aSourceRoot) {
          throw new Error("Subclasses must implement _parseMappings");
        };

      SourceMapConsumer.GENERATED_ORDER = 1;
      SourceMapConsumer.ORIGINAL_ORDER = 2;

      SourceMapConsumer.GREATEST_LOWER_BOUND = 1;
      SourceMapConsumer.LEAST_UPPER_BOUND = 2;

      /**
       * Iterate over each mapping between an original source/line/column and a
       * generated line/column in this source map.
       *
       * @param Function aCallback
       *        The function that is called with each mapping.
       * @param Object aContext
       *        Optional. If specified, this object will be the value of `this` every
       *        time that `aCallback` is called.
       * @param aOrder
       *        Either `SourceMapConsumer.GENERATED_ORDER` or
       *        `SourceMapConsumer.ORIGINAL_ORDER`. Specifies whether you want to
       *        iterate over the mappings sorted by the generated file's line/column
       *        order or the original's source/line/column order, respectively. Defaults to
       *        `SourceMapConsumer.GENERATED_ORDER`.
       */
      SourceMapConsumer.prototype.eachMapping =
        function SourceMapConsumer_eachMapping(aCallback, aContext, aOrder) {
          var context = aContext || null;
          var order = aOrder || SourceMapConsumer.GENERATED_ORDER;

          var mappings;
          switch (order) {
          case SourceMapConsumer.GENERATED_ORDER:
            mappings = this._generatedMappings;
            break;
          case SourceMapConsumer.ORIGINAL_ORDER:
            mappings = this._originalMappings;
            break;
          default:
            throw new Error("Unknown order of iteration.");
          }

          var sourceRoot = this.sourceRoot;
          mappings.map(function (mapping) {
            var source = mapping.source === null ? null : this._sources.at(mapping.source);
            if (source != null && sourceRoot != null) {
              source = util.join(sourceRoot, source);
            }
            return {
              source: source,
              generatedLine: mapping.generatedLine,
              generatedColumn: mapping.generatedColumn,
              originalLine: mapping.originalLine,
              originalColumn: mapping.originalColumn,
              name: mapping.name === null ? null : this._names.at(mapping.name)
            };
          }, this).forEach(aCallback, context);
        };

      /**
       * Returns all generated line and column information for the original source,
       * line, and column provided. If no column is provided, returns all mappings
       * corresponding to a either the line we are searching for or the next
       * closest line that has any mappings. Otherwise, returns all mappings
       * corresponding to the given line and either the column we are searching for
       * or the next closest column that has any offsets.
       *
       * The only argument is an object with the following properties:
       *
       *   - source: The filename of the original source.
       *   - line: The line number in the original source.
       *   - column: Optional. the column number in the original source.
       *
       * and an array of objects is returned, each with the following properties:
       *
       *   - line: The line number in the generated source, or null.
       *   - column: The column number in the generated source, or null.
       */
      SourceMapConsumer.prototype.allGeneratedPositionsFor =
        function SourceMapConsumer_allGeneratedPositionsFor(aArgs) {
          var line = util.getArg(aArgs, 'line');

          // When there is no exact match, BasicSourceMapConsumer.prototype._findMapping
          // returns the index of the closest mapping less than the needle. By
          // setting needle.originalColumn to 0, we thus find the last mapping for
          // the given line, provided such a mapping exists.
          var needle = {
            source: util.getArg(aArgs, 'source'),
            originalLine: line,
            originalColumn: util.getArg(aArgs, 'column', 0)
          };

          if (this.sourceRoot != null) {
            needle.source = util.relative(this.sourceRoot, needle.source);
          }
          if (!this._sources.has(needle.source)) {
            return [];
          }
          needle.source = this._sources.indexOf(needle.source);

          var mappings = [];

          var index = this._findMapping(needle,
                                        this._originalMappings,
                                        "originalLine",
                                        "originalColumn",
                                        util.compareByOriginalPositions,
                                        binarySearch.LEAST_UPPER_BOUND);
          if (index >= 0) {
            var mapping = this._originalMappings[index];

            if (aArgs.column === undefined) {
              var originalLine = mapping.originalLine;

              // Iterate until either we run out of mappings, or we run into
              // a mapping for a different line than the one we found. Since
              // mappings are sorted, this is guaranteed to find all mappings for
              // the line we found.
              while (mapping && mapping.originalLine === originalLine) {
                mappings.push({
                  line: util.getArg(mapping, 'generatedLine', null),
                  column: util.getArg(mapping, 'generatedColumn', null),
                  lastColumn: util.getArg(mapping, 'lastGeneratedColumn', null)
                });

                mapping = this._originalMappings[++index];
              }
            } else {
              var originalColumn = mapping.originalColumn;

              // Iterate until either we run out of mappings, or we run into
              // a mapping for a different line than the one we were searching for.
              // Since mappings are sorted, this is guaranteed to find all mappings for
              // the line we are searching for.
              while (mapping &&
                     mapping.originalLine === line &&
                     mapping.originalColumn == originalColumn) {
                mappings.push({
                  line: util.getArg(mapping, 'generatedLine', null),
                  column: util.getArg(mapping, 'generatedColumn', null),
                  lastColumn: util.getArg(mapping, 'lastGeneratedColumn', null)
                });

                mapping = this._originalMappings[++index];
              }
            }
          }

          return mappings;
        };

      exports.SourceMapConsumer = SourceMapConsumer;

      /**
       * A BasicSourceMapConsumer instance represents a parsed source map which we can
       * query for information about the original file positions by giving it a file
       * position in the generated source.
       *
       * The only parameter is the raw source map (either as a JSON string, or
       * already parsed to an object). According to the spec, source maps have the
       * following attributes:
       *
       *   - version: Which version of the source map spec this map is following.
       *   - sources: An array of URLs to the original source files.
       *   - names: An array of identifiers which can be referrenced by individual mappings.
       *   - sourceRoot: Optional. The URL root from which all sources are relative.
       *   - sourcesContent: Optional. An array of contents of the original source files.
       *   - mappings: A string of base64 VLQs which contain the actual mappings.
       *   - file: Optional. The generated file this source map is associated with.
       *
       * Here is an example source map, taken from the source map spec[0]:
       *
       *     {
       *       version : 3,
       *       file: "out.js",
       *       sourceRoot : "",
       *       sources: ["foo.js", "bar.js"],
       *       names: ["src", "maps", "are", "fun"],
       *       mappings: "AA,AB;;ABCDE;"
       *     }
       *
       * [0]: https://docs.google.com/document/d/1U1RGAehQwRypUTovF1KRlpiOFze0b-_2gc6fAH0KY0k/edit?pli=1#
       */
      function BasicSourceMapConsumer(aSourceMap) {
        var sourceMap = aSourceMap;
        if (typeof aSourceMap === 'string') {
          sourceMap = JSON.parse(aSourceMap.replace(/^\)\]\}'/, ''));
        }

        var version = util.getArg(sourceMap, 'version');
        var sources = util.getArg(sourceMap, 'sources');
        // Sass 3.3 leaves out the 'names' array, so we deviate from the spec (which
        // requires the array) to play nice here.
        var names = util.getArg(sourceMap, 'names', []);
        var sourceRoot = util.getArg(sourceMap, 'sourceRoot', null);
        var sourcesContent = util.getArg(sourceMap, 'sourcesContent', null);
        var mappings = util.getArg(sourceMap, 'mappings');
        var file = util.getArg(sourceMap, 'file', null);

        // Once again, Sass deviates from the spec and supplies the version as a
        // string rather than a number, so we use loose equality checking here.
        if (version != this._version) {
          throw new Error('Unsupported version: ' + version);
        }

        sources = sources
          // Some source maps produce relative source paths like "./foo.js" instead of
          // "foo.js".  Normalize these first so that future comparisons will succeed.
          // See bugzil.la/1090768.
          .map(util.normalize)
          // Always ensure that absolute sources are internally stored relative to
          // the source root, if the source root is absolute. Not doing this would
          // be particularly problematic when the source root is a prefix of the
          // source (valid, but why??). See github issue #199 and bugzil.la/1188982.
          .map(function (source) {
            return sourceRoot && util.isAbsolute(sourceRoot) && util.isAbsolute(source)
              ? util.relative(sourceRoot, source)
              : source;
          });

        // Pass `true` below to allow duplicate names and sources. While source maps
        // are intended to be compressed and deduplicated, the TypeScript compiler
        // sometimes generates source maps with duplicates in them. See Github issue
        // #72 and bugzil.la/889492.
        this._names = ArraySet.fromArray(names, true);
        this._sources = ArraySet.fromArray(sources, true);

        this.sourceRoot = sourceRoot;
        this.sourcesContent = sourcesContent;
        this._mappings = mappings;
        this.file = file;
      }

      BasicSourceMapConsumer.prototype = Object.create(SourceMapConsumer.prototype);
      BasicSourceMapConsumer.prototype.consumer = SourceMapConsumer;

      /**
       * Create a BasicSourceMapConsumer from a SourceMapGenerator.
       *
       * @param SourceMapGenerator aSourceMap
       *        The source map that will be consumed.
       * @returns BasicSourceMapConsumer
       */
      BasicSourceMapConsumer.fromSourceMap =
        function SourceMapConsumer_fromSourceMap(aSourceMap) {
          var smc = Object.create(BasicSourceMapConsumer.prototype);

          var names = smc._names = ArraySet.fromArray(aSourceMap._names.toArray(), true);
          var sources = smc._sources = ArraySet.fromArray(aSourceMap._sources.toArray(), true);
          smc.sourceRoot = aSourceMap._sourceRoot;
          smc.sourcesContent = aSourceMap._generateSourcesContent(smc._sources.toArray(),
                                                                  smc.sourceRoot);
          smc.file = aSourceMap._file;

          // Because we are modifying the entries (by converting string sources and
          // names to indices into the sources and names ArraySets), we have to make
          // a copy of the entry or else bad things happen. Shared mutable state
          // strikes again! See github issue #191.

          var generatedMappings = aSourceMap._mappings.toArray().slice();
          var destGeneratedMappings = smc.__generatedMappings = [];
          var destOriginalMappings = smc.__originalMappings = [];

          for (var i = 0, length = generatedMappings.length; i < length; i++) {
            var srcMapping = generatedMappings[i];
            var destMapping = new Mapping;
            destMapping.generatedLine = srcMapping.generatedLine;
            destMapping.generatedColumn = srcMapping.generatedColumn;

            if (srcMapping.source) {
              destMapping.source = sources.indexOf(srcMapping.source);
              destMapping.originalLine = srcMapping.originalLine;
              destMapping.originalColumn = srcMapping.originalColumn;

              if (srcMapping.name) {
                destMapping.name = names.indexOf(srcMapping.name);
              }

              destOriginalMappings.push(destMapping);
            }

            destGeneratedMappings.push(destMapping);
          }

          quickSort(smc.__originalMappings, util.compareByOriginalPositions);

          return smc;
        };

      /**
       * The version of the source mapping spec that we are consuming.
       */
      BasicSourceMapConsumer.prototype._version = 3;

      /**
       * The list of original sources.
       */
      Object.defineProperty(BasicSourceMapConsumer.prototype, 'sources', {
        get: function () {
          return this._sources.toArray().map(function (s) {
            return this.sourceRoot != null ? util.join(this.sourceRoot, s) : s;
          }, this);
        }
      });

      /**
       * Provide the JIT with a nice shape / hidden class.
       */
      function Mapping() {
        this.generatedLine = 0;
        this.generatedColumn = 0;
        this.source = null;
        this.originalLine = null;
        this.originalColumn = null;
        this.name = null;
      }

      /**
       * Parse the mappings in a string in to a data structure which we can easily
       * query (the ordered arrays in the `this.__generatedMappings` and
       * `this.__originalMappings` properties).
       */
      BasicSourceMapConsumer.prototype._parseMappings =
        function SourceMapConsumer_parseMappings(aStr, aSourceRoot) {
          var generatedLine = 1;
          var previousGeneratedColumn = 0;
          var previousOriginalLine = 0;
          var previousOriginalColumn = 0;
          var previousSource = 0;
          var previousName = 0;
          var length = aStr.length;
          var index = 0;
          var cachedSegments = {};
          var temp = {};
          var originalMappings = [];
          var generatedMappings = [];
          var mapping, str, segment, end, value;

          while (index < length) {
            if (aStr.charAt(index) === ';') {
              generatedLine++;
              index++;
              previousGeneratedColumn = 0;
            }
            else if (aStr.charAt(index) === ',') {
              index++;
            }
            else {
              mapping = new Mapping();
              mapping.generatedLine = generatedLine;

              // Because each offset is encoded relative to the previous one,
              // many segments often have the same encoding. We can exploit this
              // fact by caching the parsed variable length fields of each segment,
              // allowing us to avoid a second parse if we encounter the same
              // segment again.
              for (end = index; end < length; end++) {
                if (this._charIsMappingSeparator(aStr, end)) {
                  break;
                }
              }
              str = aStr.slice(index, end);

              segment = cachedSegments[str];
              if (segment) {
                index += str.length;
              } else {
                segment = [];
                while (index < end) {
                  base64VLQ.decode(aStr, index, temp);
                  value = temp.value;
                  index = temp.rest;
                  segment.push(value);
                }

                if (segment.length === 2) {
                  throw new Error('Found a source, but no line and column');
                }

                if (segment.length === 3) {
                  throw new Error('Found a source and line, but no column');
                }

                cachedSegments[str] = segment;
              }

              // Generated column.
              mapping.generatedColumn = previousGeneratedColumn + segment[0];
              previousGeneratedColumn = mapping.generatedColumn;

              if (segment.length > 1) {
                // Original source.
                mapping.source = previousSource + segment[1];
                previousSource += segment[1];

                // Original line.
                mapping.originalLine = previousOriginalLine + segment[2];
                previousOriginalLine = mapping.originalLine;
                // Lines are stored 0-based
                mapping.originalLine += 1;

                // Original column.
                mapping.originalColumn = previousOriginalColumn + segment[3];
                previousOriginalColumn = mapping.originalColumn;

                if (segment.length > 4) {
                  // Original name.
                  mapping.name = previousName + segment[4];
                  previousName += segment[4];
                }
              }

              generatedMappings.push(mapping);
              if (typeof mapping.originalLine === 'number') {
                originalMappings.push(mapping);
              }
            }
          }

          quickSort(generatedMappings, util.compareByGeneratedPositionsDeflated);
          this.__generatedMappings = generatedMappings;

          quickSort(originalMappings, util.compareByOriginalPositions);
          this.__originalMappings = originalMappings;
        };

      /**
       * Find the mapping that best matches the hypothetical "needle" mapping that
       * we are searching for in the given "haystack" of mappings.
       */
      BasicSourceMapConsumer.prototype._findMapping =
        function SourceMapConsumer_findMapping(aNeedle, aMappings, aLineName,
                                               aColumnName, aComparator, aBias) {
          // To return the position we are searching for, we must first find the
          // mapping for the given position and then return the opposite position it
          // points to. Because the mappings are sorted, we can use binary search to
          // find the best mapping.

          if (aNeedle[aLineName] <= 0) {
            throw new TypeError('Line must be greater than or equal to 1, got '
                                + aNeedle[aLineName]);
          }
          if (aNeedle[aColumnName] < 0) {
            throw new TypeError('Column must be greater than or equal to 0, got '
                                + aNeedle[aColumnName]);
          }

          return binarySearch.search(aNeedle, aMappings, aComparator, aBias);
        };

      /**
       * Compute the last column for each generated mapping. The last column is
       * inclusive.
       */
      BasicSourceMapConsumer.prototype.computeColumnSpans =
        function SourceMapConsumer_computeColumnSpans() {
          for (var index = 0; index < this._generatedMappings.length; ++index) {
            var mapping = this._generatedMappings[index];

            // Mappings do not contain a field for the last generated columnt. We
            // can come up with an optimistic estimate, however, by assuming that
            // mappings are contiguous (i.e. given two consecutive mappings, the
            // first mapping ends where the second one starts).
            if (index + 1 < this._generatedMappings.length) {
              var nextMapping = this._generatedMappings[index + 1];

              if (mapping.generatedLine === nextMapping.generatedLine) {
                mapping.lastGeneratedColumn = nextMapping.generatedColumn - 1;
                continue;
              }
            }

            // The last mapping for each line spans the entire line.
            mapping.lastGeneratedColumn = Infinity;
          }
        };

      /**
       * Returns the original source, line, and column information for the generated
       * source's line and column positions provided. The only argument is an object
       * with the following properties:
       *
       *   - line: The line number in the generated source.
       *   - column: The column number in the generated source.
       *   - bias: Either 'SourceMapConsumer.GREATEST_LOWER_BOUND' or
       *     'SourceMapConsumer.LEAST_UPPER_BOUND'. Specifies whether to return the
       *     closest element that is smaller than or greater than the one we are
       *     searching for, respectively, if the exact element cannot be found.
       *     Defaults to 'SourceMapConsumer.GREATEST_LOWER_BOUND'.
       *
       * and an object is returned with the following properties:
       *
       *   - source: The original source file, or null.
       *   - line: The line number in the original source, or null.
       *   - column: The column number in the original source, or null.
       *   - name: The original identifier, or null.
       */
      BasicSourceMapConsumer.prototype.originalPositionFor =
        function SourceMapConsumer_originalPositionFor(aArgs) {
          var needle = {
            generatedLine: util.getArg(aArgs, 'line'),
            generatedColumn: util.getArg(aArgs, 'column')
          };

          var index = this._findMapping(
            needle,
            this._generatedMappings,
            "generatedLine",
            "generatedColumn",
            util.compareByGeneratedPositionsDeflated,
            util.getArg(aArgs, 'bias', SourceMapConsumer.GREATEST_LOWER_BOUND)
          );

          if (index >= 0) {
            var mapping = this._generatedMappings[index];

            if (mapping.generatedLine === needle.generatedLine) {
              var source = util.getArg(mapping, 'source', null);
              if (source !== null) {
                source = this._sources.at(source);
                if (this.sourceRoot != null) {
                  source = util.join(this.sourceRoot, source);
                }
              }
              var name = util.getArg(mapping, 'name', null);
              if (name !== null) {
                name = this._names.at(name);
              }
              return {
                source: source,
                line: util.getArg(mapping, 'originalLine', null),
                column: util.getArg(mapping, 'originalColumn', null),
                name: name
              };
            }
          }

          return {
            source: null,
            line: null,
            column: null,
            name: null
          };
        };

      /**
       * Return true if we have the source content for every source in the source
       * map, false otherwise.
       */
      BasicSourceMapConsumer.prototype.hasContentsOfAllSources =
        function BasicSourceMapConsumer_hasContentsOfAllSources() {
          if (!this.sourcesContent) {
            return false;
          }
          return this.sourcesContent.length >= this._sources.size() &&
            !this.sourcesContent.some(function (sc) { return sc == null; });
        };

      /**
       * Returns the original source content. The only argument is the url of the
       * original source file. Returns null if no original source content is
       * available.
       */
      BasicSourceMapConsumer.prototype.sourceContentFor =
        function SourceMapConsumer_sourceContentFor(aSource, nullOnMissing) {
          if (!this.sourcesContent) {
            return null;
          }

          if (this.sourceRoot != null) {
            aSource = util.relative(this.sourceRoot, aSource);
          }

          if (this._sources.has(aSource)) {
            return this.sourcesContent[this._sources.indexOf(aSource)];
          }

          var url;
          if (this.sourceRoot != null
              && (url = util.urlParse(this.sourceRoot))) {
            // XXX: file:// URIs and absolute paths lead to unexpected behavior for
            // many users. We can help them out when they expect file:// URIs to
            // behave like it would if they were running a local HTTP server. See
            // https://bugzilla.mozilla.org/show_bug.cgi?id=885597.
            var fileUriAbsPath = aSource.replace(/^file:\/\//, "");
            if (url.scheme == "file"
                && this._sources.has(fileUriAbsPath)) {
              return this.sourcesContent[this._sources.indexOf(fileUriAbsPath)]
            }

            if ((!url.path || url.path == "/")
                && this._sources.has("/" + aSource)) {
              return this.sourcesContent[this._sources.indexOf("/" + aSource)];
            }
          }

          // This function is used recursively from
          // IndexedSourceMapConsumer.prototype.sourceContentFor. In that case, we
          // don't want to throw if we can't find the source - we just want to
          // return null, so we provide a flag to exit gracefully.
          if (nullOnMissing) {
            return null;
          }
          else {
            throw new Error('"' + aSource + '" is not in the SourceMap.');
          }
        };

      /**
       * Returns the generated line and column information for the original source,
       * line, and column positions provided. The only argument is an object with
       * the following properties:
       *
       *   - source: The filename of the original source.
       *   - line: The line number in the original source.
       *   - column: The column number in the original source.
       *   - bias: Either 'SourceMapConsumer.GREATEST_LOWER_BOUND' or
       *     'SourceMapConsumer.LEAST_UPPER_BOUND'. Specifies whether to return the
       *     closest element that is smaller than or greater than the one we are
       *     searching for, respectively, if the exact element cannot be found.
       *     Defaults to 'SourceMapConsumer.GREATEST_LOWER_BOUND'.
       *
       * and an object is returned with the following properties:
       *
       *   - line: The line number in the generated source, or null.
       *   - column: The column number in the generated source, or null.
       */
      BasicSourceMapConsumer.prototype.generatedPositionFor =
        function SourceMapConsumer_generatedPositionFor(aArgs) {
          var source = util.getArg(aArgs, 'source');
          if (this.sourceRoot != null) {
            source = util.relative(this.sourceRoot, source);
          }
          if (!this._sources.has(source)) {
            return {
              line: null,
              column: null,
              lastColumn: null
            };
          }
          source = this._sources.indexOf(source);

          var needle = {
            source: source,
            originalLine: util.getArg(aArgs, 'line'),
            originalColumn: util.getArg(aArgs, 'column')
          };

          var index = this._findMapping(
            needle,
            this._originalMappings,
            "originalLine",
            "originalColumn",
            util.compareByOriginalPositions,
            util.getArg(aArgs, 'bias', SourceMapConsumer.GREATEST_LOWER_BOUND)
          );

          if (index >= 0) {
            var mapping = this._originalMappings[index];

            if (mapping.source === needle.source) {
              return {
                line: util.getArg(mapping, 'generatedLine', null),
                column: util.getArg(mapping, 'generatedColumn', null),
                lastColumn: util.getArg(mapping, 'lastGeneratedColumn', null)
              };
            }
          }

          return {
            line: null,
            column: null,
            lastColumn: null
          };
        };

      exports.BasicSourceMapConsumer = BasicSourceMapConsumer;

      /**
       * An IndexedSourceMapConsumer instance represents a parsed source map which
       * we can query for information. It differs from BasicSourceMapConsumer in
       * that it takes "indexed" source maps (i.e. ones with a "sections" field) as
       * input.
       *
       * The only parameter is a raw source map (either as a JSON string, or already
       * parsed to an object). According to the spec for indexed source maps, they
       * have the following attributes:
       *
       *   - version: Which version of the source map spec this map is following.
       *   - file: Optional. The generated file this source map is associated with.
       *   - sections: A list of section definitions.
       *
       * Each value under the "sections" field has two fields:
       *   - offset: The offset into the original specified at which this section
       *       begins to apply, defined as an object with a "line" and "column"
       *       field.
       *   - map: A source map definition. This source map could also be indexed,
       *       but doesn't have to be.
       *
       * Instead of the "map" field, it's also possible to have a "url" field
       * specifying a URL to retrieve a source map from, but that's currently
       * unsupported.
       *
       * Here's an example source map, taken from the source map spec[0], but
       * modified to omit a section which uses the "url" field.
       *
       *  {
       *    version : 3,
       *    file: "app.js",
       *    sections: [{
       *      offset: {line:100, column:10},
       *      map: {
       *        version : 3,
       *        file: "section.js",
       *        sources: ["foo.js", "bar.js"],
       *        names: ["src", "maps", "are", "fun"],
       *        mappings: "AAAA,E;;ABCDE;"
       *      }
       *    }],
       *  }
       *
       * [0]: https://docs.google.com/document/d/1U1RGAehQwRypUTovF1KRlpiOFze0b-_2gc6fAH0KY0k/edit#heading=h.535es3xeprgt
       */
      function IndexedSourceMapConsumer(aSourceMap) {
        var sourceMap = aSourceMap;
        if (typeof aSourceMap === 'string') {
          sourceMap = JSON.parse(aSourceMap.replace(/^\)\]\}'/, ''));
        }

        var version = util.getArg(sourceMap, 'version');
        var sections = util.getArg(sourceMap, 'sections');

        if (version != this._version) {
          throw new Error('Unsupported version: ' + version);
        }

        this._sources = new ArraySet();
        this._names = new ArraySet();

        var lastOffset = {
          line: -1,
          column: 0
        };
        this._sections = sections.map(function (s) {
          if (s.url) {
            // The url field will require support for asynchronicity.
            // See https://github.com/mozilla/source-map/issues/16
            throw new Error('Support for url field in sections not implemented.');
          }
          var offset = util.getArg(s, 'offset');
          var offsetLine = util.getArg(offset, 'line');
          var offsetColumn = util.getArg(offset, 'column');

          if (offsetLine < lastOffset.line ||
              (offsetLine === lastOffset.line && offsetColumn < lastOffset.column)) {
            throw new Error('Section offsets must be ordered and non-overlapping.');
          }
          lastOffset = offset;

          return {
            generatedOffset: {
              // The offset fields are 0-based, but we use 1-based indices when
              // encoding/decoding from VLQ.
              generatedLine: offsetLine + 1,
              generatedColumn: offsetColumn + 1
            },
            consumer: new SourceMapConsumer(util.getArg(s, 'map'))
          }
        });
      }

      IndexedSourceMapConsumer.prototype = Object.create(SourceMapConsumer.prototype);
      IndexedSourceMapConsumer.prototype.constructor = SourceMapConsumer;

      /**
       * The version of the source mapping spec that we are consuming.
       */
      IndexedSourceMapConsumer.prototype._version = 3;

      /**
       * The list of original sources.
       */
      Object.defineProperty(IndexedSourceMapConsumer.prototype, 'sources', {
        get: function () {
          var sources = [];
          for (var i = 0; i < this._sections.length; i++) {
            for (var j = 0; j < this._sections[i].consumer.sources.length; j++) {
              sources.push(this._sections[i].consumer.sources[j]);
            }
          }
          return sources;
        }
      });

      /**
       * Returns the original source, line, and column information for the generated
       * source's line and column positions provided. The only argument is an object
       * with the following properties:
       *
       *   - line: The line number in the generated source.
       *   - column: The column number in the generated source.
       *
       * and an object is returned with the following properties:
       *
       *   - source: The original source file, or null.
       *   - line: The line number in the original source, or null.
       *   - column: The column number in the original source, or null.
       *   - name: The original identifier, or null.
       */
      IndexedSourceMapConsumer.prototype.originalPositionFor =
        function IndexedSourceMapConsumer_originalPositionFor(aArgs) {
          var needle = {
            generatedLine: util.getArg(aArgs, 'line'),
            generatedColumn: util.getArg(aArgs, 'column')
          };

          // Find the section containing the generated position we're trying to map
          // to an original position.
          var sectionIndex = binarySearch.search(needle, this._sections,
            function(needle, section) {
              var cmp = needle.generatedLine - section.generatedOffset.generatedLine;
              if (cmp) {
                return cmp;
              }

              return (needle.generatedColumn -
                      section.generatedOffset.generatedColumn);
            });
          var section = this._sections[sectionIndex];

          if (!section) {
            return {
              source: null,
              line: null,
              column: null,
              name: null
            };
          }

          return section.consumer.originalPositionFor({
            line: needle.generatedLine -
              (section.generatedOffset.generatedLine - 1),
            column: needle.generatedColumn -
              (section.generatedOffset.generatedLine === needle.generatedLine
               ? section.generatedOffset.generatedColumn - 1
               : 0),
            bias: aArgs.bias
          });
        };

      /**
       * Return true if we have the source content for every source in the source
       * map, false otherwise.
       */
      IndexedSourceMapConsumer.prototype.hasContentsOfAllSources =
        function IndexedSourceMapConsumer_hasContentsOfAllSources() {
          return this._sections.every(function (s) {
            return s.consumer.hasContentsOfAllSources();
          });
        };

      /**
       * Returns the original source content. The only argument is the url of the
       * original source file. Returns null if no original source content is
       * available.
       */
      IndexedSourceMapConsumer.prototype.sourceContentFor =
        function IndexedSourceMapConsumer_sourceContentFor(aSource, nullOnMissing) {
          for (var i = 0; i < this._sections.length; i++) {
            var section = this._sections[i];

            var content = section.consumer.sourceContentFor(aSource, true);
            if (content) {
              return content;
            }
          }
          if (nullOnMissing) {
            return null;
          }
          else {
            throw new Error('"' + aSource + '" is not in the SourceMap.');
          }
        };

      /**
       * Returns the generated line and column information for the original source,
       * line, and column positions provided. The only argument is an object with
       * the following properties:
       *
       *   - source: The filename of the original source.
       *   - line: The line number in the original source.
       *   - column: The column number in the original source.
       *
       * and an object is returned with the following properties:
       *
       *   - line: The line number in the generated source, or null.
       *   - column: The column number in the generated source, or null.
       */
      IndexedSourceMapConsumer.prototype.generatedPositionFor =
        function IndexedSourceMapConsumer_generatedPositionFor(aArgs) {
          for (var i = 0; i < this._sections.length; i++) {
            var section = this._sections[i];

            // Only consider this section if the requested source is in the list of
            // sources of the consumer.
            if (section.consumer.sources.indexOf(util.getArg(aArgs, 'source')) === -1) {
              continue;
            }
            var generatedPosition = section.consumer.generatedPositionFor(aArgs);
            if (generatedPosition) {
              var ret = {
                line: generatedPosition.line +
                  (section.generatedOffset.generatedLine - 1),
                column: generatedPosition.column +
                  (section.generatedOffset.generatedLine === generatedPosition.line
                   ? section.generatedOffset.generatedColumn - 1
                   : 0)
              };
              return ret;
            }
          }

          return {
            line: null,
            column: null
          };
        };

      /**
       * Parse the mappings in a string in to a data structure which we can easily
       * query (the ordered arrays in the `this.__generatedMappings` and
       * `this.__originalMappings` properties).
       */
      IndexedSourceMapConsumer.prototype._parseMappings =
        function IndexedSourceMapConsumer_parseMappings(aStr, aSourceRoot) {
          this.__generatedMappings = [];
          this.__originalMappings = [];
          for (var i = 0; i < this._sections.length; i++) {
            var section = this._sections[i];
            var sectionMappings = section.consumer._generatedMappings;
            for (var j = 0; j < sectionMappings.length; j++) {
              var mapping = sectionMappings[j];

              var source = section.consumer._sources.at(mapping.source);
              if (section.consumer.sourceRoot !== null) {
                source = util.join(section.consumer.sourceRoot, source);
              }
              this._sources.add(source);
              source = this._sources.indexOf(source);

              var name = section.consumer._names.at(mapping.name);
              this._names.add(name);
              name = this._names.indexOf(name);

              // The mappings coming from the consumer for the section have
              // generated positions relative to the start of the section, so we
              // need to offset them to be relative to the start of the concatenated
              // generated file.
              var adjustedMapping = {
                source: source,
                generatedLine: mapping.generatedLine +
                  (section.generatedOffset.generatedLine - 1),
                generatedColumn: mapping.generatedColumn +
                  (section.generatedOffset.generatedLine === mapping.generatedLine
                  ? section.generatedOffset.generatedColumn - 1
                  : 0),
                originalLine: mapping.originalLine,
                originalColumn: mapping.originalColumn,
                name: name
              };

              this.__generatedMappings.push(adjustedMapping);
              if (typeof adjustedMapping.originalLine === 'number') {
                this.__originalMappings.push(adjustedMapping);
              }
            }
          }

          quickSort(this.__generatedMappings, util.compareByGeneratedPositionsDeflated);
          quickSort(this.__originalMappings, util.compareByOriginalPositions);
        };

      exports.IndexedSourceMapConsumer = IndexedSourceMapConsumer;
    }
    });

    var require$$1$28 = (sourceMapConsumer && typeof sourceMapConsumer === 'object' && 'default' in sourceMapConsumer ? sourceMapConsumer['default'] : sourceMapConsumer);

    var sourceMap = __commonjs(function (module, exports) {
    /*
     * Copyright 2009-2011 Mozilla Foundation and contributors
     * Licensed under the New BSD license. See LICENSE.txt or:
     * http://opensource.org/licenses/BSD-3-Clause
     */
    exports.SourceMapGenerator = require$$1$26.SourceMapGenerator;
    exports.SourceMapConsumer = require$$1$28.SourceMapConsumer;
    exports.SourceNode = require$$0$41.SourceNode;
    });

    var SourceNode = sourceMap.SourceNode;

    var ASTNode = function () {
    	function ASTNode(line, col, props) {
    		babelHelpers.classCallCheck(this, ASTNode);

    		if ((typeof line === "undefined" ? "undefined" : babelHelpers.typeof(line)) === "object" && col == null && props == null) {
    			var _ref = [line, null];
    			props = _ref[0];
    			line = _ref[1];
    		}

    		this._line = typeof line === "number" ? line : 0;
    		this._column = typeof col === "number" ? col : 0;
    		_default3$1(this, props);
    	}

    	babelHelpers.createClass(ASTNode, [{
    		key: "_sn",
    		value: function _sn(file, chunk) {
    			return new SourceNode(this._line, this._column, file, chunk);
    		}
    	}, {
    		key: "start",
    		value: function start(data) {
    			this._writer = {
    				chunks: [],
    				data: data
    			};

    			return this;
    		}
    	}, {
    		key: "_normalize_indent",
    		value: function _normalize_indent() {
    			var d = this._writer.data;
    			if (typeof d.indent === "string") d.tabchar = d.indent;
    			if (d.indent !== false && typeof d.indent !== "number") d.indent = 0;
    		}
    	}, {
    		key: "indent",
    		value: function indent() {
    			this._normalize_indent();
    			var d = this._writer.data;
    			if (typeof d.indent === "number") d.indent++;
    			return this;
    		}
    	}, {
    		key: "outdent",
    		value: function outdent() {
    			this._normalize_indent();
    			var d = this._writer.data;
    			if (typeof d.indent === "number" && d.indent > 0) d.indent--;
    			return this;
    		}
    	}, {
    		key: "tabs",
    		value: function tabs() {
    			this._normalize_indent();

    			var res = "";
    			var d = this._writer.data;
    			var tabchar = d.tabchar;
    			if (tabchar == null) tabchar = "  ";

    			if (typeof d.indent === "number") {
    				for (var i = 0; i < d.indent; i++) {
    					res += tabchar;
    				}
    			}

    			return res;
    		}
    	}, {
    		key: "write",
    		value: function write(chunk) {
    			this.push([].concat(this.tabs(), chunk, "\n"));
    			return this;
    		}
    	}, {
    		key: "push",
    		value: function push(chunk) {
    			this._writer.chunks.push(chunk);
    			return this;
    		}
    	}, {
    		key: "end",
    		value: function end(chunk) {
    			if (chunk) this.write(chunk);
    			var w = this._writer;
    			delete this._writer;
    			return this._sn(w.data.filename, w.chunks);
    		}
    	}, {
    		key: "compile",
    		value: function compile() {
    			throw new Error("Not implemented.");
    			// return this._sn(data.filename);
    		}
    	}, {
    		key: "toJSON",
    		value: function toJSON() {
    			var _this = this;

    			var out = {};
    			Object.keys(this).forEach(function (k) {
    				if (k[0] === "_") return;
    				out[k] = _this[k];
    			});
    			_default3$1(out, _default2$3(this, "_line", "_column"));
    		}
    	}]);
    	return ASTNode;
    }();

    var _baseInvoke = __commonjs(function (module) {
    var apply = require$$4,
        baseCastPath = require$$3$6,
        isKey = require$$0$34,
        last = _default4$1,
        parent = require$$0$32;

    /**
     * The base implementation of `_.invoke` without support for individual
     * method arguments.
     *
     * @private
     * @param {Object} object The object to query.
     * @param {Array|string} path The path of the method to invoke.
     * @param {Array} args The arguments to invoke the method with.
     * @returns {*} Returns the result of the invoked method.
     */
    function baseInvoke(object, path, args) {
      if (!isKey(path, object)) {
        path = baseCastPath(path);
        object = parent(object, path);
        path = last(path);
      }
      var func = object == null ? object : object[path];
      return func == null ? undefined : apply(func, object, args);
    }

    module.exports = baseInvoke;
    });

    var require$$3$9 = (_baseInvoke && typeof _baseInvoke === 'object' && 'default' in _baseInvoke ? _baseInvoke['default'] : _baseInvoke);

    var invokeMap = __commonjs(function (module) {
    var apply = require$$4,
        baseEach = require$$1$11,
        baseInvoke = require$$3$9,
        isArrayLike = require$$0$5,
        isKey = require$$0$34,
        rest = require$$0;

    /**
     * Invokes the method at `path` of each element in `collection`, returning
     * an array of the results of each invoked method. Any additional arguments
     * are provided to each invoked method. If `methodName` is a function it's
     * invoked for, and `this` bound to, each element in `collection`.
     *
     * @static
     * @memberOf _
     * @category Collection
     * @param {Array|Object} collection The collection to iterate over.
     * @param {Array|Function|string} path The path of the method to invoke or
     *  the function invoked per iteration.
     * @param {...*} [args] The arguments to invoke each method with.
     * @returns {Array} Returns the array of results.
     * @example
     *
     * _.invokeMap([[5, 1, 7], [3, 2, 1]], 'sort');
     * // => [[1, 5, 7], [1, 2, 3]]
     *
     * _.invokeMap([123, 456], String.prototype.split, '');
     * // => [['1', '2', '3'], ['4', '5', '6']]
     */
    var invokeMap = rest(function(collection, path, args) {
      var index = -1,
          isFunc = typeof path == 'function',
          isProp = isKey(path),
          result = isArrayLike(collection) ? Array(collection.length) : [];

      baseEach(collection, function(value) {
        var func = isFunc ? path : ((isProp && value != null) ? value[path] : undefined);
        result[++index] = func ? apply(func, value, args) : baseInvoke(value, path, args);
      });
      return result;
    });

    module.exports = invokeMap;
    });

    var _default$1 = (invokeMap && typeof invokeMap === 'object' && 'default' in invokeMap ? invokeMap['default'] : invokeMap);

    function header(data, h) {
    	if (require$$2$5(data.headers) && !_default2$2(data.headers, h)) {
    		data.headers.push(h);
    	}
    }

    function hash(str) {
    	var h = 0,
    	    i,
    	    chr,
    	    len;

    	if (str.length === 0) return h;

    	for (i = 0, len = str.length; i < len; i++) {
    		chr = str.charCodeAt(i);
    		h = (h << 5) - h + chr;
    		h |= 0; // Convert to 32bit integer
    	}

    	return h;
    }

    function compileGroup(nodes, data) {
    	return nodes.map(function (n, i) {
    		return n.compile(addKey(data, i.toString()));
    	});
    }

    function compileGroupAsync(nodes, data) {
    	nodes = nodes.slice(0);
    	var out = [];
    	var next = function next() {
    		return !nodes.length ? Promise.resolve() : nodes.shift().compile(data).then(function (o) {
    			out.push(o);
    			return next();
    		});
    	};
    	return next().then(function () {
    		return out;
    	});
    }

    function getKey(data) {
    	return (data.key || []).reduce(function (memo, v) {
    		if (_default3(v) && _default3(_default4$1(memo))) {
    			memo.push(memo.pop() + "-" + v);
    		} else {
    			memo.push(v);
    		}

    		return memo;
    	}, []).map(function (v, i, l) {
    		if ((typeof v === "undefined" ? "undefined" : babelHelpers.typeof(v)) === "object") return v.value;
    		if (i !== 0) v = "-" + v;
    		if (i !== l.length - 1) v += "-";
    		return JSON.stringify(v);
    	}).join(" + ");
    }

    function addKey(data, key) {
    	var base = data.key || [];
    	return _default3$1({}, data, {
    		key: [].concat(base, key)
    	});
    }

    function resetKey(data) {
    	return _default3$1({}, data, { key: [] });
    }

var utils$1 = Object.freeze({
    	header: header,
    	hash: hash,
    	compileGroup: compileGroup,
    	compileGroupAsync: compileGroupAsync,
    	getKey: getKey,
    	addKey: addKey,
    	resetKey: resetKey
    });

    var Root = function (_Node) {
    	babelHelpers.inherits(Root, _Node);

    	function Root() {
    		babelHelpers.classCallCheck(this, Root);
    		return babelHelpers.possibleConstructorReturn(this, Object.getPrototypeOf(Root).apply(this, arguments));
    	}

    	babelHelpers.createClass(Root, [{
    		key: "compile",
    		value: function compile(data) {
    			data = _default3$1({}, data, {
    				included: []
    			});

    			this.start(data);

    			switch (data.format) {
    				case "es6":
    					this.write("import * as Temple from \"templejs\";\n");
    					break;

    				case "cjs":
    					this.write("var Temple = require(\"templejs\");\n");
    					break;

    				case "umd":
    					this.write("(function (global, factory) {").indent();
    					this.write("typeof exports === 'object' && typeof module !== 'undefined' ? factory(require(\"templejs\")) :");
    					this.write("typeof define === 'function' && define.amd ? define([\"templejs\"], factory) :");
    					this.write("(factory(global.Temple));");
    					this.outdent().write("}(this, function(Temple) {\n").indent();
    					break;

    				case "iife":
    					this.write("(function(Temple) {\n").indent();
    					break;
    			}

    			if (data.async) {
    				return compileGroupAsync(this.files, data).then(this._finish.bind(this, data));
    			} else {
    				return this._finish(data, _default$1(this.files, "compile", data));
    			}
    		}
    	}, {
    		key: "_finish",
    		value: function _finish(data, src) {
    			this.push(src);

    			switch (data.format) {
    				case "umd":
    					this.outdent().write("}));");
    					break;

    				case "iife":
    					this.outdent().write("}(Temple));");
    					break;
    			}

    			var output = this.end();
    			output.includes = data.included;
    			return output;
    		}
    	}]);
    	return Root;
    }(ASTNode);

    var _baseMap = __commonjs(function (module) {
    var baseEach = require$$1$11,
        isArrayLike = require$$0$5;

    /**
     * The base implementation of `_.map` without support for iteratee shorthands.
     *
     * @private
     * @param {Array|Object} collection The collection to iterate over.
     * @param {Function} iteratee The function invoked per iteration.
     * @returns {Array} Returns the new mapped array.
     */
    function baseMap(collection, iteratee) {
      var index = -1,
          result = isArrayLike(collection) ? Array(collection.length) : [];

      baseEach(collection, function(value, key, collection) {
        result[++index] = iteratee(value, key, collection);
      });
      return result;
    }

    module.exports = baseMap;
    });

    var require$$1$29 = (_baseMap && typeof _baseMap === 'object' && 'default' in _baseMap ? _baseMap['default'] : _baseMap);

    var _basePropertyDeep = __commonjs(function (module) {
    var baseGet = require$$0$33;

    /**
     * A specialized version of `baseProperty` which supports deep paths.
     *
     * @private
     * @param {Array|string} path The path of the property to get.
     * @returns {Function} Returns the new function.
     */
    function basePropertyDeep(path) {
      return function(object) {
        return baseGet(object, path);
      };
    }

    module.exports = basePropertyDeep;
    });

    var require$$1$30 = (_basePropertyDeep && typeof _basePropertyDeep === 'object' && 'default' in _basePropertyDeep ? _basePropertyDeep['default'] : _basePropertyDeep);

    var property = __commonjs(function (module) {
    var baseProperty = require$$2$1,
        basePropertyDeep = require$$1$30,
        isKey = require$$0$34;

    /**
     * Creates a function that returns the value at `path` of a given object.
     *
     * @static
     * @memberOf _
     * @category Util
     * @param {Array|string} path The path of the property to get.
     * @returns {Function} Returns the new function.
     * @example
     *
     * var objects = [
     *   { 'a': { 'b': { 'c': 2 } } },
     *   { 'a': { 'b': { 'c': 1 } } }
     * ];
     *
     * _.map(objects, _.property('a.b.c'));
     * // => [2, 1]
     *
     * _.map(_.sortBy(objects, _.property(['a', 'b', 'c'])), 'a.b.c');
     * // => [1, 2]
     */
    function property(path) {
      return isKey(path) ? baseProperty(path) : basePropertyDeep(path);
    }

    module.exports = property;
    });

    var require$$0$45 = (property && typeof property === 'object' && 'default' in property ? property['default'] : property);

    var _baseHasIn = __commonjs(function (module) {
    /**
     * The base implementation of `_.hasIn` without support for deep paths.
     *
     * @private
     * @param {Object} object The object to query.
     * @param {Array|string} key The key to check.
     * @returns {boolean} Returns `true` if `key` exists, else `false`.
     */
    function baseHasIn(object, key) {
      return key in Object(object);
    }

    module.exports = baseHasIn;
    });

    var require$$1$31 = (_baseHasIn && typeof _baseHasIn === 'object' && 'default' in _baseHasIn ? _baseHasIn['default'] : _baseHasIn);

    var hasIn = __commonjs(function (module) {
    var baseHasIn = require$$1$31,
        hasPath = require$$0$31;

    /**
     * Checks if `path` is a direct or inherited property of `object`.
     *
     * @static
     * @memberOf _
     * @category Object
     * @param {Object} object The object to query.
     * @param {Array|string} path The path to check.
     * @returns {boolean} Returns `true` if `path` exists, else `false`.
     * @example
     *
     * var object = _.create({ 'a': _.create({ 'b': _.create({ 'c': 3 }) }) });
     *
     * _.hasIn(object, 'a');
     * // => true
     *
     * _.hasIn(object, 'a.b.c');
     * // => true
     *
     * _.hasIn(object, ['a', 'b', 'c']);
     * // => true
     *
     * _.hasIn(object, 'b');
     * // => false
     */
    function hasIn(object, path) {
      return hasPath(object, path, baseHasIn);
    }

    module.exports = hasIn;
    });

    var require$$0$46 = (hasIn && typeof hasIn === 'object' && 'default' in hasIn ? hasIn['default'] : hasIn);

    var isTypedArray = __commonjs(function (module) {
    var isLength = require$$1$1,
        isObjectLike = require$$0$4;

    /** `Object#toString` result references. */
    var argsTag = '[object Arguments]',
        arrayTag = '[object Array]',
        boolTag = '[object Boolean]',
        dateTag = '[object Date]',
        errorTag = '[object Error]',
        funcTag = '[object Function]',
        mapTag = '[object Map]',
        numberTag = '[object Number]',
        objectTag = '[object Object]',
        regexpTag = '[object RegExp]',
        setTag = '[object Set]',
        stringTag = '[object String]',
        weakMapTag = '[object WeakMap]';

    var arrayBufferTag = '[object ArrayBuffer]',
        float32Tag = '[object Float32Array]',
        float64Tag = '[object Float64Array]',
        int8Tag = '[object Int8Array]',
        int16Tag = '[object Int16Array]',
        int32Tag = '[object Int32Array]',
        uint8Tag = '[object Uint8Array]',
        uint8ClampedTag = '[object Uint8ClampedArray]',
        uint16Tag = '[object Uint16Array]',
        uint32Tag = '[object Uint32Array]';

    /** Used to identify `toStringTag` values of typed arrays. */
    var typedArrayTags = {};
    typedArrayTags[float32Tag] = typedArrayTags[float64Tag] =
    typedArrayTags[int8Tag] = typedArrayTags[int16Tag] =
    typedArrayTags[int32Tag] = typedArrayTags[uint8Tag] =
    typedArrayTags[uint8ClampedTag] = typedArrayTags[uint16Tag] =
    typedArrayTags[uint32Tag] = true;
    typedArrayTags[argsTag] = typedArrayTags[arrayTag] =
    typedArrayTags[arrayBufferTag] = typedArrayTags[boolTag] =
    typedArrayTags[dateTag] = typedArrayTags[errorTag] =
    typedArrayTags[funcTag] = typedArrayTags[mapTag] =
    typedArrayTags[numberTag] = typedArrayTags[objectTag] =
    typedArrayTags[regexpTag] = typedArrayTags[setTag] =
    typedArrayTags[stringTag] = typedArrayTags[weakMapTag] = false;

    /** Used for built-in method references. */
    var objectProto = Object.prototype;

    /**
     * Used to resolve the [`toStringTag`](http://ecma-international.org/ecma-262/6.0/#sec-object.prototype.tostring)
     * of values.
     */
    var objectToString = objectProto.toString;

    /**
     * Checks if `value` is classified as a typed array.
     *
     * @static
     * @memberOf _
     * @category Lang
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is correctly classified, else `false`.
     * @example
     *
     * _.isTypedArray(new Uint8Array);
     * // => true
     *
     * _.isTypedArray([]);
     * // => false
     */
    function isTypedArray(value) {
      return isObjectLike(value) &&
        isLength(value.length) && !!typedArrayTags[objectToString.call(value)];
    }

    module.exports = isTypedArray;
    });

    var require$$0$48 = (isTypedArray && typeof isTypedArray === 'object' && 'default' in isTypedArray ? isTypedArray['default'] : isTypedArray);

    var _equalObjects = __commonjs(function (module) {
    var baseHas = require$$1$14,
        keys = require$$0$24;

    /** Used to compose bitmasks for comparison styles. */
    var PARTIAL_COMPARE_FLAG = 2;

    /**
     * A specialized version of `baseIsEqualDeep` for objects with support for
     * partial deep comparisons.
     *
     * @private
     * @param {Object} object The object to compare.
     * @param {Object} other The other object to compare.
     * @param {Function} equalFunc The function to determine equivalents of values.
     * @param {Function} [customizer] The function to customize comparisons.
     * @param {number} [bitmask] The bitmask of comparison flags. See `baseIsEqual` for more details.
     * @param {Object} [stack] Tracks traversed `object` and `other` objects.
     * @returns {boolean} Returns `true` if the objects are equivalent, else `false`.
     */
    function equalObjects(object, other, equalFunc, customizer, bitmask, stack) {
      var isPartial = bitmask & PARTIAL_COMPARE_FLAG,
          objProps = keys(object),
          objLength = objProps.length,
          othProps = keys(other),
          othLength = othProps.length;

      if (objLength != othLength && !isPartial) {
        return false;
      }
      var index = objLength;
      while (index--) {
        var key = objProps[index];
        if (!(isPartial ? key in other : baseHas(other, key))) {
          return false;
        }
      }
      // Assume cyclic values are equal.
      var stacked = stack.get(object);
      if (stacked) {
        return stacked == other;
      }
      var result = true;
      stack.set(object, other);

      var skipCtor = isPartial;
      while (++index < objLength) {
        key = objProps[index];
        var objValue = object[key],
            othValue = other[key];

        if (customizer) {
          var compared = isPartial
            ? customizer(othValue, objValue, key, other, object, stack)
            : customizer(objValue, othValue, key, object, other, stack);
        }
        // Recursively compare objects (susceptible to call stack limits).
        if (!(compared === undefined
              ? (objValue === othValue || equalFunc(objValue, othValue, customizer, bitmask, stack))
              : compared
            )) {
          result = false;
          break;
        }
        skipCtor || (skipCtor = key == 'constructor');
      }
      if (result && !skipCtor) {
        var objCtor = object.constructor,
            othCtor = other.constructor;

        // Non `Object` object instances with different constructors are not equal.
        if (objCtor != othCtor &&
            ('constructor' in object && 'constructor' in other) &&
            !(typeof objCtor == 'function' && objCtor instanceof objCtor &&
              typeof othCtor == 'function' && othCtor instanceof othCtor)) {
          result = false;
        }
      }
      stack['delete'](object);
      return result;
    }

    module.exports = equalObjects;
    });

    var require$$4$8 = (_equalObjects && typeof _equalObjects === 'object' && 'default' in _equalObjects ? _equalObjects['default'] : _equalObjects);

    var _Uint8Array = __commonjs(function (module) {
    var root = require$$0$17;

    /** Built-in value references. */
    var Uint8Array = root.Uint8Array;

    module.exports = Uint8Array;
    });

    var require$$2$14 = (_Uint8Array && typeof _Uint8Array === 'object' && 'default' in _Uint8Array ? _Uint8Array['default'] : _Uint8Array);

    var _equalByTag = __commonjs(function (module) {
    var Symbol = require$$3$5,
        Uint8Array = require$$2$14,
        mapToArray = require$$1$18,
        setToArray = require$$0$28;

    /** Used to compose bitmasks for comparison styles. */
    var UNORDERED_COMPARE_FLAG = 1,
        PARTIAL_COMPARE_FLAG = 2;

    /** `Object#toString` result references. */
    var boolTag = '[object Boolean]',
        dateTag = '[object Date]',
        errorTag = '[object Error]',
        mapTag = '[object Map]',
        numberTag = '[object Number]',
        regexpTag = '[object RegExp]',
        setTag = '[object Set]',
        stringTag = '[object String]',
        symbolTag = '[object Symbol]';

    var arrayBufferTag = '[object ArrayBuffer]';

    /** Used to convert symbols to primitives and strings. */
    var symbolProto = Symbol ? Symbol.prototype : undefined,
        symbolValueOf = Symbol ? symbolProto.valueOf : undefined;

    /**
     * A specialized version of `baseIsEqualDeep` for comparing objects of
     * the same `toStringTag`.
     *
     * **Note:** This function only supports comparing values with tags of
     * `Boolean`, `Date`, `Error`, `Number`, `RegExp`, or `String`.
     *
     * @private
     * @param {Object} object The object to compare.
     * @param {Object} other The other object to compare.
     * @param {string} tag The `toStringTag` of the objects to compare.
     * @param {Function} equalFunc The function to determine equivalents of values.
     * @param {Function} [customizer] The function to customize comparisons.
     * @param {number} [bitmask] The bitmask of comparison flags. See `baseIsEqual` for more details.
     * @returns {boolean} Returns `true` if the objects are equivalent, else `false`.
     */
    function equalByTag(object, other, tag, equalFunc, customizer, bitmask) {
      switch (tag) {
        case arrayBufferTag:
          if ((object.byteLength != other.byteLength) ||
              !equalFunc(new Uint8Array(object), new Uint8Array(other))) {
            return false;
          }
          return true;

        case boolTag:
        case dateTag:
          // Coerce dates and booleans to numbers, dates to milliseconds and booleans
          // to `1` or `0` treating invalid dates coerced to `NaN` as not equal.
          return +object == +other;

        case errorTag:
          return object.name == other.name && object.message == other.message;

        case numberTag:
          // Treat `NaN` vs. `NaN` as equal.
          return (object != +object) ? other != +other : object == +other;

        case regexpTag:
        case stringTag:
          // Coerce regexes to strings and treat strings primitives and string
          // objects as equal. See https://es5.github.io/#x15.10.6.4 for more details.
          return object == (other + '');

        case mapTag:
          var convert = mapToArray;

        case setTag:
          var isPartial = bitmask & PARTIAL_COMPARE_FLAG;
          convert || (convert = setToArray);

          // Recursively compare objects (susceptible to call stack limits).
          return (isPartial || object.size == other.size) &&
            equalFunc(convert(object), convert(other), customizer, bitmask | UNORDERED_COMPARE_FLAG);

        case symbolTag:
          return !!Symbol && (symbolValueOf.call(object) == symbolValueOf.call(other));
      }
      return false;
    }

    module.exports = equalByTag;
    });

    var require$$5$1 = (_equalByTag && typeof _equalByTag === 'object' && 'default' in _equalByTag ? _equalByTag['default'] : _equalByTag);

    var _arraySome = __commonjs(function (module) {
    /**
     * A specialized version of `_.some` for arrays without support for iteratee
     * shorthands.
     *
     * @private
     * @param {Array} array The array to iterate over.
     * @param {Function} predicate The function invoked per iteration.
     * @returns {boolean} Returns `true` if any element passes the predicate check, else `false`.
     */
    function arraySome(array, predicate) {
      var index = -1,
          length = array.length;

      while (++index < length) {
        if (predicate(array[index], index, array)) {
          return true;
        }
      }
      return false;
    }

    module.exports = arraySome;
    });

    var require$$0$49 = (_arraySome && typeof _arraySome === 'object' && 'default' in _arraySome ? _arraySome['default'] : _arraySome);

    var _equalArrays = __commonjs(function (module) {
    var arraySome = require$$0$49;

    /** Used to compose bitmasks for comparison styles. */
    var UNORDERED_COMPARE_FLAG = 1,
        PARTIAL_COMPARE_FLAG = 2;

    /**
     * A specialized version of `baseIsEqualDeep` for arrays with support for
     * partial deep comparisons.
     *
     * @private
     * @param {Array} array The array to compare.
     * @param {Array} other The other array to compare.
     * @param {Function} equalFunc The function to determine equivalents of values.
     * @param {Function} [customizer] The function to customize comparisons.
     * @param {number} [bitmask] The bitmask of comparison flags. See `baseIsEqual` for more details.
     * @param {Object} [stack] Tracks traversed `array` and `other` objects.
     * @returns {boolean} Returns `true` if the arrays are equivalent, else `false`.
     */
    function equalArrays(array, other, equalFunc, customizer, bitmask, stack) {
      var index = -1,
          isPartial = bitmask & PARTIAL_COMPARE_FLAG,
          isUnordered = bitmask & UNORDERED_COMPARE_FLAG,
          arrLength = array.length,
          othLength = other.length;

      if (arrLength != othLength && !(isPartial && othLength > arrLength)) {
        return false;
      }
      // Assume cyclic values are equal.
      var stacked = stack.get(array);
      if (stacked) {
        return stacked == other;
      }
      var result = true;
      stack.set(array, other);

      // Ignore non-index properties.
      while (++index < arrLength) {
        var arrValue = array[index],
            othValue = other[index];

        if (customizer) {
          var compared = isPartial
            ? customizer(othValue, arrValue, index, other, array, stack)
            : customizer(arrValue, othValue, index, array, other, stack);
        }
        if (compared !== undefined) {
          if (compared) {
            continue;
          }
          result = false;
          break;
        }
        // Recursively compare arrays (susceptible to call stack limits).
        if (isUnordered) {
          if (!arraySome(other, function(othValue) {
                return arrValue === othValue || equalFunc(arrValue, othValue, customizer, bitmask, stack);
              })) {
            result = false;
            break;
          }
        } else if (!(arrValue === othValue || equalFunc(arrValue, othValue, customizer, bitmask, stack))) {
          result = false;
          break;
        }
      }
      stack['delete'](array);
      return result;
    }

    module.exports = equalArrays;
    });

    var require$$6 = (_equalArrays && typeof _equalArrays === 'object' && 'default' in _equalArrays ? _equalArrays['default'] : _equalArrays);

    var _stackSet = __commonjs(function (module) {
    var MapCache = require$$1$3,
        assocSet = require$$0$14;

    /** Used as the size to enable large array optimizations. */
    var LARGE_ARRAY_SIZE = 200;

    /**
     * Sets the stack `key` to `value`.
     *
     * @private
     * @name set
     * @memberOf Stack
     * @param {string} key The key of the value to set.
     * @param {*} value The value to set.
     * @returns {Object} Returns the stack cache object.
     */
    function stackSet(key, value) {
      var data = this.__data__,
          array = data.array;

      if (array) {
        if (array.length < (LARGE_ARRAY_SIZE - 1)) {
          assocSet(array, key, value);
        } else {
          data.array = null;
          data.map = new MapCache(array);
        }
      }
      var map = data.map;
      if (map) {
        map.set(key, value);
      }
      return this;
    }

    module.exports = stackSet;
    });

    var require$$0$50 = (_stackSet && typeof _stackSet === 'object' && 'default' in _stackSet ? _stackSet['default'] : _stackSet);

    var _stackHas = __commonjs(function (module) {
    var assocHas = require$$0$20;

    /**
     * Checks if a stack value for `key` exists.
     *
     * @private
     * @name has
     * @memberOf Stack
     * @param {string} key The key of the entry to check.
     * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
     */
    function stackHas(key) {
      var data = this.__data__,
          array = data.array;

      return array ? assocHas(array, key) : data.map.has(key);
    }

    module.exports = stackHas;
    });

    var require$$1$33 = (_stackHas && typeof _stackHas === 'object' && 'default' in _stackHas ? _stackHas['default'] : _stackHas);

    var _stackGet = __commonjs(function (module) {
    var assocGet = require$$0$21;

    /**
     * Gets the stack value for `key`.
     *
     * @private
     * @name get
     * @memberOf Stack
     * @param {string} key The key of the value to get.
     * @returns {*} Returns the entry value.
     */
    function stackGet(key) {
      var data = this.__data__,
          array = data.array;

      return array ? assocGet(array, key) : data.map.get(key);
    }

    module.exports = stackGet;
    });

    var require$$2$15 = (_stackGet && typeof _stackGet === 'object' && 'default' in _stackGet ? _stackGet['default'] : _stackGet);

    var _stackDelete = __commonjs(function (module) {
    var assocDelete = require$$0$22;

    /**
     * Removes `key` and its value from the stack.
     *
     * @private
     * @name delete
     * @memberOf Stack
     * @param {string} key The key of the value to remove.
     * @returns {boolean} Returns `true` if the entry was removed, else `false`.
     */
    function stackDelete(key) {
      var data = this.__data__,
          array = data.array;

      return array ? assocDelete(array, key) : data.map['delete'](key);
    }

    module.exports = stackDelete;
    });

    var require$$3$11 = (_stackDelete && typeof _stackDelete === 'object' && 'default' in _stackDelete ? _stackDelete['default'] : _stackDelete);

    var _stackClear = __commonjs(function (module) {
    /**
     * Removes all key-value entries from the stack.
     *
     * @private
     * @name clear
     * @memberOf Stack
     */
    function stackClear() {
      this.__data__ = { 'array': [], 'map': null };
    }

    module.exports = stackClear;
    });

    var require$$4$9 = (_stackClear && typeof _stackClear === 'object' && 'default' in _stackClear ? _stackClear['default'] : _stackClear);

    var _Stack = __commonjs(function (module) {
    var stackClear = require$$4$9,
        stackDelete = require$$3$11,
        stackGet = require$$2$15,
        stackHas = require$$1$33,
        stackSet = require$$0$50;

    /**
     * Creates a stack cache object to store key-value pairs.
     *
     * @private
     * @constructor
     * @param {Array} [values] The values to cache.
     */
    function Stack(values) {
      var index = -1,
          length = values ? values.length : 0;

      this.clear();
      while (++index < length) {
        var entry = values[index];
        this.set(entry[0], entry[1]);
      }
    }

    // Add functions to the `Stack` cache.
    Stack.prototype.clear = stackClear;
    Stack.prototype['delete'] = stackDelete;
    Stack.prototype.get = stackGet;
    Stack.prototype.has = stackHas;
    Stack.prototype.set = stackSet;

    module.exports = Stack;
    });

    var require$$1$32 = (_Stack && typeof _Stack === 'object' && 'default' in _Stack ? _Stack['default'] : _Stack);

    var _baseIsEqualDeep = __commonjs(function (module) {
    var Stack = require$$1$32,
        equalArrays = require$$6,
        equalByTag = require$$5$1,
        equalObjects = require$$4$8,
        getTag = require$$3$4,
        isArray = require$$2$5,
        isHostObject = require$$1$6,
        isTypedArray = require$$0$48;

    /** Used to compose bitmasks for comparison styles. */
    var PARTIAL_COMPARE_FLAG = 2;

    /** `Object#toString` result references. */
    var argsTag = '[object Arguments]',
        arrayTag = '[object Array]',
        objectTag = '[object Object]';

    /** Used for built-in method references. */
    var objectProto = Object.prototype;

    /** Used to check objects for own properties. */
    var hasOwnProperty = objectProto.hasOwnProperty;

    /**
     * A specialized version of `baseIsEqual` for arrays and objects which performs
     * deep comparisons and tracks traversed objects enabling objects with circular
     * references to be compared.
     *
     * @private
     * @param {Object} object The object to compare.
     * @param {Object} other The other object to compare.
     * @param {Function} equalFunc The function to determine equivalents of values.
     * @param {Function} [customizer] The function to customize comparisons.
     * @param {number} [bitmask] The bitmask of comparison flags. See `baseIsEqual` for more details.
     * @param {Object} [stack] Tracks traversed `object` and `other` objects.
     * @returns {boolean} Returns `true` if the objects are equivalent, else `false`.
     */
    function baseIsEqualDeep(object, other, equalFunc, customizer, bitmask, stack) {
      var objIsArr = isArray(object),
          othIsArr = isArray(other),
          objTag = arrayTag,
          othTag = arrayTag;

      if (!objIsArr) {
        objTag = getTag(object);
        if (objTag == argsTag) {
          objTag = objectTag;
        } else if (objTag != objectTag) {
          objIsArr = isTypedArray(object);
        }
      }
      if (!othIsArr) {
        othTag = getTag(other);
        if (othTag == argsTag) {
          othTag = objectTag;
        } else if (othTag != objectTag) {
          othIsArr = isTypedArray(other);
        }
      }
      var objIsObj = objTag == objectTag && !isHostObject(object),
          othIsObj = othTag == objectTag && !isHostObject(other),
          isSameTag = objTag == othTag;

      if (isSameTag && !(objIsArr || objIsObj)) {
        return equalByTag(object, other, objTag, equalFunc, customizer, bitmask);
      }
      var isPartial = bitmask & PARTIAL_COMPARE_FLAG;
      if (!isPartial) {
        var objIsWrapped = objIsObj && hasOwnProperty.call(object, '__wrapped__'),
            othIsWrapped = othIsObj && hasOwnProperty.call(other, '__wrapped__');

        if (objIsWrapped || othIsWrapped) {
          return equalFunc(objIsWrapped ? object.value() : object, othIsWrapped ? other.value() : other, customizer, bitmask, stack);
        }
      }
      if (!isSameTag) {
        return false;
      }
      stack || (stack = new Stack);
      return (objIsArr ? equalArrays : equalObjects)(object, other, equalFunc, customizer, bitmask, stack);
    }

    module.exports = baseIsEqualDeep;
    });

    var require$$2$13 = (_baseIsEqualDeep && typeof _baseIsEqualDeep === 'object' && 'default' in _baseIsEqualDeep ? _baseIsEqualDeep['default'] : _baseIsEqualDeep);

    var _baseIsEqual = __commonjs(function (module) {
    var baseIsEqualDeep = require$$2$13,
        isObject = require$$0$2,
        isObjectLike = require$$0$4;

    /**
     * The base implementation of `_.isEqual` which supports partial comparisons
     * and tracks traversed objects.
     *
     * @private
     * @param {*} value The value to compare.
     * @param {*} other The other value to compare.
     * @param {Function} [customizer] The function to customize comparisons.
     * @param {boolean} [bitmask] The bitmask of comparison flags.
     *  The bitmask may be composed of the following flags:
     *     1 - Unordered comparison
     *     2 - Partial comparison
     * @param {Object} [stack] Tracks traversed `value` and `other` objects.
     * @returns {boolean} Returns `true` if the values are equivalent, else `false`.
     */
    function baseIsEqual(value, other, customizer, bitmask, stack) {
      if (value === other) {
        return true;
      }
      if (value == null || other == null || (!isObject(value) && !isObjectLike(other))) {
        return value !== value && other !== other;
      }
      return baseIsEqualDeep(value, other, baseIsEqual, customizer, bitmask, stack);
    }

    module.exports = baseIsEqual;
    });

    var require$$0$47 = (_baseIsEqual && typeof _baseIsEqual === 'object' && 'default' in _baseIsEqual ? _baseIsEqual['default'] : _baseIsEqual);

    var _baseMatchesProperty = __commonjs(function (module) {
    var baseIsEqual = require$$0$47,
        get = require$$1$20,
        hasIn = require$$0$46;

    /** Used to compose bitmasks for comparison styles. */
    var UNORDERED_COMPARE_FLAG = 1,
        PARTIAL_COMPARE_FLAG = 2;

    /**
     * The base implementation of `_.matchesProperty` which doesn't clone `srcValue`.
     *
     * @private
     * @param {string} path The path of the property to get.
     * @param {*} srcValue The value to match.
     * @returns {Function} Returns the new function.
     */
    function baseMatchesProperty(path, srcValue) {
      return function(object) {
        var objValue = get(object, path);
        return (objValue === undefined && objValue === srcValue)
          ? hasIn(object, path)
          : baseIsEqual(srcValue, objValue, undefined, UNORDERED_COMPARE_FLAG | PARTIAL_COMPARE_FLAG);
      };
    }

    module.exports = baseMatchesProperty;
    });

    var require$$3$10 = (_baseMatchesProperty && typeof _baseMatchesProperty === 'object' && 'default' in _baseMatchesProperty ? _baseMatchesProperty['default'] : _baseMatchesProperty);

    var _baseToPairs = __commonjs(function (module) {
    var arrayMap = require$$0$8;

    /**
     * The base implementation of `_.toPairs` and `_.toPairsIn` which creates an array
     * of key-value pairs for `object` corresponding to the property names of `props`.
     *
     * @private
     * @param {Object} object The object to query.
     * @param {Array} props The property names to get values for.
     * @returns {Object} Returns the new array of key-value pairs.
     */
    function baseToPairs(object, props) {
      return arrayMap(props, function(key) {
        return [key, object[key]];
      });
    }

    module.exports = baseToPairs;
    });

    var require$$1$34 = (_baseToPairs && typeof _baseToPairs === 'object' && 'default' in _baseToPairs ? _baseToPairs['default'] : _baseToPairs);

    var toPairs = __commonjs(function (module) {
    var baseToPairs = require$$1$34,
        keys = require$$0$24;

    /**
     * Creates an array of own enumerable key-value pairs for `object` which
     * can be consumed by `_.fromPairs`.
     *
     * @static
     * @memberOf _
     * @category Object
     * @param {Object} object The object to query.
     * @returns {Array} Returns the new array of key-value pairs.
     * @example
     *
     * function Foo() {
     *   this.a = 1;
     *   this.b = 2;
     * }
     *
     * Foo.prototype.c = 3;
     *
     * _.toPairs(new Foo);
     * // => [['a', 1], ['b', 2]] (iteration order is not guaranteed)
     */
    function toPairs(object) {
      return baseToPairs(object, keys(object));
    }

    module.exports = toPairs;
    });

    var require$$0$52 = (toPairs && typeof toPairs === 'object' && 'default' in toPairs ? toPairs['default'] : toPairs);

    var _isStrictComparable = __commonjs(function (module) {
    var isObject = require$$0$2;

    /**
     * Checks if `value` is suitable for strict equality comparisons, i.e. `===`.
     *
     * @private
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` if suitable for strict
     *  equality comparisons, else `false`.
     */
    function isStrictComparable(value) {
      return value === value && !isObject(value);
    }

    module.exports = isStrictComparable;
    });

    var require$$1$35 = (_isStrictComparable && typeof _isStrictComparable === 'object' && 'default' in _isStrictComparable ? _isStrictComparable['default'] : _isStrictComparable);

    var _getMatchData = __commonjs(function (module) {
    var isStrictComparable = require$$1$35,
        toPairs = require$$0$52;

    /**
     * Gets the property names, values, and compare flags of `object`.
     *
     * @private
     * @param {Object} object The object to query.
     * @returns {Array} Returns the match data of `object`.
     */
    function getMatchData(object) {
      var result = toPairs(object),
          length = result.length;

      while (length--) {
        result[length][2] = isStrictComparable(result[length][1]);
      }
      return result;
    }

    module.exports = getMatchData;
    });

    var require$$0$51 = (_getMatchData && typeof _getMatchData === 'object' && 'default' in _getMatchData ? _getMatchData['default'] : _getMatchData);

    var _baseIsMatch = __commonjs(function (module) {
    var Stack = require$$1$32,
        baseIsEqual = require$$0$47;

    /** Used to compose bitmasks for comparison styles. */
    var UNORDERED_COMPARE_FLAG = 1,
        PARTIAL_COMPARE_FLAG = 2;

    /**
     * The base implementation of `_.isMatch` without support for iteratee shorthands.
     *
     * @private
     * @param {Object} object The object to inspect.
     * @param {Object} source The object of property values to match.
     * @param {Array} matchData The property names, values, and compare flags to match.
     * @param {Function} [customizer] The function to customize comparisons.
     * @returns {boolean} Returns `true` if `object` is a match, else `false`.
     */
    function baseIsMatch(object, source, matchData, customizer) {
      var index = matchData.length,
          length = index,
          noCustomizer = !customizer;

      if (object == null) {
        return !length;
      }
      object = Object(object);
      while (index--) {
        var data = matchData[index];
        if ((noCustomizer && data[2])
              ? data[1] !== object[data[0]]
              : !(data[0] in object)
            ) {
          return false;
        }
      }
      while (++index < length) {
        data = matchData[index];
        var key = data[0],
            objValue = object[key],
            srcValue = data[1];

        if (noCustomizer && data[2]) {
          if (objValue === undefined && !(key in object)) {
            return false;
          }
        } else {
          var stack = new Stack,
              result = customizer ? customizer(objValue, srcValue, key, object, source, stack) : undefined;

          if (!(result === undefined
                ? baseIsEqual(srcValue, objValue, customizer, UNORDERED_COMPARE_FLAG | PARTIAL_COMPARE_FLAG, stack)
                : result
              )) {
            return false;
          }
        }
      }
      return true;
    }

    module.exports = baseIsMatch;
    });

    var require$$1$36 = (_baseIsMatch && typeof _baseIsMatch === 'object' && 'default' in _baseIsMatch ? _baseIsMatch['default'] : _baseIsMatch);

    var _baseMatches = __commonjs(function (module) {
    var baseIsMatch = require$$1$36,
        getMatchData = require$$0$51;

    /**
     * The base implementation of `_.matches` which doesn't clone `source`.
     *
     * @private
     * @param {Object} source The object of property values to match.
     * @returns {Function} Returns the new function.
     */
    function baseMatches(source) {
      var matchData = getMatchData(source);
      if (matchData.length == 1 && matchData[0][2]) {
        var key = matchData[0][0],
            value = matchData[0][1];

        return function(object) {
          if (object == null) {
            return false;
          }
          return object[key] === value &&
            (value !== undefined || (key in Object(object)));
        };
      }
      return function(object) {
        return object === source || baseIsMatch(object, source, matchData);
      };
    }

    module.exports = baseMatches;
    });

    var require$$4$10 = (_baseMatches && typeof _baseMatches === 'object' && 'default' in _baseMatches ? _baseMatches['default'] : _baseMatches);

    var _baseIteratee = __commonjs(function (module) {
    var baseMatches = require$$4$10,
        baseMatchesProperty = require$$3$10,
        identity = require$$2$8,
        isArray = require$$2$5,
        property = require$$0$45;

    /**
     * The base implementation of `_.iteratee`.
     *
     * @private
     * @param {*} [value=_.identity] The value to convert to an iteratee.
     * @returns {Function} Returns the iteratee.
     */
    function baseIteratee(value) {
      var type = typeof value;
      if (type == 'function') {
        return value;
      }
      if (value == null) {
        return identity;
      }
      if (type == 'object') {
        return isArray(value)
          ? baseMatchesProperty(value[0], value[1])
          : baseMatches(value);
      }
      return property(value);
    }

    module.exports = baseIteratee;
    });

    var require$$2$12 = (_baseIteratee && typeof _baseIteratee === 'object' && 'default' in _baseIteratee ? _baseIteratee['default'] : _baseIteratee);

    var map$1 = __commonjs(function (module) {
    var arrayMap = require$$0$8,
        baseIteratee = require$$2$12,
        baseMap = require$$1$29,
        isArray = require$$2$5;

    /**
     * Creates an array of values by running each element in `collection` through
     * `iteratee`. The iteratee is invoked with three arguments:
     * (value, index|key, collection).
     *
     * Many lodash methods are guarded to work as iteratees for methods like
     * `_.every`, `_.filter`, `_.map`, `_.mapValues`, `_.reject`, and `_.some`.
     *
     * The guarded methods are:
     * `ary`, `curry`, `curryRight`, `drop`, `dropRight`, `every`, `fill`,
     * `invert`, `parseInt`, `random`, `range`, `rangeRight`, `slice`, `some`,
     * `sortBy`, `take`, `takeRight`, `template`, `trim`, `trimEnd`, `trimStart`,
     * and `words`
     *
     * @static
     * @memberOf _
     * @category Collection
     * @param {Array|Object} collection The collection to iterate over.
     * @param {Function|Object|string} [iteratee=_.identity] The function invoked per iteration.
     * @returns {Array} Returns the new mapped array.
     * @example
     *
     * function square(n) {
     *   return n * n;
     * }
     *
     * _.map([4, 8], square);
     * // => [16, 64]
     *
     * _.map({ 'a': 4, 'b': 8 }, square);
     * // => [16, 64] (iteration order is not guaranteed)
     *
     * var users = [
     *   { 'user': 'barney' },
     *   { 'user': 'fred' }
     * ];
     *
     * // The `_.property` iteratee shorthand.
     * _.map(users, 'user');
     * // => ['barney', 'fred']
     */
    function map(collection, iteratee) {
      var func = isArray(collection) ? arrayMap : baseMap;
      return func(collection, baseIteratee(iteratee, 3));
    }

    module.exports = map;
    });

    var _default$2 = (map$1 && typeof map$1 === 'object' && 'default' in map$1 ? map$1['default'] : map$1);

    var uniqueId = __commonjs(function (module) {
    var toString = require$$0$36;

    /** Used to generate unique IDs. */
    var idCounter = 0;

    /**
     * Generates a unique ID. If `prefix` is given the ID is appended to it.
     *
     * @static
     * @memberOf _
     * @category Util
     * @param {string} [prefix=''] The value to prefix the ID with.
     * @returns {string} Returns the unique ID.
     * @example
     *
     * _.uniqueId('contact_');
     * // => 'contact_104'
     *
     * _.uniqueId();
     * // => '105'
     */
    function uniqueId(prefix) {
      var id = ++idCounter;
      return toString(prefix) + id;
    }

    module.exports = uniqueId;
    });

    var _default$3 = (uniqueId && typeof uniqueId === 'object' && 'default' in uniqueId ? uniqueId['default'] : uniqueId);

    var File = function (_Node) {
    	babelHelpers.inherits(File, _Node);

    	function File() {
    		babelHelpers.classCallCheck(this, File);
    		return babelHelpers.possibleConstructorReturn(this, Object.getPrototypeOf(File).apply(this, arguments));
    	}

    	babelHelpers.createClass(File, [{
    		key: "compile",
    		value: function compile(data) {
    			data = _default3$1({}, data, {
    				filename: this.filename || _default$3("template_"),
    				headers: []
    			});
    			if (!data.included) data.included = [];
    			data.included.push(data.filename);

    			this.start(data);

    			if (data.async) {
    				return compileGroupAsync(this.includes, data).then(this._finish.bind(this, data));
    			} else {
    				return this._finish(data, _default$1(this.includes, "compile", data));
    			}
    		}
    	}, {
    		key: "_finish",
    		value: function _finish(data, src) {
    			this.indent();

    			if (this.styles.length) {
    				this.write("(function() {").indent();
    				this.write("var style = document.createElement(\"style\");");
    				this.write("style.innerHTML = " + JSON.stringify(_default$2(this.styles, "value").join("\n")) + ";");
    				this.write("document.head.appendChild(style);");
    				this.outdent().write("}());\n");
    			}

    			this.push(_default$1(this.children, "compile", data));
    			var etabs = this.tabs();
    			this.outdent();

    			var tabs = this.tabs();
    			var source = this.end();
    			if (data.headers.length) source.prepend([data.headers.map(function (h) {
    				return etabs + h;
    			}), "\n"]);
    			source.prepend([tabs, "(function() {\n"]).add([tabs, "}());\n\n"]);
    			if (data.filename) source.prepend([tabs, "/* " + data.filename + " */\n"]);
    			source.prepend(src);
    			if (this.source) source.setSourceContent(data.filename, this.source);
    			return source;
    		}
    	}]);
    	return File;
    }(ASTNode);

    var index$5 = __commonjs(function (module, exports) {
    // Copyright Joyent, Inc. and other Node contributors.
    //
    // Permission is hereby granted, free of charge, to any person obtaining a
    // copy of this software and associated documentation files (the
    // "Software"), to deal in the Software without restriction, including
    // without limitation the rights to use, copy, modify, merge, publish,
    // distribute, sublicense, and/or sell copies of the Software, and to permit
    // persons to whom the Software is furnished to do so, subject to the
    // following conditions:
    //
    // The above copyright notice and this permission notice shall be included
    // in all copies or substantial portions of the Software.
    //
    // THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
    // OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
    // MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN
    // NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
    // DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
    // OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE
    // USE OR OTHER DEALINGS IN THE SOFTWARE.

    // resolves . and .. elements in a path array with directory names there
    // must be no slashes, empty elements, or device names (c:\) in the array
    // (so also no leading and trailing slashes - it does not distinguish
    // relative and absolute paths)
    function normalizeArray(parts, allowAboveRoot) {
      // if the path tries to go above the root, `up` ends up > 0
      var up = 0;
      for (var i = parts.length - 1; i >= 0; i--) {
        var last = parts[i];
        if (last === '.') {
          parts.splice(i, 1);
        } else if (last === '..') {
          parts.splice(i, 1);
          up++;
        } else if (up) {
          parts.splice(i, 1);
          up--;
        }
      }

      // if the path is allowed to go above the root, restore leading ..s
      if (allowAboveRoot) {
        for (; up--; up) {
          parts.unshift('..');
        }
      }

      return parts;
    }

    // Split a filename into [root, dir, basename, ext], unix version
    // 'root' is just a slash, or nothing.
    var splitPathRe =
        /^(\/?|)([\s\S]*?)((?:\.{1,2}|[^\/]+?|)(\.[^.\/]*|))(?:[\/]*)$/;
    var splitPath = function(filename) {
      return splitPathRe.exec(filename).slice(1);
    };

    // path.resolve([from ...], to)
    // posix version
    exports.resolve = function() {
      var resolvedPath = '',
          resolvedAbsolute = false;

      for (var i = arguments.length - 1; i >= -1 && !resolvedAbsolute; i--) {
        var path = (i >= 0) ? arguments[i] : process.cwd();

        // Skip empty and invalid entries
        if (typeof path !== 'string') {
          throw new TypeError('Arguments to path.resolve must be strings');
        } else if (!path) {
          continue;
        }

        resolvedPath = path + '/' + resolvedPath;
        resolvedAbsolute = path.charAt(0) === '/';
      }

      // At this point the path should be resolved to a full absolute path, but
      // handle relative paths to be safe (might happen when process.cwd() fails)

      // Normalize the path
      resolvedPath = normalizeArray(filter(resolvedPath.split('/'), function(p) {
        return !!p;
      }), !resolvedAbsolute).join('/');

      return ((resolvedAbsolute ? '/' : '') + resolvedPath) || '.';
    };

    // path.normalize(path)
    // posix version
    exports.normalize = function(path) {
      var isAbsolute = exports.isAbsolute(path),
          trailingSlash = substr(path, -1) === '/';

      // Normalize the path
      path = normalizeArray(filter(path.split('/'), function(p) {
        return !!p;
      }), !isAbsolute).join('/');

      if (!path && !isAbsolute) {
        path = '.';
      }
      if (path && trailingSlash) {
        path += '/';
      }

      return (isAbsolute ? '/' : '') + path;
    };

    // posix version
    exports.isAbsolute = function(path) {
      return path.charAt(0) === '/';
    };

    // posix version
    exports.join = function() {
      var paths = Array.prototype.slice.call(arguments, 0);
      return exports.normalize(filter(paths, function(p, index) {
        if (typeof p !== 'string') {
          throw new TypeError('Arguments to path.join must be strings');
        }
        return p;
      }).join('/'));
    };


    // path.relative(from, to)
    // posix version
    exports.relative = function(from, to) {
      from = exports.resolve(from).substr(1);
      to = exports.resolve(to).substr(1);

      function trim(arr) {
        var start = 0;
        for (; start < arr.length; start++) {
          if (arr[start] !== '') break;
        }

        var end = arr.length - 1;
        for (; end >= 0; end--) {
          if (arr[end] !== '') break;
        }

        if (start > end) return [];
        return arr.slice(start, end - start + 1);
      }

      var fromParts = trim(from.split('/'));
      var toParts = trim(to.split('/'));

      var length = Math.min(fromParts.length, toParts.length);
      var samePartsLength = length;
      for (var i = 0; i < length; i++) {
        if (fromParts[i] !== toParts[i]) {
          samePartsLength = i;
          break;
        }
      }

      var outputParts = [];
      for (var i = samePartsLength; i < fromParts.length; i++) {
        outputParts.push('..');
      }

      outputParts = outputParts.concat(toParts.slice(samePartsLength));

      return outputParts.join('/');
    };

    exports.sep = '/';
    exports.delimiter = ':';

    exports.dirname = function(path) {
      var result = splitPath(path),
          root = result[0],
          dir = result[1];

      if (!root && !dir) {
        // No dirname whatsoever
        return '.';
      }

      if (dir) {
        // It has a dirname, strip trailing slash
        dir = dir.substr(0, dir.length - 1);
      }

      return root + dir;
    };


    exports.basename = function(path, ext) {
      var f = splitPath(path)[2];
      // TODO: make this comparison case-insensitive on windows?
      if (ext && f.substr(-1 * ext.length) === ext) {
        f = f.substr(0, f.length - ext.length);
      }
      return f;
    };


    exports.extname = function(path) {
      return splitPath(path)[3];
    };

    function filter (xs, f) {
        if (xs.filter) return xs.filter(f);
        var res = [];
        for (var i = 0; i < xs.length; i++) {
            if (f(xs[i], i, xs)) res.push(xs[i]);
        }
        return res;
    }

    // String.prototype.substr - negative index don't work in IE8
    var substr = 'ab'.substr(-1) === 'b'
        ? function (str, start, len) { return str.substr(start, len) }
        : function (str, start, len) {
            if (start < 0) start = str.length + start;
            return str.substr(start, len);
        }
    ;
    });

    var path = (index$5 && typeof index$5 === 'object' && 'default' in index$5 ? index$5['default'] : index$5);

    var fs = {};

    var Include = function (_Node) {
    	babelHelpers.inherits(Include, _Node);

    	function Include() {
    		babelHelpers.classCallCheck(this, Include);
    		return babelHelpers.possibleConstructorReturn(this, Object.getPrototypeOf(Include).apply(this, arguments));
    	}

    	babelHelpers.createClass(Include, [{
    		key: "resolve",
    		value: function resolve(file) {
    			return path.resolve(path.dirname(file), this.src);
    		}
    	}, {
    		key: "compile",
    		value: function compile(data) {
    			var fpath = this.resolve(data.filename);

    			if (_default2$2(data.included, fpath)) {
    				var empty = this._sn(data.filename, "");
    				return data.async ? Promise.resolve(empty) : empty;
    			}

    			var compile = function compile(src) {
    				return data.parse(src, fpath).compile(data);
    			};

    			if (data.async) {
    				return fs.readFile(fpath, { encoding: "utf-8" }).then(compile);
    			} else {
    				return compile(fs.readFileSync(fpath, { encoding: "utf-8" }));
    			}
    		}
    	}]);
    	return Include;
    }(ASTNode);

    var Template$1 = function (_Node) {
    	babelHelpers.inherits(Template, _Node);

    	function Template() {
    		babelHelpers.classCallCheck(this, Template);
    		return babelHelpers.possibleConstructorReturn(this, Object.getPrototypeOf(Template).apply(this, arguments));
    	}

    	babelHelpers.createClass(Template, [{
    		key: "compile",
    		value: function compile(data) {
    			var _this2 = this;

    			this.start(data);
    			var safename = JSON.stringify(this.name);
    			var safetype = this.type ? JSON.stringify(this.type) : null;

    			header(data, "var Template = {};\n");

    			this.write("Template[" + safename + "] = Temple.create(" + safename + ", " + (safetype ? safetype + ", " : "") + "function(ctx, key) {").indent();
    			data = addKey(data, { value: "key" });
    			this.push(compileGroup(this.children, data));
    			this.outdent().write("});\n");

    			if (this.plugins && this.plugins.length) {
    				this.plugins.forEach(function (p) {
    					_this2.write("Template[" + safename + "].use(" + JSON.stringify(p) + ");");
    				});
    				this.write("");
    			}

    			return this.end();
    		}
    	}]);
    	return Template;
    }(ASTNode);

    var Script = function (_Node) {
    	babelHelpers.inherits(Script, _Node);

    	function Script() {
    		babelHelpers.classCallCheck(this, Script);
    		return babelHelpers.possibleConstructorReturn(this, Object.getPrototypeOf(Script).apply(this, arguments));
    	}

    	babelHelpers.createClass(Script, [{
    		key: "compile",
    		value: function compile(data) {
    			var _this2 = this;

    			this.start(data);

    			var attrs = this.attributes.reduce(function (m, a) {
    				switch (a.type) {
    					case "empty":
    						m[a.name] = true;
    						break;

    					case "string":
    						m[a.name] = a.value;
    						break;
    				}

    				return m;
    			}, {});

    			if (attrs.src) {
    				this.write("(function(){").indent();
    				this.write("var script = document.createElement(\"script\");");
    				_default(attrs, function (v, n) {
    					_this2.write("script[" + JSON.stringify(n) + "] = " + JSON.stringify(v) + ";");
    				});
    				this.write("document.head.appendChild(script);");
    				this.outdent().write("}());");
    			} else {
    				(function () {
    					_this2._normalize_indent();
    					var line = _this2._line || 1;
    					var column = _this2._column || 1;

    					_this2.value.split(/\r?\n/g).forEach(function (l, i) {
    						_this2.push(new SourceNode(i + line, i === 0 ? column : 1, data.filename, l + "\n"));
    					});
    				})();
    			}

    			return this.end();
    		}
    	}, {
    		key: "reactive",
    		get: function get() {
    			return true;
    		}
    	}]);
    	return Script;
    }(ASTNode);

    var Render = function (_Node) {
    	babelHelpers.inherits(Render, _Node);

    	function Render() {
    		babelHelpers.classCallCheck(this, Render);
    		return babelHelpers.possibleConstructorReturn(this, Object.getPrototypeOf(Render).apply(this, arguments));
    	}

    	babelHelpers.createClass(Render, [{
    		key: "compile",
    		value: function compile(data) {
    			this.start(data);
    			var exp = this.expression.compile(data);
    			this.write(["Temple.render(", exp, ", ctx, " + getKey(data) + ");"]);
    			return this.end();
    		}
    	}, {
    		key: "reactive",
    		get: function get() {
    			return true;
    		}
    	}]);
    	return Render;
    }(ASTNode);

    var Text = function (_Node) {
    	babelHelpers.inherits(Text, _Node);

    	function Text() {
    		babelHelpers.classCallCheck(this, Text);
    		return babelHelpers.possibleConstructorReturn(this, Object.getPrototypeOf(Text).apply(this, arguments));
    	}

    	babelHelpers.createClass(Text, [{
    		key: "compile",
    		value: function compile(data) {
    			this.start(data);

    			var value = this.value.replace(/\s+/g, " ");
    			var safe = JSON.stringify(value);

    			if (containsEntities(value)) {
    				safe = "Temple.utils.decodeEntities(" + safe + ")";
    			}

    			header(data, "var idom = Temple.idom;\n");
    			this.write("idom.text(" + safe + ");");
    			return this.end();
    		}
    	}, {
    		key: "reactive",
    		get: function get() {
    			return false;
    		}
    	}]);
    	return Text;
    }(ASTNode);

    var Element$1 = function (_Node) {
    	babelHelpers.inherits(Element, _Node);

    	function Element() {
    		babelHelpers.classCallCheck(this, Element);
    		return babelHelpers.possibleConstructorReturn(this, Object.getPrototypeOf(Element).apply(this, arguments));
    	}

    	babelHelpers.createClass(Element, [{
    		key: "compile",
    		value: function compile(data) {
    			var _this2 = this;

    			this.start(data);

    			var tagName = JSON.stringify(this.tagname);
    			var key = getKey(data);
    			var childs = this.children;
    			var attrs = this.attributes;

    			var body = function body() {
    				_this2.push([].concat(_default$1(attrs, "compile", data), compileGroup(childs, resetKey(data))));
    			};

    			header(data, "var idom = Temple.idom;\n");

    			if (childs.length || attrs.length) {
    				if (!childs.some(function (c) {
    					return c.reactive;
    				})) {
    					this.write("idom.elementOpen(" + tagName + (key ? ", " + key : "") + ");");
    					body();
    					this.write("idom.elementClose(" + tagName + ");");
    				} else {
    					this.write("Temple.Element(" + tagName + ", " + (key || "null") + ", ctx, function(ctx) {").indent();
    					body();
    					this.outdent().write("});");
    				}
    			} else {
    				this.write("idom.elementVoid(" + tagName + (key ? ", " + key : "") + ");");
    			}

    			return this.end();
    		}
    	}, {
    		key: "reactive",
    		get: function get() {
    			return false;
    		}
    	}]);
    	return Element;
    }(ASTNode);

    var Attribute = function (_Node) {
    	babelHelpers.inherits(Attribute, _Node);

    	function Attribute() {
    		babelHelpers.classCallCheck(this, Attribute);
    		return babelHelpers.possibleConstructorReturn(this, Object.getPrototypeOf(Attribute).apply(this, arguments));
    	}

    	babelHelpers.createClass(Attribute, [{
    		key: "compile",
    		value: function compile(data) {
    			this.start(data);

    			var fun = undefined;
    			var value = this._sn(data.filename, "");
    			var len = this.children.length;

    			if (len) {
    				value.add(_default$1(this.children, "compile", data)).join(",");
    				fun = this.children.some(function (c) {
    					return c.reactive;
    				});
    				if (len > 1) value.prepend("[").add("]");

    				if (fun && this.type === "string") {
    					if (len > 1) value.add(".map(Temple.utils.toString).join(\"\")");else value.prepend("Temple.utils.toString(").add(")");
    				}
    			} else {
    				value = null;
    			}

    			header(data, "var decorators = Temple.decorators;\n");
    			this.push([this.tabs(), "decorators.render(ctx, " + JSON.stringify(this.name)]);

    			if (fun) {
    				this.push(", function(ctx) {\n").indent();
    				this.write(["return ", value, ";"]);
    				this.outdent().push([this.tabs(), "}"]);
    			} else if (value) {
    				this.push([", ", value]);
    			}

    			this.push(");\n");

    			return this.end();
    		}
    	}, {
    		key: "reactive",
    		get: function get() {
    			return false;
    		}
    	}]);
    	return Attribute;
    }(ASTNode);

    var If = function (_Node) {
    	babelHelpers.inherits(If, _Node);

    	function If() {
    		babelHelpers.classCallCheck(this, If);
    		return babelHelpers.possibleConstructorReturn(this, Object.getPrototypeOf(If).apply(this, arguments));
    	}

    	babelHelpers.createClass(If, [{
    		key: "compile",
    		value: function compile(data) {
    			var _this2 = this;

    			this.start(data);

    			if (this.attribute) {
    				this.push("(");
    			}

    			this.children.forEach(function (c, i, l) {
    				if (_this2.attribute) {
    					if (c.expression) _this2.push([c.expression.compile(data), " ? "]);
    					_this2.push(["Temple.utils.joinValues(", c.compile(addKey(data, i.toString())).join(","), ")"]);
    					if (i + 1 === l.length && c.expression) _this2.push(" : ''");
    				} else {
    					var line = [];
    					line.push(!i ? "if" : !c.expression ? "else" : "else if", " ");
    					if (c.expression) line.push(["(", c.expression.compile(data), ") "]);
    					line.push("{");
    					_this2.write(line).indent();
    					_this2.push(c.compile(addKey(data, i.toString())));
    					_this2.outdent().write("}");
    				}
    			});

    			if (this.attribute) {
    				this.push(")");
    			}

    			return this.end();
    		}
    	}, {
    		key: "reactive",
    		get: function get() {
    			return true;
    		}
    	}]);
    	return If;
    }(ASTNode);

    var Branch = function (_Node) {
    	babelHelpers.inherits(Branch, _Node);

    	function Branch() {
    		babelHelpers.classCallCheck(this, Branch);
    		return babelHelpers.possibleConstructorReturn(this, Object.getPrototypeOf(Branch).apply(this, arguments));
    	}

    	babelHelpers.createClass(Branch, [{
    		key: "compile",
    		value: function compile(data) {
    			this.start(data);
    			this.push(compileGroup(this.children, data));
    			return this.end();
    		}
    	}]);
    	return Branch;
    }(ASTNode);

    var Each = function (_Node) {
    	babelHelpers.inherits(Each, _Node);

    	function Each() {
    		babelHelpers.classCallCheck(this, Each);
    		return babelHelpers.possibleConstructorReturn(this, Object.getPrototypeOf(Each).apply(this, arguments));
    	}

    	babelHelpers.createClass(Each, [{
    		key: "compile",
    		value: function compile(data) {
    			this.start(data);

    			var exp = this.expression.compile(data);
    			var indexvar = _default$3("index");
    			var vars = JSON.stringify(this.variables || []);

    			if (!this.attribute) this.push(this.tabs());
    			this.push(["Temple.Each(", exp, ", ", vars, ", ctx, function(ctx, " + indexvar + ") {"]).indent();
    			if (!this.attribute) this.push("\n");
    			data = addKey(data, { value: indexvar });
    			var c = this._sn(data.filename, compileGroup(this.children, data));
    			if (this.attribute) c = [" return Temple.utils.joinValues(", c.join(","), "); "];
    			this.push(c);
    			this.outdent();
    			if (!this.attribute) this.write("});");else this.push("}).join(\"\")");

    			return this.end();
    		}
    	}, {
    		key: "reactive",
    		get: function get() {
    			return true;
    		}
    	}]);
    	return Each;
    }(ASTNode);

    var With = function (_Node) {
    	babelHelpers.inherits(With, _Node);

    	function With() {
    		babelHelpers.classCallCheck(this, With);
    		return babelHelpers.possibleConstructorReturn(this, Object.getPrototypeOf(With).apply(this, arguments));
    	}

    	babelHelpers.createClass(With, [{
    		key: "compile",
    		value: function compile(data) {
    			this.start(data);

    			var exp = this.expression.compile(data);

    			if (!this.attribute) this.push(this.tabs());
    			this.push(["Temple.With(", exp, ", ctx, function(ctx) {"]).indent();
    			if (!this.attribute) this.push("\n");
    			var c = this._sn(data.filename, compileGroup(this.children, data));
    			if (this.attribute) c = [" return Temple.utils.joinValues(", c.join(","), "); "];
    			this.push(c);
    			this.outdent();

    			if (!this.attribute) this.write("});");else this.push("})");

    			return this.end();
    		}
    	}, {
    		key: "reactive",
    		get: function get() {
    			return true;
    		}
    	}]);
    	return With;
    }(ASTNode);

    var Interpolator = function (_Node) {
    	babelHelpers.inherits(Interpolator, _Node);

    	function Interpolator() {
    		babelHelpers.classCallCheck(this, Interpolator);
    		return babelHelpers.possibleConstructorReturn(this, Object.getPrototypeOf(Interpolator).apply(this, arguments));
    	}

    	babelHelpers.createClass(Interpolator, [{
    		key: "compile",
    		value: function compile(data) {
    			this.start(data);
    			header(data, "var idom = Temple.idom;\n");
    			this.write("idom.autotext(" + this.expression.compile(_default3$1({ asFn: true }, data)) + ");");
    			return this.end();
    		}
    	}, {
    		key: "reactive",

    		// while technically reactive, they contain their own autorun statement
    		get: function get() {
    			return false;
    		}
    	}]);
    	return Interpolator;
    }(ASTNode);

    var Comment = function (_Node) {
    	babelHelpers.inherits(Comment, _Node);

    	function Comment() {
    		babelHelpers.classCallCheck(this, Comment);
    		return babelHelpers.possibleConstructorReturn(this, Object.getPrototypeOf(Comment).apply(this, arguments));
    	}

    	babelHelpers.createClass(Comment, [{
    		key: "compile",
    		value: function compile(data) {
    			this.start(data);
    			return this.end();
    		}
    	}]);
    	return Comment;
    }(ASTNode);

    // method to run to query the context
    var CONTEXT_LOOKUP = "ctx.lookup";

    var Expression = function (_Node) {
    	babelHelpers.inherits(Expression, _Node);

    	function Expression() {
    		babelHelpers.classCallCheck(this, Expression);
    		return babelHelpers.possibleConstructorReturn(this, Object.getPrototypeOf(Expression).apply(this, arguments));
    	}

    	babelHelpers.createClass(Expression, [{
    		key: "compile",
    		value: function compile(data) {
    			this.start(data);
    			var exp = Expression.render(this.tree);

    			if (data.asFn) {
    				this.push("function() {\n").indent();
    				this.write("return " + exp + ";");
    				this.outdent().push([this.tabs(), "}"]);
    			} else {
    				this.push(exp);
    			}

    			return this.end();
    		}
    	}, {
    		key: "reactive",
    		get: function get() {
    			return !Expression.isStatic(this.tree);
    		}
    	}], [{
    		key: "isStatic",
    		value: function isStatic(tree) {
    			var _isStatic = Expression.isStatic;

    			switch (tree.type) {
    				case "Compound":
    					return tree.body.every(_isStatic);
    				case "Identifier":
    					return false;
    				case "ThisExpression":
    					return false;
    				case "MemberExpression":
    					{
    						if (!_isStatic(tree.object)) return false;
    						var prop = tree.property;
    						if (!tree.computed && prop.type === "Identifier") return true;
    						return _isStatic(prop);
    					}
    				case "Literal":
    					return true;
    				case "CallExpression":
    					{
    						return _isStatic(tree.callee) && tree.arguments.every(_isStatic);
    					}
    				case "UnaryExpression":
    					return _isStatic(tree.argument);
    				case "LogicalExpression":
    				case "BinaryExpression":
    					return _isStatic(tree.left) && _isStatic(tree.right);
    				case "ArrayExpression":
    					return tree.elements.every(_isStatic);
    				case "ConditionalExpression":
    					{
    						return [tree.test, tree.consequent, tree.alternate].every(_isStatic);
    					}
    				default:
    					return false;
    			}
    		}
    	}, {
    		key: "render",
    		value: function render(tree) {
    			var _render = Expression.render;

    			switch (tree.type) {
    				case "Compound":
    					{
    						// expressions seperated by comma or semicolon
    						return "(" + tree.body.map(_render).join(",") + ")";
    					}

    				case "Identifier":
    					// plain varable
    					return CONTEXT_LOOKUP + "(" + JSON.stringify(tree.name) + ")";

    				case "ThisExpression":
    					// plain varable
    					return CONTEXT_LOOKUP + "()";

    				case "MemberExpression":
    					{
    						// object property
    						var out = _render(tree.object);
    						var prop = tree.property;
    						if (!tree.computed && prop.type === "Identifier") out += "." + prop.name;else out += "[" + _render(prop) + "]";
    						return out;
    					}

    				case "Literal":
    					// string, number, boolean
    					return JSON.stringify(tree.value);

    				case "CallExpression":
    					{
    						// function call
    						var out = _render(tree.callee);
    						if (tree.callee.type === "MemberExpression") out += "(";else out += ".call(" + CONTEXT_LOOKUP + "()" + (tree.arguments.length ? ", " : "");
    						out += tree.arguments.map(_render).join(", ") + ")";
    						return out;
    					}

    				case "UnaryExpression":
    					{
    						// single operators: ! - ++ --
    						var out = _render(tree.argument);
    						if (tree.prefix) out = tree.operator + out;else out += tree.operator;
    						return out;
    					}

    				case "LogicalExpression":
    				case "BinaryExpression":
    					{
    						// math
    						return "(" + _render(tree.left) + tree.operator + _render(tree.right) + ")";
    					}

    				case "ArrayExpression":
    					{
    						// arrays
    						return "[" + tree.elements.map(_render).join(",") + "]";
    					}

    				case "ConditionalExpression":
    					{
    						// if ? then : else
    						return "(" + _render(tree.test) + "?" + _render(tree.consequent) + ":" + _render(tree.alternate) + ")";
    					}

    				default:
    					throw new Error("Not supported.");
    			}
    		}
    	}]);
    	return Expression;
    }(ASTNode);

    var Literal = function (_Node) {
    	babelHelpers.inherits(Literal, _Node);

    	function Literal() {
    		babelHelpers.classCallCheck(this, Literal);
    		return babelHelpers.possibleConstructorReturn(this, Object.getPrototypeOf(Literal).apply(this, arguments));
    	}

    	babelHelpers.createClass(Literal, [{
    		key: "compile",
    		value: function compile(data) {
    			this.start(data);
    			this.push(JSON.stringify(this.value));
    			return this.end();
    		}
    	}, {
    		key: "reactive",
    		get: function get() {
    			return false;
    		}
    	}]);
    	return Literal;
    }(ASTNode);

    var Set = function (_Node) {
    	babelHelpers.inherits(Set, _Node);

    	function Set() {
    		babelHelpers.classCallCheck(this, Set);
    		return babelHelpers.possibleConstructorReturn(this, Object.getPrototypeOf(Set).apply(this, arguments));
    	}

    	babelHelpers.createClass(Set, [{
    		key: "compile",
    		value: function compile(data) {
    			this.start(data);

    			var exp = this.expression.compile(data);
    			var safevar = JSON.stringify(this.variable);
    			if (this.attribute) this.push("(");else this.push(this.tabs());
    			this.push(["ctx.set(" + safevar + ", ", exp, ")"]);
    			if (!this.attribute) this.push(";\n");else this.push(", \"\")");

    			return this.end();
    		}
    	}, {
    		key: "reactive",
    		get: function get() {
    			return true;
    		}
    	}]);
    	return Set;
    }(ASTNode);

    var Style = function (_Node) {
    	babelHelpers.inherits(Style, _Node);

    	function Style() {
    		babelHelpers.classCallCheck(this, Style);
    		return babelHelpers.possibleConstructorReturn(this, Object.getPrototypeOf(Style).apply(this, arguments));
    	}

    	babelHelpers.createClass(Style, [{
    		key: "reactive",
    		get: function get() {
    			return false;
    		}
    	}]);
    	return Style;
    }(ASTNode);



    var AST = Object.freeze({
    	utils: utils$1,
    	Node: ASTNode,
    	Root: Root,
    	File: File,
    	Include: Include,
    	Comment: Comment,
    	Template: Template$1,
    	Script: Script,
    	Style: Style,
    	Element: Element$1,
    	Text: Text,
    	Attribute: Attribute,
    	If: If,
    	Branch: Branch,
    	Each: Each,
    	With: With,
    	Set: Set,
    	Render: Render,
    	Interpolator: Interpolator,
    	Expression: Expression,
    	Literal: Literal
    });

    var name = "templejs";
    var version$1 = "1.0.0-alpha.1";
    var description = "A reactive Mustache view framework.";
    var author = "Beneath the Ink <info@beneaththeink.com>";
    var contributors = [{"name":"Tyler Johnson","email":"tyler@beneaththeink.com","url":"http://github.com/tyler-johnson"}];
    var repository = {"type":"git","url":"https://github.com/BeneathTheInk/Temple.git"};
    var scripts = {"lint":"jshint src/","test":"make test","build":"make build","prepublish":"make clean && make","semantic-release":"semantic-release pre && npm publish && semantic-release post"};
    var main = "temple.js";
    var bin = "temple.cli.js";
    var browser = {"fs-promise":false};
    var dependencies = {"assign-props":"~1.1.2","backbone-extend-standalone":"~0.1.2","chalk":"~1.1.1","chokidar":"~1.4.2","dom-matches":"~2.0.0","express":"~4.13.4","fs-promise":"~0.4.1","jsep":"~0.3.0","lodash":"4.x","minimist":"~1.2.0","open":"0.0.5","raf":"~3.1.0","source-map":"~0.5.3","trackr":"~2.0.2","trackr-objects":"~0.4.0"};
    var devDependencies = {"babel-plugin-lodash":"~2.0.1","babel-preset-es2015-rollup":"~1.1.1","browserify":"~13.0.0","incremental-dom":"~0.3.0","istanbul":"~0.4.2","istanbul-coveralls":"~1.0.3","jshint":"~2.9.1","pegjs":"~0.9.0","random-port":"~0.1.0","rollup":"~0.25.4","rollup-plugin-babel":"~2.3.9","rollup-plugin-commonjs":"~2.2.1","rollup-plugin-json":"~2.0.0","rollup-plugin-node-resolve":"~1.4.0","rollup-plugin-replace":"~1.1.0","semantic-release":"^4.3.5","tape":"~4.4.0","tape-run":"~2.1.3","uglify-js":"~2.6.1"};
    var license = "MIT";
    var keywords = ["view","framework","DOM","html","binding","reactive","dependency","mustache"];
    var pkg = {
    	name: name,
    	version: version$1,
    	description: description,
    	author: author,
    	contributors: contributors,
    	repository: repository,
    	scripts: scripts,
    	main: main,
    	bin: bin,
    	browser: browser,
    	dependencies: dependencies,
    	devDependencies: devDependencies,
    	license: license,
    	keywords: keywords,
    	"jsnext:main": "temple.es6.js"
    };

    var jsep = __commonjs(function (module, exports, global) {
    //     JavaScript Expression Parser (JSEP) 0.3.0
    //     JSEP may be freely distributed under the MIT License
    //     http://jsep.from.so/

    /*global module: true, exports: true, console: true */
    (function (root) {
    	'use strict';
    	// Node Types
    	// ----------
    	
    	// This is the full set of types that any JSEP node can be.
    	// Store them here to save space when minified
    	var COMPOUND = 'Compound',
    		IDENTIFIER = 'Identifier',
    		MEMBER_EXP = 'MemberExpression',
    		LITERAL = 'Literal',
    		THIS_EXP = 'ThisExpression',
    		CALL_EXP = 'CallExpression',
    		UNARY_EXP = 'UnaryExpression',
    		BINARY_EXP = 'BinaryExpression',
    		LOGICAL_EXP = 'LogicalExpression',
    		CONDITIONAL_EXP = 'ConditionalExpression',
    		ARRAY_EXP = 'ArrayExpression',

    		PERIOD_CODE = 46, // '.'
    		COMMA_CODE  = 44, // ','
    		SQUOTE_CODE = 39, // single quote
    		DQUOTE_CODE = 34, // double quotes
    		OPAREN_CODE = 40, // (
    		CPAREN_CODE = 41, // )
    		OBRACK_CODE = 91, // [
    		CBRACK_CODE = 93, // ]
    		QUMARK_CODE = 63, // ?
    		SEMCOL_CODE = 59, // ;
    		COLON_CODE  = 58, // :

    		throwError = function(message, index) {
    			var error = new Error(message + ' at character ' + index);
    			error.index = index;
    			error.description = message;
    			throw error;
    		},

    	// Operations
    	// ----------
    	
    	// Set `t` to `true` to save space (when minified, not gzipped)
    		t = true,
    	// Use a quickly-accessible map to store all of the unary operators
    	// Values are set to `true` (it really doesn't matter)
    		unary_ops = {'-': t, '!': t, '~': t, '+': t},
    	// Also use a map for the binary operations but set their values to their
    	// binary precedence for quick reference:
    	// see [Order of operations](http://en.wikipedia.org/wiki/Order_of_operations#Programming_language)
    		binary_ops = {
    			'||': 1, '&&': 2, '|': 3,  '^': 4,  '&': 5,
    			'==': 6, '!=': 6, '===': 6, '!==': 6,
    			'<': 7,  '>': 7,  '<=': 7,  '>=': 7, 
    			'<<':8,  '>>': 8, '>>>': 8,
    			'+': 9, '-': 9,
    			'*': 10, '/': 10, '%': 10
    		},
    	// Get return the longest key length of any object
    		getMaxKeyLen = function(obj) {
    			var max_len = 0, len;
    			for(var key in obj) {
    				if((len = key.length) > max_len && obj.hasOwnProperty(key)) {
    					max_len = len;
    				}
    			}
    			return max_len;
    		},
    		max_unop_len = getMaxKeyLen(unary_ops),
    		max_binop_len = getMaxKeyLen(binary_ops),
    	// Literals
    	// ----------
    	// Store the values to return for the various literals we may encounter
    		literals = {
    			'true': true,
    			'false': false,
    			'null': null
    		},
    	// Except for `this`, which is special. This could be changed to something like `'self'` as well
    		this_str = 'this',
    	// Returns the precedence of a binary operator or `0` if it isn't a binary operator
    		binaryPrecedence = function(op_val) {
    			return binary_ops[op_val] || 0;
    		},
    	// Utility function (gets called from multiple places)
    	// Also note that `a && b` and `a || b` are *logical* expressions, not binary expressions
    		createBinaryExpression = function (operator, left, right) {
    			var type = (operator === '||' || operator === '&&') ? LOGICAL_EXP : BINARY_EXP;
    			return {
    				type: type,
    				operator: operator,
    				left: left,
    				right: right
    			};
    		},
    		// `ch` is a character code in the next three functions
    		isDecimalDigit = function(ch) {
    			return (ch >= 48 && ch <= 57); // 0...9
    		},
    		isIdentifierStart = function(ch) {
    			return (ch === 36) || (ch === 95) || // `$` and `_`
    					(ch >= 65 && ch <= 90) || // A...Z
    					(ch >= 97 && ch <= 122); // a...z
    		},
    		isIdentifierPart = function(ch) {
    			return (ch === 36) || (ch === 95) || // `$` and `_`
    					(ch >= 65 && ch <= 90) || // A...Z
    					(ch >= 97 && ch <= 122) || // a...z
    					(ch >= 48 && ch <= 57); // 0...9
    		},

    		// Parsing
    		// -------
    		// `expr` is a string with the passed in expression
    		jsep = function(expr) {
    			// `index` stores the character number we are currently at while `length` is a constant
    			// All of the gobbles below will modify `index` as we move along
    			var index = 0,
    				charAtFunc = expr.charAt,
    				charCodeAtFunc = expr.charCodeAt,
    				exprI = function(i) { return charAtFunc.call(expr, i); },
    				exprICode = function(i) { return charCodeAtFunc.call(expr, i); },
    				length = expr.length,

    				// Push `index` up to the next non-space character
    				gobbleSpaces = function() {
    					var ch = exprICode(index);
    					// space or tab
    					while(ch === 32 || ch === 9) {
    						ch = exprICode(++index);
    					}
    				},
    				
    				// The main parsing function. Much of this code is dedicated to ternary expressions
    				gobbleExpression = function() {
    					var test = gobbleBinaryExpression(),
    						consequent, alternate;
    					gobbleSpaces();
    					if(exprICode(index) === QUMARK_CODE) {
    						// Ternary expression: test ? consequent : alternate
    						index++;
    						consequent = gobbleExpression();
    						if(!consequent) {
    							throwError('Expected expression', index);
    						}
    						gobbleSpaces();
    						if(exprICode(index) === COLON_CODE) {
    							index++;
    							alternate = gobbleExpression();
    							if(!alternate) {
    								throwError('Expected expression', index);
    							}
    							return {
    								type: CONDITIONAL_EXP,
    								test: test,
    								consequent: consequent,
    								alternate: alternate
    							};
    						} else {
    							throwError('Expected :', index);
    						}
    					} else {
    						return test;
    					}
    				},

    				// Search for the operation portion of the string (e.g. `+`, `===`)
    				// Start by taking the longest possible binary operations (3 characters: `===`, `!==`, `>>>`)
    				// and move down from 3 to 2 to 1 character until a matching binary operation is found
    				// then, return that binary operation
    				gobbleBinaryOp = function() {
    					gobbleSpaces();
    					var biop, to_check = expr.substr(index, max_binop_len), tc_len = to_check.length;
    					while(tc_len > 0) {
    						if(binary_ops.hasOwnProperty(to_check)) {
    							index += tc_len;
    							return to_check;
    						}
    						to_check = to_check.substr(0, --tc_len);
    					}
    					return false;
    				},

    				// This function is responsible for gobbling an individual expression,
    				// e.g. `1`, `1+2`, `a+(b*2)-Math.sqrt(2)`
    				gobbleBinaryExpression = function() {
    					var ch_i, node, biop, prec, stack, biop_info, left, right, i;

    					// First, try to get the leftmost thing
    					// Then, check to see if there's a binary operator operating on that leftmost thing
    					left = gobbleToken();
    					biop = gobbleBinaryOp();

    					// If there wasn't a binary operator, just return the leftmost node
    					if(!biop) {
    						return left;
    					}

    					// Otherwise, we need to start a stack to properly place the binary operations in their
    					// precedence structure
    					biop_info = { value: biop, prec: binaryPrecedence(biop)};

    					right = gobbleToken();
    					if(!right) {
    						throwError("Expected expression after " + biop, index);
    					}
    					stack = [left, biop_info, right];

    					// Properly deal with precedence using [recursive descent](http://www.engr.mun.ca/~theo/Misc/exp_parsing.htm)
    					while((biop = gobbleBinaryOp())) {
    						prec = binaryPrecedence(biop);

    						if(prec === 0) {
    							break;
    						}
    						biop_info = { value: biop, prec: prec };

    						// Reduce: make a binary expression from the three topmost entries.
    						while ((stack.length > 2) && (prec <= stack[stack.length - 2].prec)) {
    							right = stack.pop();
    							biop = stack.pop().value;
    							left = stack.pop();
    							node = createBinaryExpression(biop, left, right);
    							stack.push(node);
    						}

    						node = gobbleToken();
    						if(!node) {
    							throwError("Expected expression after " + biop, index);
    						}
    						stack.push(biop_info, node);
    					}

    					i = stack.length - 1;
    					node = stack[i];
    					while(i > 1) {
    						node = createBinaryExpression(stack[i - 1].value, stack[i - 2], node); 
    						i -= 2;
    					}
    					return node;
    				},

    				// An individual part of a binary expression:
    				// e.g. `foo.bar(baz)`, `1`, `"abc"`, `(a % 2)` (because it's in parenthesis)
    				gobbleToken = function() {
    					var ch, to_check, tc_len;
    					
    					gobbleSpaces();
    					ch = exprICode(index);

    					if(isDecimalDigit(ch) || ch === PERIOD_CODE) {
    						// Char code 46 is a dot `.` which can start off a numeric literal
    						return gobbleNumericLiteral();
    					} else if(ch === SQUOTE_CODE || ch === DQUOTE_CODE) {
    						// Single or double quotes
    						return gobbleStringLiteral();
    					} else if(isIdentifierStart(ch) || ch === OPAREN_CODE) { // open parenthesis
    						// `foo`, `bar.baz`
    						return gobbleVariable();
    					} else if (ch === OBRACK_CODE) {
    						return gobbleArray();
    					} else {
    						to_check = expr.substr(index, max_unop_len);
    						tc_len = to_check.length;
    						while(tc_len > 0) {
    							if(unary_ops.hasOwnProperty(to_check)) {
    								index += tc_len;
    								return {
    									type: UNARY_EXP,
    									operator: to_check,
    									argument: gobbleToken(),
    									prefix: true
    								};
    							}
    							to_check = to_check.substr(0, --tc_len);
    						}
    						
    						return false;
    					}
    				},
    				// Parse simple numeric literals: `12`, `3.4`, `.5`. Do this by using a string to
    				// keep track of everything in the numeric literal and then calling `parseFloat` on that string
    				gobbleNumericLiteral = function() {
    					var number = '', ch, chCode;
    					while(isDecimalDigit(exprICode(index))) {
    						number += exprI(index++);
    					}

    					if(exprICode(index) === PERIOD_CODE) { // can start with a decimal marker
    						number += exprI(index++);

    						while(isDecimalDigit(exprICode(index))) {
    							number += exprI(index++);
    						}
    					}
    					
    					ch = exprI(index);
    					if(ch === 'e' || ch === 'E') { // exponent marker
    						number += exprI(index++);
    						ch = exprI(index);
    						if(ch === '+' || ch === '-') { // exponent sign
    							number += exprI(index++);
    						}
    						while(isDecimalDigit(exprICode(index))) { //exponent itself
    							number += exprI(index++);
    						}
    						if(!isDecimalDigit(exprICode(index-1)) ) {
    							throwError('Expected exponent (' + number + exprI(index) + ')', index);
    						}
    					}
    					

    					chCode = exprICode(index);
    					// Check to make sure this isn't a variable name that start with a number (123abc)
    					if(isIdentifierStart(chCode)) {
    						throwError('Variable names cannot start with a number (' +
    									number + exprI(index) + ')', index);
    					} else if(chCode === PERIOD_CODE) {
    						throwError('Unexpected period', index);
    					}

    					return {
    						type: LITERAL,
    						value: parseFloat(number),
    						raw: number
    					};
    				},

    				// Parses a string literal, staring with single or double quotes with basic support for escape codes
    				// e.g. `"hello world"`, `'this is\nJSEP'`
    				gobbleStringLiteral = function() {
    					var str = '', quote = exprI(index++), closed = false, ch;

    					while(index < length) {
    						ch = exprI(index++);
    						if(ch === quote) {
    							closed = true;
    							break;
    						} else if(ch === '\\') {
    							// Check for all of the common escape codes
    							ch = exprI(index++);
    							switch(ch) {
    								case 'n': str += '\n'; break;
    								case 'r': str += '\r'; break;
    								case 't': str += '\t'; break;
    								case 'b': str += '\b'; break;
    								case 'f': str += '\f'; break;
    								case 'v': str += '\x0B'; break;
    							}
    						} else {
    							str += ch;
    						}
    					}

    					if(!closed) {
    						throwError('Unclosed quote after "'+str+'"', index);
    					}

    					return {
    						type: LITERAL,
    						value: str,
    						raw: quote + str + quote
    					};
    				},
    				
    				// Gobbles only identifiers
    				// e.g.: `foo`, `_value`, `$x1`
    				// Also, this function checks if that identifier is a literal:
    				// (e.g. `true`, `false`, `null`) or `this`
    				gobbleIdentifier = function() {
    					var ch = exprICode(index), start = index, identifier;

    					if(isIdentifierStart(ch)) {
    						index++;
    					} else {
    						throwError('Unexpected ' + exprI(index), index);
    					}

    					while(index < length) {
    						ch = exprICode(index);
    						if(isIdentifierPart(ch)) {
    							index++;
    						} else {
    							break;
    						}
    					}
    					identifier = expr.slice(start, index);

    					if(literals.hasOwnProperty(identifier)) {
    						return {
    							type: LITERAL,
    							value: literals[identifier],
    							raw: identifier
    						};
    					} else if(identifier === this_str) {
    						return { type: THIS_EXP };
    					} else {
    						return {
    							type: IDENTIFIER,
    							name: identifier
    						};
    					}
    				},

    				// Gobbles a list of arguments within the context of a function call
    				// or array literal. This function also assumes that the opening character
    				// `(` or `[` has already been gobbled, and gobbles expressions and commas
    				// until the terminator character `)` or `]` is encountered.
    				// e.g. `foo(bar, baz)`, `my_func()`, or `[bar, baz]`
    				gobbleArguments = function(termination) {
    					var ch_i, args = [], node;
    					while(index < length) {
    						gobbleSpaces();
    						ch_i = exprICode(index);
    						if(ch_i === termination) { // done parsing
    							index++;
    							break;
    						} else if (ch_i === COMMA_CODE) { // between expressions
    							index++;
    						} else {
    							node = gobbleExpression();
    							if(!node || node.type === COMPOUND) {
    								throwError('Expected comma', index);
    							}
    							args.push(node);
    						}
    					}
    					return args;
    				},

    				// Gobble a non-literal variable name. This variable name may include properties
    				// e.g. `foo`, `bar.baz`, `foo['bar'].baz`
    				// It also gobbles function calls:
    				// e.g. `Math.acos(obj.angle)`
    				gobbleVariable = function() {
    					var ch_i, node;
    					ch_i = exprICode(index);
    						
    					if(ch_i === OPAREN_CODE) {
    						node = gobbleGroup();
    					} else {
    						node = gobbleIdentifier();
    					}
    					gobbleSpaces();
    					ch_i = exprICode(index);
    					while(ch_i === PERIOD_CODE || ch_i === OBRACK_CODE || ch_i === OPAREN_CODE) {
    						index++;
    						if(ch_i === PERIOD_CODE) {
    							gobbleSpaces();
    							node = {
    								type: MEMBER_EXP,
    								computed: false,
    								object: node,
    								property: gobbleIdentifier()
    							};
    						} else if(ch_i === OBRACK_CODE) {
    							node = {
    								type: MEMBER_EXP,
    								computed: true,
    								object: node,
    								property: gobbleExpression()
    							};
    							gobbleSpaces();
    							ch_i = exprICode(index);
    							if(ch_i !== CBRACK_CODE) {
    								throwError('Unclosed [', index);
    							}
    							index++;
    						} else if(ch_i === OPAREN_CODE) {
    							// A function call is being made; gobble all the arguments
    							node = {
    								type: CALL_EXP,
    								'arguments': gobbleArguments(CPAREN_CODE),
    								callee: node
    							};
    						}
    						gobbleSpaces();
    						ch_i = exprICode(index);
    					}
    					return node;
    				},

    				// Responsible for parsing a group of things within parentheses `()`
    				// This function assumes that it needs to gobble the opening parenthesis
    				// and then tries to gobble everything within that parenthesis, assuming
    				// that the next thing it should see is the close parenthesis. If not,
    				// then the expression probably doesn't have a `)`
    				gobbleGroup = function() {
    					index++;
    					var node = gobbleExpression();
    					gobbleSpaces();
    					if(exprICode(index) === CPAREN_CODE) {
    						index++;
    						return node;
    					} else {
    						throwError('Unclosed (', index);
    					}
    				},

    				// Responsible for parsing Array literals `[1, 2, 3]`
    				// This function assumes that it needs to gobble the opening bracket
    				// and then tries to gobble the expressions as arguments.
    				gobbleArray = function() {
    					index++;
    					return {
    						type: ARRAY_EXP,
    						elements: gobbleArguments(CBRACK_CODE)
    					};
    				},

    				nodes = [], ch_i, node;
    				
    			while(index < length) {
    				ch_i = exprICode(index);

    				// Expressions can be separated by semicolons, commas, or just inferred without any
    				// separators
    				if(ch_i === SEMCOL_CODE || ch_i === COMMA_CODE) {
    					index++; // ignore separators
    				} else {
    					// Try to gobble each expression individually
    					if((node = gobbleExpression())) {
    						nodes.push(node);
    					// If we weren't able to find a binary expression and are out of room, then
    					// the expression passed in probably has too much
    					} else if(index < length) {
    						throwError('Unexpected "' + exprI(index) + '"', index);
    					}
    				}
    			}

    			// If there's only one expression just try returning the expression
    			if(nodes.length === 1) {
    				return nodes[0];
    			} else {
    				return {
    					type: COMPOUND,
    					body: nodes
    				};
    			}
    		};

    	// To be filled in by the template
    	jsep.version = '0.3.0';
    	jsep.toString = function() { return 'JavaScript Expression Parser (JSEP) v' + jsep.version; };

    	/**
    	 * @method jsep.addUnaryOp
    	 * @param {string} op_name The name of the unary op to add
    	 * @return jsep
    	 */
    	jsep.addUnaryOp = function(op_name) {
    		unary_ops[op_name] = t; return this;
    	};

    	/**
    	 * @method jsep.addBinaryOp
    	 * @param {string} op_name The name of the binary op to add
    	 * @param {number} precedence The precedence of the binary op (can be a float)
    	 * @return jsep
    	 */
    	jsep.addBinaryOp = function(op_name, precedence) {
    		max_binop_len = Math.max(op_name.length, max_binop_len);
    		binary_ops[op_name] = precedence;
    		return this;
    	};

    	/**
    	 * @method jsep.removeUnaryOp
    	 * @param {string} op_name The name of the unary op to remove
    	 * @return jsep
    	 */
    	jsep.removeUnaryOp = function(op_name) {
    		delete unary_ops[op_name];
    		if(op_name.length === max_unop_len) {
    			max_unop_len = getMaxKeyLen(unary_ops);
    		}
    		return this;
    	};

    	/**
    	 * @method jsep.removeBinaryOp
    	 * @param {string} op_name The name of the binary op to remove
    	 * @return jsep
    	 */
    	jsep.removeBinaryOp = function(op_name) {
    		delete binary_ops[op_name];
    		if(op_name.length === max_binop_len) {
    			max_binop_len = getMaxKeyLen(binary_ops);
    		}
    		return this;
    	};

    	// In desktop environments, have a way to restore the old value for `jsep`
    	if (typeof exports === 'undefined') {
    		var old_jsep = root.jsep;
    		// The star of the show! It's a function!
    		root.jsep = jsep;
    		// And a courteous function willing to move out of the way for other similarly-named objects!
    		jsep.noConflict = function() {
    			if(root.jsep === jsep) {
    				root.jsep = old_jsep;
    			}
    			return jsep;
    		};
    	} else {
    		// In Node.JS environments
    		if (typeof module !== 'undefined' && module.exports) {
    			exports = module.exports = jsep;
    		} else {
    			exports.parse = jsep;
    		}
    	}
    }(__commonjs_global));
    });

    var jsep$1 = (jsep && typeof jsep === 'object' && 'default' in jsep ? jsep['default'] : jsep);

    var parser = function () {
      "use strict";

      /*
       * Generated by PEG.js 0.9.0.
       *
       * http://pegjs.org/
       */

      function peg$subclass(child, parent) {
        function ctor() {
          this.constructor = child;
        }
        ctor.prototype = parent.prototype;
        child.prototype = new ctor();
      }

      function peg$SyntaxError(message, expected, found, location) {
        this.message = message;
        this.expected = expected;
        this.found = found;
        this.location = location;
        this.name = "SyntaxError";

        if (typeof Error.captureStackTrace === "function") {
          Error.captureStackTrace(this, peg$SyntaxError);
        }
      }

      peg$subclass(peg$SyntaxError, Error);

      function peg$parse(input) {
        var options = arguments.length > 1 ? arguments[1] : {},
            parser = this,
            peg$FAILED = {},
            peg$startRuleIndices = { start: 0 },
            peg$startRuleIndex = 0,
            peg$consts = [function (nodes) {
          var _map$reduce = _default$2(nodes, 0).reduce(function (m, n) {
            m[n instanceof Style ? 1 : n instanceof Include ? 2 : 0].push(n);
            return m;
          }, [[], [], []]);

          var _map$reduce2 = babelHelpers.slicedToArray(_map$reduce, 3);

          var children = _map$reduce2[0];
          var styles = _map$reduce2[1];
          var includes = _map$reduce2[2];


          return createNode("File", {
            filename: options.filename,
            source: text(),
            children: children,
            styles: styles,
            includes: includes
          });
        }, { type: "other", description: "template" }, "<", { type: "literal", value: "<", description: "\"<\"" }, "template", { type: "literal", value: "template", description: "\"template\"" }, ">", { type: "literal", value: ">", description: "\">\"" }, "</template>", { type: "literal", value: "</template>", description: "\"</template>\"" }, function (attrs, nodes) {
          var name,
              type,
              plugins = [];

          attrs = attrs.filter(function (a) {
            switch (a.name) {
              case "name":
                name = a.value;
                break;

              case "type":
                type = a.value;
                break;

              case "use":
                plugins.push(a.value);
                break;

              default:
                return true;
            }
          });

          return createNode("Template", {
            name: name,
            type: type,
            children: nodes,
            plugins: plugins,
            attributes: attrs
          });
        }, { type: "other", description: "include" }, "include", { type: "literal", value: "include", description: "\"include\"" }, "/>", { type: "literal", value: "/>", description: "\"/>\"" }, function (attrs) {
          var src;

          attrs = attrs.filter(function (a) {
            switch (a.name) {
              case "src":
                src = a.value;
                break;

              default:
                return true;
            }
          });

          return createNode("Include", {
            src: src,
            attributes: attrs
          });
        }, { type: "other", description: "interpolator" }, "{-", { type: "literal", value: "{-", description: "\"{-\"" }, "-}", { type: "literal", value: "-}", description: "\"-}\"" }, { type: "any", description: "any character" }, function (v) {
          return v;
        }, "{{", { type: "literal", value: "{{", description: "\"{{\"" }, "}}", { type: "literal", value: "}}", description: "\"}}\"" }, function (value) {
          return createExpression(value);
        }, function (expression) {
          return createNode("Interpolator", {
            expression: expression
          });
        }, function (nodes) {
          return combineText(nodes);
        }, /^[a-z0-9\-$]/i, { type: "class", value: "[a-z0-9\\-$]i", description: "[a-z0-9\\-$]i" }, function (k) {
          return k.toLowerCase();
        }, "</", { type: "literal", value: "</", description: "\"</\"" }, "{%", { type: "literal", value: "{%", description: "\"{%\"" }, { type: "other", description: "comment" }, "<!--", { type: "literal", value: "<!--", description: "\"<!--\"" }, "-->", { type: "literal", value: "-->", description: "\"-->\"" }, "{#", { type: "literal", value: "{#", description: "\"{#\"" }, "#}", { type: "literal", value: "#}", description: "\"#}\"" }, function (value) {
          return createNode("Comment", { value: value });
        }, { type: "other", description: "raw tag" }, function (tagname) {
          if (tagname[0] === "$") tagname = tagname.substr(1);
          currentRawTag = tagname;
          return _default2$2(rawTags, tagname);
        }, function (tagname, attrs, v) {
          currentRawTag = null;
          return true;
        }, function (tagname, attrs, v) {
          if (tagname[0] === "$") tagname = tagname.substr(1);
          return createRawNode(tagname, attrs, v);
        }, function (t) {
          if (t[0] === "$") t = t.substr(1);
          return t === currentRawTag;
        }, { type: "other", description: "element" }, function (tagname, attrs) {
          return createNode("Element", {
            tagname: tagname,
            attributes: attrs,
            children: []
          });
        }, function (starttag, attrs, nodes, t) {
          if (starttag !== t) {
            throw expected("</" + starttag + ">");
          }

          return t;
        }, function (starttag, attrs, nodes) {
          return createNode("Element", {
            tagname: starttag,
            attributes: attrs,
            children: nodes
          });
        }, { type: "other", description: "attribute" }, "=", { type: "literal", value: "=", description: "\"=\"" }, function (key) {
          enterAttribute();
          return true;
        }, function (key, v) {
          return v;
        }, function (key, value) {
          exitAttribute();
          return true;
        }, function (key, value) {
          return createNode("Attribute", _default3$1({
            name: key,
            children: [],
            type: "empty"
          }, value));
        }, "{", { type: "literal", value: "{", description: "\"{\"" }, "}", { type: "literal", value: "}", description: "\"}\"" }, function (exp) {
          var e = jsep$1(exp);
          var exps = e.type === "Compound" ? e.body : [e];

          return {
            type: "expression",
            children: exps.map(function (e) {
              return createNode("Expression", { tree: e });
            })
          };
        }, "\"", { type: "literal", value: "\"", description: "\"\\\"\"" }, function (n) {
          return {
            children: combineText(n, "Literal"),
            type: "string"
          };
        }, "'", { type: "literal", value: "'", description: "\"'\"" }, function (children) {
          var t = text();
          t = t.substr(1, t.length - 2);

          return _default3$1({
            value: t
          }, children);
        }, "%}", { type: "literal", value: "%}", description: "\"%}\"" }, function () {
          return attributeMode;
        }, function (n) {
          return combineText(n, "Literal");
        }, { type: "other", description: "if section" }, "if", { type: "literal", value: "if", description: "\"if\"" }, "else", { type: "literal", value: "else", description: "\"else\"" }, function (exp, nodes) {
          return [exp, nodes];
        }, function (exp, nodes, elsifs) {
          return nodes;
        }, "endif", { type: "literal", value: "endif", description: "\"endif\"" }, function (exp, nodes, elsifs, els) {
          var branches = [createNode("Branch", {
            expression: createExpression(exp),
            children: nodes
          })];

          elsifs.forEach(function (b) {
            branches.push(createNode("Branch", {
              expression: createExpression(b[0]),
              children: b[1]
            }));
          });

          if (els) branches.push(createNode("Branch", {
            expression: null,
            children: els
          }));

          return createNode("If", {
            children: branches,
            attribute: attributeMode
          });
        }, { type: "other", description: "each section" }, "each", { type: "literal", value: "each", description: "\"each\"" }, ",", { type: "literal", value: ",", description: "\",\"" }, "in", { type: "literal", value: "in", description: "\"in\"" }, function (l, r) {
          return [l].concat(_default$2(r, 3));
        }, "endeach", { type: "literal", value: "endeach", description: "\"endeach\"" }, function (vars, exp, nodes) {
          return createNode("Each", {
            expression: createExpression(exp),
            children: nodes,
            variables: vars || [],
            attribute: attributeMode
          });
        }, /^[a-z_$]/i, { type: "class", value: "[a-z_$]i", description: "[a-z_$]i" }, /^[a-z0-9_$]/i, { type: "class", value: "[a-z0-9_$]i", description: "[a-z0-9_$]i" }, { type: "other", description: "render section" }, function () {
          return !attributeMode;
        }, "render", { type: "literal", value: "render", description: "\"render\"" }, function (exp) {
          return createNode("Render", {
            expression: createExpression(exp)
          });
        }, { type: "other", description: "with section" }, "with", { type: "literal", value: "with", description: "\"with\"" }, "endwith", { type: "literal", value: "endwith", description: "\"endwith\"" }, function (exp, nodes) {
          return createNode("With", {
            expression: createExpression(exp),
            children: nodes,
            attribute: attributeMode
          });
        }, { type: "other", description: "set section" }, "set", { type: "literal", value: "set", description: "\"set\"" }, /^[a-z]/i, { type: "class", value: "[a-z]i", description: "[a-z]i" }, function (v, exp) {
          return createNode("Set", {
            variable: v,
            expression: createExpression(exp),
            attribute: attributeMode
          });
        }, "true", { type: "literal", value: "true", description: "\"true\"" }, function () {
          return true;
        }, "false", { type: "literal", value: "false", description: "\"false\"" }, function () {
          return false;
        }, "-", { type: "literal", value: "-", description: "\"-\"" }, /^[0-9]/, { type: "class", value: "[0-9]", description: "[0-9]" }, ".", { type: "literal", value: ".", description: "\".\"" }, function () {
          return parseFloat(text(), 10);
        }, function () {
          return parseInt(text(), 10);
        }, /^[^"]/, { type: "class", value: "[^\"]", description: "[^\"]" }, function (v) {
          return v.join("");
        }, /^[^']/, { type: "class", value: "[^']", description: "[^']" }, "null", { type: "literal", value: "null", description: "\"null\"" }, function () {
          return null;
        }, "undefined", { type: "literal", value: "undefined", description: "\"undefined\"" }, "void", { type: "literal", value: "void", description: "\"void\"" }, /^[,; \t\n\r]/, { type: "class", value: "[,; \\t\\n\\r]", description: "[,; \\t\\n\\r]" }, function () {
          return void 0;
        }, { type: "other", description: "whitespace" }, /^[ \t\n\r]/, { type: "class", value: "[ \\t\\n\\r]", description: "[ \\t\\n\\r]" }, { type: "other", description: "guaranteed whitespace" }, "\\", { type: "literal", value: "\\", description: "\"\\\\\"" }, function (char) {
          return char;
        }],
            peg$bytecode = [peg$decode("%;B/\x82#$%;)./ &;\".) &;!.# &;(/,#;B/#$+\")(\"'#&'#0H*%;)./ &;\".) &;!.# &;(/,#;B/#$+\")(\"'#&'#&/($8\": \"! )(\"'#&'#"), peg$decode("<%2\"\"\"6\"7#/q#;B/h$2$\"\"6$7%/Y$;,/P$2&\"\"6&7'/A$;%/8$2(\"\"6(7)/)$8':*'\"#!)(''#(&'#(%'#($'#(#'#(\"'#&'#=.\" 7!"), peg$decode("<%2\"\"\"6\"7#/X#;B/O$2,\"\"6,7-/@$;,/7$2.\"\"6.7//($8%:0%!!)(%'#($'#(#'#(\"'#&'#=.\" 7+"), peg$decode("<%%22\"\"6273/\xA2#%$%%<24\"\"6475=.##&&!&'#/1#1\"\"5!76/#$+\")(\"'#&'#0M*%%<24\"\"6475=.##&&!&'#/1#1\"\"5!76/#$+\")(\"'#&'#&/\"!&,)/7$24\"\"6475/($8#:7#!!)(#'#(\"'#&'#.\xB2 &%28\"\"6879/\xA2#%$%%<2:\"\"6:7;=.##&&!&'#/1#1\"\"5!76/#$+\")(\"'#&'#0M*%%<2:\"\"6:7;=.##&&!&'#/1#1\"\"5!76/#$+\")(\"'#&'#&/\"!&,)/7$2:\"\"6:7;/($8#:7#!!)(#'#(\"'#&'#/' 8!:<!! )=.\" 71"), peg$decode("%;#/' 8!:=!! )"), peg$decode("%$;(.; &;1.5 &;$./ &;).) &;+.# &;'0A*;(.; &;1.5 &;$./ &;).) &;+.# &;'&/' 8!:>!! )"), peg$decode("%;B/Z#%$4?\"\"5!7@/,#0)*4?\"\"5!7@&&&#/\"!&,)/1$;B/($8#:A#!!)(#'#(\"'#&'#"), peg$decode("%%%<%2B\"\"6B7C/;#;&/2$2&\"\"6&7'/#$+#)(#'#(\"'#&'#=.##&&!&'#/g#%<2D\"\"6D7E=.##&&!&'#/L$%<28\"\"6879=.##&&!&'#/1$1\"\"5!76/#$+$)($'#(#'#(\"'#&'#/\"!&,)"), peg$decode("<%%2G\"\"6G7H/\xA2#%$%%<2I\"\"6I7J=.##&&!&'#/1#1\"\"5!76/#$+\")(\"'#&'#0M*%%<2I\"\"6I7J=.##&&!&'#/1#1\"\"5!76/#$+\")(\"'#&'#&/\"!&,)/7$2I\"\"6I7J/($8#:7#!!)(#'#(\"'#&'#.\xB2 &%2K\"\"6K7L/\xA2#%$%%<2M\"\"6M7N=.##&&!&'#/1#1\"\"5!76/#$+\")(\"'#&'#0M*%%<2M\"\"6M7N=.##&&!&'#/1#1\"\"5!76/#$+\")(\"'#&'#&/\"!&,)/7$2M\"\"6M7N/($8#:7#!!)(#'#(\"'#&'#/' 8!:O!! )=.\" 7F"), peg$decode("<%2\"\"\"6\"7#/\xDD#;&/\xD4$9:Q ! -\"\"&!&#/\xC0$;,/\xB7$2&\"\"6&7'/\xA8$%$%%<;*=.##&&!&'#/1#1\"\"5!76/#$+\")(\"'#&'#0G*%%<;*=.##&&!&'#/1#1\"\"5!76/#$+\")(\"'#&'#&/\"!&,)/I$;*/@$9:R #%#!-\"\"&!&#/*$8(:S(#&$\")(('#(''#(&'#(%'#($'#(#'#(\"'#&'#=.\" 7P"), peg$decode("%2B\"\"6B7C/O#;&/F$9:T ! -\"\"&!&#/2$2&\"\"6&7'/#$+$)($'#(#'#(\"'#&'#"), peg$decode("<%2\"\"\"6\"7#/J#;&/A$;,/8$2.\"\"6.7//)$8$:V$\"\"!)($'#(#'#(\"'#&'#.\x9D &%2\"\"\"6\"7#/\x8D#;&/\x84$;,/{$2&\"\"6&7'/l$;%/c$%2B\"\"6B7C/C#;&/:$2&\"\"6&7'/+$8#:W#$'&$!)(#'#(\"'#&'#/*$8&:X&#$#!)(&'#(%'#($'#(#'#(\"'#&'#=.\" 7U"), peg$decode("$;-0#*;-&"), peg$decode("<%;./\x91#%2Z\"\"6Z7[/X#;B/O$9:\\ !#-\"\"&!&#/;$;0/2$;B/)$8%:]%\"&!)(%'#($'#(#'#(\"'#&'#.\" &\"/>$9:^ \"! -\"\"&!&#/)$8#:_#\"\"!)(#'#(\"'#&'#=.\" 7Y"), peg$decode("%;B/Z#%$4?\"\"5!7@/,#0)*4?\"\"5!7@&&&#/\"!&,)/1$;B/($8#:A#!!)(#'#(\"'#&'#"), peg$decode(";D.) &;1.# &;#"), peg$decode("%%2`\"\"6`7a/¢#%$%%<2b\"\"6b7c=.##&&!&'#/1#1\"\"5!76/#$+\")(\"'#&'#0M*%%<2b\"\"6b7c=.##&&!&'#/1#1\"\"5!76/#$+\")(\"'#&'#&/\"!&,)/7$2b\"\"6b7c/($8#:d#!!)(#'#(\"'#&'#.ŭ &%2e\"\"6e7f/µ#$;/.T &%%%<2e\"\"6e7f=.##&&!&'#/1#1\"\"5!76/#$+\")(\"'#&'#/\"!&,)0Z*;/.T &%%%<2e\"\"6e7f=.##&&!&'#/1#1\"\"5!76/#$+\")(\"'#&'#/\"!&,)&/7$2e\"\"6e7f/($8#:g#!!)(#'#(\"'#&'#.Å &%2h\"\"6h7i/µ#$;/.T &%%%<2h\"\"6h7i=.##&&!&'#/1#1\"\"5!76/#$+\")(\"'#&'#/\"!&,)0Z*;/.T &%%%<2h\"\"6h7i=.##&&!&'#/1#1\"\"5!76/#$+\")(\"'#&'#/\"!&,)&/7$2h\"\"6h7i/($8#:g#!!)(#'#(\"'#&'#/' 8!:j!! )"), peg$decode(";5.5 &;6./ &;8.) &;9.# &;:"), peg$decode("%2D\"\"6D7E/,#;B/#$+\")(\"'#&'#"), peg$decode("%;B/2#2k\"\"6k7l/#$+\")(\"'#&'#"), peg$decode("%9:m  -\"\"&!&#/\x9A#$;/.N &%%%<;2=.##&&!&'#/1#1\"\"5!76/#$+\")(\"'#&'#/\"!&,)0T*;/.N &%%%<;2=.##&&!&'#/1#1\"\"5!76/#$+\")(\"'#&'#/\"!&,)&/($8\":n\"! )(\"'#&'#.# &;%"), peg$decode("<%;2/Ư#3p\"\"5\"7q/Ơ$;B/Ɨ$%$;;0#*;;&/\"!&,)/ƀ$;3/ŷ$;4/Ů$$%;2/#3r\"\"5$7s/s$;C/j$3p\"\"5\"7q/[$;B/R$%$;;0#*;;&/\"!&,)/;$;3/2$;4/)$8(:t(\"\" )(('#(''#(&'#(%'#($'#(#'#(\"'#&'#0*%;2/#3r\"\"5$7s/s$;C/j$3p\"\"5\"7q/[$;B/R$%$;;0#*;;&/\"!&,)/;$;3/2$;4/)$8(:t(\"\" )(('#(''#(&'#(%'#($'#(#'#(\"'#&'#&/$%;2/K#3r\"\"5$7s/<$;3/3$;4/*$8$:u$#( %)($'#(#'#(\"'#&'#.\" &\"/L$;2/C$3v\"\"5%7w/4$;3/+$8+:x+$'%$#)(+'#(*'#()'#(('#(''#(&'#(%'#($'#(#'#(\"'#&'#=.\" 7o"), peg$decode("<%;2/ı#3z\"\"5$7{/Ģ$;B/ę$%;7/§#$%;B/D#2|\"\"6|7}/5$;B/,$;7/#$+$)($'#(#'#(\"'#&'#0N*%;B/D#2|\"\"6|7}/5$;B/,$;7/#$+$)($'#(#'#(\"'#&'#&/A$;B/8$2~\"\"6~7/)$8$:$\"#\")($'#(#'#(\"'#&'#.\" &\"/}$;B/t$%$;;0#*;;&/\"!&,)/]$;3/T$;4/K$;2/B$3\"\"5'7/3$;3/*$8+:+#'%#)(+'#(*'#()'#(('#(''#(&'#(%'#($'#(#'#(\"'#&'#=.\" 7y"), peg$decode("%%4\x84\"\"5!7\x85/?#$4\x86\"\"5!7\x870)*4\x86\"\"5!7\x87&/#$+\")(\"'#&'#/\"!&,)"), peg$decode("<%9:\x89  -\"\"&!&#/i#;2/`$3\x8A\"\"5&7\x8B/Q$;B/H$%$;;0#*;;&/\"!&,)/1$;3/($8&:\x8C&!!)(&'#(%'#($'#(#'#(\"'#&'#=.\" 7\x88"), peg$decode("<%;2/\x8B#3\x8E\"\"5$7\x8F/|$;B/s$%$;;0#*;;&/\"!&,)/\\$;3/S$;4/J$;2/A$3\x90\"\"5'7\x91/2$;3/)$8):\x92)\"%#)()'#(('#(''#(&'#(%'#($'#(#'#(\"'#&'#=.\" 7\x8D"), peg$decode("<%;2/\xC4#3\x94\"\"5#7\x95/\xB5$;B/\xAC$%%4\x96\"\"5!7\x97/E#$4\x86\"\"5!7\x87/,#0)*4\x86\"\"5!7\x87&&&#/#$+\")(\"'#&'#/\"!&,)/j$;B/a$2Z\"\"6Z7[/R$;B/I$%$;;0#*;;&/\"!&,)/2$;3/)$8):\x98)\"%!)()'#(('#(''#(&'#(%'#($'#(#'#(\"'#&'#=.\" 7\x93"), peg$decode("%%<2k\"\"6k7l=.##&&!&'#/1#1\"\"5!76/#$+\")(\"'#&'#"), peg$decode("%2\x99\"\"6\x997\x9A/& 8!:\x9B! ).4 &%2\x9C\"\"6\x9C7\x9D/& 8!:\x9E! )"), peg$decode("%2\x9F\"\"6\x9F7\xA0.\" &\"/\x89#$4\xA1\"\"5!7\xA2/,#0)*4\xA1\"\"5!7\xA2&&&#/g$%2\xA3\"\"6\xA37\xA4/E#$4\xA1\"\"5!7\xA2/,#0)*4\xA1\"\"5!7\xA2&&&#/#$+\")(\"'#&'#.\" &\"/'$8#:\xA5# )(#'#(\"'#&'#"), peg$decode("%$4\xA1\"\"5!7\xA2/,#0)*4\xA1\"\"5!7\xA2&&&#/& 8!:\xA6! )"), peg$decode("%2e\"\"6e7f/_#$;D.) &4\xA7\"\"5!7\xA80/*;D.) &4\xA7\"\"5!7\xA8&/7$2e\"\"6e7f/($8#:\xA9#!!)(#'#(\"'#&'#.o &%2h\"\"6h7i/_#$;D.) &4\xAA\"\"5!7\xAB0/*;D.) &4\xAA\"\"5!7\xAB&/7$2h\"\"6h7i/($8#:\xA9#!!)(#'#(\"'#&'#"), peg$decode("%2\xAC\"\"6\xAC7\xAD/& 8!:\xAE! )"), peg$decode("%2\xAF\"\"6\xAF7\xB0.\xA6 &%2\xB1\"\"6\xB17\xB2/\x96#;C/\x8D$$%%<4\xB3\"\"5!7\xB4=.##&&!&'#/1#1\"\"5!76/#$+\")(\"'#&'#/P#0M*%%<4\xB3\"\"5!7\xB4=.##&&!&'#/1#1\"\"5!76/#$+\")(\"'#&'#&&&#/#$+#)(#'#(\"'#&'#/& 8!:\xB5! )"), peg$decode("<%$4\xB7\"\"5!7\xB80)*4\xB7\"\"5!7\xB8&/\"!&,)=.\" 7\xB6"), peg$decode("<%$4\xB7\"\"5!7\xB8/,#0)*4\xB7\"\"5!7\xB8&&&#/\"!&,)=.\" 7\xB9"), peg$decode("%2\xBA\"\"6\xBA7\xBB/6#1\"\"5!76/($8\":\xBC\"! )(\"'#&'#")],
            peg$currPos = 0,
            peg$savedPos = 0,
            peg$posDetailsCache = [{ line: 1, column: 1, seenCR: false }],
            peg$maxFailPos = 0,
            peg$maxFailExpected = [],
            peg$silentFails = 0,
            peg$result;

        if ("startRule" in options) {
          if (!(options.startRule in peg$startRuleIndices)) {
            throw new Error("Can't start parsing from rule \"" + options.startRule + "\".");
          }

          peg$startRuleIndex = peg$startRuleIndices[options.startRule];
        }

        function text() {
          return input.substring(peg$savedPos, peg$currPos);
        }

        function location() {
          return peg$computeLocation(peg$savedPos, peg$currPos);
        }

        function expected(description) {
          throw peg$buildException(null, [{ type: "other", description: description }], input.substring(peg$savedPos, peg$currPos), peg$computeLocation(peg$savedPos, peg$currPos));
        }

        function error(message) {
          throw peg$buildException(message, null, input.substring(peg$savedPos, peg$currPos), peg$computeLocation(peg$savedPos, peg$currPos));
        }

        function peg$computePosDetails(pos) {
          var details = peg$posDetailsCache[pos],
              p,
              ch;

          if (details) {
            return details;
          } else {
            p = pos - 1;
            while (!peg$posDetailsCache[p]) {
              p--;
            }

            details = peg$posDetailsCache[p];
            details = {
              line: details.line,
              column: details.column,
              seenCR: details.seenCR
            };

            while (p < pos) {
              ch = input.charAt(p);
              if (ch === "\n") {
                if (!details.seenCR) {
                  details.line++;
                }
                details.column = 1;
                details.seenCR = false;
              } else if (ch === "\r" || ch === "\u2028" || ch === "\u2029") {
                details.line++;
                details.column = 1;
                details.seenCR = true;
              } else {
                details.column++;
                details.seenCR = false;
              }

              p++;
            }

            peg$posDetailsCache[pos] = details;
            return details;
          }
        }

        function peg$computeLocation(startPos, endPos) {
          var startPosDetails = peg$computePosDetails(startPos),
              endPosDetails = peg$computePosDetails(endPos);

          return {
            start: {
              offset: startPos,
              line: startPosDetails.line,
              column: startPosDetails.column
            },
            end: {
              offset: endPos,
              line: endPosDetails.line,
              column: endPosDetails.column
            }
          };
        }

        function peg$fail(expected) {
          if (peg$currPos < peg$maxFailPos) {
            return;
          }

          if (peg$currPos > peg$maxFailPos) {
            peg$maxFailPos = peg$currPos;
            peg$maxFailExpected = [];
          }

          peg$maxFailExpected.push(expected);
        }

        function peg$buildException(message, expected, found, location) {
          function cleanupExpected(expected) {
            var i = 1;

            expected.sort(function (a, b) {
              if (a.description < b.description) {
                return -1;
              } else if (a.description > b.description) {
                return 1;
              } else {
                return 0;
              }
            });

            while (i < expected.length) {
              if (expected[i - 1] === expected[i]) {
                expected.splice(i, 1);
              } else {
                i++;
              }
            }
          }

          function buildMessage(expected, found) {
            function stringEscape(s) {
              function hex(ch) {
                return ch.charCodeAt(0).toString(16).toUpperCase();
              }

              return s.replace(/\\/g, '\\\\').replace(/"/g, '\\"').replace(/\x08/g, '\\b').replace(/\t/g, '\\t').replace(/\n/g, '\\n').replace(/\f/g, '\\f').replace(/\r/g, '\\r').replace(/[\x00-\x07\x0B\x0E\x0F]/g, function (ch) {
                return '\\x0' + hex(ch);
              }).replace(/[\x10-\x1F\x80-\xFF]/g, function (ch) {
                return '\\x' + hex(ch);
              }).replace(/[\u0100-\u0FFF]/g, function (ch) {
                return "\\u0" + hex(ch);
              }).replace(/[\u1000-\uFFFF]/g, function (ch) {
                return "\\u" + hex(ch);
              });
            }

            var expectedDescs = new Array(expected.length),
                expectedDesc,
                foundDesc,
                i;

            for (i = 0; i < expected.length; i++) {
              expectedDescs[i] = expected[i].description;
            }

            expectedDesc = expected.length > 1 ? expectedDescs.slice(0, -1).join(", ") + " or " + expectedDescs[expected.length - 1] : expectedDescs[0];

            foundDesc = found ? "\"" + stringEscape(found) + "\"" : "end of input";

            return "Expected " + expectedDesc + " but " + foundDesc + " found.";
          }

          if (expected !== null) {
            cleanupExpected(expected);
          }

          return new peg$SyntaxError(message !== null ? message : buildMessage(expected, found), expected, found, location);
        }

        function peg$decode(s) {
          var bc = new Array(s.length),
              i;

          for (i = 0; i < s.length; i++) {
            bc[i] = s.charCodeAt(i) - 32;
          }

          return bc;
        }

        function peg$parseRule(index) {
          var bc = peg$bytecode[index],
              ip = 0,
              ips = [],
              end = bc.length,
              ends = [],
              stack = [],
              params,
              i;

          while (true) {
            while (ip < end) {
              switch (bc[ip]) {
                case 0:
                  stack.push(peg$consts[bc[ip + 1]]);
                  ip += 2;
                  break;

                case 1:
                  stack.push(void 0);
                  ip++;
                  break;

                case 2:
                  stack.push(null);
                  ip++;
                  break;

                case 3:
                  stack.push(peg$FAILED);
                  ip++;
                  break;

                case 4:
                  stack.push([]);
                  ip++;
                  break;

                case 5:
                  stack.push(peg$currPos);
                  ip++;
                  break;

                case 6:
                  stack.pop();
                  ip++;
                  break;

                case 7:
                  peg$currPos = stack.pop();
                  ip++;
                  break;

                case 8:
                  stack.length -= bc[ip + 1];
                  ip += 2;
                  break;

                case 9:
                  stack.splice(-2, 1);
                  ip++;
                  break;

                case 10:
                  stack[stack.length - 2].push(stack.pop());
                  ip++;
                  break;

                case 11:
                  stack.push(stack.splice(stack.length - bc[ip + 1], bc[ip + 1]));
                  ip += 2;
                  break;

                case 12:
                  stack.push(input.substring(stack.pop(), peg$currPos));
                  ip++;
                  break;

                case 13:
                  ends.push(end);
                  ips.push(ip + 3 + bc[ip + 1] + bc[ip + 2]);

                  if (stack[stack.length - 1]) {
                    end = ip + 3 + bc[ip + 1];
                    ip += 3;
                  } else {
                    end = ip + 3 + bc[ip + 1] + bc[ip + 2];
                    ip += 3 + bc[ip + 1];
                  }

                  break;

                case 14:
                  ends.push(end);
                  ips.push(ip + 3 + bc[ip + 1] + bc[ip + 2]);

                  if (stack[stack.length - 1] === peg$FAILED) {
                    end = ip + 3 + bc[ip + 1];
                    ip += 3;
                  } else {
                    end = ip + 3 + bc[ip + 1] + bc[ip + 2];
                    ip += 3 + bc[ip + 1];
                  }

                  break;

                case 15:
                  ends.push(end);
                  ips.push(ip + 3 + bc[ip + 1] + bc[ip + 2]);

                  if (stack[stack.length - 1] !== peg$FAILED) {
                    end = ip + 3 + bc[ip + 1];
                    ip += 3;
                  } else {
                    end = ip + 3 + bc[ip + 1] + bc[ip + 2];
                    ip += 3 + bc[ip + 1];
                  }

                  break;

                case 16:
                  if (stack[stack.length - 1] !== peg$FAILED) {
                    ends.push(end);
                    ips.push(ip);

                    end = ip + 2 + bc[ip + 1];
                    ip += 2;
                  } else {
                    ip += 2 + bc[ip + 1];
                  }

                  break;

                case 17:
                  ends.push(end);
                  ips.push(ip + 3 + bc[ip + 1] + bc[ip + 2]);

                  if (input.length > peg$currPos) {
                    end = ip + 3 + bc[ip + 1];
                    ip += 3;
                  } else {
                    end = ip + 3 + bc[ip + 1] + bc[ip + 2];
                    ip += 3 + bc[ip + 1];
                  }

                  break;

                case 18:
                  ends.push(end);
                  ips.push(ip + 4 + bc[ip + 2] + bc[ip + 3]);

                  if (input.substr(peg$currPos, peg$consts[bc[ip + 1]].length) === peg$consts[bc[ip + 1]]) {
                    end = ip + 4 + bc[ip + 2];
                    ip += 4;
                  } else {
                    end = ip + 4 + bc[ip + 2] + bc[ip + 3];
                    ip += 4 + bc[ip + 2];
                  }

                  break;

                case 19:
                  ends.push(end);
                  ips.push(ip + 4 + bc[ip + 2] + bc[ip + 3]);

                  if (input.substr(peg$currPos, peg$consts[bc[ip + 1]].length).toLowerCase() === peg$consts[bc[ip + 1]]) {
                    end = ip + 4 + bc[ip + 2];
                    ip += 4;
                  } else {
                    end = ip + 4 + bc[ip + 2] + bc[ip + 3];
                    ip += 4 + bc[ip + 2];
                  }

                  break;

                case 20:
                  ends.push(end);
                  ips.push(ip + 4 + bc[ip + 2] + bc[ip + 3]);

                  if (peg$consts[bc[ip + 1]].test(input.charAt(peg$currPos))) {
                    end = ip + 4 + bc[ip + 2];
                    ip += 4;
                  } else {
                    end = ip + 4 + bc[ip + 2] + bc[ip + 3];
                    ip += 4 + bc[ip + 2];
                  }

                  break;

                case 21:
                  stack.push(input.substr(peg$currPos, bc[ip + 1]));
                  peg$currPos += bc[ip + 1];
                  ip += 2;
                  break;

                case 22:
                  stack.push(peg$consts[bc[ip + 1]]);
                  peg$currPos += peg$consts[bc[ip + 1]].length;
                  ip += 2;
                  break;

                case 23:
                  stack.push(peg$FAILED);
                  if (peg$silentFails === 0) {
                    peg$fail(peg$consts[bc[ip + 1]]);
                  }
                  ip += 2;
                  break;

                case 24:
                  peg$savedPos = stack[stack.length - 1 - bc[ip + 1]];
                  ip += 2;
                  break;

                case 25:
                  peg$savedPos = peg$currPos;
                  ip++;
                  break;

                case 26:
                  params = bc.slice(ip + 4, ip + 4 + bc[ip + 3]);
                  for (i = 0; i < bc[ip + 3]; i++) {
                    params[i] = stack[stack.length - 1 - params[i]];
                  }

                  stack.splice(stack.length - bc[ip + 2], bc[ip + 2], peg$consts[bc[ip + 1]].apply(null, params));

                  ip += 4 + bc[ip + 3];
                  break;

                case 27:
                  stack.push(peg$parseRule(bc[ip + 1]));
                  ip += 2;
                  break;

                case 28:
                  peg$silentFails++;
                  ip++;
                  break;

                case 29:
                  peg$silentFails--;
                  ip++;
                  break;

                default:
                  throw new Error("Invalid opcode: " + bc[ip] + ".");
              }
            }

            if (ends.length > 0) {
              end = ends.pop();
              ip = ips.pop();
            } else {
              break;
            }
          }

          return stack[0];
        }

        options = _default3$1({
          strict: true
        }, options);

        function createNode(type, props) {
          var loc = location();
          if (typeof type !== "function") type = AST[type];
          return new type(loc.start.line, loc.start.column, props);
        }

        function combineText(nodes, type) {
          return nodes.reduce(function (m, n) {
            var last = m.length - 1;
            if (typeof n === "string" && typeof m[last] === "string") {
              m[last] += n;
            } else {
              m.push(n);
            }
            return m;
          }, []).map(function (n) {
            if (typeof n !== "string") return n;
            return createNode(type || "Text", { value: n });
          });
        }

        function createExpression(v) {
          return createNode("Expression", {
            value: v,
            tree: jsep$1(v)
          });
        }

        var attributeMode = false;
        function enterAttribute() {
          attributeMode = true;
        }
        function exitAttribute() {
          attributeMode = false;
        }

        var rawNodes = _default3$1({
          script: "Script",
          style: "Style"
        }, options.rawNodes);
        var rawTags = Object.keys(rawNodes);
        var currentRawTag;

        function createRawNode(tag, attrs, value) {
          var astType = rawNodes[tag];
          if (!astType) {
            throw new Error("Unknown raw node tag '" + tag + "'");
          }
          return createNode(astType, {
            tagname: tag,
            attributes: attrs,
            value: value
          });
        }

        peg$result = peg$parseRule(peg$startRuleIndex);

        if (peg$result !== peg$FAILED && peg$currPos === input.length) {
          return peg$result;
        } else {
          if (peg$result !== peg$FAILED && peg$currPos < input.length) {
            peg$fail({ type: "end", description: "end of input" });
          }

          throw peg$buildException(null, peg$maxFailExpected, peg$maxFailPos < input.length ? input.charAt(peg$maxFailPos) : null, peg$maxFailPos < input.length ? peg$computeLocation(peg$maxFailPos, peg$maxFailPos + 1) : peg$computeLocation(peg$maxFailPos, peg$maxFailPos));
        }
      }

      return {
        SyntaxError: peg$SyntaxError,
        parse: peg$parse
      };
    }();
    var parse$1 = parser.parse;

    var smfurl = "sourceMappingURL=";
    var datauri = "data:application/json;charset=utf-8;base64,";

    var toBase64;
    if (typeof window !== "undefined" && typeof window.btoa === "function") {
    	toBase64 = window.btoa;
    } else toBase64 = function toBase64(str) {
    	return new Buffer(str, "utf-8").toString("base64");
    };

    function parseFile(src, name, options) {
    	if (typeof name === "number") name = "template" + name + ".js";

    	try {
    		return parse$1(src, _default3$1({
    			filename: name
    		}, options));
    	} catch (e) {
    		e.filename = name;
    		e.source = src;
    		throw e;
    	}
    }

    function parse(files, options) {
    	if (typeof files === "string") files = [files];
    	files = _default$2(files, function (src, name) {
    		return parseFile(src, name, options);
    	});
    	return new Root({ files: files });
    }

    function srcToString(smf) {
    	return this.code + "//# " + smfurl + (typeof smf === "string" ? smf : datauri + toBase64(this.map.toString()));
    }

    function processOut(source) {
    	var out = source.toStringWithSourceMap();
    	out.includes = source.includes;
    	out.toString = srcToString;
    	return out;
    }

    function compile(files, options, cb) {
    	if (typeof files === "string") files = [files];

    	files = _default$2(files, function (file, index) {
    		if (typeof file === "string") {
    			file = parseFile(file, index, options);
    		}

    		return file;
    	});

    	var root = new Root({ files: files });
    	var data = _default3$1({ parse: parseFile }, options);
    	var hasCb = typeof cb === "function";

    	if (hasCb || data.async) {
    		return root.compile(data).then(processOut).then(function (res) {
    			if (hasCb) cb(null, res);
    			return res;
    		}, function (e) {
    			if (hasCb) cb(e);
    			throw e;
    		});
    	} else {
    		return processOut(root.compile(data));
    	}
    }

    function exec(tpl, options) {
    	/* jshint -W054 */
    	var r = compile(tpl, options);
    	// console.log(r);
    	return new Function("Temple", r.code)(Temple);
    }

    // export function compileHTML(html, options) {
    // 	options = options || {};
    // 	var node = new AST.HTML(null, html);
    // 	return getSource(node.compile(options), html, options);
    // }
    //
    // export function renderHTML(html, options) {
    // 	/* jshint -W054 */
    // 	var r = compileHTML(html, options);
    // 	// console.log(r);
    // 	return (new Function("Temple", r))(require("./"));
    // }

    function Each$1(val, vars, ctx, fn, that) {
    	return map(val, function (item, key) {
    		var nctx = new Context$1(ctx);

    		if (vars.length === 1) nctx.set(vars[0], item);else if (vars.length == 2) {
    			nctx.set(vars[0], key);
    			nctx.set(vars[1], item);
    		}

    		return fn.call(that, nctx, key, val);
    	});
    }

    function With$1(val, ctx, fn, that) {
    	var nctx = new Context$1(ctx);
    	nctx.set(val);
    	nctx.dataVar.set(val);
    	return fn.call(that, nctx);
    }

    function Element$2(tagname, key, ctx, fn, that) {
    	var node = elementOpen(tagname, key);
    	var nctx = new Context$1(null, ctx);
    	var comp = autoelement(node, function () {
    		return fn.call(that, nctx, node);
    	});
    	elementClose(tagname);
    	return comp;
    }

    var version = pkg.version || "edge";



    var Temple = Object.freeze({
    	version: version,
    	Trackr: Trackr,
    	Context: Context$1,
    	AST: AST,
    	idom: idom,
    	utils: utils,
    	plugins: plugins$1,
    	decorators: decorators$1,
    	actions: actions$1,
    	Map: Map,
    	List: List,
    	Variable: Variable,
    	trackProperty: trackProperty,
    	templates: templates,
    	types: types,
    	Template: Template,
    	helpers: helpers,
    	getHelper: getHelper,
    	render: render,
    	getByName: getByName,
    	paint: paint,
    	registerType: registerType,
    	create: create$1,
    	parse: parse,
    	compile: compile,
    	exec: exec,
    	Each: Each$1,
    	With: With$1,
    	Element: Element$2
    });

    exports.version = version;
    exports.Trackr = Trackr;
    exports.Context = Context$1;
    exports.AST = AST;
    exports.idom = idom;
    exports.utils = utils;
    exports.plugins = plugins$1;
    exports.decorators = decorators$1;
    exports.actions = actions$1;
    exports.Map = Map;
    exports.List = List;
    exports.Variable = Variable;
    exports.trackProperty = trackProperty;
    exports.templates = templates;
    exports.types = types;
    exports.Template = Template;
    exports.helpers = helpers;
    exports.getHelper = getHelper;
    exports.render = render;
    exports.getByName = getByName;
    exports.paint = paint;
    exports.registerType = registerType;
    exports.create = create$1;
    exports.parse = parse;
    exports.compile = compile;
    exports.exec = exec;
    exports.Each = Each$1;
    exports.With = With$1;
    exports.Element = Element$2;

}));
//# sourceMappingURL=temple.js.map